/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  android.content.Context
 *  android.content.res.TypedArray
 *  android.graphics.Bitmap
 *  android.graphics.Canvas
 *  android.graphics.Paint
 *  android.graphics.Paint$Style
 *  android.graphics.Rect
 *  android.graphics.RectF
 *  android.graphics.Typeface
 *  android.os.Parcelable
 *  android.text.TextUtils
 *  android.util.AttributeSet
 *  android.view.MotionEvent
 *  android.view.View
 *  android.view.View$MeasureSpec
 *  android.view.ViewGroup
 *  android.view.ViewParent
 *  java.lang.CharSequence
 *  java.lang.Exception
 *  java.lang.IllegalArgumentException
 *  java.lang.Integer
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.annotation.Annotation
 *  java.lang.annotation.Retention
 *  java.lang.annotation.RetentionPolicy
 *  java.math.BigDecimal
 *  java.math.RoundingMode
 *  java.util.ArrayList
 *  java.util.Collection
 *  java.util.List
 */
package com.jaygoo.widget;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.RectF;
import android.graphics.Typeface;
import android.os.Parcelable;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewParent;
import com.jaygoo.widget.OnRangeChangedListener;
import com.jaygoo.widget.R;
import com.jaygoo.widget.SavedState;
import com.jaygoo.widget.SeekBar;
import com.jaygoo.widget.SeekBarState;
import com.jaygoo.widget.Utils;
import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class RangeSeekBar
extends View {
    private static final int MIN_INTERCEPT_DISTANCE = 100;
    public static final int SEEKBAR_MODE_RANGE = 2;
    public static final int SEEKBAR_MODE_SINGLE = 1;
    public static final int TICK_MARK_GRAVITY_CENTER = 1;
    public static final int TICK_MARK_GRAVITY_LEFT = 0;
    public static final int TICK_MARK_GRAVITY_RIGHT = 2;
    public static final int TRICK_MARK_MODE_NUMBER = 0;
    public static final int TRICK_MARK_MODE_OTHER = 1;
    private OnRangeChangedListener callback;
    SeekBar currTouchSB;
    private boolean enableThumbOverlap;
    private int gravity;
    private boolean isEnable = true;
    boolean isScaleThumb = false;
    SeekBar leftSB;
    private float maxProgress;
    private float minInterval;
    private float minProgress;
    Paint paint = new Paint();
    Bitmap progressBitmap;
    private int progressBottom;
    private int progressColor;
    Bitmap progressDefaultBitmap;
    private int progressDefaultColor;
    private int progressDefaultDrawableId;
    RectF progressDefaultDstRect = new RectF();
    private int progressDrawableId;
    RectF progressDstRect = new RectF();
    private int progressHeight;
    private int progressLeft;
    private int progressPaddingRight;
    private float progressRadius;
    private int progressRight;
    Rect progressSrcRect = new Rect();
    private int progressTop;
    private int progressWidth;
    float reservePercent;
    SeekBar rightSB;
    private int seekBarMode;
    RectF stepDivRect = new RectF();
    private int steps;
    private boolean stepsAutoBonding;
    List<Bitmap> stepsBitmaps = new ArrayList();
    private int stepsColor;
    private int stepsDrawableId;
    private float stepsHeight;
    private float stepsRadius;
    private float stepsWidth;
    private int tickMarkGravity;
    private int tickMarkInRangeTextColor;
    private int tickMarkLayoutGravity;
    private int tickMarkMode;
    private CharSequence[] tickMarkTextArray;
    private int tickMarkTextColor;
    private int tickMarkTextMargin;
    Rect tickMarkTextRect = new Rect();
    private int tickMarkTextSize;
    float touchDownX;
    float touchDownY;

    public RangeSeekBar(Context context) {
        this(context, null);
    }

    public RangeSeekBar(Context context, AttributeSet attributeSet) {
        super(context, attributeSet);
        this.initAttrs(attributeSet);
        this.initPaint();
        this.initSeekBar(attributeSet);
        this.initStepsBitmap();
    }

    private void changeThumbActivateState(boolean bl) {
        SeekBar seekBar;
        if (bl && (seekBar = this.currTouchSB) != null) {
            SeekBar seekBar2 = this.leftSB;
            boolean bl2 = false;
            if (seekBar == seekBar2) {
                bl2 = true;
            }
            this.leftSB.setActivate(bl2);
            if (this.seekBarMode == 2) {
                this.rightSB.setActivate(bl2 ^ true);
                return;
            }
        } else {
            this.leftSB.setActivate(false);
            if (this.seekBarMode == 2) {
                this.rightSB.setActivate(false);
            }
        }
    }

    private void initAttrs(AttributeSet attributeSet) {
        try {
            TypedArray typedArray = this.getContext().obtainStyledAttributes(attributeSet, R.styleable.RangeSeekBar);
            this.seekBarMode = typedArray.getInt(R.styleable.RangeSeekBar_rsb_mode, 2);
            this.minProgress = typedArray.getFloat(R.styleable.RangeSeekBar_rsb_min, 0.0f);
            this.maxProgress = typedArray.getFloat(R.styleable.RangeSeekBar_rsb_max, 100.0f);
            this.minInterval = typedArray.getFloat(R.styleable.RangeSeekBar_rsb_min_interval, 0.0f);
            this.gravity = typedArray.getInt(R.styleable.RangeSeekBar_rsb_gravity, 0);
            this.progressColor = typedArray.getColor(R.styleable.RangeSeekBar_rsb_progress_color, -11806366);
            this.progressRadius = (int)typedArray.getDimension(R.styleable.RangeSeekBar_rsb_progress_radius, -1.0f);
            this.progressDefaultColor = typedArray.getColor(R.styleable.RangeSeekBar_rsb_progress_default_color, -2631721);
            this.progressDrawableId = typedArray.getResourceId(R.styleable.RangeSeekBar_rsb_progress_drawable, 0);
            this.progressDefaultDrawableId = typedArray.getResourceId(R.styleable.RangeSeekBar_rsb_progress_drawable_default, 0);
            this.progressHeight = (int)typedArray.getDimension(R.styleable.RangeSeekBar_rsb_progress_height, (float)Utils.dp2px(this.getContext(), 2.0f));
            this.tickMarkMode = typedArray.getInt(R.styleable.RangeSeekBar_rsb_tick_mark_mode, 0);
            this.tickMarkGravity = typedArray.getInt(R.styleable.RangeSeekBar_rsb_tick_mark_gravity, 1);
            this.tickMarkLayoutGravity = typedArray.getInt(R.styleable.RangeSeekBar_rsb_tick_mark_layout_gravity, 0);
            this.tickMarkTextArray = typedArray.getTextArray(R.styleable.RangeSeekBar_rsb_tick_mark_text_array);
            this.tickMarkTextMargin = (int)typedArray.getDimension(R.styleable.RangeSeekBar_rsb_tick_mark_text_margin, (float)Utils.dp2px(this.getContext(), 7.0f));
            this.tickMarkTextSize = (int)typedArray.getDimension(R.styleable.RangeSeekBar_rsb_tick_mark_text_size, (float)Utils.dp2px(this.getContext(), 12.0f));
            this.tickMarkTextColor = typedArray.getColor(R.styleable.RangeSeekBar_rsb_tick_mark_text_color, this.progressDefaultColor);
            this.tickMarkInRangeTextColor = typedArray.getColor(R.styleable.RangeSeekBar_rsb_tick_mark_text_color, this.progressColor);
            this.steps = typedArray.getInt(R.styleable.RangeSeekBar_rsb_steps, 0);
            this.stepsColor = typedArray.getColor(R.styleable.RangeSeekBar_rsb_step_color, -6447715);
            this.stepsRadius = typedArray.getDimension(R.styleable.RangeSeekBar_rsb_step_radius, 0.0f);
            this.stepsWidth = typedArray.getDimension(R.styleable.RangeSeekBar_rsb_step_width, 0.0f);
            this.stepsHeight = typedArray.getDimension(R.styleable.RangeSeekBar_rsb_step_height, 0.0f);
            this.stepsDrawableId = typedArray.getResourceId(R.styleable.RangeSeekBar_rsb_step_drawable, 0);
            this.stepsAutoBonding = typedArray.getBoolean(R.styleable.RangeSeekBar_rsb_step_auto_bonding, true);
            typedArray.recycle();
            return;
        }
        catch (Exception exception) {
            exception.printStackTrace();
            return;
        }
    }

    private void initPaint() {
        this.paint.setStyle(Paint.Style.FILL);
        this.paint.setColor(this.progressDefaultColor);
        this.paint.setTextSize((float)this.tickMarkTextSize);
    }

    private void initProgressBitmap() {
        if (this.progressBitmap == null) {
            this.progressBitmap = Utils.drawableToBitmap(this.getContext(), this.progressWidth, this.progressHeight, this.progressDrawableId);
        }
        if (this.progressDefaultBitmap == null) {
            this.progressDefaultBitmap = Utils.drawableToBitmap(this.getContext(), this.progressWidth, this.progressHeight, this.progressDefaultDrawableId);
        }
    }

    private void initSeekBar(AttributeSet attributeSet) {
        int n = 1;
        this.leftSB = new SeekBar(this, attributeSet, (boolean)n);
        SeekBar seekBar = this.rightSB = new SeekBar(this, attributeSet, false);
        if (this.seekBarMode == n) {
            n = 0;
        }
        seekBar.setVisible((boolean)n);
    }

    private void initStepsBitmap() {
        if (this.verifyStepsMode()) {
            if (this.stepsDrawableId == 0) {
                return;
            }
            if (this.stepsBitmaps.isEmpty()) {
                Bitmap bitmap = Utils.drawableToBitmap(this.getContext(), (int)this.stepsWidth, (int)this.stepsHeight, this.stepsDrawableId);
                for (int i = 0; i <= this.steps; ++i) {
                    this.stepsBitmaps.add((Object)bitmap);
                }
            }
        }
    }

    private void resetCurrentSeekBarThumb() {
        SeekBar seekBar = this.currTouchSB;
        if (seekBar != null && seekBar.getThumbScaleRatio() > 1.0f && this.isScaleThumb) {
            this.isScaleThumb = false;
            this.currTouchSB.resetThumb();
        }
    }

    private void scaleCurrentSeekBarThumb() {
        SeekBar seekBar = this.currTouchSB;
        if (seekBar != null && seekBar.getThumbScaleRatio() > 1.0f && !this.isScaleThumb) {
            this.isScaleThumb = true;
            this.currTouchSB.scaleThumb();
        }
    }

    private boolean verifyStepsMode() {
        return this.steps >= 1 && !(this.stepsHeight <= 0.0f) && !(this.stepsWidth <= 0.0f);
        {
        }
    }

    protected float calculateCurrentSeekBarPercent(float f) {
        if (this.currTouchSB == null) {
            return 0.0f;
        }
        float f2 = 1.0f * (f - (float)this.getProgressLeft()) / (float)this.progressWidth;
        if (f < (float)this.getProgressLeft()) {
            f2 = 0.0f;
        } else if (f > (float)this.getProgressRight()) {
            f2 = 1.0f;
        }
        if (this.seekBarMode == 2) {
            SeekBar seekBar = this.currTouchSB;
            SeekBar seekBar2 = this.leftSB;
            if (seekBar == seekBar2) {
                if (f2 > this.rightSB.currPercent - this.reservePercent) {
                    return this.rightSB.currPercent - this.reservePercent;
                }
            } else if (seekBar == this.rightSB && f2 < seekBar2.currPercent + this.reservePercent) {
                f2 = this.leftSB.currPercent + this.reservePercent;
            }
        }
        return f2;
    }

    protected float getEventX(MotionEvent motionEvent) {
        return motionEvent.getX();
    }

    protected float getEventY(MotionEvent motionEvent) {
        return motionEvent.getY();
    }

    public int getGravity() {
        return this.gravity;
    }

    public SeekBar getLeftSeekBar() {
        return this.leftSB;
    }

    public float getMaxProgress() {
        return this.maxProgress;
    }

    public float getMinInterval() {
        return this.minInterval;
    }

    public float getMinProgress() {
        return this.minProgress;
    }

    public int getProgressBottom() {
        return this.progressBottom;
    }

    public int getProgressColor() {
        return this.progressColor;
    }

    public int getProgressDefaultColor() {
        return this.progressDefaultColor;
    }

    public int getProgressDefaultDrawableId() {
        return this.progressDefaultDrawableId;
    }

    public int getProgressDrawableId() {
        return this.progressDrawableId;
    }

    public int getProgressHeight() {
        return this.progressHeight;
    }

    public int getProgressLeft() {
        return this.progressLeft;
    }

    public int getProgressPaddingRight() {
        return this.progressPaddingRight;
    }

    public float getProgressRadius() {
        return this.progressRadius;
    }

    public int getProgressRight() {
        return this.progressRight;
    }

    public int getProgressTop() {
        return this.progressTop;
    }

    public int getProgressWidth() {
        return this.progressWidth;
    }

    public SeekBarState[] getRangeSeekBarState() {
        SeekBarState seekBarState = new SeekBarState();
        seekBarState.value = this.leftSB.getProgress();
        seekBarState.indicatorText = String.valueOf((float)seekBarState.value);
        if (Utils.compareFloat(seekBarState.value, this.minProgress) == 0) {
            seekBarState.isMin = true;
        } else if (Utils.compareFloat(seekBarState.value, this.maxProgress) == 0) {
            seekBarState.isMax = true;
        }
        SeekBarState seekBarState2 = new SeekBarState();
        if (this.seekBarMode == 2) {
            seekBarState2.value = this.rightSB.getProgress();
            seekBarState2.indicatorText = String.valueOf((float)seekBarState2.value);
            if (Utils.compareFloat(this.rightSB.currPercent, this.minProgress) == 0) {
                seekBarState2.isMin = true;
            } else if (Utils.compareFloat(this.rightSB.currPercent, this.maxProgress) == 0) {
                seekBarState2.isMax = true;
            }
        }
        return new SeekBarState[]{seekBarState, seekBarState2};
    }

    protected float getRawHeight() {
        float f;
        if (this.seekBarMode == 1) {
            f = this.leftSB.getRawHeight();
            if (this.tickMarkLayoutGravity == 1 && this.tickMarkTextArray != null) {
                return Math.max((float)((this.leftSB.getThumbScaleHeight() - (float)this.progressHeight) / 2.0f), (float)this.getTickMarkRawHeight()) + (f - this.leftSB.getThumbScaleHeight() / 2.0f + (float)this.progressHeight / 2.0f);
            }
        } else {
            f = Math.max((float)this.leftSB.getRawHeight(), (float)this.rightSB.getRawHeight());
            if (this.tickMarkLayoutGravity == 1 && this.tickMarkTextArray != null) {
                float f2 = Math.max((float)this.leftSB.getThumbScaleHeight(), (float)this.rightSB.getThumbScaleHeight());
                f = Math.max((float)((f2 - (float)this.progressHeight) / 2.0f), (float)this.getTickMarkRawHeight()) + (f - f2 / 2.0f + (float)this.progressHeight / 2.0f);
            }
        }
        return f;
    }

    public SeekBar getRightSeekBar() {
        return this.rightSB;
    }

    public int getSeekBarMode() {
        return this.seekBarMode;
    }

    public int getSteps() {
        return this.steps;
    }

    public List<Bitmap> getStepsBitmaps() {
        return this.stepsBitmaps;
    }

    public int getStepsColor() {
        return this.stepsColor;
    }

    public int getStepsDrawableId() {
        return this.stepsDrawableId;
    }

    public float getStepsHeight() {
        return this.stepsHeight;
    }

    public float getStepsRadius() {
        return this.stepsRadius;
    }

    public float getStepsWidth() {
        return this.stepsWidth;
    }

    public int getTickMarkGravity() {
        return this.tickMarkGravity;
    }

    public int getTickMarkInRangeTextColor() {
        return this.tickMarkInRangeTextColor;
    }

    public int getTickMarkLayoutGravity() {
        return this.tickMarkLayoutGravity;
    }

    public int getTickMarkMode() {
        return this.tickMarkMode;
    }

    protected int getTickMarkRawHeight() {
        CharSequence[] arrcharSequence = this.tickMarkTextArray;
        if (arrcharSequence != null && arrcharSequence.length > 0) {
            return 3 + (this.tickMarkTextMargin + Utils.measureText(String.valueOf((Object)arrcharSequence[0]), this.tickMarkTextSize).height());
        }
        return 0;
    }

    public CharSequence[] getTickMarkTextArray() {
        return this.tickMarkTextArray;
    }

    public int getTickMarkTextColor() {
        return this.tickMarkTextColor;
    }

    public int getTickMarkTextMargin() {
        return this.tickMarkTextMargin;
    }

    public int getTickMarkTextSize() {
        return this.tickMarkTextSize;
    }

    public boolean isEnableThumbOverlap() {
        return this.enableThumbOverlap;
    }

    public boolean isStepsAutoBonding() {
        return this.stepsAutoBonding;
    }

    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        this.onDrawTickMark(canvas, this.paint);
        this.onDrawProgressBar(canvas, this.paint);
        this.onDrawSteps(canvas, this.paint);
        this.onDrawSeekBar(canvas);
    }

    protected void onDrawProgressBar(Canvas canvas, Paint paint) {
        if (Utils.verifyBitmap(this.progressDefaultBitmap)) {
            canvas.drawBitmap(this.progressDefaultBitmap, null, this.progressDefaultDstRect, paint);
        } else {
            paint.setColor(this.progressDefaultColor);
            RectF rectF = this.progressDefaultDstRect;
            float f = this.progressRadius;
            canvas.drawRoundRect(rectF, f, f, paint);
        }
        if (this.seekBarMode == 2) {
            this.progressDstRect.top = this.getProgressTop();
            this.progressDstRect.left = (float)this.leftSB.left + this.leftSB.getThumbScaleWidth() / 2.0f + (float)this.progressWidth * this.leftSB.currPercent;
            this.progressDstRect.right = (float)this.rightSB.left + this.rightSB.getThumbScaleWidth() / 2.0f + (float)this.progressWidth * this.rightSB.currPercent;
            this.progressDstRect.bottom = this.getProgressBottom();
        } else {
            this.progressDstRect.top = this.getProgressTop();
            this.progressDstRect.left = (float)this.leftSB.left + this.leftSB.getThumbScaleWidth() / 2.0f;
            this.progressDstRect.right = (float)this.leftSB.left + this.leftSB.getThumbScaleWidth() / 2.0f + (float)this.progressWidth * this.leftSB.currPercent;
            this.progressDstRect.bottom = this.getProgressBottom();
        }
        if (Utils.verifyBitmap(this.progressBitmap)) {
            Rect rect = this.progressSrcRect;
            rect.top = 0;
            rect.bottom = this.progressBitmap.getHeight();
            int n = this.progressBitmap.getWidth();
            if (this.seekBarMode == 2) {
                Rect rect2 = this.progressSrcRect;
                float f = n;
                rect2.left = (int)(f * this.leftSB.currPercent);
                this.progressSrcRect.right = (int)(f * this.rightSB.currPercent);
            } else {
                Rect rect3 = this.progressSrcRect;
                rect3.left = 0;
                rect3.right = (int)((float)n * this.leftSB.currPercent);
            }
            canvas.drawBitmap(this.progressBitmap, this.progressSrcRect, this.progressDstRect, null);
            return;
        }
        paint.setColor(this.progressColor);
        RectF rectF = this.progressDstRect;
        float f = this.progressRadius;
        canvas.drawRoundRect(rectF, f, f, paint);
    }

    protected void onDrawSeekBar(Canvas canvas) {
        if (this.leftSB.getIndicatorShowMode() == 3) {
            this.leftSB.setShowIndicatorEnable(true);
        }
        this.leftSB.draw(canvas);
        if (this.seekBarMode == 2) {
            if (this.rightSB.getIndicatorShowMode() == 3) {
                this.rightSB.setShowIndicatorEnable(true);
            }
            this.rightSB.draw(canvas);
        }
    }

    protected void onDrawSteps(Canvas canvas, Paint paint) {
        if (!this.verifyStepsMode()) {
            return;
        }
        int n = this.getProgressWidth() / this.steps;
        float f = (this.stepsHeight - (float)this.getProgressHeight()) / 2.0f;
        for (int i = 0; i <= this.steps; ++i) {
            float f2 = (float)(this.getProgressLeft() + i * n) - this.stepsWidth / 2.0f;
            this.stepDivRect.set(f2, (float)this.getProgressTop() - f, f2 + this.stepsWidth, f + (float)this.getProgressBottom());
            if (!this.stepsBitmaps.isEmpty() && this.stepsBitmaps.size() > i) {
                canvas.drawBitmap((Bitmap)this.stepsBitmaps.get(i), null, this.stepDivRect, paint);
                continue;
            }
            paint.setColor(this.stepsColor);
            RectF rectF = this.stepDivRect;
            float f3 = this.stepsRadius;
            canvas.drawRoundRect(rectF, f3, f3, paint);
        }
    }

    /*
     * Unable to fully structure code
     * Enabled aggressive block sorting
     * Lifted jumps to return sites
     */
    protected void onDrawTickMark(Canvas var1_1, Paint var2_2) {
        var3_3 = this.tickMarkTextArray;
        if (var3_3 == null) return;
        var4_4 = this.progressWidth / (var3_3.length - 1);
        var5_5 = 0;
        while (var5_5 < (var6_6 = this.tickMarkTextArray).length) {
            block4 : {
                block7 : {
                    block5 : {
                        block6 : {
                            var7_7 = var6_6[var5_5].toString();
                            if (TextUtils.isEmpty((CharSequence)var7_7)) break block4;
                            var2_2.getTextBounds(var7_7, 0, var7_7.length(), this.tickMarkTextRect);
                            var2_2.setColor(this.tickMarkTextColor);
                            if (this.tickMarkMode != 1) break block5;
                            var15_15 = this.tickMarkGravity;
                            if (var15_15 != 2) break block6;
                            var16_16 = this.getProgressLeft() + var5_5 * var4_4 - this.tickMarkTextRect.width();
                            ** GOTO lbl20
                        }
                        if (var15_15 == 1) {
                            var13_13 = (float)(this.getProgressLeft() + var5_5 * var4_4) - (float)this.tickMarkTextRect.width() / 2.0f;
                        } else {
                            var16_16 = this.getProgressLeft() + var5_5 * var4_4;
lbl20: // 2 sources:
                            var13_13 = var16_16;
                        }
                        break block7;
                    }
                    var8_8 = Utils.parseFloat(var7_7);
                    var9_9 = this.getRangeSeekBarState();
                    if (Utils.compareFloat(var8_8, var9_9[0].value) != -1 && Utils.compareFloat(var8_8, var9_9[1].value) != 1 && this.seekBarMode == 2) {
                        var2_2.setColor(this.tickMarkInRangeTextColor);
                    }
                    var10_10 = this.getProgressLeft();
                    var11_11 = this.progressWidth;
                    var12_12 = this.minProgress;
                    var13_13 = var10_10 + var11_11 * (var8_8 - var12_12) / (this.maxProgress - var12_12) - (float)this.tickMarkTextRect.width() / 2.0f;
                }
                var14_14 = this.tickMarkLayoutGravity == 0 ? this.getProgressTop() - this.tickMarkTextMargin : this.getProgressBottom() + this.tickMarkTextMargin + this.tickMarkTextRect.height();
                var1_1.drawText(var7_7, var13_13, (float)var14_14, var2_2);
            }
            ++var5_5;
        }
    }

    protected void onMeasure(int n, int n2) {
        int n3;
        int n4 = View.MeasureSpec.getSize((int)n2);
        int n5 = View.MeasureSpec.getMode((int)n2);
        if (n5 == 1073741824) {
            n3 = View.MeasureSpec.makeMeasureSpec((int)n4, (int)1073741824);
        } else if (n5 == Integer.MIN_VALUE && this.getParent() instanceof ViewGroup && n4 == -1) {
            n3 = View.MeasureSpec.makeMeasureSpec((int)((ViewGroup)this.getParent()).getMeasuredHeight(), (int)Integer.MIN_VALUE);
        } else {
            float f;
            if (this.gravity == 2) {
                float f2;
                float f3;
                if (this.tickMarkTextArray != null && this.tickMarkLayoutGravity == 1) {
                    f3 = this.getRawHeight();
                    f2 = this.getTickMarkRawHeight();
                } else {
                    f3 = this.getRawHeight();
                    f2 = Math.max((float)this.leftSB.getThumbScaleHeight(), (float)this.rightSB.getThumbScaleHeight()) / 2.0f;
                }
                f = 2.0f * (f3 - f2);
            } else {
                f = this.getRawHeight();
            }
            n3 = View.MeasureSpec.makeMeasureSpec((int)((int)f), (int)1073741824);
        }
        super.onMeasure(n, n3);
    }

    protected void onMeasureProgress(int n, int n2) {
        int n3 = n2 - this.getPaddingBottom() - this.getPaddingTop();
        if (n2 <= 0) {
            return;
        }
        int n4 = this.gravity;
        if (n4 == 0) {
            float f = this.leftSB.getIndicatorShowMode() == 1 && this.rightSB.getIndicatorShowMode() == 1 ? 0.0f : (float)Math.max((int)this.leftSB.getIndicatorRawHeight(), (int)this.rightSB.getIndicatorRawHeight());
            float f2 = Math.max((float)this.leftSB.getThumbScaleHeight(), (float)this.rightSB.getThumbScaleHeight());
            int n5 = this.progressHeight;
            float f3 = f2 - (float)n5 / 2.0f;
            this.progressTop = (int)(f + (f3 - (float)n5) / 2.0f);
            if (this.tickMarkTextArray != null && this.tickMarkLayoutGravity == 0) {
                this.progressTop = (int)Math.max((float)this.getTickMarkRawHeight(), (float)(f + (f3 - (float)this.progressHeight) / 2.0f));
            }
            this.progressBottom = this.progressTop + this.progressHeight;
        } else if (n4 == 1) {
            this.progressBottom = this.tickMarkTextArray != null && this.tickMarkLayoutGravity == 1 ? n3 - this.getTickMarkRawHeight() : (int)((float)n3 - Math.max((float)this.leftSB.getThumbScaleHeight(), (float)this.rightSB.getThumbScaleHeight()) / 2.0f + (float)this.progressHeight / 2.0f);
            this.progressTop = this.progressBottom - this.progressHeight;
        } else {
            int n6 = this.progressHeight;
            this.progressTop = (n3 - n6) / 2;
            this.progressBottom = n6 + this.progressTop;
        }
        int n7 = (int)Math.max((float)this.leftSB.getThumbScaleWidth(), (float)this.rightSB.getThumbScaleWidth()) / 2;
        this.progressLeft = n7 + this.getPaddingLeft();
        this.progressRight = n - n7 - this.getPaddingRight();
        this.progressWidth = this.progressRight - this.progressLeft;
        this.progressDefaultDstRect.set((float)this.getProgressLeft(), (float)this.getProgressTop(), (float)this.getProgressRight(), (float)this.getProgressBottom());
        this.progressPaddingRight = n - this.progressRight;
        if (this.progressRadius <= 0.0f) {
            this.progressRadius = (int)(0.45f * (float)(this.getProgressBottom() - this.getProgressTop()));
        }
        this.initProgressBitmap();
    }

    public void onRestoreInstanceState(Parcelable parcelable) {
        try {
            SavedState savedState = (SavedState)parcelable;
            super.onRestoreInstanceState(savedState.getSuperState());
            this.setRange(savedState.minValue, savedState.maxValue, savedState.rangeInterval);
            this.setProgress(savedState.currSelectedMin, savedState.currSelectedMax);
            return;
        }
        catch (Exception exception) {
            exception.printStackTrace();
            return;
        }
    }

    public Parcelable onSaveInstanceState() {
        SavedState savedState = new SavedState(super.onSaveInstanceState());
        savedState.minValue = this.minProgress;
        savedState.maxValue = this.maxProgress;
        savedState.rangeInterval = this.minInterval;
        SeekBarState[] arrseekBarState = this.getRangeSeekBarState();
        savedState.currSelectedMin = arrseekBarState[0].value;
        savedState.currSelectedMax = arrseekBarState[1].value;
        return savedState;
    }

    protected void onSizeChanged(int n, int n2, int n3, int n4) {
        super.onSizeChanged(n, n2, n3, n4);
        this.onMeasureProgress(n, n2);
        this.setRange(this.minProgress, this.maxProgress, this.minInterval);
        int n5 = (this.getProgressBottom() + this.getProgressTop()) / 2;
        this.leftSB.onSizeChanged(this.getProgressLeft(), n5);
        if (this.seekBarMode == 2) {
            this.rightSB.onSizeChanged(this.getProgressLeft(), n5);
        }
    }

    public boolean onTouchEvent(MotionEvent motionEvent) {
        OnRangeChangedListener onRangeChangedListener;
        boolean bl = this.isEnable;
        boolean bl2 = true;
        if (!bl) {
            return bl2;
        }
        boolean bl3 = motionEvent.getAction();
        float f = 1.0f;
        if (bl3) {
            if (bl3 != bl2) {
                if (!bl3) {
                    if (bl3) {
                        SeekBar seekBar;
                        if (this.seekBarMode == 2) {
                            this.rightSB.setShowIndicatorEnable(false);
                        }
                        if ((seekBar = this.currTouchSB) == this.leftSB) {
                            this.resetCurrentSeekBarThumb();
                        } else if (seekBar == this.rightSB) {
                            this.resetCurrentSeekBarThumb();
                        }
                        this.leftSB.setShowIndicatorEnable(false);
                        if (this.callback != null) {
                            SeekBarState[] arrseekBarState = this.getRangeSeekBarState();
                            this.callback.onRangeChanged(this, arrseekBarState[0].value, arrseekBarState[bl2].value, false);
                        }
                        if (this.getParent() != null) {
                            this.getParent().requestDisallowInterceptTouchEvent(bl2);
                        }
                        this.changeThumbActivateState(false);
                    }
                } else {
                    float f2 = this.getEventX(motionEvent);
                    if (this.seekBarMode == 2 && this.leftSB.currPercent == this.rightSB.currPercent) {
                        OnRangeChangedListener onRangeChangedListener2;
                        this.currTouchSB.materialRestore();
                        OnRangeChangedListener onRangeChangedListener3 = this.callback;
                        if (onRangeChangedListener3 != null) {
                            boolean bl4 = this.currTouchSB == this.leftSB;
                            onRangeChangedListener3.onStopTrackingTouch(this, bl4);
                        }
                        if (f2 - this.touchDownX > 0.0f) {
                            SeekBar seekBar = this.currTouchSB;
                            if (seekBar != this.rightSB) {
                                seekBar.setShowIndicatorEnable(false);
                                this.resetCurrentSeekBarThumb();
                                this.currTouchSB = this.rightSB;
                            }
                        } else {
                            SeekBar seekBar = this.currTouchSB;
                            if (seekBar != this.leftSB) {
                                seekBar.setShowIndicatorEnable(false);
                                this.resetCurrentSeekBarThumb();
                                this.currTouchSB = this.leftSB;
                            }
                        }
                        if ((onRangeChangedListener2 = this.callback) != null) {
                            boolean bl5 = this.currTouchSB == this.leftSB;
                            onRangeChangedListener2.onStartTrackingTouch(this, bl5);
                        }
                    }
                    this.scaleCurrentSeekBarThumb();
                    SeekBar seekBar = this.currTouchSB;
                    if (!(seekBar.material >= f)) {
                        f = 0.1f + this.currTouchSB.material;
                    }
                    seekBar.material = f;
                    this.touchDownX = f2;
                    this.currTouchSB.slide(this.calculateCurrentSeekBarPercent(this.touchDownX));
                    this.currTouchSB.setShowIndicatorEnable(bl2);
                    if (this.callback != null) {
                        SeekBarState[] arrseekBarState = this.getRangeSeekBarState();
                        this.callback.onRangeChanged(this, arrseekBarState[0].value, arrseekBarState[bl2].value, bl2);
                    }
                    this.invalidate();
                    if (this.getParent() != null) {
                        this.getParent().requestDisallowInterceptTouchEvent(bl2);
                    }
                    this.changeThumbActivateState(bl2);
                }
            } else {
                OnRangeChangedListener onRangeChangedListener4;
                if (this.verifyStepsMode() && this.stepsAutoBonding) {
                    float f3 = this.calculateCurrentSeekBarPercent(this.getEventX(motionEvent));
                    float f4 = f / (float)this.steps;
                    int n = new BigDecimal((double)(f3 / f4)).setScale(0, RoundingMode.HALF_UP).intValue();
                    this.currTouchSB.slide(f4 * (float)n);
                }
                if (this.seekBarMode == 2) {
                    this.rightSB.setShowIndicatorEnable(false);
                }
                this.leftSB.setShowIndicatorEnable(false);
                this.currTouchSB.materialRestore();
                this.resetCurrentSeekBarThumb();
                if (this.callback != null) {
                    SeekBarState[] arrseekBarState = this.getRangeSeekBarState();
                    this.callback.onRangeChanged(this, arrseekBarState[0].value, arrseekBarState[bl2].value, false);
                }
                if (this.getParent() != null) {
                    this.getParent().requestDisallowInterceptTouchEvent(bl2);
                }
                if ((onRangeChangedListener4 = this.callback) != null) {
                    if (this.currTouchSB != this.leftSB) {
                        bl2 = false;
                    }
                    onRangeChangedListener4.onStopTrackingTouch(this, bl2);
                }
                this.changeThumbActivateState(false);
            }
            return super.onTouchEvent(motionEvent);
        }
        this.touchDownX = this.getEventX(motionEvent);
        this.touchDownY = this.getEventY(motionEvent);
        if (this.seekBarMode == 2) {
            if (this.rightSB.currPercent >= f && this.leftSB.collide(this.getEventX(motionEvent), this.getEventY(motionEvent))) {
                this.currTouchSB = this.leftSB;
                this.scaleCurrentSeekBarThumb();
            } else if (this.rightSB.collide(this.getEventX(motionEvent), this.getEventY(motionEvent))) {
                this.currTouchSB = this.rightSB;
                this.scaleCurrentSeekBarThumb();
            } else {
                float f5 = f * (this.touchDownX - (float)this.getProgressLeft()) / (float)this.progressWidth;
                this.currTouchSB = Math.abs((float)(this.leftSB.currPercent - f5)) < Math.abs((float)(this.rightSB.currPercent - f5)) ? this.leftSB : this.rightSB;
                float f6 = this.calculateCurrentSeekBarPercent(this.touchDownX);
                this.currTouchSB.slide(f6);
            }
        } else {
            this.currTouchSB = this.leftSB;
            this.scaleCurrentSeekBarThumb();
        }
        if (this.getParent() != null) {
            this.getParent().requestDisallowInterceptTouchEvent(bl2);
        }
        if ((onRangeChangedListener = this.callback) != null) {
            SeekBar seekBar = this.currTouchSB;
            SeekBar seekBar2 = this.leftSB;
            boolean bl6 = false;
            if (seekBar == seekBar2) {
                bl6 = true;
            }
            onRangeChangedListener.onStartTrackingTouch(this, bl6);
        }
        this.changeThumbActivateState(bl2);
        return bl2;
    }

    public void setEnableThumbOverlap(boolean bl) {
        this.enableThumbOverlap = bl;
    }

    public void setEnabled(boolean bl) {
        super.setEnabled(bl);
        this.isEnable = bl;
    }

    public void setGravity(int n) {
        this.gravity = n;
    }

    public void setIndicatorText(String string2) {
        this.leftSB.setIndicatorText(string2);
        if (this.seekBarMode == 2) {
            this.rightSB.setIndicatorText(string2);
        }
    }

    public void setIndicatorTextDecimalFormat(String string2) {
        this.leftSB.setIndicatorTextDecimalFormat(string2);
        if (this.seekBarMode == 2) {
            this.rightSB.setIndicatorTextDecimalFormat(string2);
        }
    }

    public void setIndicatorTextStringFormat(String string2) {
        this.leftSB.setIndicatorTextStringFormat(string2);
        if (this.seekBarMode == 2) {
            this.rightSB.setIndicatorTextStringFormat(string2);
        }
    }

    public void setOnRangeChangedListener(OnRangeChangedListener onRangeChangedListener) {
        this.callback = onRangeChangedListener;
    }

    public void setProgress(float f) {
        this.setProgress(f, this.maxProgress);
    }

    public void setProgress(float f, float f2) {
        float f3;
        float f4;
        float f5 = Math.min((float)f, (float)f2);
        float f6 = Math.max((float)f5, (float)f2);
        float f7 = f6 - f5;
        if (f7 < (f4 = this.minInterval)) {
            f5 = f6 - f4;
        }
        if (!(f5 < (f3 = this.minProgress))) {
            float f8 = this.maxProgress;
            if (!(f6 > f8)) {
                OnRangeChangedListener onRangeChangedListener;
                float f9 = f8 - f3;
                this.leftSB.currPercent = Math.abs((float)(f5 - f3)) / f9;
                if (this.seekBarMode == 2) {
                    this.rightSB.currPercent = Math.abs((float)(f6 - this.minProgress)) / f9;
                }
                if ((onRangeChangedListener = this.callback) != null) {
                    onRangeChangedListener.onRangeChanged(this, f5, f6, false);
                }
                this.invalidate();
                return;
            }
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("setProgress() max > (preset max - offsetValue) . #max:");
            stringBuilder.append(f6);
            stringBuilder.append(" #preset max:");
            stringBuilder.append(f6);
            throw new IllegalArgumentException(stringBuilder.toString());
        }
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append("setProgress() min < (preset min - offsetValue) . #min:");
        stringBuilder.append(f5);
        stringBuilder.append(" #preset min:");
        stringBuilder.append(f6);
        throw new IllegalArgumentException(stringBuilder.toString());
    }

    public void setProgressBottom(int n) {
        this.progressBottom = n;
    }

    public void setProgressColor(int n) {
        this.progressColor = n;
    }

    public void setProgressColor(int n, int n2) {
        this.progressDefaultColor = n;
        this.progressColor = n2;
    }

    public void setProgressDefaultColor(int n) {
        this.progressDefaultColor = n;
    }

    public void setProgressDefaultDrawableId(int n) {
        this.progressDefaultDrawableId = n;
        this.progressDefaultBitmap = null;
        this.initProgressBitmap();
    }

    public void setProgressDrawableId(int n) {
        this.progressDrawableId = n;
        this.progressBitmap = null;
        this.initProgressBitmap();
    }

    public void setProgressHeight(int n) {
        this.progressHeight = n;
    }

    public void setProgressLeft(int n) {
        this.progressLeft = n;
    }

    public void setProgressRadius(float f) {
        this.progressRadius = f;
    }

    public void setProgressRight(int n) {
        this.progressRight = n;
    }

    public void setProgressTop(int n) {
        this.progressTop = n;
    }

    public void setProgressWidth(int n) {
        this.progressWidth = n;
    }

    public void setRange(float f, float f2) {
        this.setRange(f, f2, this.minInterval);
    }

    public void setRange(float f, float f2, float f3) {
        if (!(f2 <= f)) {
            if (!(f3 < 0.0f)) {
                float f4 = f2 - f;
                if (!(f3 >= f4)) {
                    this.maxProgress = f2;
                    this.minProgress = f;
                    this.minInterval = f3;
                    this.reservePercent = f3 / f4;
                    if (this.seekBarMode == 2) {
                        if (this.leftSB.currPercent + this.reservePercent <= 1.0f && this.leftSB.currPercent + this.reservePercent > this.rightSB.currPercent) {
                            this.rightSB.currPercent = this.leftSB.currPercent + this.reservePercent;
                        } else if (this.rightSB.currPercent - this.reservePercent >= 0.0f && this.rightSB.currPercent - this.reservePercent < this.leftSB.currPercent) {
                            this.leftSB.currPercent = this.rightSB.currPercent - this.reservePercent;
                        }
                    }
                    this.invalidate();
                    return;
                }
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("setRange() interval must be less than (max - min) ! #minInterval:");
                stringBuilder.append(f3);
                stringBuilder.append(" #max - min:");
                stringBuilder.append(f4);
                throw new IllegalArgumentException(stringBuilder.toString());
            }
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("setRange() interval must be greater than zero ! #minInterval:");
            stringBuilder.append(f3);
            throw new IllegalArgumentException(stringBuilder.toString());
        }
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append("setRange() max must be greater than min ! #max:");
        stringBuilder.append(f2);
        stringBuilder.append(" #min:");
        stringBuilder.append(f);
        throw new IllegalArgumentException(stringBuilder.toString());
    }

    public void setSeekBarMode(int n) {
        this.seekBarMode = n;
        SeekBar seekBar = this.rightSB;
        int n2 = 1;
        if (n == n2) {
            n2 = 0;
        }
        seekBar.setVisible((boolean)n2);
    }

    public void setSteps(int n) {
        this.steps = n;
    }

    public void setStepsAutoBonding(boolean bl) {
        this.stepsAutoBonding = bl;
    }

    public void setStepsBitmaps(List<Bitmap> list) {
        if (list != null && !list.isEmpty() && list.size() > this.steps) {
            this.stepsBitmaps.clear();
            this.stepsBitmaps.addAll(list);
            return;
        }
        throw new IllegalArgumentException("stepsBitmaps must > steps !");
    }

    public void setStepsColor(int n) {
        this.stepsColor = n;
    }

    public void setStepsDrawable(List<Integer> list) {
        IllegalArgumentException illegalArgumentException;
        if (list != null && !list.isEmpty() && list.size() > this.steps) {
            if (this.verifyStepsMode()) {
                ArrayList arrayList = new ArrayList();
                for (int i = 0; i < list.size(); ++i) {
                    arrayList.add((Object)Utils.drawableToBitmap(this.getContext(), (int)this.stepsWidth, (int)this.stepsHeight, (Integer)list.get(i)));
                }
                this.setStepsBitmaps((List<Bitmap>)arrayList);
                return;
            }
            throw new IllegalArgumentException("stepsWidth must > 0, stepsHeight must > 0,steps must > 0 First!!");
        }
        illegalArgumentException = new IllegalArgumentException("stepsDrawableIds must > steps !");
        throw illegalArgumentException;
    }

    public void setStepsDrawableId(int n) {
        this.stepsBitmaps.clear();
        this.stepsDrawableId = n;
        this.initStepsBitmap();
    }

    public void setStepsHeight(float f) {
        this.stepsHeight = f;
    }

    public void setStepsRadius(float f) {
        this.stepsRadius = f;
    }

    public void setStepsWidth(float f) {
        this.stepsWidth = f;
    }

    public void setTickMarkGravity(int n) {
        this.tickMarkGravity = n;
    }

    public void setTickMarkInRangeTextColor(int n) {
        this.tickMarkInRangeTextColor = n;
    }

    public void setTickMarkLayoutGravity(int n) {
        this.tickMarkLayoutGravity = n;
    }

    public void setTickMarkMode(int n) {
        this.tickMarkMode = n;
    }

    public void setTickMarkTextArray(CharSequence[] arrcharSequence) {
        this.tickMarkTextArray = arrcharSequence;
    }

    public void setTickMarkTextColor(int n) {
        this.tickMarkTextColor = n;
    }

    public void setTickMarkTextMargin(int n) {
        this.tickMarkTextMargin = n;
    }

    public void setTickMarkTextSize(int n) {
        this.tickMarkTextSize = n;
    }

    public void setTypeface(Typeface typeface) {
        this.paint.setTypeface(typeface);
    }

    public static class Gravity {
        public static final int BOTTOM = 1;
        public static final int CENTER = 2;
        public static final int TOP;
    }

    @Retention(value=RetentionPolicy.SOURCE)
    public static @interface GravityDef {
    }

    @Retention(value=RetentionPolicy.SOURCE)
    public static @interface SeekBarModeDef {
    }

    @Retention(value=RetentionPolicy.SOURCE)
    public static @interface TickMarkGravityDef {
    }

    @Retention(value=RetentionPolicy.SOURCE)
    public static @interface TickMarkLayoutGravityDef {
    }

    @Retention(value=RetentionPolicy.SOURCE)
    public static @interface TickMarkModeDef {
    }

}

