/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  android.content.Context
 *  android.content.res.TypedArray
 *  android.graphics.Canvas
 *  android.graphics.Paint
 *  android.graphics.Rect
 *  android.text.TextUtils
 *  android.util.AttributeSet
 *  android.view.MotionEvent
 *  android.view.View
 *  android.view.View$MeasureSpec
 *  android.view.ViewGroup
 *  android.view.ViewParent
 *  java.lang.CharSequence
 *  java.lang.Exception
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.annotation.Annotation
 *  java.lang.annotation.Retention
 *  java.lang.annotation.RetentionPolicy
 */
package com.jaygoo.widget;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewParent;
import com.jaygoo.widget.R;
import com.jaygoo.widget.RangeSeekBar;
import com.jaygoo.widget.SeekBar;
import com.jaygoo.widget.SeekBarState;
import com.jaygoo.widget.Utils;
import com.jaygoo.widget.VerticalSeekBar;
import java.lang.annotation.Annotation;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

public class VerticalRangeSeekBar
extends RangeSeekBar {
    public static final int DIRECTION_LEFT = 1;
    public static final int DIRECTION_RIGHT = 2;
    public static final int TEXT_DIRECTION_HORIZONTAL = 2;
    public static final int TEXT_DIRECTION_VERTICAL = 1;
    private int maxTickMarkWidth;
    private int orientation = 1;
    private int tickMarkDirection = 1;

    public VerticalRangeSeekBar(Context context) {
        this(context, null);
    }

    public VerticalRangeSeekBar(Context context, AttributeSet attributeSet) {
        super(context, attributeSet);
        this.initAttrs(attributeSet);
        this.initSeekBar(attributeSet);
    }

    private void initAttrs(AttributeSet attributeSet) {
        try {
            TypedArray typedArray = this.getContext().obtainStyledAttributes(attributeSet, R.styleable.VerticalRangeSeekBar);
            this.orientation = typedArray.getInt(R.styleable.VerticalRangeSeekBar_rsb_orientation, 1);
            this.tickMarkDirection = typedArray.getInt(R.styleable.VerticalRangeSeekBar_rsb_tick_mark_orientation, 1);
            typedArray.recycle();
            return;
        }
        catch (Exception exception) {
            exception.printStackTrace();
            return;
        }
    }

    @Override
    protected float getEventX(MotionEvent motionEvent) {
        if (this.orientation == 1) {
            return (float)this.getHeight() - motionEvent.getY();
        }
        return motionEvent.getY();
    }

    @Override
    protected float getEventY(MotionEvent motionEvent) {
        if (this.orientation == 1) {
            return motionEvent.getX();
        }
        return -motionEvent.getX() + (float)this.getWidth();
    }

    @Override
    public VerticalSeekBar getLeftSeekBar() {
        return (VerticalSeekBar)this.leftSB;
    }

    public int getOrientation() {
        return this.orientation;
    }

    @Override
    public VerticalSeekBar getRightSeekBar() {
        return (VerticalSeekBar)this.rightSB;
    }

    public int getTickMarkDirection() {
        return this.tickMarkDirection;
    }

    /*
     * Enabled force condition propagation
     * Lifted jumps to return sites
     */
    @Override
    protected int getTickMarkRawHeight() {
        int n;
        int n2;
        if (this.maxTickMarkWidth > 0) {
            n2 = this.getTickMarkTextMargin();
            n = this.maxTickMarkWidth;
            do {
                return n2 + n;
                break;
            } while (true);
        }
        if (this.getTickMarkTextArray() == null || this.getTickMarkTextArray().length <= 0) return 0;
        int n3 = this.getTickMarkTextArray().length;
        this.maxTickMarkWidth = Utils.measureText(String.valueOf((Object)this.getTickMarkTextArray()[0]), this.getTickMarkTextSize()).width();
        for (int i = 1; i < n3; ++i) {
            int n4 = Utils.measureText(String.valueOf((Object)this.getTickMarkTextArray()[i]), this.getTickMarkTextSize()).width();
            if (this.maxTickMarkWidth >= n4) continue;
            this.maxTickMarkWidth = n4;
        }
        n2 = this.getTickMarkTextMargin();
        n = this.maxTickMarkWidth;
        return n2 + n;
    }

    protected void initSeekBar(AttributeSet attributeSet) {
        int n = 1;
        this.leftSB = new VerticalSeekBar(this, attributeSet, (boolean)n);
        SeekBar seekBar = this.rightSB = new VerticalSeekBar(this, attributeSet, false);
        if (this.getSeekBarMode() == n) {
            n = 0;
        }
        seekBar.setVisible((boolean)n);
    }

    @Override
    protected void onDraw(Canvas canvas) {
        if (this.orientation == 1) {
            canvas.rotate(-90.0f);
            canvas.translate((float)(-this.getHeight()), 0.0f);
        } else {
            canvas.rotate(90.0f);
            canvas.translate(0.0f, (float)(-this.getWidth()));
        }
        super.onDraw(canvas);
    }

    /*
     * Unable to fully structure code
     * Enabled aggressive block sorting
     * Lifted jumps to return sites
     */
    @Override
    protected void onDrawTickMark(Canvas var1_1, Paint var2_2) {
        if (this.getTickMarkTextArray() == null) return;
        var3_3 = this.getTickMarkTextArray().length;
        var4_4 = this.getProgressWidth() / (var3_3 - 1);
        var5_5 = 0;
        while (var5_5 < var3_3) {
            block10 : {
                block13 : {
                    block11 : {
                        block12 : {
                            var6_6 = this.getTickMarkTextArray()[var5_5].toString();
                            if (TextUtils.isEmpty((CharSequence)var6_6)) break block10;
                            var2_2.getTextBounds(var6_6, 0, var6_6.length(), this.tickMarkTextRect);
                            var2_2.setColor(this.getTickMarkTextColor());
                            if (this.getTickMarkMode() != 1) break block11;
                            if (this.getTickMarkGravity() != 2) break block12;
                            var16_16 = this.getProgressLeft() + var5_5 * var4_4 - this.tickMarkTextRect.width();
                            ** GOTO lbl19
                        }
                        if (this.getTickMarkGravity() == 1) {
                            var9_9 = (float)(this.getProgressLeft() + var5_5 * var4_4) - (float)this.tickMarkTextRect.width() / 2.0f;
                        } else {
                            var16_16 = this.getProgressLeft() + var5_5 * var4_4;
lbl19: // 2 sources:
                            var9_9 = var16_16;
                        }
                        break block13;
                    }
                    var7_7 = Utils.parseFloat(var6_6);
                    var8_8 = this.getRangeSeekBarState();
                    if (Utils.compareFloat(var7_7, var8_8[0].value) != -1 && Utils.compareFloat(var7_7, var8_8[1].value) != 1 && this.getSeekBarMode() == 2) {
                        var2_2.setColor(this.getTickMarkInRangeTextColor());
                    }
                    var9_9 = (float)this.getProgressLeft() + (float)this.getProgressWidth() * (var7_7 - this.getMinProgress()) / (this.getMaxProgress() - this.getMinProgress()) - (float)this.tickMarkTextRect.width() / 2.0f;
                }
                var10_10 = this.getTickMarkLayoutGravity() == 0 ? this.getProgressTop() - this.getTickMarkTextMargin() : this.getProgressBottom() + this.getTickMarkTextMargin() + this.tickMarkTextRect.height();
                var11_11 = var10_10;
                var12_12 = var9_9 + (float)this.tickMarkTextRect.width() / 2.0f;
                var13_13 = var11_11 - (float)this.tickMarkTextRect.height() / 2.0f;
                if (this.tickMarkDirection != 1) ** GOTO lbl-1000
                var15_15 = this.orientation;
                if (var15_15 == 1) {
                    var14_14 = 90;
                } else if (var15_15 == 2) {
                    var14_14 = -90;
                } else lbl-1000: // 2 sources:
                {
                    var14_14 = 0;
                }
                if (var14_14 != 0) {
                    var1_1.rotate((float)var14_14, var12_12, var13_13);
                }
                var1_1.drawText(var6_6, var9_9, var11_11, var2_2);
                if (var14_14 != 0) {
                    var1_1.rotate((float)(-var14_14), var12_12, var13_13);
                }
            }
            ++var5_5;
        }
    }

    @Override
    protected void onMeasure(int n, int n2) {
        int n3;
        int n4 = View.MeasureSpec.getSize((int)n);
        int n5 = View.MeasureSpec.getMode((int)n);
        if (n5 == 1073741824) {
            n3 = View.MeasureSpec.makeMeasureSpec((int)n4, (int)1073741824);
        } else if (n5 == Integer.MIN_VALUE && this.getParent() instanceof ViewGroup && n4 == -1) {
            n3 = View.MeasureSpec.makeMeasureSpec((int)((ViewGroup)this.getParent()).getMeasuredHeight(), (int)Integer.MIN_VALUE);
        } else {
            int n6 = this.getGravity() == 2 ? 2 * this.getProgressTop() + this.getProgressHeight() : (int)this.getRawHeight();
            n3 = View.MeasureSpec.makeMeasureSpec((int)n6, (int)1073741824);
        }
        super.onMeasure(n3, n2);
    }

    @Override
    protected void onSizeChanged(int n, int n2, int n3, int n4) {
        super.onSizeChanged(n2, n, n4, n3);
    }

    public void setOrientation(int n) {
        this.orientation = n;
    }

    public void setTickMarkDirection(int n) {
        this.tickMarkDirection = n;
    }

    @Override
    public void setTickMarkTextArray(CharSequence[] arrcharSequence) {
        super.setTickMarkTextArray(arrcharSequence);
        this.maxTickMarkWidth = 0;
    }

    @Override
    public void setTickMarkTextSize(int n) {
        super.setTickMarkTextSize(n);
        this.maxTickMarkWidth = 0;
    }

    @Retention(value=RetentionPolicy.SOURCE)
    public static @interface DirectionDef {
    }

    @Retention(value=RetentionPolicy.SOURCE)
    public static @interface TextDirectionDef {
    }

}

