/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  android.content.Context
 *  android.content.res.ColorStateList
 *  android.content.res.Resources
 *  android.content.res.TypedArray
 *  android.graphics.drawable.ColorDrawable
 *  android.graphics.drawable.Drawable
 *  android.graphics.drawable.GradientDrawable
 *  android.os.Bundle
 *  android.os.Parcelable
 *  android.text.Editable
 *  android.text.TextUtils
 *  android.text.TextWatcher
 *  android.text.method.PasswordTransformationMethod
 *  android.text.method.TransformationMethod
 *  android.util.AttributeSet
 *  android.view.KeyEvent
 *  android.view.LayoutInflater
 *  android.view.View
 *  android.view.View$OnClickListener
 *  android.view.View$OnKeyListener
 *  android.view.ViewGroup
 *  android.view.ViewGroup$LayoutParams
 *  android.view.inputmethod.InputMethodManager
 *  android.widget.EditText
 *  android.widget.LinearLayout
 *  android.widget.LinearLayout$LayoutParams
 *  android.widget.TextView
 *  java.lang.CharSequence
 *  java.lang.Deprecated
 *  java.lang.NoSuchFieldError
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 */
package com.jungly.gridpasswordview;

import android.content.Context;
import android.content.res.ColorStateList;
import android.content.res.Resources;
import android.content.res.TypedArray;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.GradientDrawable;
import android.os.Bundle;
import android.os.Parcelable;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.text.method.PasswordTransformationMethod;
import android.text.method.TransformationMethod;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.jungly.gridpasswordview.CustomPasswordTransformationMethod;
import com.jungly.gridpasswordview.PasswordType;
import com.jungly.gridpasswordview.PasswordView;
import com.jungly.gridpasswordview.R;
import com.jungly.gridpasswordview.Util;
import com.jungly.gridpasswordview.imebugfixer.ImeDelBugFixedEditText;

public class GridPasswordView
extends LinearLayout
implements PasswordView {
    private static final int DEFAULT_GRIDCOLOR = -1;
    private static final int DEFAULT_LINECOLOR = -1433892728;
    private static final int DEFAULT_PASSWORDLENGTH = 6;
    private static final int DEFAULT_TEXTSIZE = 16;
    private static final String DEFAULT_TRANSFORMATION = "\u25cf";
    private int mGridColor;
    private ImeDelBugFixedEditText mInputView;
    private int mLineColor;
    private Drawable mLineDrawable;
    private int mLineWidth;
    private OnPasswordChangedListener mListener;
    private View.OnClickListener mOnClickListener = new View.OnClickListener(){

        public void onClick(View view) {
            GridPasswordView.this.forceInputViewGetFocus();
        }
    };
    private Drawable mOuterLineDrawable;
    private String[] mPasswordArr;
    private int mPasswordLength;
    private String mPasswordTransformation;
    private int mPasswordType;
    private ColorStateList mTextColor;
    private int mTextSize = 16;
    private PasswordTransformationMethod mTransformationMethod;
    private TextView[] mViewArr;
    private ImeDelBugFixedEditText.OnDelKeyEventListener onDelKeyEventListener = new ImeDelBugFixedEditText.OnDelKeyEventListener(){

        @Override
        public void onDeleteClick() {
            for (int i = -1 + GridPasswordView.access$100((GridPasswordView)GridPasswordView.this).length; i >= 0; --i) {
                if (GridPasswordView.this.mPasswordArr[i] != null) {
                    GridPasswordView.access$100((GridPasswordView)GridPasswordView.this)[i] = null;
                    GridPasswordView.this.mViewArr[i].setText(null);
                    GridPasswordView.this.notifyTextChanged();
                    return;
                }
                GridPasswordView.this.mViewArr[i].setText(null);
            }
        }
    };
    @Deprecated
    private View.OnKeyListener onKeyListener = new View.OnKeyListener(){

        public boolean onKey(View view, int n, KeyEvent keyEvent) {
            if (keyEvent.getAction() == 0 && keyEvent.getKeyCode() == 67) {
                GridPasswordView.this.onDelKeyEventListener.onDeleteClick();
                return true;
            }
            return false;
        }
    };
    private TextWatcher textWatcher = new TextWatcher(){

        public void afterTextChanged(Editable editable) {
        }

        public void beforeTextChanged(CharSequence charSequence, int n, int n2, int n3) {
        }

        public void onTextChanged(CharSequence charSequence, int n, int n2, int n3) {
            if (charSequence == null) {
                return;
            }
            String string2 = charSequence.toString();
            if (string2.length() == 1) {
                GridPasswordView.access$100((GridPasswordView)GridPasswordView.this)[0] = string2;
                GridPasswordView.this.notifyTextChanged();
                return;
            }
            if (string2.length() == 2) {
                String string3 = string2.substring(1);
                for (int i = 0; i < GridPasswordView.this.mPasswordArr.length; ++i) {
                    if (GridPasswordView.this.mPasswordArr[i] != null) continue;
                    GridPasswordView.access$100((GridPasswordView)GridPasswordView.this)[i] = string3;
                    GridPasswordView.this.mViewArr[i].setText((CharSequence)string3);
                    GridPasswordView.this.notifyTextChanged();
                    break;
                }
                GridPasswordView.this.mInputView.removeTextChangedListener((TextWatcher)this);
                GridPasswordView.this.mInputView.setText((CharSequence)GridPasswordView.this.mPasswordArr[0]);
                if (GridPasswordView.this.mInputView.getText().length() >= 1) {
                    GridPasswordView.this.mInputView.setSelection(1);
                }
                GridPasswordView.this.mInputView.addTextChangedListener((TextWatcher)this);
            }
        }
    };

    public GridPasswordView(Context context) {
        super(context);
        this.initViews(context);
        this.init(context, null, 0);
    }

    public GridPasswordView(Context context, AttributeSet attributeSet) {
        super(context, attributeSet);
        this.init(context, attributeSet, 0);
    }

    public GridPasswordView(Context context, AttributeSet attributeSet, int n) {
        super(context, attributeSet, n);
        this.init(context, attributeSet, n);
    }

    public GridPasswordView(Context context, AttributeSet attributeSet, int n, int n2) {
        super(context, attributeSet, n, n2);
        this.init(context, attributeSet, n);
    }

    private void forceInputViewGetFocus() {
        this.mInputView.setFocusable(true);
        this.mInputView.setFocusableInTouchMode(true);
        this.mInputView.requestFocus();
        ((InputMethodManager)this.getContext().getSystemService("input_method")).showSoftInput((View)this.mInputView, 1);
    }

    private GradientDrawable generateBackgroundDrawable() {
        GradientDrawable gradientDrawable = new GradientDrawable();
        gradientDrawable.setColor(this.mGridColor);
        gradientDrawable.setStroke(this.mLineWidth, this.mLineColor);
        return gradientDrawable;
    }

    private boolean getPassWordVisibility() {
        TransformationMethod transformationMethod = this.mViewArr[0].getTransformationMethod();
        boolean bl = false;
        if (transformationMethod == null) {
            bl = true;
        }
        return bl;
    }

    private void inflaterViews(Context context) {
        LayoutInflater layoutInflater = LayoutInflater.from((Context)context);
        layoutInflater.inflate(R.layout.gridpasswordview, (ViewGroup)this);
        this.mInputView = (ImeDelBugFixedEditText)this.findViewById(R.id.inputView);
        this.mInputView.setMaxEms(this.mPasswordLength);
        this.mInputView.addTextChangedListener(this.textWatcher);
        this.mInputView.setDelKeyEventListener(this.onDelKeyEventListener);
        this.setCustomAttr((TextView)this.mInputView);
        this.mViewArr[0] = this.mInputView;
        for (int i = 1; i < this.mPasswordLength; ++i) {
            View view = layoutInflater.inflate(R.layout.divider, null);
            LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(this.mLineWidth, -1);
            view.setBackgroundDrawable(this.mLineDrawable);
            this.addView(view, (ViewGroup.LayoutParams)layoutParams);
            TextView textView = (TextView)layoutInflater.inflate(R.layout.textview, null);
            this.setCustomAttr(textView);
            this.addView((View)textView, (ViewGroup.LayoutParams)new LinearLayout.LayoutParams(0, -1, 1.0f));
            this.mViewArr[i] = textView;
        }
        this.setOnClickListener(this.mOnClickListener);
    }

    private void init(Context context, AttributeSet attributeSet, int n) {
        this.initAttrs(context, attributeSet, n);
        this.initViews(context);
    }

    private void initAttrs(Context context, AttributeSet attributeSet, int n) {
        int n2;
        TypedArray typedArray = context.obtainStyledAttributes(attributeSet, R.styleable.gridPasswordView, n, 0);
        this.mTextColor = typedArray.getColorStateList(R.styleable.gridPasswordView_gpvTextColor);
        if (this.mTextColor == null) {
            this.mTextColor = ColorStateList.valueOf((int)this.getResources().getColor(17170435));
        }
        if ((n2 = typedArray.getDimensionPixelSize(R.styleable.gridPasswordView_gpvTextSize, -1)) != -1) {
            this.mTextSize = Util.px2sp(context, n2);
        }
        this.mLineWidth = (int)typedArray.getDimension(R.styleable.gridPasswordView_gpvLineWidth, (float)Util.dp2px(this.getContext(), 1));
        this.mLineColor = typedArray.getColor(R.styleable.gridPasswordView_gpvLineColor, -1433892728);
        this.mGridColor = typedArray.getColor(R.styleable.gridPasswordView_gpvGridColor, -1);
        this.mLineDrawable = typedArray.getDrawable(R.styleable.gridPasswordView_gpvLineColor);
        if (this.mLineDrawable == null) {
            this.mLineDrawable = new ColorDrawable(this.mLineColor);
        }
        this.mOuterLineDrawable = this.generateBackgroundDrawable();
        this.mPasswordLength = typedArray.getInt(R.styleable.gridPasswordView_gpvPasswordLength, 6);
        this.mPasswordTransformation = typedArray.getString(R.styleable.gridPasswordView_gpvPasswordTransformation);
        if (TextUtils.isEmpty((CharSequence)this.mPasswordTransformation)) {
            this.mPasswordTransformation = DEFAULT_TRANSFORMATION;
        }
        this.mPasswordType = typedArray.getInt(R.styleable.gridPasswordView_gpvPasswordType, 0);
        typedArray.recycle();
        int n3 = this.mPasswordLength;
        this.mPasswordArr = new String[n3];
        this.mViewArr = new TextView[n3];
    }

    private void initViews(Context context) {
        super.setBackgroundDrawable(this.mOuterLineDrawable);
        this.setShowDividers(0);
        this.setOrientation(0);
        this.mTransformationMethod = new CustomPasswordTransformationMethod(this.mPasswordTransformation);
        this.inflaterViews(context);
    }

    private void notifyTextChanged() {
        if (this.mListener == null) {
            return;
        }
        String string2 = this.getPassWord();
        this.mListener.onTextChanged(string2);
        if (string2.length() == this.mPasswordLength) {
            this.mListener.onInputFinish(string2);
        }
    }

    private void setCustomAttr(TextView textView) {
        ColorStateList colorStateList = this.mTextColor;
        if (colorStateList != null) {
            textView.setTextColor(colorStateList);
        }
        textView.setTextSize((float)this.mTextSize);
        int n = 18;
        int n2 = this.mPasswordType;
        if (n2 != 1) {
            if (n2 != 2) {
                if (n2 == 3) {
                    n = 225;
                }
            } else {
                n = 145;
            }
        } else {
            n = 129;
        }
        textView.setInputType(n);
        textView.setTransformationMethod((TransformationMethod)this.mTransformationMethod);
    }

    private void setError(String string2) {
        this.mInputView.setError((CharSequence)string2);
    }

    @Override
    public void clearPassword() {
        String[] arrstring;
        for (int i = 0; i < (arrstring = this.mPasswordArr).length; ++i) {
            arrstring[i] = null;
            this.mViewArr[i].setText(null);
        }
    }

    @Override
    public String getPassWord() {
        String[] arrstring;
        StringBuilder stringBuilder = new StringBuilder();
        for (int i = 0; i < (arrstring = this.mPasswordArr).length; ++i) {
            if (arrstring[i] == null) continue;
            stringBuilder.append(arrstring[i]);
        }
        return stringBuilder.toString();
    }

    protected void onRestoreInstanceState(Parcelable parcelable) {
        if (parcelable instanceof Bundle) {
            Bundle bundle = (Bundle)parcelable;
            this.mPasswordArr = bundle.getStringArray("passwordArr");
            parcelable = bundle.getParcelable("instanceState");
            this.mInputView.removeTextChangedListener(this.textWatcher);
            this.setPassword(this.getPassWord());
            this.mInputView.addTextChangedListener(this.textWatcher);
        }
        super.onRestoreInstanceState(parcelable);
    }

    protected Parcelable onSaveInstanceState() {
        Bundle bundle = new Bundle();
        bundle.putParcelable("instanceState", super.onSaveInstanceState());
        bundle.putStringArray("passwordArr", this.mPasswordArr);
        return bundle;
    }

    public void setBackground(Drawable drawable2) {
    }

    public void setBackgroundColor(int n) {
    }

    public void setBackgroundDrawable(Drawable drawable2) {
    }

    public void setBackgroundResource(int n) {
    }

    @Override
    public void setOnPasswordChangedListener(OnPasswordChangedListener onPasswordChangedListener) {
        this.mListener = onPasswordChangedListener;
    }

    @Override
    public void setPassword(String string2) {
        this.clearPassword();
        if (TextUtils.isEmpty((CharSequence)string2)) {
            return;
        }
        char[] arrc = string2.toCharArray();
        for (int i = 0; i < arrc.length; ++i) {
            String[] arrstring = this.mPasswordArr;
            if (i >= arrstring.length) continue;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append(arrc[i]);
            stringBuilder.append("");
            arrstring[i] = stringBuilder.toString();
            this.mViewArr[i].setText((CharSequence)this.mPasswordArr[i]);
        }
    }

    @Override
    public void setPasswordType(PasswordType passwordType) {
        boolean bl = this.getPassWordVisibility();
        int n = 5.$SwitchMap$com$jungly$gridpasswordview$PasswordType[passwordType.ordinal()];
        int n2 = n != 1 ? (n != 2 ? (n != 3 ? 18 : 225) : 145) : 129;
        TextView[] arrtextView = this.mViewArr;
        int n3 = arrtextView.length;
        for (int i = 0; i < n3; ++i) {
            arrtextView[i].setInputType(n2);
        }
        this.setPasswordVisibility(bl);
    }

    @Override
    public void setPasswordVisibility(boolean bl) {
        for (TextView textView : this.mViewArr) {
            PasswordTransformationMethod passwordTransformationMethod = bl ? null : this.mTransformationMethod;
            textView.setTransformationMethod((TransformationMethod)passwordTransformationMethod);
            if (!(textView instanceof EditText)) continue;
            EditText editText = (EditText)textView;
            editText.setSelection(editText.getText().length());
        }
    }

    @Override
    public void togglePasswordVisibility() {
        this.setPasswordVisibility(true ^ this.getPassWordVisibility());
    }

    public static interface OnPasswordChangedListener {
        public void onInputFinish(String var1);

        public void onTextChanged(String var1);
    }

}

