/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  android.content.Context
 *  android.content.res.Resources
 *  android.graphics.Canvas
 *  android.graphics.Color
 *  android.graphics.Paint
 *  android.graphics.Paint$Cap
 *  android.graphics.PointF
 *  android.graphics.Rect
 *  android.util.AttributeSet
 *  android.util.DisplayMetrics
 *  android.util.TypedValue
 *  android.view.View
 *  java.lang.Math
 *  java.lang.String
 *  java.util.ArrayList
 *  java.util.List
 */
package com.juntek.celiangvat.view;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PointF;
import android.graphics.Rect;
import android.util.AttributeSet;
import android.util.DisplayMetrics;
import android.util.TypedValue;
import android.view.View;
import com.juntek.celiangvat.util.TimeFormat;
import com.juntek.celiangvat.view.LineView;
import java.util.ArrayList;
import java.util.List;

public class OffLineView
extends View {
    private float blank = this.dp2px(20.0f);
    private Rect bounds = new Rect();
    private List<LineView.Data> dataList = new ArrayList();
    private int initialMin = -1;
    private Paint mCurPaint;
    private Paint mTextPaint;
    private Paint mVolPaint;
    private boolean showCUR = true;
    private boolean showVOL = true;

    public OffLineView(Context context) {
        this(context, null);
    }

    public OffLineView(Context context, AttributeSet attributeSet) {
        this(context, attributeSet, 0);
    }

    public OffLineView(Context context, AttributeSet attributeSet, int n) {
        super(context, attributeSet, n);
        this.init();
    }

    private int dp2px(float f) {
        return (int)TypedValue.applyDimension((int)1, (float)f, (DisplayMetrics)this.getResources().getDisplayMetrics());
    }

    private void drawCUR(Canvas canvas) {
        if (this.dataList.size() == 0) {
            return;
        }
        int n = this.initialMin;
        int n2 = n * 60;
        int n3 = 60 * (n + 5);
        int n4 = n3 - n2;
        PointF pointF = null;
        for (LineView.Data data : this.dataList) {
            if (data.getTime() < n2 || data.getTime() > n3 || !data.isValid()) continue;
            if (pointF == null) {
                pointF = new PointF(1.0f * (float)(data.getTime() - n2) / (float)n4 * (float)this.getWidth(), ((float)this.getHeight() - 2.0f * this.blank) * (1.0f - Math.abs((float)data.getCur())) + this.blank);
                continue;
            }
            PointF pointF2 = new PointF(1.0f * (float)(data.getTime() - n2) / (float)n4 * (float)this.getWidth(), ((float)this.getHeight() - 2.0f * this.blank) * (1.0f - Math.abs((float)data.getCur())) + this.blank);
            Paint paint = this.mCurPaint;
            String string2 = data.getCur() >= 0.0f ? "#35e74a" : "#3ffdf4";
            paint.setColor(Color.parseColor((String)string2));
            canvas.drawLine(pointF.x, pointF.y, pointF2.x, pointF2.y, this.mCurPaint);
            pointF = pointF2;
        }
    }

    private void drawText(Canvas canvas) {
        this.mTextPaint.setTextSize((float)this.dp2px(10.0f));
        int n = 0;
        while (n < 4) {
            String string2 = TimeFormat.secToLong(60 * (n + (1 + this.initialMin)));
            this.mTextPaint.getTextBounds(string2, 0, string2.length(), this.bounds);
            float f = (float)this.getWidth() / 5.0f;
            int n2 = n + 1;
            float f2 = f * (float)n2;
            float f3 = n < 0 ? 0.0f : (float)this.bounds.width() / 2.0f;
            canvas.drawText(string2, f2 - f3, (float)this.getHeight() - this.blank / 2.0f + (float)(this.bounds.height() / 2), this.mTextPaint);
            n = n2;
        }
    }

    private void drawVOL(Canvas canvas) {
        if (this.dataList.size() == 0) {
            return;
        }
        int n = this.initialMin;
        int n2 = n * 60;
        int n3 = 60 * (n + 5);
        int n4 = n3 - n2;
        PointF pointF = null;
        for (LineView.Data data : this.dataList) {
            if (data.getTime() < n2 || data.getTime() > n3 || !data.isValid()) continue;
            if (pointF == null) {
                pointF = new PointF(1.0f * (float)(data.getTime() - n2) / (float)n4 * (float)this.getWidth(), ((float)this.getHeight() - 2.0f * this.blank) * (1.0f - data.getVol()) + this.blank);
                continue;
            }
            PointF pointF2 = new PointF(1.0f * (float)(data.getTime() - n2) / (float)n4 * (float)this.getWidth(), ((float)this.getHeight() - 2.0f * this.blank) * (1.0f - data.getVol()) + this.blank);
            canvas.drawLine(pointF.x, pointF.y, pointF2.x, pointF2.y, this.mVolPaint);
            pointF = pointF2;
        }
    }

    private void init() {
        this.mTextPaint = new Paint();
        this.mTextPaint.setAntiAlias(true);
        this.mTextPaint.setColor(-1);
        this.mVolPaint = new Paint();
        this.mVolPaint.setAntiAlias(true);
        this.mVolPaint.setStrokeWidth((float)this.dp2px(2.0f));
        this.mVolPaint.setColor(Color.parseColor((String)"#f8f036"));
        this.mVolPaint.setStrokeCap(Paint.Cap.ROUND);
        this.mCurPaint = new Paint();
        this.mCurPaint.setAntiAlias(true);
        this.mCurPaint.setStrokeWidth((float)this.dp2px(2.0f));
        this.mCurPaint.setStrokeCap(Paint.Cap.ROUND);
    }

    public List<LineView.Data> getDataList() {
        return this.dataList;
    }

    public int getInitialMin() {
        return this.initialMin;
    }

    public boolean isShowCUR() {
        return this.showCUR;
    }

    public boolean isShowVOL() {
        return this.showVOL;
    }

    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        if (this.initialMin >= 0) {
            this.drawText(canvas);
        }
        if (this.showVOL) {
            this.drawVOL(canvas);
        }
        if (this.showCUR) {
            this.drawCUR(canvas);
        }
    }

    public void setDataList(List<LineView.Data> list) {
        this.dataList = list;
    }

    public void setInitialMin(int n) {
        this.initialMin = n;
    }

    public void setShowCUR(boolean bl) {
        this.showCUR = bl;
    }

    public void setShowVOL(boolean bl) {
        this.showVOL = bl;
    }
}

