/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  jxl.HeaderFooter
 *  jxl.biff.SheetRangeImpl
 */
package jxl;

import jxl.Cell;
import jxl.HeaderFooter;
import jxl.Range;
import jxl.Sheet;
import jxl.biff.SheetRangeImpl;
import jxl.common.Assert;
import jxl.format.PageOrder;
import jxl.format.PageOrientation;
import jxl.format.PaperSize;

public final class SheetSettings {
    private static final int DEFAULT_DEFAULT_COLUMN_WIDTH = 8;
    public static final int DEFAULT_DEFAULT_ROW_HEIGHT = 255;
    private static final double DEFAULT_FOOTER_MARGIN = 0.5;
    private static final double DEFAULT_HEADER_MARGIN = 0.5;
    private static final double DEFAULT_HEIGHT_MARGIN = 1.0;
    private static final int DEFAULT_NORMAL_MAGNIFICATION = 100;
    private static final PageOrder DEFAULT_ORDER;
    private static final PageOrientation DEFAULT_ORIENTATION;
    private static final int DEFAULT_PAGE_BREAK_PREVIEW_MAGNIFICATION = 60;
    private static final PaperSize DEFAULT_PAPER_SIZE;
    private static final int DEFAULT_PRINT_RESOLUTION = 300;
    private static final double DEFAULT_WIDTH_MARGIN = 0.75;
    private static final int DEFAULT_ZOOM_FACTOR = 100;
    private boolean automaticFormulaCalculation;
    private double bottomMargin;
    private int copies;
    private int defaultColumnWidth;
    private int defaultRowHeight;
    private boolean displayZeroValues;
    private int fitHeight;
    private boolean fitToPages;
    private int fitWidth;
    private HeaderFooter footer;
    private double footerMargin;
    private HeaderFooter header;
    private double headerMargin;
    private boolean hidden;
    private boolean horizontalCentre;
    private int horizontalFreeze;
    private int horizontalPrintResolution;
    private double leftMargin;
    private int normalMagnification;
    private PageOrientation orientation;
    private int pageBreakPreviewMagnification;
    private boolean pageBreakPreviewMode;
    private PageOrder pageOrder;
    private int pageStart;
    private PaperSize paperSize;
    private String password;
    private int passwordHash;
    private Range printArea;
    private boolean printGridLines;
    private boolean printHeaders;
    private Range printTitlesCol;
    private Range printTitlesRow;
    private boolean recalculateFormulasBeforeSave;
    private double rightMargin;
    private int scaleFactor;
    private boolean selected;
    private Sheet sheet;
    private boolean sheetProtected;
    private boolean showGridLines;
    private double topMargin;
    private boolean verticalCentre;
    private int verticalFreeze;
    private int verticalPrintResolution;
    private int zoomFactor;

    static {
        DEFAULT_ORIENTATION = PageOrientation.PORTRAIT;
        DEFAULT_ORDER = PageOrder.RIGHT_THEN_DOWN;
        DEFAULT_PAPER_SIZE = PaperSize.A4;
    }

    public SheetSettings(Sheet sheet) {
        this.sheet = sheet;
        this.orientation = DEFAULT_ORIENTATION;
        this.pageOrder = DEFAULT_ORDER;
        this.paperSize = DEFAULT_PAPER_SIZE;
        this.sheetProtected = false;
        this.hidden = false;
        this.selected = false;
        this.headerMargin = 0.5;
        this.footerMargin = 0.5;
        this.horizontalPrintResolution = 300;
        this.verticalPrintResolution = 300;
        this.leftMargin = 0.75;
        this.rightMargin = 0.75;
        this.topMargin = 1.0;
        this.bottomMargin = 1.0;
        this.fitToPages = false;
        this.showGridLines = true;
        this.printGridLines = false;
        this.printHeaders = false;
        this.pageBreakPreviewMode = false;
        this.displayZeroValues = true;
        this.defaultColumnWidth = 8;
        this.defaultRowHeight = 255;
        this.zoomFactor = 100;
        this.pageBreakPreviewMagnification = 60;
        this.normalMagnification = 100;
        this.horizontalFreeze = 0;
        this.verticalFreeze = 0;
        this.copies = 1;
        this.header = new HeaderFooter();
        this.footer = new HeaderFooter();
        this.automaticFormulaCalculation = true;
        this.recalculateFormulasBeforeSave = true;
    }

    public SheetSettings(SheetSettings sheetSettings, Sheet sheet) {
        boolean bl = sheetSettings != null;
        Assert.verify(bl);
        this.sheet = sheet;
        this.orientation = sheetSettings.orientation;
        this.pageOrder = sheetSettings.pageOrder;
        this.paperSize = sheetSettings.paperSize;
        this.sheetProtected = sheetSettings.sheetProtected;
        this.hidden = sheetSettings.hidden;
        this.selected = false;
        this.headerMargin = sheetSettings.headerMargin;
        this.footerMargin = sheetSettings.footerMargin;
        this.scaleFactor = sheetSettings.scaleFactor;
        this.pageStart = sheetSettings.pageStart;
        this.fitWidth = sheetSettings.fitWidth;
        this.fitHeight = sheetSettings.fitHeight;
        this.horizontalPrintResolution = sheetSettings.horizontalPrintResolution;
        this.verticalPrintResolution = sheetSettings.verticalPrintResolution;
        this.leftMargin = sheetSettings.leftMargin;
        this.rightMargin = sheetSettings.rightMargin;
        this.topMargin = sheetSettings.topMargin;
        this.bottomMargin = sheetSettings.bottomMargin;
        this.fitToPages = sheetSettings.fitToPages;
        this.password = sheetSettings.password;
        this.passwordHash = sheetSettings.passwordHash;
        this.defaultColumnWidth = sheetSettings.defaultColumnWidth;
        this.defaultRowHeight = sheetSettings.defaultRowHeight;
        this.zoomFactor = sheetSettings.zoomFactor;
        this.pageBreakPreviewMagnification = sheetSettings.pageBreakPreviewMagnification;
        this.normalMagnification = sheetSettings.normalMagnification;
        this.showGridLines = sheetSettings.showGridLines;
        this.displayZeroValues = sheetSettings.displayZeroValues;
        this.pageBreakPreviewMode = sheetSettings.pageBreakPreviewMode;
        this.horizontalFreeze = sheetSettings.horizontalFreeze;
        this.verticalFreeze = sheetSettings.verticalFreeze;
        this.horizontalCentre = sheetSettings.horizontalCentre;
        this.verticalCentre = sheetSettings.verticalCentre;
        this.copies = sheetSettings.copies;
        this.header = new HeaderFooter(sheetSettings.header);
        this.footer = new HeaderFooter(sheetSettings.footer);
        this.automaticFormulaCalculation = sheetSettings.automaticFormulaCalculation;
        this.recalculateFormulasBeforeSave = sheetSettings.recalculateFormulasBeforeSave;
        if (sheetSettings.printArea != null) {
            SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, sheetSettings.getPrintArea().getTopLeft().getColumn(), sheetSettings.getPrintArea().getTopLeft().getRow(), sheetSettings.getPrintArea().getBottomRight().getColumn(), sheetSettings.getPrintArea().getBottomRight().getRow());
            this.printArea = sheetRangeImpl;
        }
        if (sheetSettings.printTitlesRow != null) {
            SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, sheetSettings.getPrintTitlesRow().getTopLeft().getColumn(), sheetSettings.getPrintTitlesRow().getTopLeft().getRow(), sheetSettings.getPrintTitlesRow().getBottomRight().getColumn(), sheetSettings.getPrintTitlesRow().getBottomRight().getRow());
            this.printTitlesRow = sheetRangeImpl;
        }
        if (sheetSettings.printTitlesCol != null) {
            SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, sheetSettings.getPrintTitlesCol().getTopLeft().getColumn(), sheetSettings.getPrintTitlesCol().getTopLeft().getRow(), sheetSettings.getPrintTitlesCol().getBottomRight().getColumn(), sheetSettings.getPrintTitlesCol().getBottomRight().getRow());
            this.printTitlesCol = sheetRangeImpl;
        }
    }

    public boolean getAutomaticFormulaCalculation() {
        return this.automaticFormulaCalculation;
    }

    public double getBottomMargin() {
        return this.bottomMargin;
    }

    public int getCopies() {
        return this.copies;
    }

    public int getDefaultColumnWidth() {
        return this.defaultColumnWidth;
    }

    public double getDefaultHeightMargin() {
        return 1.0;
    }

    public int getDefaultRowHeight() {
        return this.defaultRowHeight;
    }

    public double getDefaultWidthMargin() {
        return 0.75;
    }

    public boolean getDisplayZeroValues() {
        return this.displayZeroValues;
    }

    public int getFitHeight() {
        return this.fitHeight;
    }

    public boolean getFitToPages() {
        return this.fitToPages;
    }

    public int getFitWidth() {
        return this.fitWidth;
    }

    public HeaderFooter getFooter() {
        return this.footer;
    }

    public double getFooterMargin() {
        return this.footerMargin;
    }

    public HeaderFooter getHeader() {
        return this.header;
    }

    public double getHeaderMargin() {
        return this.headerMargin;
    }

    public int getHorizontalFreeze() {
        return this.horizontalFreeze;
    }

    public int getHorizontalPrintResolution() {
        return this.horizontalPrintResolution;
    }

    public double getLeftMargin() {
        return this.leftMargin;
    }

    public int getNormalMagnification() {
        return this.normalMagnification;
    }

    public PageOrientation getOrientation() {
        return this.orientation;
    }

    public int getPageBreakPreviewMagnification() {
        return this.pageBreakPreviewMagnification;
    }

    public boolean getPageBreakPreviewMode() {
        return this.pageBreakPreviewMode;
    }

    public PageOrder getPageOrder() {
        return this.pageOrder;
    }

    public int getPageStart() {
        return this.pageStart;
    }

    public PaperSize getPaperSize() {
        return this.paperSize;
    }

    public String getPassword() {
        return this.password;
    }

    public int getPasswordHash() {
        return this.passwordHash;
    }

    public Range getPrintArea() {
        return this.printArea;
    }

    public boolean getPrintGridLines() {
        return this.printGridLines;
    }

    public boolean getPrintHeaders() {
        return this.printHeaders;
    }

    public Range getPrintTitlesCol() {
        return this.printTitlesCol;
    }

    public Range getPrintTitlesRow() {
        return this.printTitlesRow;
    }

    public boolean getRecalculateFormulasBeforeSave() {
        return this.recalculateFormulasBeforeSave;
    }

    public double getRightMargin() {
        return this.rightMargin;
    }

    public int getScaleFactor() {
        return this.scaleFactor;
    }

    public boolean getShowGridLines() {
        return this.showGridLines;
    }

    public double getTopMargin() {
        return this.topMargin;
    }

    public int getVerticalFreeze() {
        return this.verticalFreeze;
    }

    public int getVerticalPrintResolution() {
        return this.verticalPrintResolution;
    }

    public int getZoomFactor() {
        return this.zoomFactor;
    }

    public boolean isHidden() {
        return this.hidden;
    }

    public boolean isHorizontalCentre() {
        return this.horizontalCentre;
    }

    public boolean isProtected() {
        return this.sheetProtected;
    }

    public boolean isSelected() {
        return this.selected;
    }

    public boolean isVerticalCentre() {
        return this.verticalCentre;
    }

    public void setAutomaticFormulaCalculation(boolean bl) {
        this.automaticFormulaCalculation = bl;
    }

    public void setBottomMargin(double d) {
        this.bottomMargin = d;
    }

    public void setCopies(int n) {
        this.copies = n;
    }

    public void setDefaultColumnWidth(int n) {
        this.defaultColumnWidth = n;
    }

    public void setDefaultRowHeight(int n) {
        this.defaultRowHeight = n;
    }

    public void setDisplayZeroValues(boolean bl) {
        this.displayZeroValues = bl;
    }

    public void setFitHeight(int n) {
        this.fitHeight = n;
        this.fitToPages = true;
    }

    public void setFitToPages(boolean bl) {
        this.fitToPages = bl;
    }

    public void setFitWidth(int n) {
        this.fitWidth = n;
        this.fitToPages = true;
    }

    public void setFooter(HeaderFooter headerFooter) {
        this.footer = headerFooter;
    }

    public void setFooterMargin(double d) {
        this.footerMargin = d;
    }

    public void setHeader(HeaderFooter headerFooter) {
        this.header = headerFooter;
    }

    public void setHeaderMargin(double d) {
        this.headerMargin = d;
    }

    public void setHidden(boolean bl) {
        this.hidden = bl;
    }

    public void setHorizontalCentre(boolean bl) {
        this.horizontalCentre = bl;
    }

    public void setHorizontalFreeze(int n) {
        this.horizontalFreeze = Math.max((int)n, (int)0);
    }

    public void setHorizontalPrintResolution(int n) {
        this.horizontalPrintResolution = n;
    }

    public void setLeftMargin(double d) {
        this.leftMargin = d;
    }

    public void setNormalMagnification(int n) {
        this.normalMagnification = n;
    }

    public void setOrientation(PageOrientation pageOrientation) {
        this.orientation = pageOrientation;
    }

    public void setPageBreakPreviewMagnification(int n) {
        this.pageBreakPreviewMagnification = n;
    }

    public void setPageBreakPreviewMode(boolean bl) {
        this.pageBreakPreviewMode = bl;
    }

    public void setPageOrder(PageOrder pageOrder) {
        this.pageOrder = pageOrder;
    }

    public void setPageStart(int n) {
        this.pageStart = n;
    }

    public void setPaperSize(PaperSize paperSize) {
        this.paperSize = paperSize;
    }

    public void setPassword(String string2) {
        this.password = string2;
    }

    public void setPasswordHash(int n) {
        this.passwordHash = n;
    }

    public void setPrintArea(int n, int n2, int n3, int n4) {
        SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, n, n2, n3, n4);
        this.printArea = sheetRangeImpl;
    }

    public void setPrintGridLines(boolean bl) {
        this.printGridLines = bl;
    }

    public void setPrintHeaders(boolean bl) {
        this.printHeaders = bl;
    }

    public void setPrintTitles(int n, int n2, int n3, int n4) {
        this.setPrintTitlesRow(n, n2);
        this.setPrintTitlesCol(n3, n4);
    }

    public void setPrintTitlesCol(int n, int n2) {
        SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, n, 0, n2, 65535);
        this.printTitlesCol = sheetRangeImpl;
    }

    public void setPrintTitlesRow(int n, int n2) {
        SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, 0, n, 255, n2);
        this.printTitlesRow = sheetRangeImpl;
    }

    public void setProtected(boolean bl) {
        this.sheetProtected = bl;
    }

    public void setRecalculateFormulasBeforeSave(boolean bl) {
        this.recalculateFormulasBeforeSave = bl;
    }

    public void setRightMargin(double d) {
        this.rightMargin = d;
    }

    public void setScaleFactor(int n) {
        this.scaleFactor = n;
        this.fitToPages = false;
    }

    public void setSelected() {
        this.setSelected(true);
    }

    public void setSelected(boolean bl) {
        this.selected = bl;
    }

    public void setShowGridLines(boolean bl) {
        this.showGridLines = bl;
    }

    public void setTopMargin(double d) {
        this.topMargin = d;
    }

    public void setVerticalCentre(boolean bl) {
        this.verticalCentre = bl;
    }

    public void setVerticalFreeze(int n) {
        this.verticalFreeze = Math.max((int)n, (int)0);
    }

    public void setVerticalPrintResolution(int n) {
        this.verticalPrintResolution = n;
    }

    public void setZoomFactor(int n) {
        this.zoomFactor = n;
    }
}

