/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.File
 *  java.io.FileInputStream
 *  java.io.FileOutputStream
 *  java.io.IOException
 *  java.io.InputStream
 *  java.io.OutputStream
 *  java.lang.IndexOutOfBoundsException
 *  java.lang.Object
 *  java.lang.String
 *  jxl.read.biff.BiffException
 *  jxl.read.biff.PasswordException
 *  jxl.read.biff.WorkbookParser
 *  jxl.write.biff.WritableWorkbookImpl
 */
package jxl;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import jxl.Cell;
import jxl.Range;
import jxl.Sheet;
import jxl.WorkbookSettings;
import jxl.read.biff.BiffException;
import jxl.read.biff.File;
import jxl.read.biff.PasswordException;
import jxl.read.biff.WorkbookParser;
import jxl.write.WritableWorkbook;
import jxl.write.biff.WritableWorkbookImpl;

public abstract class Workbook {
    private static final String VERSION = "2.6.12";

    protected Workbook() {
    }

    public static WritableWorkbook createWorkbook(java.io.File file) throws IOException {
        return Workbook.createWorkbook(file, new WorkbookSettings());
    }

    public static WritableWorkbook createWorkbook(java.io.File file, Workbook workbook) throws IOException {
        return Workbook.createWorkbook(file, workbook, new WorkbookSettings());
    }

    public static WritableWorkbook createWorkbook(java.io.File file, Workbook workbook, WorkbookSettings workbookSettings) throws IOException {
        return new WritableWorkbookImpl((OutputStream)new FileOutputStream(file), workbook, true, workbookSettings);
    }

    public static WritableWorkbook createWorkbook(java.io.File file, WorkbookSettings workbookSettings) throws IOException {
        return new WritableWorkbookImpl((OutputStream)new FileOutputStream(file), true, workbookSettings);
    }

    public static WritableWorkbook createWorkbook(OutputStream outputStream) throws IOException {
        return Workbook.createWorkbook(outputStream, new WorkbookSettings());
    }

    public static WritableWorkbook createWorkbook(OutputStream outputStream, Workbook workbook) throws IOException {
        return Workbook.createWorkbook(outputStream, workbook, ((WorkbookParser)workbook).getSettings());
    }

    public static WritableWorkbook createWorkbook(OutputStream outputStream, Workbook workbook, WorkbookSettings workbookSettings) throws IOException {
        return new WritableWorkbookImpl(outputStream, workbook, false, workbookSettings);
    }

    public static WritableWorkbook createWorkbook(OutputStream outputStream, WorkbookSettings workbookSettings) throws IOException {
        return new WritableWorkbookImpl(outputStream, false, workbookSettings);
    }

    public static String getVersion() {
        return VERSION;
    }

    public static Workbook getWorkbook(java.io.File file) throws IOException, BiffException {
        return Workbook.getWorkbook(file, new WorkbookSettings());
    }

    public static Workbook getWorkbook(java.io.File file, WorkbookSettings workbookSettings) throws IOException, BiffException {
        File file2;
        FileInputStream fileInputStream = new FileInputStream(file);
        try {
            file2 = new File((InputStream)fileInputStream, workbookSettings);
        }
        catch (BiffException biffException) {
            fileInputStream.close();
            throw biffException;
        }
        catch (IOException iOException) {
            fileInputStream.close();
            throw iOException;
        }
        fileInputStream.close();
        WorkbookParser workbookParser = new WorkbookParser(file2, workbookSettings);
        workbookParser.parse();
        return workbookParser;
    }

    public static Workbook getWorkbook(InputStream inputStream) throws IOException, BiffException {
        return Workbook.getWorkbook(inputStream, new WorkbookSettings());
    }

    public static Workbook getWorkbook(InputStream inputStream, WorkbookSettings workbookSettings) throws IOException, BiffException {
        WorkbookParser workbookParser = new WorkbookParser(new File(inputStream, workbookSettings), workbookSettings);
        workbookParser.parse();
        return workbookParser;
    }

    public abstract void close();

    public abstract Range[] findByName(String var1);

    public abstract Cell findCellByName(String var1);

    public abstract Cell getCell(String var1);

    public abstract int getNumberOfSheets();

    public abstract String[] getRangeNames();

    public abstract Sheet getSheet(int var1) throws IndexOutOfBoundsException;

    public abstract Sheet getSheet(String var1);

    public abstract String[] getSheetNames();

    public abstract Sheet[] getSheets();

    public abstract boolean isProtected();

    protected abstract void parse() throws BiffException, PasswordException;
}

