/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.File
 *  java.lang.Boolean
 *  java.lang.Object
 *  java.lang.SecurityException
 *  java.lang.String
 *  java.lang.System
 *  java.lang.Throwable
 *  java.util.HashMap
 *  java.util.Locale
 */
package jxl;

import java.io.File;
import java.util.HashMap;
import java.util.Locale;
import jxl.biff.CountryCode;
import jxl.biff.formula.FunctionNames;
import jxl.common.Logger;

public final class WorkbookSettings {
    private static final int DEFAULT_ARRAY_GROW_SIZE = 1048576;
    private static final int DEFAULT_INITIAL_FILE_SIZE = 5242880;
    public static final int HIDEOBJ_HIDE_ALL = 2;
    public static final int HIDEOBJ_SHOW_ALL = 0;
    public static final int HIDEOBJ_SHOW_PLACEHOLDERS = 1;
    private static Logger logger = Logger.getLogger(WorkbookSettings.class);
    private int arrayGrowSize = 1048576;
    private boolean autoFilterDisabled;
    private boolean cellValidationDisabled;
    private int characterSet;
    private boolean drawingsDisabled;
    private String encoding;
    private boolean excel9file = false;
    private String excelDisplayLanguage = CountryCode.USA.getCode();
    private String excelRegionalSettings = CountryCode.UK.getCode();
    private boolean formulaReferenceAdjustDisabled;
    private FunctionNames functionNames;
    private boolean gcDisabled;
    private int hideobj = 0;
    private boolean ignoreBlankCells;
    private int initialFileSize = 5242880;
    private Locale locale;
    private HashMap localeFunctionNames = new HashMap();
    private boolean mergedCellCheckingDisabled;
    private boolean namesDisabled;
    private boolean propertySetsDisabled;
    private boolean rationalizationDisabled;
    private boolean refreshAll = false;
    private boolean template = false;
    private File temporaryFileDuringWriteDirectory;
    private boolean useTemporaryFileDuringWrite;
    private boolean windowProtected = false;
    private String writeAccess;

    /*
     * Enabled aggressive block sorting
     * Enabled unnecessary exception pruning
     * Enabled aggressive exception aggregation
     */
    public WorkbookSettings() {
        try {
            this.setSuppressWarnings(Boolean.getBoolean((String)"jxl.nowarnings"));
            this.drawingsDisabled = Boolean.getBoolean((String)"jxl.nodrawings");
            this.namesDisabled = Boolean.getBoolean((String)"jxl.nonames");
            this.gcDisabled = Boolean.getBoolean((String)"jxl.nogc");
            this.rationalizationDisabled = Boolean.getBoolean((String)"jxl.norat");
            this.mergedCellCheckingDisabled = Boolean.getBoolean((String)"jxl.nomergedcellchecks");
            this.formulaReferenceAdjustDisabled = Boolean.getBoolean((String)"jxl.noformulaadjust");
            this.propertySetsDisabled = Boolean.getBoolean((String)"jxl.nopropertysets");
            this.ignoreBlankCells = Boolean.getBoolean((String)"jxl.ignoreblanks");
            this.cellValidationDisabled = Boolean.getBoolean((String)"jxl.nocellvalidation");
            boolean bl = Boolean.getBoolean((String)"jxl.autofilter");
            boolean bl2 = false;
            if (!bl) {
                bl2 = true;
            }
            this.autoFilterDisabled = bl2;
            this.useTemporaryFileDuringWrite = Boolean.getBoolean((String)"jxl.usetemporaryfileduringwrite");
            String string2 = System.getProperty((String)"jxl.temporaryfileduringwritedirectory");
            if (string2 != null) {
                this.temporaryFileDuringWriteDirectory = new File(string2);
            }
            this.encoding = System.getProperty((String)"file.encoding");
        }
        catch (SecurityException securityException) {
            logger.warn("Error accessing system properties.", securityException);
        }
        try {
            this.locale = System.getProperty((String)"jxl.lang") != null && System.getProperty((String)"jxl.country") != null ? new Locale(System.getProperty((String)"jxl.lang"), System.getProperty((String)"jxl.country")) : Locale.getDefault();
            if (System.getProperty((String)"jxl.encoding") == null) return;
            this.encoding = System.getProperty((String)"jxl.encoding");
            return;
        }
        catch (SecurityException securityException) {
            logger.warn("Error accessing system properties.", securityException);
            this.locale = Locale.getDefault();
        }
    }

    public int getArrayGrowSize() {
        return this.arrayGrowSize;
    }

    public boolean getAutoFilterDisabled() {
        return this.autoFilterDisabled;
    }

    public boolean getCellValidationDisabled() {
        return this.cellValidationDisabled;
    }

    public int getCharacterSet() {
        return this.characterSet;
    }

    public boolean getDrawingsDisabled() {
        return this.drawingsDisabled;
    }

    public String getEncoding() {
        return this.encoding;
    }

    public boolean getExcel9File() {
        return this.excel9file;
    }

    public String getExcelDisplayLanguage() {
        return this.excelDisplayLanguage;
    }

    public String getExcelRegionalSettings() {
        return this.excelRegionalSettings;
    }

    public boolean getFormulaAdjust() {
        return true ^ this.formulaReferenceAdjustDisabled;
    }

    public FunctionNames getFunctionNames() {
        if (this.functionNames == null) {
            this.functionNames = (FunctionNames)this.localeFunctionNames.get((Object)this.locale);
            if (this.functionNames == null) {
                this.functionNames = new FunctionNames(this.locale);
                this.localeFunctionNames.put((Object)this.locale, (Object)this.functionNames);
            }
        }
        return this.functionNames;
    }

    public boolean getGCDisabled() {
        return this.gcDisabled;
    }

    public int getHideobj() {
        return this.hideobj;
    }

    public boolean getIgnoreBlanks() {
        return this.ignoreBlankCells;
    }

    public int getInitialFileSize() {
        return this.initialFileSize;
    }

    public Locale getLocale() {
        return this.locale;
    }

    public boolean getMergedCellCheckingDisabled() {
        return this.mergedCellCheckingDisabled;
    }

    public boolean getNamesDisabled() {
        return this.namesDisabled;
    }

    public boolean getPropertySetsDisabled() {
        return this.propertySetsDisabled;
    }

    public boolean getRationalizationDisabled() {
        return this.rationalizationDisabled;
    }

    public boolean getRefreshAll() {
        return this.refreshAll;
    }

    public boolean getTemplate() {
        return this.template;
    }

    public File getTemporaryFileDuringWriteDirectory() {
        return this.temporaryFileDuringWriteDirectory;
    }

    public boolean getUseTemporaryFileDuringWrite() {
        return this.useTemporaryFileDuringWrite;
    }

    public boolean getWindowProtected() {
        return this.windowProtected;
    }

    public String getWriteAccess() {
        return this.writeAccess;
    }

    public void setArrayGrowSize(int n) {
        this.arrayGrowSize = n;
    }

    public void setAutoFilterDisabled(boolean bl) {
        this.autoFilterDisabled = bl;
    }

    public void setCellValidationDisabled(boolean bl) {
        this.cellValidationDisabled = bl;
    }

    public void setCharacterSet(int n) {
        this.characterSet = n;
    }

    public void setDrawingsDisabled(boolean bl) {
        this.drawingsDisabled = bl;
    }

    public void setEncoding(String string2) {
        this.encoding = string2;
    }

    public void setExcel9File(boolean bl) {
        this.excel9file = bl;
    }

    public void setExcelDisplayLanguage(String string2) {
        this.excelDisplayLanguage = string2;
    }

    public void setExcelRegionalSettings(String string2) {
        this.excelRegionalSettings = string2;
    }

    public void setFormulaAdjust(boolean bl) {
        this.formulaReferenceAdjustDisabled = bl ^ true;
    }

    public void setGCDisabled(boolean bl) {
        this.gcDisabled = bl;
    }

    public void setHideobj(int n) {
        this.hideobj = n;
    }

    public void setIgnoreBlanks(boolean bl) {
        this.ignoreBlankCells = bl;
    }

    public void setInitialFileSize(int n) {
        this.initialFileSize = n;
    }

    public void setLocale(Locale locale) {
        this.locale = locale;
    }

    public void setMergedCellChecking(boolean bl) {
        this.mergedCellCheckingDisabled = bl ^ true;
    }

    public void setNamesDisabled(boolean bl) {
        this.namesDisabled = bl;
    }

    public void setPropertySets(boolean bl) {
        this.propertySetsDisabled = bl ^ true;
    }

    public void setRationalization(boolean bl) {
        this.rationalizationDisabled = bl ^ true;
    }

    public void setRefreshAll(boolean bl) {
        this.refreshAll = bl;
    }

    public void setSuppressWarnings(boolean bl) {
        logger.setSuppressWarnings(bl);
    }

    public void setTemplate(boolean bl) {
        this.template = bl;
    }

    public void setTemporaryFileDuringWriteDirectory(File file) {
        this.temporaryFileDuringWriteDirectory = file;
    }

    public void setUseTemporaryFileDuringWrite(boolean bl) {
        this.useTemporaryFileDuringWrite = bl;
    }

    public void setWindowProtected(boolean bl) {
        this.windowProtected = this.windowProtected;
    }

    public void setWriteAccess(String string2) {
        this.writeAccess = string2;
    }
}

