/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.util.Collection
 *  jxl.biff.DataValiditySettingsRecord
 *  jxl.biff.SheetRangeImpl
 *  jxl.biff.drawing.ComboBox
 *  jxl.biff.drawing.Comment
 *  jxl.write.biff.CellValue
 *  jxl.write.biff.WritableSheetImpl
 */
package jxl.biff;

import java.util.Collection;
import jxl.Cell;
import jxl.CellReferenceHelper;
import jxl.Range;
import jxl.Sheet;
import jxl.biff.DVParser;
import jxl.biff.DataValiditySettingsRecord;
import jxl.biff.SheetRangeImpl;
import jxl.biff.drawing.ComboBox;
import jxl.biff.drawing.Comment;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.write.biff.CellValue;
import jxl.write.biff.WritableSheetImpl;

public class BaseCellFeatures {
    public static final ValidationCondition BETWEEN;
    public static final ValidationCondition EQUAL;
    public static final ValidationCondition GREATER_EQUAL;
    public static final ValidationCondition GREATER_THAN;
    public static final ValidationCondition LESS_EQUAL;
    public static final ValidationCondition LESS_THAN;
    public static final ValidationCondition NOT_BETWEEN;
    public static final ValidationCondition NOT_EQUAL;
    private static final double defaultCommentHeight = 4.0;
    private static final double defaultCommentWidth = 3.0;
    public static Logger logger;
    private ComboBox comboBox;
    private String comment;
    private Comment commentDrawing;
    private double commentHeight;
    private double commentWidth;
    private boolean dataValidation;
    private boolean dropDown;
    private DVParser dvParser;
    private DataValiditySettingsRecord validationSettings;
    private CellValue writableCell;

    static {
        logger = Logger.getLogger(BaseCellFeatures.class);
        BETWEEN = new ValidationCondition(DVParser.BETWEEN);
        NOT_BETWEEN = new ValidationCondition(DVParser.NOT_BETWEEN);
        EQUAL = new ValidationCondition(DVParser.EQUAL);
        NOT_EQUAL = new ValidationCondition(DVParser.NOT_EQUAL);
        GREATER_THAN = new ValidationCondition(DVParser.GREATER_THAN);
        LESS_THAN = new ValidationCondition(DVParser.LESS_THAN);
        GREATER_EQUAL = new ValidationCondition(DVParser.GREATER_EQUAL);
        LESS_EQUAL = new ValidationCondition(DVParser.LESS_EQUAL);
    }

    protected BaseCellFeatures() {
    }

    public BaseCellFeatures(BaseCellFeatures baseCellFeatures) {
        this.comment = baseCellFeatures.comment;
        this.commentWidth = baseCellFeatures.commentWidth;
        this.commentHeight = baseCellFeatures.commentHeight;
        this.dropDown = baseCellFeatures.dropDown;
        this.dataValidation = baseCellFeatures.dataValidation;
        this.validationSettings = baseCellFeatures.validationSettings;
        DVParser dVParser = baseCellFeatures.dvParser;
        if (dVParser != null) {
            this.dvParser = new DVParser(dVParser);
        }
    }

    private void clearValidationSettings() {
        this.validationSettings = null;
        this.dvParser = null;
        this.dropDown = false;
        this.comboBox = null;
        this.dataValidation = false;
    }

    protected String getComment() {
        return this.comment;
    }

    public final Comment getCommentDrawing() {
        return this.commentDrawing;
    }

    public double getCommentHeight() {
        return this.commentHeight;
    }

    public double getCommentWidth() {
        return this.commentWidth;
    }

    public DVParser getDVParser() {
        DVParser dVParser = this.dvParser;
        if (dVParser != null) {
            return dVParser;
        }
        DataValiditySettingsRecord dataValiditySettingsRecord = this.validationSettings;
        if (dataValiditySettingsRecord != null) {
            this.dvParser = new DVParser(dataValiditySettingsRecord.getDVParser());
            return this.dvParser;
        }
        return null;
    }

    public String getDataValidationList() {
        DataValiditySettingsRecord dataValiditySettingsRecord = this.validationSettings;
        if (dataValiditySettingsRecord == null) {
            return null;
        }
        return dataValiditySettingsRecord.getValidationFormula();
    }

    public Range getSharedDataValidationRange() {
        if (!this.dataValidation) {
            return null;
        }
        DVParser dVParser = this.getDVParser();
        SheetRangeImpl sheetRangeImpl = new SheetRangeImpl((Sheet)this.writableCell.getSheet(), dVParser.getFirstColumn(), dVParser.getFirstRow(), dVParser.getLastColumn(), dVParser.getLastRow());
        return sheetRangeImpl;
    }

    public boolean hasDataValidation() {
        return this.dataValidation;
    }

    public boolean hasDropDown() {
        return this.dropDown;
    }

    public void removeComment() {
        this.comment = null;
        Comment comment = this.commentDrawing;
        if (comment != null) {
            this.writableCell.removeComment(comment);
            this.commentDrawing = null;
        }
    }

    public void removeDataValidation() {
        if (!this.dataValidation) {
            return;
        }
        DVParser dVParser = this.getDVParser();
        if (dVParser.extendedCellsValidation()) {
            Logger logger = BaseCellFeatures.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Cannot remove data validation from ");
            stringBuilder.append(CellReferenceHelper.getCellReference((Cell)this.writableCell));
            stringBuilder.append(" as it is part of the shared reference ");
            stringBuilder.append(CellReferenceHelper.getCellReference(dVParser.getFirstColumn(), dVParser.getFirstRow()));
            stringBuilder.append("-");
            stringBuilder.append(CellReferenceHelper.getCellReference(dVParser.getLastColumn(), dVParser.getLastRow()));
            logger.warn(stringBuilder.toString());
            return;
        }
        this.writableCell.removeDataValidation();
        this.clearValidationSettings();
    }

    public void removeSharedDataValidation() {
        if (!this.dataValidation) {
            return;
        }
        this.writableCell.removeDataValidation();
        this.clearValidationSettings();
    }

    public void setComboBox(ComboBox comboBox) {
        this.comboBox = comboBox;
    }

    public void setComment(String string2) {
        this.setComment(string2, 3.0, 4.0);
    }

    public void setComment(String string2, double d, double d2) {
        this.comment = string2;
        this.commentWidth = d;
        this.commentHeight = d2;
        Comment comment = this.commentDrawing;
        if (comment != null) {
            comment.setCommentText(string2);
            this.commentDrawing.setWidth(d);
            this.commentDrawing.setWidth(d2);
        }
    }

    public final void setCommentDrawing(Comment comment) {
        this.commentDrawing = comment;
    }

    public void setDataValidationList(Collection collection) {
        if (this.dataValidation && this.getDVParser().extendedCellsValidation()) {
            Logger logger = BaseCellFeatures.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Cannot set data validation on ");
            stringBuilder.append(CellReferenceHelper.getCellReference((Cell)this.writableCell));
            stringBuilder.append(" as it is part of a shared data validation");
            logger.warn(stringBuilder.toString());
            return;
        }
        this.clearValidationSettings();
        this.dvParser = new DVParser(collection);
        this.dropDown = true;
        this.dataValidation = true;
    }

    public void setDataValidationRange(int n, int n2, int n3, int n4) {
        if (this.dataValidation && this.getDVParser().extendedCellsValidation()) {
            Logger logger = BaseCellFeatures.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Cannot set data validation on ");
            stringBuilder.append(CellReferenceHelper.getCellReference((Cell)this.writableCell));
            stringBuilder.append(" as it is part of a shared data validation");
            logger.warn(stringBuilder.toString());
            return;
        }
        this.clearValidationSettings();
        this.dvParser = new DVParser(n, n2, n3, n4);
        this.dropDown = true;
        this.dataValidation = true;
    }

    public void setDataValidationRange(String string2) {
        if (this.dataValidation && this.getDVParser().extendedCellsValidation()) {
            Logger logger = BaseCellFeatures.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Cannot set data validation on ");
            stringBuilder.append(CellReferenceHelper.getCellReference((Cell)this.writableCell));
            stringBuilder.append(" as it is part of a shared data validation");
            logger.warn(stringBuilder.toString());
            return;
        }
        this.clearValidationSettings();
        this.dvParser = new DVParser(string2);
        this.dropDown = true;
        this.dataValidation = true;
    }

    public void setNumberValidation(double d, double d2, ValidationCondition validationCondition) {
        DVParser dVParser;
        if (this.dataValidation && this.getDVParser().extendedCellsValidation()) {
            Logger logger = BaseCellFeatures.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Cannot set data validation on ");
            stringBuilder.append(CellReferenceHelper.getCellReference((Cell)this.writableCell));
            stringBuilder.append(" as it is part of a shared data validation");
            logger.warn(stringBuilder.toString());
            return;
        }
        this.clearValidationSettings();
        this.dvParser = dVParser = new DVParser(d, d2, validationCondition.getCondition());
        this.dropDown = false;
        this.dataValidation = true;
    }

    public void setNumberValidation(double d, ValidationCondition validationCondition) {
        DVParser dVParser;
        if (this.dataValidation && this.getDVParser().extendedCellsValidation()) {
            Logger logger = BaseCellFeatures.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Cannot set data validation on ");
            stringBuilder.append(CellReferenceHelper.getCellReference((Cell)this.writableCell));
            stringBuilder.append(" as it is part of a shared data validation");
            logger.warn(stringBuilder.toString());
            return;
        }
        this.clearValidationSettings();
        this.dvParser = dVParser = new DVParser(d, Double.NaN, validationCondition.getCondition());
        this.dropDown = false;
        this.dataValidation = true;
    }

    public void setReadComment(String string2, double d, double d2) {
        this.comment = string2;
        this.commentWidth = d;
        this.commentHeight = d2;
    }

    public void setValidationSettings(DataValiditySettingsRecord dataValiditySettingsRecord) {
        boolean bl = dataValiditySettingsRecord != null;
        Assert.verify(bl);
        this.validationSettings = dataValiditySettingsRecord;
        this.dataValidation = true;
    }

    public final void setWritableCell(CellValue cellValue) {
        this.writableCell = cellValue;
    }

    public void shareDataValidation(BaseCellFeatures baseCellFeatures) {
        if (this.dataValidation) {
            Logger logger = BaseCellFeatures.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Attempting to share a data validation on cell ");
            stringBuilder.append(CellReferenceHelper.getCellReference((Cell)this.writableCell));
            stringBuilder.append(" which already has a data validation");
            logger.warn(stringBuilder.toString());
            return;
        }
        this.clearValidationSettings();
        this.dvParser = baseCellFeatures.getDVParser();
        this.validationSettings = null;
        this.dataValidation = true;
        this.dropDown = baseCellFeatures.dropDown;
        this.comboBox = baseCellFeatures.comboBox;
    }

    protected static class ValidationCondition {
        private static ValidationCondition[] types = new ValidationCondition[0];
        private DVParser.Condition condition;

        ValidationCondition(DVParser.Condition condition) {
            this.condition = condition;
            ValidationCondition[] arrvalidationCondition = types;
            types = new ValidationCondition[1 + arrvalidationCondition.length];
            System.arraycopy((Object)arrvalidationCondition, (int)0, (Object)types, (int)0, (int)arrvalidationCondition.length);
            ValidationCondition.types[arrvalidationCondition.length] = this;
        }

        public DVParser.Condition getCondition() {
            return this.condition;
        }
    }

}

