/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Double
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuffer
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.text.DecimalFormat
 *  java.text.MessageFormat
 *  java.util.Collection
 *  java.util.Iterator
 *  jxl.biff.EmptyCell
 *  jxl.biff.formula.FormulaException
 */
package jxl.biff;

import java.text.DecimalFormat;
import java.text.MessageFormat;
import java.util.Collection;
import java.util.Iterator;
import jxl.Cell;
import jxl.WorkbookSettings;
import jxl.biff.CellReferenceHelper;
import jxl.biff.EmptyCell;
import jxl.biff.IntegerHelper;
import jxl.biff.StringHelper;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.FormulaParser;
import jxl.biff.formula.ParseContext;
import jxl.common.Assert;
import jxl.common.Logger;

public class DVParser {
    public static final DVType ANY;
    public static final Condition BETWEEN;
    public static final DVType DATE;
    public static final DVType DECIMAL;
    private static DecimalFormat DECIMAL_FORMAT;
    private static final int EMPTY_CELLS_ALLOWED_MASK = 256;
    public static final Condition EQUAL;
    public static final DVType FORMULA;
    public static final Condition GREATER_EQUAL;
    public static final Condition GREATER_THAN;
    public static final ErrorStyle INFO;
    public static final DVType INTEGER;
    public static final Condition LESS_EQUAL;
    public static final Condition LESS_THAN;
    public static final DVType LIST;
    private static final int MAX_COLUMNS = 255;
    private static final int MAX_ROWS = 65535;
    private static final int MAX_VALIDATION_LIST_LENGTH = 254;
    public static final Condition NOT_BETWEEN;
    public static final Condition NOT_EQUAL;
    private static final int SHOW_ERROR_MASK = 524288;
    private static final int SHOW_PROMPT_MASK = 262144;
    public static final ErrorStyle STOP;
    private static final int STRING_LIST_GIVEN_MASK = 128;
    private static final int SUPPRESS_ARROW_MASK = 512;
    public static final DVType TEXT_LENGTH;
    public static final DVType TIME;
    public static final ErrorStyle WARNING;
    private static Logger logger;
    private int column1;
    private int column2;
    private Condition condition;
    private boolean copied;
    private boolean emptyCellsAllowed;
    private ErrorStyle errorStyle;
    private String errorText;
    private String errorTitle;
    private boolean extendedCellsValidation;
    private FormulaParser formula1;
    private String formula1String;
    private FormulaParser formula2;
    private String formula2String;
    private String promptText;
    private String promptTitle;
    private int row1;
    private int row2;
    private boolean showError;
    private boolean showPrompt;
    private boolean stringListGiven;
    private boolean suppressArrow;
    private DVType type;

    static {
        logger = Logger.getLogger(DVParser.class);
        ANY = new DVType(0, "any");
        INTEGER = new DVType(1, "int");
        DECIMAL = new DVType(2, "dec");
        LIST = new DVType(3, "list");
        DATE = new DVType(4, "date");
        TIME = new DVType(5, "time");
        TEXT_LENGTH = new DVType(6, "strlen");
        FORMULA = new DVType(7, "form");
        STOP = new ErrorStyle(0);
        WARNING = new ErrorStyle(1);
        INFO = new ErrorStyle(2);
        BETWEEN = new Condition(0, "{0} <= x <= {1}");
        NOT_BETWEEN = new Condition(1, "!({0} <= x <= {1}");
        EQUAL = new Condition(2, "x == {0}");
        NOT_EQUAL = new Condition(3, "x != {0}");
        GREATER_THAN = new Condition(4, "x > {0}");
        LESS_THAN = new Condition(5, "x < {0}");
        GREATER_EQUAL = new Condition(6, "x >= {0}");
        LESS_EQUAL = new Condition(7, "x <= {0}");
        DECIMAL_FORMAT = new DecimalFormat("#.#");
    }

    public DVParser(double d, double d2, Condition condition) {
        this.copied = false;
        this.type = DECIMAL;
        this.errorStyle = STOP;
        this.condition = condition;
        this.extendedCellsValidation = false;
        this.stringListGiven = false;
        this.emptyCellsAllowed = true;
        this.suppressArrow = false;
        this.showPrompt = true;
        this.showError = true;
        this.promptTitle = "\u0000";
        this.errorTitle = "\u0000";
        this.promptText = "\u0000";
        this.errorText = "\u0000";
        this.formula1String = DECIMAL_FORMAT.format(d);
        if (!Double.isNaN((double)d2)) {
            this.formula2String = DECIMAL_FORMAT.format(d2);
        }
    }

    public DVParser(int n, int n2, int n3, int n4) {
        this.copied = false;
        this.type = LIST;
        this.errorStyle = STOP;
        this.condition = BETWEEN;
        this.extendedCellsValidation = false;
        this.stringListGiven = false;
        this.emptyCellsAllowed = true;
        this.suppressArrow = false;
        this.showPrompt = true;
        this.showError = true;
        this.promptTitle = "\u0000";
        this.errorTitle = "\u0000";
        this.promptText = "\u0000";
        this.errorText = "\u0000";
        StringBuffer stringBuffer = new StringBuffer();
        CellReferenceHelper.getCellReference(n, n2, stringBuffer);
        stringBuffer.append(':');
        CellReferenceHelper.getCellReference(n3, n4, stringBuffer);
        this.formula1String = stringBuffer.toString();
    }

    public DVParser(String string2) {
        if (string2.length() == 0) {
            this.copied = false;
            this.type = FORMULA;
            this.errorStyle = STOP;
            this.condition = EQUAL;
            this.extendedCellsValidation = false;
            this.stringListGiven = false;
            this.emptyCellsAllowed = false;
            this.suppressArrow = false;
            this.showPrompt = true;
            this.showError = true;
            this.promptTitle = "\u0000";
            this.errorTitle = "\u0000";
            this.promptText = "\u0000";
            this.errorText = "\u0000";
            this.formula1String = "\"\"";
            return;
        }
        this.copied = false;
        this.type = LIST;
        this.errorStyle = STOP;
        this.condition = BETWEEN;
        this.extendedCellsValidation = false;
        this.stringListGiven = false;
        this.emptyCellsAllowed = true;
        this.suppressArrow = false;
        this.showPrompt = true;
        this.showError = true;
        this.promptTitle = "\u0000";
        this.errorTitle = "\u0000";
        this.promptText = "\u0000";
        this.errorText = "\u0000";
        this.formula1String = string2;
    }

    public DVParser(Collection collection) {
        this.copied = false;
        this.type = LIST;
        this.errorStyle = STOP;
        this.condition = BETWEEN;
        this.extendedCellsValidation = false;
        this.stringListGiven = true;
        this.emptyCellsAllowed = true;
        this.suppressArrow = false;
        this.showPrompt = true;
        this.showError = true;
        this.promptTitle = "\u0000";
        this.errorTitle = "\u0000";
        this.promptText = "\u0000";
        this.errorText = "\u0000";
        if (collection.size() == 0) {
            logger.warn("no validation strings - ignoring");
        }
        Iterator iterator = collection.iterator();
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append(iterator.next().toString());
        while (iterator.hasNext()) {
            stringBuffer.append('\u0000');
            stringBuffer.append(' ');
            stringBuffer.append(iterator.next().toString());
        }
        if (stringBuffer.length() > 254) {
            logger.warn("Validation list exceeds maximum number of characters - truncating");
            stringBuffer.delete(254, stringBuffer.length());
        }
        stringBuffer.insert(0, '\"');
        stringBuffer.append('\"');
        this.formula1String = stringBuffer.toString();
    }

    /*
     * Enabled aggressive block sorting
     * Enabled unnecessary exception pruning
     * Enabled aggressive exception aggregation
     */
    public DVParser(DVParser dVParser) {
        String string2;
        this.copied = true;
        this.type = dVParser.type;
        this.errorStyle = dVParser.errorStyle;
        this.condition = dVParser.condition;
        this.stringListGiven = dVParser.stringListGiven;
        this.emptyCellsAllowed = dVParser.emptyCellsAllowed;
        this.suppressArrow = dVParser.suppressArrow;
        this.showPrompt = dVParser.showPrompt;
        this.showError = dVParser.showError;
        this.promptTitle = dVParser.promptTitle;
        this.promptText = dVParser.promptText;
        this.errorTitle = dVParser.errorTitle;
        this.errorText = dVParser.errorText;
        this.extendedCellsValidation = dVParser.extendedCellsValidation;
        this.row1 = dVParser.row1;
        this.row2 = dVParser.row2;
        this.column1 = dVParser.column1;
        this.column2 = dVParser.column2;
        String string3 = dVParser.formula1String;
        if (string3 != null) {
            this.formula1String = string3;
            this.formula2String = dVParser.formula2String;
            return;
        }
        try {
            this.formula1String = dVParser.formula1.getFormula();
            string2 = dVParser.formula2 != null ? dVParser.formula2.getFormula() : null;
        }
        catch (FormulaException formulaException) {
            Logger logger = DVParser.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Cannot parse validation formula:  ");
            stringBuilder.append(formulaException.getMessage());
            logger.warn(stringBuilder.toString());
            return;
        }
        this.formula2String = string2;
    }

    /*
     * Unable to fully structure code
     * Enabled aggressive block sorting
     * Enabled unnecessary exception pruning
     * Enabled aggressive exception aggregation
     * Lifted jumps to return sites
     */
    public DVParser(byte[] var1_1, ExternalSheet var2_2, WorkbookMethods var3_3, WorkbookSettings var4_4) {
        block15 : {
            block14 : {
                block13 : {
                    super();
                    var5_5 = 1;
                    var6_6 = var3_3 != null;
                    Assert.verify(var6_6);
                    this.copied = false;
                    var7_7 = IntegerHelper.getInt(var1_1[0], var1_1[var5_5], var1_1[2], var1_1[3]);
                    this.type = DVType.getType(var7_7 & 15);
                    this.errorStyle = ErrorStyle.getErrorStyle((var7_7 & 112) >> 4);
                    this.condition = Condition.getCondition((15728640 & var7_7) >> 20);
                    var8_8 = (var7_7 & 128) != 0;
                    this.stringListGiven = var8_8;
                    var9_9 = (var7_7 & 256) != 0;
                    this.emptyCellsAllowed = var9_9;
                    var10_10 = (var7_7 & 512) != 0;
                    this.suppressArrow = var10_10;
                    var11_11 = (262144 & var7_7) != 0;
                    this.showPrompt = var11_11;
                    var12_12 = (var7_7 & 524288) != 0;
                    this.showError = var12_12;
                    var13_13 = IntegerHelper.getInt(var1_1[4], var1_1[5]);
                    var14_14 = 7;
                    if (var13_13 > 0 && var1_1[6] == 0) {
                        this.promptTitle = StringHelper.getString(var1_1, var13_13, var14_14, var4_4);
                        var14_14 = 4 + (var13_13 + 3);
                    } else if (var13_13 > 0) {
                        this.promptTitle = StringHelper.getUnicodeString(var1_1, var13_13, var14_14);
                        var14_14 = 4 + (3 + var13_13 * 2);
                    }
                    var15_15 = IntegerHelper.getInt(var1_1[var14_14], var1_1[var14_14 + 1]);
                    if (var15_15 <= 0 || var1_1[var14_14 + 2] != 0) break block13;
                    this.errorTitle = StringHelper.getString(var1_1, var15_15, var14_14 + 3, var4_4);
                    ** GOTO lbl37
                }
                if (var15_15 > 0) {
                    this.errorTitle = StringHelper.getUnicodeString(var1_1, var15_15, var14_14 + 3);
                    var15_15 *= 2;
lbl37: // 2 sources:
                    var16_16 = var14_14 + (var15_15 + 3);
                } else {
                    var16_16 = var14_14 + 3;
                }
                var17_17 = IntegerHelper.getInt(var1_1[var16_16], var1_1[var16_16 + 1]);
                if (var17_17 <= 0 || var1_1[var16_16 + 2] != 0) break block14;
                this.promptText = StringHelper.getString(var1_1, var17_17, var16_16 + 3, var4_4);
                ** GOTO lbl48
            }
            if (var17_17 > 0) {
                this.promptText = StringHelper.getUnicodeString(var1_1, var17_17, var16_16 + 3);
                var17_17 *= 2;
lbl48: // 2 sources:
                var18_18 = var16_16 + (var17_17 + 3);
            } else {
                var18_18 = var16_16 + 3;
            }
            var19_19 = IntegerHelper.getInt(var1_1[var18_18], var1_1[var18_18 + 1]);
            if (var19_19 <= 0 || var1_1[var18_18 + 2] != 0) break block15;
            this.errorText = StringHelper.getString(var1_1, var19_19, var18_18 + 3, var4_4);
            ** GOTO lbl59
        }
        if (var19_19 > 0) {
            this.errorText = StringHelper.getUnicodeString(var1_1, var19_19, var18_18 + 3);
            var19_19 *= 2;
lbl59: // 2 sources:
            var20_20 = var18_18 + (var19_19 + 3);
        } else {
            var20_20 = var18_18 + 3;
        }
        var21_21 = IntegerHelper.getInt(var1_1[var20_20], var1_1[var20_20 + 1]);
        var22_22 = var20_20 + 4;
        var23_23 = var22_22 + var21_21;
        var24_24 = IntegerHelper.getInt(var1_1[var23_23], var1_1[var23_23 + 1]);
        var25_25 = var23_23 + 4;
        var26_26 = 2 + (var25_25 + var24_24);
        this.row1 = IntegerHelper.getInt(var1_1[var26_26], var1_1[var26_26 + 1]);
        var27_27 = var26_26 + 2;
        this.row2 = IntegerHelper.getInt(var1_1[var27_27], var1_1[var27_27 + 1]);
        var28_28 = var27_27 + 2;
        this.column1 = IntegerHelper.getInt(var1_1[var28_28], var1_1[var28_28 + 1]);
        var29_29 = var28_28 + 2;
        this.column2 = IntegerHelper.getInt(var1_1[var29_29], var1_1[var29_29 + var5_5]);
        if (this.row1 == this.row2 && this.column1 == this.column2) {
            var5_5 = 0;
        }
        this.extendedCellsValidation = var5_5;
        try {
            var30_30 = new EmptyCell(this.column1, this.row1);
            if (var21_21 != 0) {
                var39_31 = new byte[var21_21];
                System.arraycopy((Object)var1_1, (int)var22_22, (Object)var39_31, (int)0, (int)var21_21);
                this.formula1 = var40_32 = new FormulaParser(var39_31, (Cell)var30_30, var2_2, var3_3, var4_4, ParseContext.DATA_VALIDATION);
                this.formula1.parse();
            }
            if (var24_24 == 0) return;
            var41_33 = new byte[var24_24];
            System.arraycopy((Object)var1_1, (int)var25_25, (Object)var41_33, (int)0, (int)var24_24);
            this.formula2 = var42_34 = new FormulaParser(var41_33, (Cell)var30_30, var2_2, var3_3, var4_4, ParseContext.DATA_VALIDATION);
            this.formula2.parse();
            return;
        }
        catch (FormulaException var31_35) {
            var32_36 = DVParser.logger;
            var33_37 = new StringBuilder();
            var33_37.append(var31_35.getMessage());
            var33_37.append(" for cells ");
            var33_37.append(CellReferenceHelper.getCellReference(this.column1, this.row1));
            var33_37.append("-");
            var33_37.append(CellReferenceHelper.getCellReference(this.column2, this.row2));
            var32_36.warn(var33_37.toString());
        }
    }

    public boolean copied() {
        return this.copied;
    }

    public void extendCellValidation(int n, int n2) {
        this.row2 = n2 + this.row1;
        this.column2 = n + this.column1;
        this.extendedCellsValidation = true;
    }

    public boolean extendedCellsValidation() {
        return this.extendedCellsValidation;
    }

    public byte[] getData() {
        FormulaParser formulaParser = this.formula1;
        byte[] arrby = formulaParser != null ? formulaParser.getBytes() : new byte[0];
        FormulaParser formulaParser2 = this.formula2;
        byte[] arrby2 = formulaParser2 != null ? formulaParser2.getBytes() : new byte[0];
        byte[] arrby3 = new byte[10 + (4 + (2 + (2 + (3 + (3 + (3 + (3 + (4 + 2 * this.promptTitle.length()) + 2 * this.errorTitle.length()) + 2 * this.promptText.length()) + 2 * this.errorText.length()) + arrby.length) + arrby2.length)))];
        int n = 0 | this.type.getValue() | this.errorStyle.getValue() << 4 | this.condition.getValue() << 20;
        if (this.stringListGiven) {
            n |= 128;
        }
        if (this.emptyCellsAllowed) {
            n |= 256;
        }
        if (this.suppressArrow) {
            n |= 512;
        }
        if (this.showPrompt) {
            n |= 262144;
        }
        if (this.showError) {
            n |= 524288;
        }
        IntegerHelper.getFourBytes(n, arrby3, 0);
        IntegerHelper.getTwoBytes(this.promptTitle.length(), arrby3, 4);
        arrby3[6] = 1;
        StringHelper.getUnicodeBytes(this.promptTitle, arrby3, 7);
        int n2 = 7 + 2 * this.promptTitle.length();
        IntegerHelper.getTwoBytes(this.errorTitle.length(), arrby3, n2);
        int n3 = n2 + 2;
        arrby3[n3] = 1;
        int n4 = n3 + 1;
        StringHelper.getUnicodeBytes(this.errorTitle, arrby3, n4);
        int n5 = n4 + 2 * this.errorTitle.length();
        IntegerHelper.getTwoBytes(this.promptText.length(), arrby3, n5);
        int n6 = n5 + 2;
        arrby3[n6] = 1;
        int n7 = n6 + 1;
        StringHelper.getUnicodeBytes(this.promptText, arrby3, n7);
        int n8 = n7 + 2 * this.promptText.length();
        IntegerHelper.getTwoBytes(this.errorText.length(), arrby3, n8);
        int n9 = n8 + 2;
        arrby3[n9] = 1;
        int n10 = n9 + 1;
        StringHelper.getUnicodeBytes(this.errorText, arrby3, n10);
        int n11 = n10 + 2 * this.errorText.length();
        IntegerHelper.getTwoBytes(arrby.length, arrby3, n11);
        int n12 = n11 + 4;
        System.arraycopy((Object)arrby, (int)0, (Object)arrby3, (int)n12, (int)arrby.length);
        int n13 = n12 + arrby.length;
        IntegerHelper.getTwoBytes(arrby2.length, arrby3, n13);
        int n14 = n13 + 4;
        System.arraycopy((Object)arrby2, (int)0, (Object)arrby3, (int)n14, (int)arrby2.length);
        int n15 = n14 + arrby2.length;
        IntegerHelper.getTwoBytes(1, arrby3, n15);
        int n16 = n15 + 2;
        IntegerHelper.getTwoBytes(this.row1, arrby3, n16);
        int n17 = n16 + 2;
        IntegerHelper.getTwoBytes(this.row2, arrby3, n17);
        int n18 = n17 + 2;
        IntegerHelper.getTwoBytes(this.column1, arrby3, n18);
        int n19 = n18 + 2;
        IntegerHelper.getTwoBytes(this.column2, arrby3, n19);
        return arrby3;
    }

    public int getFirstColumn() {
        return this.column1;
    }

    public int getFirstRow() {
        return this.row1;
    }

    public int getLastColumn() {
        return this.column2;
    }

    public int getLastRow() {
        return this.row2;
    }

    String getValidationFormula() throws FormulaException {
        if (this.type == LIST) {
            return this.formula1.getFormula();
        }
        String string2 = this.formula1.getFormula();
        FormulaParser formulaParser = this.formula2;
        String string3 = formulaParser != null ? formulaParser.getFormula() : null;
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(this.condition.getConditionString(string2, string3));
        stringBuilder.append("; x ");
        stringBuilder.append(this.type.getDescription());
        return stringBuilder.toString();
    }

    public void insertColumn(int n) {
        FormulaParser formulaParser;
        int n2;
        int n3;
        FormulaParser formulaParser2 = this.formula1;
        if (formulaParser2 != null) {
            formulaParser2.columnInserted(0, n, true);
        }
        if ((formulaParser = this.formula2) != null) {
            formulaParser.columnInserted(0, n, true);
        }
        if ((n3 = this.column1) >= n) {
            this.column1 = n3 + 1;
        }
        if ((n2 = this.column2) >= n && n2 != 255) {
            this.column2 = n2 + 1;
        }
    }

    public void insertRow(int n) {
        FormulaParser formulaParser;
        int n2;
        int n3;
        FormulaParser formulaParser2 = this.formula1;
        if (formulaParser2 != null) {
            formulaParser2.rowInserted(0, n, true);
        }
        if ((formulaParser = this.formula2) != null) {
            formulaParser.rowInserted(0, n, true);
        }
        if ((n3 = this.row1) >= n) {
            this.row1 = n3 + 1;
        }
        if ((n2 = this.row2) >= n && n2 != 65535) {
            this.row2 = n2 + 1;
        }
    }

    public void removeColumn(int n) {
        FormulaParser formulaParser;
        int n2;
        int n3;
        FormulaParser formulaParser2 = this.formula1;
        if (formulaParser2 != null) {
            formulaParser2.columnRemoved(0, n, true);
        }
        if ((formulaParser = this.formula2) != null) {
            formulaParser.columnRemoved(0, n, true);
        }
        if ((n3 = this.column1) > n) {
            this.column1 = n3 - 1;
        }
        if ((n2 = this.column2) >= n && n2 != 255) {
            this.column2 = n2 - 1;
        }
    }

    public void removeRow(int n) {
        FormulaParser formulaParser;
        int n2;
        int n3;
        FormulaParser formulaParser2 = this.formula1;
        if (formulaParser2 != null) {
            formulaParser2.rowRemoved(0, n, true);
        }
        if ((formulaParser = this.formula2) != null) {
            formulaParser.rowRemoved(0, n, true);
        }
        if ((n3 = this.row1) > n) {
            this.row1 = n3 - 1;
        }
        if ((n2 = this.row2) >= n) {
            this.row2 = n2 - 1;
        }
    }

    public void setCell(int n, int n2, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings) throws FormulaException {
        FormulaParser formulaParser;
        if (this.extendedCellsValidation) {
            return;
        }
        this.row1 = n2;
        this.row2 = n2;
        this.column1 = n;
        this.column2 = n;
        this.formula1 = formulaParser = new FormulaParser(this.formula1String, externalSheet, workbookMethods, workbookSettings, ParseContext.DATA_VALIDATION);
        this.formula1.parse();
        String string2 = this.formula2String;
        if (string2 != null) {
            FormulaParser formulaParser2;
            this.formula2 = formulaParser2 = new FormulaParser(string2, externalSheet, workbookMethods, workbookSettings, ParseContext.DATA_VALIDATION);
            this.formula2.parse();
        }
    }

    public static class Condition {
        private static Condition[] types = new Condition[0];
        private MessageFormat format;
        private int value;

        Condition(int n, String string2) {
            this.value = n;
            this.format = new MessageFormat(string2);
            Condition[] arrcondition = types;
            types = new Condition[1 + arrcondition.length];
            System.arraycopy((Object)arrcondition, (int)0, (Object)types, (int)0, (int)arrcondition.length);
            Condition.types[arrcondition.length] = this;
        }

        static Condition getCondition(int n) {
            Condition[] arrcondition;
            Condition condition = null;
            for (int i = 0; i < (arrcondition = types).length && condition == null; ++i) {
                if (arrcondition[i].value != n) continue;
                condition = arrcondition[i];
            }
            return condition;
        }

        public String getConditionString(String string2, String string3) {
            return this.format.format((Object)new String[]{string2, string3});
        }

        public int getValue() {
            return this.value;
        }
    }

    public static class DVType {
        private static DVType[] types = new DVType[0];
        private String desc;
        private int value;

        DVType(int n, String string2) {
            this.value = n;
            this.desc = string2;
            DVType[] arrdVType = types;
            types = new DVType[1 + arrdVType.length];
            System.arraycopy((Object)arrdVType, (int)0, (Object)types, (int)0, (int)arrdVType.length);
            DVType.types[arrdVType.length] = this;
        }

        static DVType getType(int n) {
            DVType[] arrdVType;
            DVType dVType = null;
            for (int i = 0; i < (arrdVType = types).length && dVType == null; ++i) {
                if (arrdVType[i].value != n) continue;
                dVType = arrdVType[i];
            }
            return dVType;
        }

        public String getDescription() {
            return this.desc;
        }

        public int getValue() {
            return this.value;
        }
    }

    public static class ErrorStyle {
        private static ErrorStyle[] types = new ErrorStyle[0];
        private int value;

        ErrorStyle(int n) {
            this.value = n;
            ErrorStyle[] arrerrorStyle = types;
            types = new ErrorStyle[1 + arrerrorStyle.length];
            System.arraycopy((Object)arrerrorStyle, (int)0, (Object)types, (int)0, (int)arrerrorStyle.length);
            ErrorStyle.types[arrerrorStyle.length] = this;
        }

        static ErrorStyle getErrorStyle(int n) {
            ErrorStyle[] arrerrorStyle;
            ErrorStyle errorStyle = null;
            for (int i = 0; i < (arrerrorStyle = types).length && errorStyle == null; ++i) {
                if (arrerrorStyle[i].value != n) continue;
                errorStyle = arrerrorStyle[i];
            }
            return errorStyle;
        }

        public int getValue() {
            return this.value;
        }
    }

}

