/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.IOException
 *  java.lang.Object
 *  java.util.ArrayList
 *  java.util.Collection
 *  java.util.Iterator
 *  java.util.List
 *  jxl.biff.DataValidityListRecord
 *  jxl.biff.DataValiditySettingsRecord
 */
package jxl.biff;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import jxl.WorkbookSettings;
import jxl.biff.ByteData;
import jxl.biff.DValParser;
import jxl.biff.DataValidityListRecord;
import jxl.biff.DataValiditySettingsRecord;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ExternalSheet;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.write.biff.File;

public class DataValidation {
    public static final int DEFAULT_OBJECT_ID = -1;
    private static final int MAX_NO_OF_VALIDITY_SETTINGS = 65533;
    private static Logger logger = Logger.getLogger(DataValidation.class);
    private int comboBoxObjectId;
    private boolean copied;
    private ExternalSheet externalSheet;
    private DataValidityListRecord validityList;
    private ArrayList validitySettings;
    private WorkbookMethods workbook;
    private WorkbookSettings workbookSettings;

    public DataValidation(int n, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings) {
        this.workbook = workbookMethods;
        this.externalSheet = externalSheet;
        this.workbookSettings = workbookSettings;
        this.validitySettings = new ArrayList();
        this.comboBoxObjectId = n;
        this.copied = false;
    }

    public DataValidation(DataValidation dataValidation, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings) {
        this.workbook = workbookMethods;
        this.externalSheet = externalSheet;
        this.workbookSettings = workbookSettings;
        this.copied = true;
        this.validityList = new DataValidityListRecord(dataValidation.getDataValidityList());
        this.validitySettings = new ArrayList();
        DataValiditySettingsRecord[] arrdataValiditySettingsRecord = dataValidation.getDataValiditySettings();
        for (int i = 0; i < arrdataValiditySettingsRecord.length; ++i) {
            this.validitySettings.add((Object)new DataValiditySettingsRecord(arrdataValiditySettingsRecord[i], this.externalSheet, this.workbook, this.workbookSettings));
        }
    }

    public DataValidation(DataValidityListRecord dataValidityListRecord) {
        this.validityList = dataValidityListRecord;
        this.validitySettings = new ArrayList(this.validityList.getNumberOfSettings());
        this.copied = false;
    }

    public void add(DataValiditySettingsRecord dataValiditySettingsRecord) {
        this.validitySettings.add((Object)dataValiditySettingsRecord);
        dataValiditySettingsRecord.setDataValidation(this);
        if (this.copied) {
            boolean bl = this.validityList != null;
            Assert.verify(bl);
            this.validityList.dvAdded();
        }
    }

    public int getComboBoxObjectId() {
        return this.comboBoxObjectId;
    }

    public DataValidityListRecord getDataValidityList() {
        return this.validityList;
    }

    public DataValiditySettingsRecord getDataValiditySettings(int n, int n2) {
        Iterator iterator = this.validitySettings.iterator();
        boolean bl = false;
        DataValiditySettingsRecord dataValiditySettingsRecord = null;
        while (iterator.hasNext() && !bl) {
            DataValiditySettingsRecord dataValiditySettingsRecord2 = (DataValiditySettingsRecord)iterator.next();
            if (dataValiditySettingsRecord2.getFirstColumn() != n || dataValiditySettingsRecord2.getFirstRow() != n2) continue;
            bl = true;
            dataValiditySettingsRecord = dataValiditySettingsRecord2;
        }
        return dataValiditySettingsRecord;
    }

    public DataValiditySettingsRecord[] getDataValiditySettings() {
        Object[] arrobject = new DataValiditySettingsRecord[]{};
        return (DataValiditySettingsRecord[])this.validitySettings.toArray(arrobject);
    }

    public void insertColumn(int n) {
        Iterator iterator = this.validitySettings.iterator();
        while (iterator.hasNext()) {
            ((DataValiditySettingsRecord)iterator.next()).insertColumn(n);
        }
    }

    public void insertRow(int n) {
        Iterator iterator = this.validitySettings.iterator();
        while (iterator.hasNext()) {
            ((DataValiditySettingsRecord)iterator.next()).insertRow(n);
        }
    }

    public void removeColumn(int n) {
        Iterator iterator = this.validitySettings.iterator();
        while (iterator.hasNext()) {
            DataValiditySettingsRecord dataValiditySettingsRecord = (DataValiditySettingsRecord)iterator.next();
            if (dataValiditySettingsRecord.getFirstColumn() == n && dataValiditySettingsRecord.getLastColumn() == n) {
                iterator.remove();
                this.validityList.dvRemoved();
                continue;
            }
            dataValiditySettingsRecord.removeColumn(n);
        }
    }

    public void removeDataValidation(int n, int n2) {
        Iterator iterator = this.validitySettings.iterator();
        while (iterator.hasNext()) {
            DataValiditySettingsRecord dataValiditySettingsRecord = (DataValiditySettingsRecord)iterator.next();
            if (dataValiditySettingsRecord.getFirstColumn() != n || dataValiditySettingsRecord.getLastColumn() != n || dataValiditySettingsRecord.getFirstRow() != n2 || dataValiditySettingsRecord.getLastRow() != n2) continue;
            iterator.remove();
            this.validityList.dvRemoved();
            break;
        }
    }

    public void removeRow(int n) {
        Iterator iterator = this.validitySettings.iterator();
        while (iterator.hasNext()) {
            DataValiditySettingsRecord dataValiditySettingsRecord = (DataValiditySettingsRecord)iterator.next();
            if (dataValiditySettingsRecord.getFirstRow() == n && dataValiditySettingsRecord.getLastRow() == n) {
                iterator.remove();
                this.validityList.dvRemoved();
                continue;
            }
            dataValiditySettingsRecord.removeRow(n);
        }
    }

    public void removeSharedDataValidation(int n, int n2, int n3, int n4) {
        Iterator iterator = this.validitySettings.iterator();
        while (iterator.hasNext()) {
            DataValiditySettingsRecord dataValiditySettingsRecord = (DataValiditySettingsRecord)iterator.next();
            if (dataValiditySettingsRecord.getFirstColumn() != n || dataValiditySettingsRecord.getLastColumn() != n3 || dataValiditySettingsRecord.getFirstRow() != n2 || dataValiditySettingsRecord.getLastRow() != n4) continue;
            iterator.remove();
            this.validityList.dvRemoved();
            break;
        }
    }

    public void write(File file) throws IOException {
        if (this.validitySettings.size() > 65533) {
            logger.warn("Maximum number of data validations exceeded - truncating...");
            this.validitySettings = new ArrayList((Collection)this.validitySettings.subList(0, 65532));
            int n = this.validitySettings.size();
            boolean bl = false;
            if (n <= 65533) {
                bl = true;
            }
            Assert.verify(bl);
        }
        if (this.validityList == null) {
            this.validityList = new DataValidityListRecord(new DValParser(this.comboBoxObjectId, this.validitySettings.size()));
        }
        if (!this.validityList.hasDVRecords()) {
            return;
        }
        file.write((ByteData)this.validityList);
        Iterator iterator = this.validitySettings.iterator();
        while (iterator.hasNext()) {
            file.write((ByteData)((DataValiditySettingsRecord)iterator.next()));
        }
    }
}

