/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 */
package jxl.biff;

import jxl.WorkbookSettings;
import jxl.biff.DVParser;
import jxl.biff.DataValidation;
import jxl.biff.Type;
import jxl.biff.WorkbookMethods;
import jxl.biff.WritableRecordData;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.Record;

public class DataValiditySettingsRecord
extends WritableRecordData {
    private static Logger logger = Logger.getLogger(DataValiditySettingsRecord.class);
    private byte[] data;
    private DataValidation dataValidation;
    private DVParser dvParser;
    private ExternalSheet externalSheet;
    private WorkbookMethods workbook;
    private WorkbookSettings workbookSettings;

    public DataValiditySettingsRecord(DVParser dVParser) {
        super(Type.DV);
        this.dvParser = dVParser;
    }

    DataValiditySettingsRecord(DataValiditySettingsRecord dataValiditySettingsRecord) {
        super(Type.DV);
        this.data = dataValiditySettingsRecord.getData();
    }

    DataValiditySettingsRecord(DataValiditySettingsRecord dataValiditySettingsRecord, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings) {
        super(Type.DV);
        this.workbook = workbookMethods;
        this.externalSheet = externalSheet;
        this.workbookSettings = workbookSettings;
        boolean bl = true;
        boolean bl2 = workbookMethods != null;
        Assert.verify(bl2);
        if (externalSheet == null) {
            bl = false;
        }
        Assert.verify(bl);
        this.data = new byte[dataValiditySettingsRecord.data.length];
        byte[] arrby = dataValiditySettingsRecord.data;
        byte[] arrby2 = this.data;
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby2.length);
    }

    public DataValiditySettingsRecord(Record record, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings) {
        super(record);
        this.data = record.getData();
        this.externalSheet = externalSheet;
        this.workbook = workbookMethods;
        this.workbookSettings = workbookSettings;
    }

    private void initialize() {
        if (this.dvParser == null) {
            this.dvParser = new DVParser(this.data, this.externalSheet, this.workbook, this.workbookSettings);
        }
    }

    DVParser getDVParser() {
        return this.dvParser;
    }

    @Override
    public byte[] getData() {
        DVParser dVParser = this.dvParser;
        if (dVParser == null) {
            return this.data;
        }
        return dVParser.getData();
    }

    public int getFirstColumn() {
        if (this.dvParser == null) {
            this.initialize();
        }
        return this.dvParser.getFirstColumn();
    }

    public int getFirstRow() {
        if (this.dvParser == null) {
            this.initialize();
        }
        return this.dvParser.getFirstRow();
    }

    public int getLastColumn() {
        if (this.dvParser == null) {
            this.initialize();
        }
        return this.dvParser.getLastColumn();
    }

    public int getLastRow() {
        if (this.dvParser == null) {
            this.initialize();
        }
        return this.dvParser.getLastRow();
    }

    public String getValidationFormula() {
        try {
            if (this.dvParser == null) {
                this.initialize();
            }
            String string = this.dvParser.getValidationFormula();
            return string;
        }
        catch (FormulaException formulaException) {
            Logger logger = DataValiditySettingsRecord.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Cannot read drop down range ");
            stringBuilder.append(formulaException.getMessage());
            logger.warn(stringBuilder.toString());
            return "";
        }
    }

    public void insertColumn(int n) {
        if (this.dvParser == null) {
            this.initialize();
        }
        this.dvParser.insertColumn(n);
    }

    public void insertRow(int n) {
        if (this.dvParser == null) {
            this.initialize();
        }
        this.dvParser.insertRow(n);
    }

    public void removeColumn(int n) {
        if (this.dvParser == null) {
            this.initialize();
        }
        this.dvParser.removeColumn(n);
    }

    public void removeRow(int n) {
        if (this.dvParser == null) {
            this.initialize();
        }
        this.dvParser.removeRow(n);
    }

    void setDataValidation(DataValidation dataValidation) {
        this.dataValidation = dataValidation;
    }
}

