/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 */
package jxl.biff;

import jxl.WorkbookSettings;
import jxl.biff.FontRecord;
import jxl.biff.IntegerHelper;
import jxl.biff.StringHelper;
import jxl.biff.Type;
import jxl.biff.WritableRecordData;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.format.Colour;
import jxl.format.Font;
import jxl.format.ScriptStyle;
import jxl.format.UnderlineStyle;
import jxl.read.biff.Record;

public class FontRecord
extends WritableRecordData
implements Font {
    private static final int EXCEL_UNITS_PER_POINT = 20;
    public static final Biff7 biff7;
    private static Logger logger;
    private int boldWeight;
    private byte characterSet;
    private int colourIndex;
    private byte fontFamily;
    private int fontIndex;
    private boolean initialized;
    private boolean italic;
    private String name;
    private int pointHeight;
    private int scriptStyle;
    private boolean struckout;
    private int underlineStyle;

    static {
        logger = Logger.getLogger(FontRecord.class);
        biff7 = new Object(){};
    }

    protected FontRecord(String string, int n, int n2, boolean bl, int n3, int n4, int n5) {
        super(Type.FONT);
        this.boldWeight = n2;
        this.underlineStyle = n3;
        this.name = string;
        this.pointHeight = n;
        this.italic = bl;
        this.scriptStyle = n5;
        this.colourIndex = n4;
        this.initialized = false;
        this.struckout = false;
    }

    protected FontRecord(Font font) {
        super(Type.FONT);
        boolean bl = font != null;
        Assert.verify(bl);
        this.pointHeight = font.getPointSize();
        this.colourIndex = font.getColour().getValue();
        this.boldWeight = font.getBoldWeight();
        this.scriptStyle = font.getScriptStyle().getValue();
        this.underlineStyle = font.getUnderlineStyle().getValue();
        this.italic = font.isItalic();
        this.name = font.getName();
        this.struckout = font.isStruckout();
        this.initialized = false;
    }

    public FontRecord(Record record, WorkbookSettings workbookSettings) {
        super(record);
        byte[] arrby = this.getRecord().getData();
        this.pointHeight = IntegerHelper.getInt(arrby[0], arrby[1]) / 20;
        this.colourIndex = IntegerHelper.getInt(arrby[4], arrby[5]);
        this.boldWeight = IntegerHelper.getInt(arrby[6], arrby[7]);
        this.scriptStyle = IntegerHelper.getInt(arrby[8], arrby[9]);
        this.underlineStyle = arrby[10];
        this.fontFamily = arrby[11];
        this.characterSet = arrby[12];
        this.initialized = false;
        if ((2 & arrby[2]) != 0) {
            this.italic = true;
        }
        if ((8 & arrby[2]) != 0) {
            this.struckout = true;
        }
        byte by = arrby[14];
        if (arrby[15] == 0) {
            this.name = StringHelper.getString(arrby, by, 16, workbookSettings);
            return;
        }
        if (arrby[15] == 1) {
            this.name = StringHelper.getUnicodeString(arrby, by, 16);
            return;
        }
        this.name = StringHelper.getString(arrby, by, 15, workbookSettings);
    }

    public FontRecord(Record record, WorkbookSettings workbookSettings, Biff7 biff7) {
        super(record);
        byte[] arrby = this.getRecord().getData();
        this.pointHeight = IntegerHelper.getInt(arrby[0], arrby[1]) / 20;
        this.colourIndex = IntegerHelper.getInt(arrby[4], arrby[5]);
        this.boldWeight = IntegerHelper.getInt(arrby[6], arrby[7]);
        this.scriptStyle = IntegerHelper.getInt(arrby[8], arrby[9]);
        this.underlineStyle = arrby[10];
        this.fontFamily = arrby[11];
        this.initialized = false;
        if ((2 & arrby[2]) != 0) {
            this.italic = true;
        }
        if ((8 & arrby[2]) != 0) {
            this.struckout = true;
        }
        this.name = StringHelper.getString(arrby, arrby[14], 15, workbookSettings);
    }

    public boolean equals(Object object) {
        if (object == this) {
            return true;
        }
        if (!(object instanceof FontRecord)) {
            return false;
        }
        FontRecord fontRecord = (FontRecord)object;
        return this.pointHeight == fontRecord.pointHeight && this.colourIndex == fontRecord.colourIndex && this.boldWeight == fontRecord.boldWeight && this.scriptStyle == fontRecord.scriptStyle && this.underlineStyle == fontRecord.underlineStyle && this.italic == fontRecord.italic && this.struckout == fontRecord.struckout && this.fontFamily == fontRecord.fontFamily && this.characterSet == fontRecord.characterSet && this.name.equals((Object)fontRecord.name);
    }

    @Override
    public int getBoldWeight() {
        return this.boldWeight;
    }

    @Override
    public Colour getColour() {
        return Colour.getInternalColour(this.colourIndex);
    }

    @Override
    public byte[] getData() {
        byte[] arrby = new byte[16 + 2 * this.name.length()];
        IntegerHelper.getTwoBytes(20 * this.pointHeight, arrby, 0);
        if (this.italic) {
            arrby[2] = (byte)(2 | arrby[2]);
        }
        if (this.struckout) {
            arrby[2] = (byte)(8 | arrby[2]);
        }
        IntegerHelper.getTwoBytes(this.colourIndex, arrby, 4);
        IntegerHelper.getTwoBytes(this.boldWeight, arrby, 6);
        IntegerHelper.getTwoBytes(this.scriptStyle, arrby, 8);
        arrby[10] = (byte)this.underlineStyle;
        arrby[11] = this.fontFamily;
        arrby[12] = this.characterSet;
        arrby[13] = 0;
        arrby[14] = (byte)this.name.length();
        arrby[15] = 1;
        StringHelper.getUnicodeBytes(this.name, arrby, 16);
        return arrby;
    }

    public final int getFontIndex() {
        return this.fontIndex;
    }

    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public int getPointSize() {
        return this.pointHeight;
    }

    @Override
    public ScriptStyle getScriptStyle() {
        return ScriptStyle.getStyle(this.scriptStyle);
    }

    @Override
    public UnderlineStyle getUnderlineStyle() {
        return UnderlineStyle.getStyle(this.underlineStyle);
    }

    public int hashCode() {
        return this.name.hashCode();
    }

    public final void initialize(int n) {
        this.fontIndex = n;
        this.initialized = true;
    }

    public final boolean isInitialized() {
        return this.initialized;
    }

    @Override
    public boolean isItalic() {
        return this.italic;
    }

    @Override
    public boolean isStruckout() {
        return this.struckout;
    }

    protected void setFontBoldStyle(int n) {
        Assert.verify(true ^ this.initialized);
        this.boldWeight = n;
    }

    protected void setFontColour(int n) {
        Assert.verify(true ^ this.initialized);
        this.colourIndex = n;
    }

    protected void setFontItalic(boolean bl) {
        Assert.verify(true ^ this.initialized);
        this.italic = bl;
    }

    protected void setFontPointSize(int n) {
        Assert.verify(true ^ this.initialized);
        this.pointHeight = n;
    }

    protected void setFontScriptStyle(int n) {
        Assert.verify(true ^ this.initialized);
        this.scriptStyle = n;
    }

    protected void setFontStruckout(boolean bl) {
        this.struckout = bl;
    }

    protected void setFontUnderlineStyle(int n) {
        Assert.verify(true ^ this.initialized);
        this.underlineStyle = n;
    }

    public final void uninitialize() {
        this.initialized = false;
    }

}

