/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Math
 */
package jxl.biff;

import jxl.biff.IntegerHelper;
import jxl.biff.Type;
import jxl.biff.WritableRecordData;
import jxl.format.Colour;
import jxl.format.RGB;
import jxl.read.biff.Record;

public class PaletteRecord
extends WritableRecordData {
    private static final int numColours = 56;
    private boolean dirty;
    private boolean initialized;
    private boolean read;
    private RGB[] rgbColours = new RGB[56];

    public PaletteRecord() {
        super(Type.PALETTE);
        this.initialized = true;
        this.dirty = false;
        this.read = false;
        Colour[] arrcolour = Colour.getAllColours();
        for (int i = 0; i < arrcolour.length; ++i) {
            Colour colour = arrcolour[i];
            this.setColourRGB(colour, colour.getDefaultRGB().getRed(), colour.getDefaultRGB().getGreen(), colour.getDefaultRGB().getBlue());
        }
    }

    public PaletteRecord(Record record) {
        super(record);
        this.initialized = false;
        this.dirty = false;
        this.read = true;
    }

    private void initialize() {
        byte[] arrby = this.getRecord().getData();
        int n = IntegerHelper.getInt(arrby[0], arrby[1]);
        for (int i = 0; i < n; ++i) {
            int n2 = 2 + i * 4;
            int n3 = IntegerHelper.getInt(arrby[n2], (byte)0);
            int n4 = IntegerHelper.getInt(arrby[n2 + 1], (byte)0);
            int n5 = IntegerHelper.getInt(arrby[n2 + 2], (byte)0);
            this.rgbColours[i] = new RGB(n3, n4, n5);
        }
        this.initialized = true;
    }

    private int setValueRange(int n, int n2, int n3) {
        return Math.min((int)Math.max((int)n, (int)n2), (int)n3);
    }

    public RGB getColourRGB(Colour colour) {
        int n = -8 + colour.getValue();
        if (n >= 0 && n < 56) {
            if (!this.initialized) {
                this.initialize();
            }
            return this.rgbColours[n];
        }
        return colour.getDefaultRGB();
    }

    @Override
    public byte[] getData() {
        if (this.read && !this.dirty) {
            return this.getRecord().getData();
        }
        byte[] arrby = new byte[226];
        IntegerHelper.getTwoBytes(56, arrby, 0);
        for (int i = 0; i < 56; ++i) {
            int n = 2 + i * 4;
            arrby[n] = (byte)this.rgbColours[i].getRed();
            arrby[n + 1] = (byte)this.rgbColours[i].getGreen();
            arrby[n + 2] = (byte)this.rgbColours[i].getBlue();
        }
        return arrby;
    }

    public boolean isDirty() {
        return this.dirty;
    }

    public void setColourRGB(Colour colour, int n, int n2, int n3) {
        int n4 = -8 + colour.getValue();
        if (n4 >= 0) {
            if (n4 >= 56) {
                return;
            }
            if (!this.initialized) {
                this.initialize();
            }
            int n5 = this.setValueRange(n, 0, 255);
            int n6 = this.setValueRange(n2, 0, 255);
            int n7 = this.setValueRange(n3, 0, 255);
            this.rgbColours[n4] = new RGB(n5, n6, n7);
            this.dirty = true;
        }
    }
}

