/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.text.DateFormat
 *  java.text.DecimalFormat
 *  java.text.DecimalFormatSymbols
 *  java.text.NumberFormat
 *  java.text.SimpleDateFormat
 *  java.util.Locale
 */
package jxl.biff;

import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Locale;
import jxl.WorkbookSettings;
import jxl.biff.BuiltInFormat;
import jxl.biff.DisplayFormat;
import jxl.biff.FontRecord;
import jxl.biff.Fonts;
import jxl.biff.FormatRecord;
import jxl.biff.FormattingRecords;
import jxl.biff.IndexMapping;
import jxl.biff.IntegerHelper;
import jxl.biff.NumFormatRecordsException;
import jxl.biff.Type;
import jxl.biff.WritableRecordData;
import jxl.biff.XFRecord;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.format.Alignment;
import jxl.format.Border;
import jxl.format.BorderLineStyle;
import jxl.format.CellFormat;
import jxl.format.Colour;
import jxl.format.Font;
import jxl.format.Format;
import jxl.format.Orientation;
import jxl.format.Pattern;
import jxl.format.VerticalAlignment;
import jxl.read.biff.Record;

public class XFRecord
extends WritableRecordData
implements CellFormat {
    private static final int USE_ALIGNMENT = 16;
    private static final int USE_BACKGROUND = 64;
    private static final int USE_BORDER = 32;
    private static final int USE_DEFAULT_VALUE = 248;
    private static final int USE_FONT = 4;
    private static final int USE_FORMAT = 8;
    private static final int USE_PROTECTION = 128;
    public static final BiffType biff7;
    public static final BiffType biff8;
    protected static final XFType cell;
    private static final int[] dateFormats;
    private static final DateFormat[] javaDateFormats;
    private static NumberFormat[] javaNumberFormats;
    private static Logger logger;
    private static int[] numberFormats;
    protected static final XFType style;
    private Alignment align;
    private Colour backgroundColour;
    private BiffType biffType;
    private BorderLineStyle bottomBorder;
    private Colour bottomBorderColour;
    private boolean copied;
    private boolean date;
    private DateFormat dateFormat;
    private Format excelFormat;
    private FontRecord font;
    private int fontIndex;
    private DisplayFormat format;
    public int formatIndex;
    private boolean formatInfoInitialized;
    private FormattingRecords formattingRecords;
    private boolean hidden;
    private int indentation;
    private boolean initialized;
    private BorderLineStyle leftBorder;
    private Colour leftBorderColour;
    private boolean locked;
    private boolean number;
    private NumberFormat numberFormat;
    private int options;
    private Orientation orientation;
    private int parentFormat;
    private Pattern pattern;
    private boolean read;
    private BorderLineStyle rightBorder;
    private Colour rightBorderColour;
    private boolean shrinkToFit;
    private BorderLineStyle topBorder;
    private Colour topBorderColour;
    private byte usedAttributes;
    private VerticalAlignment valign;
    private boolean wrap;
    private XFType xfFormatType;
    private int xfIndex;

    static {
        logger = Logger.getLogger(XFRecord.class);
        dateFormats = new int[]{14, 15, 16, 17, 18, 19, 20, 21, 22, 45, 46, 47};
        DateFormat[] arrdateFormat = new DateFormat[]{SimpleDateFormat.getDateInstance((int)3), SimpleDateFormat.getDateInstance((int)2), new SimpleDateFormat("d-MMM"), new SimpleDateFormat("MMM-yy"), new SimpleDateFormat("h:mm a"), new SimpleDateFormat("h:mm:ss a"), new SimpleDateFormat("H:mm"), new SimpleDateFormat("H:mm:ss"), new SimpleDateFormat("M/d/yy H:mm"), new SimpleDateFormat("mm:ss"), new SimpleDateFormat("H:mm:ss"), new SimpleDateFormat("mm:ss.S")};
        javaDateFormats = arrdateFormat;
        numberFormats = new int[]{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 37, 38, 39, 40, 41, 42, 43, 44, 48};
        NumberFormat[] arrnumberFormat = new NumberFormat[]{new DecimalFormat("0"), new DecimalFormat("0.00"), new DecimalFormat("#,##0"), new DecimalFormat("#,##0.00"), new DecimalFormat("$#,##0;($#,##0)"), new DecimalFormat("$#,##0;($#,##0)"), new DecimalFormat("$#,##0.00;($#,##0.00)"), new DecimalFormat("$#,##0.00;($#,##0.00)"), new DecimalFormat("0%"), new DecimalFormat("0.00%"), new DecimalFormat("0.00E00"), new DecimalFormat("#,##0;(#,##0)"), new DecimalFormat("#,##0;(#,##0)"), new DecimalFormat("#,##0.00;(#,##0.00)"), new DecimalFormat("#,##0.00;(#,##0.00)"), new DecimalFormat("#,##0;(#,##0)"), new DecimalFormat("$#,##0;($#,##0)"), new DecimalFormat("#,##0.00;(#,##0.00)"), new DecimalFormat("$#,##0.00;($#,##0.00)"), new DecimalFormat("##0.0E0")};
        javaNumberFormats = arrnumberFormat;
        biff8 = new Object(){};
        biff7 = new /* invalid duplicate definition of identical inner class */;
        cell = new Object(){};
        style = new /* invalid duplicate definition of identical inner class */;
    }

    public XFRecord(FontRecord fontRecord, DisplayFormat displayFormat) {
        super(Type.XF);
        this.initialized = false;
        this.locked = true;
        this.hidden = false;
        this.align = Alignment.GENERAL;
        this.valign = VerticalAlignment.BOTTOM;
        this.orientation = Orientation.HORIZONTAL;
        this.wrap = false;
        this.leftBorder = BorderLineStyle.NONE;
        this.rightBorder = BorderLineStyle.NONE;
        this.topBorder = BorderLineStyle.NONE;
        this.bottomBorder = BorderLineStyle.NONE;
        this.leftBorderColour = Colour.AUTOMATIC;
        this.rightBorderColour = Colour.AUTOMATIC;
        this.topBorderColour = Colour.AUTOMATIC;
        this.bottomBorderColour = Colour.AUTOMATIC;
        this.pattern = Pattern.NONE;
        this.backgroundColour = Colour.DEFAULT_BACKGROUND;
        this.indentation = 0;
        this.shrinkToFit = false;
        this.usedAttributes = (byte)124;
        this.parentFormat = 0;
        this.xfFormatType = null;
        this.font = fontRecord;
        this.format = displayFormat;
        this.biffType = biff8;
        this.read = false;
        this.copied = false;
        this.formatInfoInitialized = true;
        boolean bl = this.font != null;
        Assert.verify(bl);
        DisplayFormat displayFormat2 = this.format;
        boolean bl2 = false;
        if (displayFormat2 != null) {
            bl2 = true;
        }
        Assert.verify(bl2);
    }

    protected XFRecord(XFRecord xFRecord) {
        super(Type.XF);
        this.initialized = false;
        this.locked = xFRecord.locked;
        this.hidden = xFRecord.hidden;
        this.align = xFRecord.align;
        this.valign = xFRecord.valign;
        this.orientation = xFRecord.orientation;
        this.wrap = xFRecord.wrap;
        this.leftBorder = xFRecord.leftBorder;
        this.rightBorder = xFRecord.rightBorder;
        this.topBorder = xFRecord.topBorder;
        this.bottomBorder = xFRecord.bottomBorder;
        this.leftBorderColour = xFRecord.leftBorderColour;
        this.rightBorderColour = xFRecord.rightBorderColour;
        this.topBorderColour = xFRecord.topBorderColour;
        this.bottomBorderColour = xFRecord.bottomBorderColour;
        this.pattern = xFRecord.pattern;
        this.xfFormatType = xFRecord.xfFormatType;
        this.indentation = xFRecord.indentation;
        this.shrinkToFit = xFRecord.shrinkToFit;
        this.parentFormat = xFRecord.parentFormat;
        this.backgroundColour = xFRecord.backgroundColour;
        this.font = xFRecord.font;
        this.format = xFRecord.format;
        this.fontIndex = xFRecord.fontIndex;
        this.formatIndex = xFRecord.formatIndex;
        this.formatInfoInitialized = xFRecord.formatInfoInitialized;
        this.biffType = biff8;
        this.read = false;
        this.copied = true;
    }

    protected XFRecord(CellFormat cellFormat) {
        super(Type.XF);
        boolean bl = cellFormat != null;
        Assert.verify(bl);
        Assert.verify(cellFormat instanceof XFRecord);
        XFRecord xFRecord = (XFRecord)cellFormat;
        if (!xFRecord.formatInfoInitialized) {
            xFRecord.initializeFormatInformation();
        }
        this.locked = xFRecord.locked;
        this.hidden = xFRecord.hidden;
        this.align = xFRecord.align;
        this.valign = xFRecord.valign;
        this.orientation = xFRecord.orientation;
        this.wrap = xFRecord.wrap;
        this.leftBorder = xFRecord.leftBorder;
        this.rightBorder = xFRecord.rightBorder;
        this.topBorder = xFRecord.topBorder;
        this.bottomBorder = xFRecord.bottomBorder;
        this.leftBorderColour = xFRecord.leftBorderColour;
        this.rightBorderColour = xFRecord.rightBorderColour;
        this.topBorderColour = xFRecord.topBorderColour;
        this.bottomBorderColour = xFRecord.bottomBorderColour;
        this.pattern = xFRecord.pattern;
        this.xfFormatType = xFRecord.xfFormatType;
        this.parentFormat = xFRecord.parentFormat;
        this.indentation = xFRecord.indentation;
        this.shrinkToFit = xFRecord.shrinkToFit;
        this.backgroundColour = xFRecord.backgroundColour;
        this.font = new FontRecord(xFRecord.getFont());
        if (xFRecord.getFormat() == null) {
            this.format = xFRecord.format.isBuiltIn() ? xFRecord.format : new FormatRecord((FormatRecord)xFRecord.format);
        } else if (xFRecord.getFormat() instanceof BuiltInFormat) {
            this.excelFormat = (BuiltInFormat)xFRecord.excelFormat;
            this.format = (BuiltInFormat)xFRecord.excelFormat;
        } else {
            Assert.verify(xFRecord.formatInfoInitialized);
            Assert.verify(xFRecord.excelFormat instanceof FormatRecord);
            FormatRecord formatRecord = new FormatRecord((FormatRecord)xFRecord.excelFormat);
            this.excelFormat = formatRecord;
            this.format = formatRecord;
        }
        this.biffType = biff8;
        this.formatInfoInitialized = true;
        this.read = false;
        this.copied = false;
        this.initialized = false;
    }

    public XFRecord(Record record, WorkbookSettings workbookSettings, BiffType biffType) {
        int[] arrn;
        int[] arrn2;
        super(record);
        this.biffType = biffType;
        byte[] arrby = this.getRecord().getData();
        this.fontIndex = IntegerHelper.getInt(arrby[0], arrby[1]);
        this.formatIndex = IntegerHelper.getInt(arrby[2], arrby[3]);
        this.date = false;
        this.number = false;
        for (int i = 0; i < (arrn = dateFormats).length && !this.date; ++i) {
            if (this.formatIndex != arrn[i]) continue;
            this.date = true;
            this.dateFormat = javaDateFormats[i];
        }
        for (int i = 0; i < (arrn2 = numberFormats).length && !this.number; ++i) {
            if (this.formatIndex != arrn2[i]) continue;
            this.number = true;
            DecimalFormat decimalFormat = (DecimalFormat)javaNumberFormats[i].clone();
            decimalFormat.setDecimalFormatSymbols(new DecimalFormatSymbols(workbookSettings.getLocale()));
            this.numberFormat = decimalFormat;
        }
        int n = IntegerHelper.getInt(arrby[4], arrby[5]);
        this.parentFormat = (65520 & n) >> 4;
        XFType xFType = (n & 4) == 0 ? cell : style;
        this.xfFormatType = xFType;
        boolean bl = (n & 1) != 0;
        this.locked = bl;
        boolean bl2 = (n & 2) != 0;
        this.hidden = bl2;
        if (this.xfFormatType == cell && (4095 & this.parentFormat) == 4095) {
            this.parentFormat = 0;
            logger.warn("Invalid parent format found - ignoring");
        }
        this.initialized = false;
        this.read = true;
        this.formatInfoInitialized = false;
        this.copied = false;
    }

    private void initializeFormatInformation() {
        int n;
        this.excelFormat = this.formatIndex < BuiltInFormat.builtIns.length && BuiltInFormat.builtIns[this.formatIndex] != null ? BuiltInFormat.builtIns[this.formatIndex] : this.formattingRecords.getFormatRecord(this.formatIndex);
        this.font = this.formattingRecords.getFonts().getFont(this.fontIndex);
        byte[] arrby = this.getRecord().getData();
        int n2 = IntegerHelper.getInt(arrby[4], arrby[5]);
        this.parentFormat = (65520 & n2) >> 4;
        XFType xFType = (n2 & 4) == 0 ? cell : style;
        this.xfFormatType = xFType;
        boolean bl = (n2 & 1) != 0;
        this.locked = bl;
        boolean bl2 = (n2 & 2) != 0;
        this.hidden = bl2;
        if (this.xfFormatType == cell && (4095 & this.parentFormat) == 4095) {
            this.parentFormat = 0;
            logger.warn("Invalid parent format found - ignoring");
        }
        if (((n = IntegerHelper.getInt(arrby[6], arrby[7])) & 8) != 0) {
            this.wrap = true;
        }
        this.align = Alignment.getAlignment(n & 7);
        this.valign = VerticalAlignment.getAlignment(7 & n >> 4);
        this.orientation = Orientation.getOrientation(255 & n >> 8);
        int n3 = IntegerHelper.getInt(arrby[8], arrby[9]);
        this.indentation = n3 & 15;
        int n4 = n3 & 16;
        boolean bl3 = false;
        if (n4 != 0) {
            bl3 = true;
        }
        this.shrinkToFit = bl3;
        if (this.biffType == biff8) {
            this.usedAttributes = arrby[9];
        }
        int n5 = IntegerHelper.getInt(arrby[10], arrby[11]);
        this.leftBorder = BorderLineStyle.getStyle(n5 & 7);
        this.rightBorder = BorderLineStyle.getStyle(7 & n5 >> 4);
        this.topBorder = BorderLineStyle.getStyle(7 & n5 >> 8);
        this.bottomBorder = BorderLineStyle.getStyle(7 & n5 >> 12);
        int n6 = IntegerHelper.getInt(arrby[12], arrby[13]);
        this.leftBorderColour = Colour.getInternalColour(n6 & 127);
        this.rightBorderColour = Colour.getInternalColour((n6 & 16256) >> 7);
        int n7 = IntegerHelper.getInt(arrby[14], arrby[15]);
        this.topBorderColour = Colour.getInternalColour(n7 & 127);
        this.bottomBorderColour = Colour.getInternalColour((n7 & 16256) >> 7);
        if (this.biffType == biff8) {
            this.pattern = Pattern.getPattern((64512 & IntegerHelper.getInt(arrby[16], arrby[17])) >> 10);
            this.backgroundColour = Colour.getInternalColour(63 & IntegerHelper.getInt(arrby[18], arrby[19]));
            if (this.backgroundColour == Colour.UNKNOWN || this.backgroundColour == Colour.DEFAULT_BACKGROUND1) {
                this.backgroundColour = Colour.DEFAULT_BACKGROUND;
            }
        } else {
            this.pattern = Pattern.NONE;
            this.backgroundColour = Colour.DEFAULT_BACKGROUND;
        }
        this.formatInfoInitialized = true;
    }

    /*
     * Enabled force condition propagation
     * Lifted jumps to return sites
     */
    public boolean equals(Object object) {
        if (object == this) {
            return true;
        }
        if (!(object instanceof XFRecord)) {
            return false;
        }
        XFRecord xFRecord = (XFRecord)object;
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        if (!xFRecord.formatInfoInitialized) {
            xFRecord.initializeFormatInformation();
        }
        if (this.xfFormatType != xFRecord.xfFormatType || this.parentFormat != xFRecord.parentFormat || this.locked != xFRecord.locked || this.hidden != xFRecord.hidden) return false;
        if (this.usedAttributes != xFRecord.usedAttributes) {
            return false;
        }
        if (this.align != xFRecord.align || this.valign != xFRecord.valign || this.orientation != xFRecord.orientation || this.wrap != xFRecord.wrap || this.shrinkToFit != xFRecord.shrinkToFit) return false;
        if (this.indentation != xFRecord.indentation) {
            return false;
        }
        if (this.leftBorder != xFRecord.leftBorder || this.rightBorder != xFRecord.rightBorder || this.topBorder != xFRecord.topBorder) return false;
        if (this.bottomBorder != xFRecord.bottomBorder) {
            return false;
        }
        if (this.leftBorderColour != xFRecord.leftBorderColour || this.rightBorderColour != xFRecord.rightBorderColour || this.topBorderColour != xFRecord.topBorderColour) return false;
        if (this.bottomBorderColour != xFRecord.bottomBorderColour) {
            return false;
        }
        if (this.backgroundColour != xFRecord.backgroundColour) return false;
        if (this.pattern != xFRecord.pattern) {
            return false;
        }
        if (this.initialized && xFRecord.initialized) {
            if (this.fontIndex == xFRecord.fontIndex && this.formatIndex == xFRecord.formatIndex) return true;
            return false;
        }
        if (!this.font.equals(xFRecord.font)) return false;
        if (this.format.equals((Object)xFRecord.format)) return true;
        return false;
    }

    @Override
    public Alignment getAlignment() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.align;
    }

    @Override
    public Colour getBackgroundColour() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.backgroundColour;
    }

    @Override
    public BorderLineStyle getBorder(Border border) {
        return this.getBorderLine(border);
    }

    @Override
    public Colour getBorderColour(Border border) {
        if (border != Border.NONE && border != Border.ALL) {
            if (!this.formatInfoInitialized) {
                this.initializeFormatInformation();
            }
            if (border == Border.LEFT) {
                return this.leftBorderColour;
            }
            if (border == Border.RIGHT) {
                return this.rightBorderColour;
            }
            if (border == Border.TOP) {
                return this.topBorderColour;
            }
            if (border == Border.BOTTOM) {
                return this.bottomBorderColour;
            }
            return Colour.BLACK;
        }
        return Colour.PALETTE_BLACK;
    }

    @Override
    public BorderLineStyle getBorderLine(Border border) {
        if (border != Border.NONE && border != Border.ALL) {
            if (!this.formatInfoInitialized) {
                this.initializeFormatInformation();
            }
            if (border == Border.LEFT) {
                return this.leftBorder;
            }
            if (border == Border.RIGHT) {
                return this.rightBorder;
            }
            if (border == Border.TOP) {
                return this.topBorder;
            }
            if (border == Border.BOTTOM) {
                return this.bottomBorder;
            }
            return BorderLineStyle.NONE;
        }
        return BorderLineStyle.NONE;
    }

    @Override
    public byte[] getData() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        byte[] arrby = new byte[20];
        IntegerHelper.getTwoBytes(this.fontIndex, arrby, 0);
        IntegerHelper.getTwoBytes(this.formatIndex, arrby, 2);
        boolean bl = this.getLocked();
        int n = 0;
        if (bl) {
            n = 1;
        }
        if (this.getHidden()) {
            n |= 2;
        }
        if (this.xfFormatType == style) {
            n |= 4;
            this.parentFormat = 65535;
        }
        IntegerHelper.getTwoBytes(n | this.parentFormat << 4, arrby, 4);
        int n2 = this.align.getValue();
        if (this.wrap) {
            n2 |= 8;
        }
        IntegerHelper.getTwoBytes(n2 | this.valign.getValue() << 4 | this.orientation.getValue() << 8, arrby, 6);
        arrby[9] = 16;
        int n3 = this.leftBorder.getValue() | this.rightBorder.getValue() << 4 | this.topBorder.getValue() << 8 | this.bottomBorder.getValue() << 12;
        IntegerHelper.getTwoBytes(n3, arrby, 10);
        if (n3 != 0) {
            byte by = (byte)this.leftBorderColour.getValue();
            byte by2 = (byte)this.rightBorderColour.getValue();
            byte by3 = (byte)this.topBorderColour.getValue();
            byte by4 = (byte)this.bottomBorderColour.getValue();
            int n4 = by & 127 | (by2 & 127) << 7;
            int n5 = by3 & 127 | (by4 & 127) << 7;
            IntegerHelper.getTwoBytes(n4, arrby, 12);
            IntegerHelper.getTwoBytes(n5, arrby, 14);
        }
        IntegerHelper.getTwoBytes(this.pattern.getValue() << 10, arrby, 16);
        IntegerHelper.getTwoBytes(8192 | this.backgroundColour.getValue(), arrby, 18);
        this.options |= 15 & this.indentation;
        this.options = this.shrinkToFit ? 16 | this.options : 239 & this.options;
        arrby[8] = (byte)this.options;
        if (this.biffType == biff8) {
            arrby[9] = this.usedAttributes;
        }
        return arrby;
    }

    public DateFormat getDateFormat() {
        return this.dateFormat;
    }

    @Override
    public Font getFont() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.font;
    }

    public int getFontIndex() {
        return this.fontIndex;
    }

    @Override
    public Format getFormat() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.excelFormat;
    }

    public int getFormatRecord() {
        return this.formatIndex;
    }

    protected final boolean getHidden() {
        return this.hidden;
    }

    @Override
    public int getIndentation() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.indentation;
    }

    protected final boolean getLocked() {
        return this.locked;
    }

    public NumberFormat getNumberFormat() {
        return this.numberFormat;
    }

    @Override
    public Orientation getOrientation() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.orientation;
    }

    @Override
    public Pattern getPattern() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.pattern;
    }

    @Override
    public VerticalAlignment getVerticalAlignment() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.valign;
    }

    @Override
    public boolean getWrap() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.wrap;
    }

    public final int getXFIndex() {
        return this.xfIndex;
    }

    @Override
    public final boolean hasBorders() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.leftBorder != BorderLineStyle.NONE || this.rightBorder != BorderLineStyle.NONE || this.topBorder != BorderLineStyle.NONE || this.bottomBorder != BorderLineStyle.NONE;
    }

    public int hashCode() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        int n = 37 * (37 * (37 * (629 + this.hidden) + this.locked) + this.wrap) + this.shrinkToFit;
        XFType xFType = this.xfFormatType;
        if (xFType == cell) {
            n = 1 + n * 37;
        } else if (xFType == style) {
            n = 2 + n * 37;
        }
        return 37 * (37 * (37 * (37 * (37 * (37 * (37 * (37 * (37 * (37 * (37 * (37 * (37 * (n * 37 + (1 + this.align.getValue())) + (1 + this.valign.getValue())) + this.orientation.getValue() ^ this.leftBorder.getDescription().hashCode() ^ this.rightBorder.getDescription().hashCode() ^ this.topBorder.getDescription().hashCode() ^ this.bottomBorder.getDescription().hashCode()) + this.leftBorderColour.getValue()) + this.rightBorderColour.getValue()) + this.topBorderColour.getValue()) + this.bottomBorderColour.getValue()) + this.backgroundColour.getValue()) + (1 + this.pattern.getValue())) + this.usedAttributes) + this.parentFormat) + this.fontIndex) + this.formatIndex) + this.indentation;
    }

    public final void initialize(int n, FormattingRecords formattingRecords, Fonts fonts) throws NumFormatRecordsException {
        this.xfIndex = n;
        this.formattingRecords = formattingRecords;
        if (!this.read && !this.copied) {
            if (!this.font.isInitialized()) {
                fonts.addFont(this.font);
            }
            if (!this.format.isInitialized()) {
                formattingRecords.addFormat(this.format);
            }
            this.fontIndex = this.font.getFontIndex();
            this.formatIndex = this.format.getFormatIndex();
            this.initialized = true;
            return;
        }
        this.initialized = true;
    }

    public boolean isDate() {
        return this.date;
    }

    public final boolean isInitialized() {
        return this.initialized;
    }

    @Override
    public boolean isLocked() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.locked;
    }

    public boolean isNumber() {
        return this.number;
    }

    public final boolean isRead() {
        return this.read;
    }

    @Override
    public boolean isShrinkToFit() {
        if (!this.formatInfoInitialized) {
            this.initializeFormatInformation();
        }
        return this.shrinkToFit;
    }

    void rationalize(IndexMapping indexMapping) {
        this.xfIndex = indexMapping.getNewIndex(this.xfIndex);
        if (this.xfFormatType == cell) {
            this.parentFormat = indexMapping.getNewIndex(this.parentFormat);
        }
    }

    public void setFont(FontRecord fontRecord) {
        this.font = fontRecord;
    }

    void setFontIndex(int n) {
        this.fontIndex = n;
    }

    void setFormatIndex(int n) {
        this.formatIndex = n;
    }

    protected void setXFAlignment(Alignment alignment) {
        Assert.verify(true ^ this.initialized);
        this.align = alignment;
        this.usedAttributes = (byte)(16 | this.usedAttributes);
    }

    protected void setXFBackground(Colour colour, Pattern pattern) {
        Assert.verify(true ^ this.initialized);
        this.backgroundColour = colour;
        this.pattern = pattern;
        this.usedAttributes = (byte)(64 | this.usedAttributes);
    }

    protected void setXFBorder(Border border, BorderLineStyle borderLineStyle, Colour colour) {
        Assert.verify(true ^ this.initialized);
        if (colour == Colour.BLACK || colour == Colour.UNKNOWN) {
            colour = Colour.PALETTE_BLACK;
        }
        if (border == Border.LEFT) {
            this.leftBorder = borderLineStyle;
            this.leftBorderColour = colour;
        } else if (border == Border.RIGHT) {
            this.rightBorder = borderLineStyle;
            this.rightBorderColour = colour;
        } else if (border == Border.TOP) {
            this.topBorder = borderLineStyle;
            this.topBorderColour = colour;
        } else if (border == Border.BOTTOM) {
            this.bottomBorder = borderLineStyle;
            this.bottomBorderColour = colour;
        }
        this.usedAttributes = (byte)(32 | this.usedAttributes);
    }

    protected final void setXFCellOptions(int n) {
        this.options = n | this.options;
    }

    protected void setXFDetails(XFType xFType, int n) {
        this.xfFormatType = xFType;
        this.parentFormat = n;
    }

    protected void setXFIndentation(int n) {
        Assert.verify(true ^ this.initialized);
        this.indentation = n;
        this.usedAttributes = (byte)(16 | this.usedAttributes);
    }

    final void setXFIndex(int n) {
        this.xfIndex = n;
    }

    protected final void setXFLocked(boolean bl) {
        this.locked = bl;
        this.usedAttributes = (byte)(128 | this.usedAttributes);
    }

    protected void setXFOrientation(Orientation orientation) {
        Assert.verify(true ^ this.initialized);
        this.orientation = orientation;
        this.usedAttributes = (byte)(16 | this.usedAttributes);
    }

    protected void setXFShrinkToFit(boolean bl) {
        Assert.verify(true ^ this.initialized);
        this.shrinkToFit = bl;
        this.usedAttributes = (byte)(16 | this.usedAttributes);
    }

    protected void setXFVerticalAlignment(VerticalAlignment verticalAlignment) {
        Assert.verify(true ^ this.initialized);
        this.valign = verticalAlignment;
        this.usedAttributes = (byte)(16 | this.usedAttributes);
    }

    protected void setXFWrap(boolean bl) {
        Assert.verify(true ^ this.initialized);
        this.wrap = bl;
        this.usedAttributes = (byte)(16 | this.usedAttributes);
    }

    public final void uninitialize() {
        if (this.initialized) {
            logger.warn("A default format has been initialized");
        }
        this.initialized = false;
    }

}

