/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.IOException
 *  java.lang.Class
 *  java.lang.Object
 *  java.lang.String
 */
package jxl.biff.drawing;

import java.io.IOException;
import jxl.WorkbookSettings;
import jxl.biff.ByteData;
import jxl.biff.ContinueRecord;
import jxl.biff.drawing.ClientAnchor;
import jxl.biff.drawing.ClientData;
import jxl.biff.drawing.DrawingData;
import jxl.biff.drawing.DrawingGroup;
import jxl.biff.drawing.DrawingGroupObject;
import jxl.biff.drawing.EscherContainer;
import jxl.biff.drawing.EscherRecord;
import jxl.biff.drawing.EscherRecordType;
import jxl.biff.drawing.MsoDrawingRecord;
import jxl.biff.drawing.ObjRecord;
import jxl.biff.drawing.Opt;
import jxl.biff.drawing.Origin;
import jxl.biff.drawing.ShapeType;
import jxl.biff.drawing.Sp;
import jxl.biff.drawing.SpContainer;
import jxl.biff.drawing.TextObjectRecord;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.write.biff.File;

public class CheckBox
implements DrawingGroupObject {
    private static Logger logger = Logger.getLogger(CheckBox.class);
    private int blipId;
    private int column;
    private DrawingData drawingData;
    private DrawingGroup drawingGroup;
    private int drawingNumber;
    private EscherContainer escherData;
    private ContinueRecord formatting;
    private double height;
    private boolean initialized = false;
    private MsoDrawingRecord mso;
    private MsoDrawingRecord msoDrawingRecord;
    private ObjRecord objRecord;
    private int objectId;
    private Origin origin;
    private EscherContainer readSpContainer;
    private int referenceCount;
    private int row;
    private int shapeId;
    private EscherContainer spContainer;
    private ContinueRecord text;
    private TextObjectRecord txo;
    private ShapeType type;
    private double width;
    private WorkbookSettings workbookSettings;

    public CheckBox() {
        this.initialized = true;
        this.origin = Origin.WRITE;
        this.referenceCount = 1;
        this.type = ShapeType.HOST_CONTROL;
    }

    public CheckBox(DrawingGroupObject drawingGroupObject, DrawingGroup drawingGroup, WorkbookSettings workbookSettings) {
        CheckBox checkBox = (CheckBox)drawingGroupObject;
        boolean bl = checkBox.origin == Origin.READ;
        Assert.verify(bl);
        this.msoDrawingRecord = checkBox.msoDrawingRecord;
        this.objRecord = checkBox.objRecord;
        this.initialized = false;
        this.origin = Origin.READ;
        this.drawingData = checkBox.drawingData;
        this.drawingGroup = drawingGroup;
        this.drawingNumber = checkBox.drawingNumber;
        this.drawingGroup.addDrawing(this);
        this.mso = checkBox.mso;
        this.txo = checkBox.txo;
        this.text = checkBox.text;
        this.formatting = checkBox.formatting;
        this.workbookSettings = workbookSettings;
    }

    public CheckBox(MsoDrawingRecord msoDrawingRecord, ObjRecord objRecord, DrawingData drawingData, DrawingGroup drawingGroup, WorkbookSettings workbookSettings) {
        this.drawingGroup = drawingGroup;
        this.msoDrawingRecord = msoDrawingRecord;
        this.drawingData = drawingData;
        this.objRecord = objRecord;
        this.initialized = false;
        this.workbookSettings = workbookSettings;
        this.origin = Origin.READ;
        this.drawingData.addData(this.msoDrawingRecord.getData());
        int n = this.drawingData.getNumDrawings();
        boolean bl = true;
        this.drawingNumber = n - bl;
        this.drawingGroup.addDrawing(this);
        if (msoDrawingRecord == null || objRecord == null) {
            bl = false;
        }
        Assert.verify(bl);
        this.initialize();
    }

    private EscherContainer getReadSpContainer() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.readSpContainer;
    }

    private void initialize() {
        EscherContainer escherContainer = this.readSpContainer = this.drawingData.getSpContainer(this.drawingNumber);
        int n = 0;
        boolean bl = escherContainer != null;
        Assert.verify(bl);
        EscherRecord[] arrescherRecord = this.readSpContainer.getChildren();
        Sp sp = (Sp)this.readSpContainer.getChildren()[0];
        this.objectId = this.objRecord.getObjectId();
        this.shapeId = sp.getShapeId();
        this.type = ShapeType.getType(sp.getShapeType());
        if (this.type == ShapeType.UNKNOWN) {
            logger.warn("Unknown shape type");
        }
        ClientAnchor clientAnchor = null;
        while (n < arrescherRecord.length && clientAnchor == null) {
            if (arrescherRecord[n].getType() == EscherRecordType.CLIENT_ANCHOR) {
                clientAnchor = (ClientAnchor)arrescherRecord[n];
            }
            ++n;
        }
        if (clientAnchor == null) {
            logger.warn("Client anchor not found");
        } else {
            this.column = (int)clientAnchor.getX1();
            this.row = (int)clientAnchor.getY1();
        }
        this.initialized = true;
    }

    public void addMso(MsoDrawingRecord msoDrawingRecord) {
        this.mso = msoDrawingRecord;
        this.drawingData.addRawData(this.mso.getData());
    }

    @Override
    public final int getBlipId() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.blipId;
    }

    public int getColumn() {
        return 0;
    }

    @Override
    public DrawingGroup getDrawingGroup() {
        return this.drawingGroup;
    }

    @Override
    public double getHeight() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.height;
    }

    @Override
    public byte[] getImageBytes() {
        Assert.verify(false);
        return null;
    }

    @Override
    public byte[] getImageData() {
        boolean bl = this.origin == Origin.READ || this.origin == Origin.READ_WRITE;
        Assert.verify(bl);
        if (!this.initialized) {
            this.initialize();
        }
        return this.drawingGroup.getImageData(this.blipId);
    }

    @Override
    public String getImageFilePath() {
        Assert.verify(false);
        return null;
    }

    @Override
    public MsoDrawingRecord getMsoDrawingRecord() {
        return this.msoDrawingRecord;
    }

    @Override
    public final int getObjectId() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.objectId;
    }

    @Override
    public Origin getOrigin() {
        return this.origin;
    }

    @Override
    public int getReferenceCount() {
        return this.referenceCount;
    }

    public int getRow() {
        return 0;
    }

    @Override
    public final int getShapeId() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.shapeId;
    }

    @Override
    public EscherContainer getSpContainer() {
        if (!this.initialized) {
            this.initialize();
        }
        if (this.origin == Origin.READ) {
            return this.getReadSpContainer();
        }
        SpContainer spContainer = new SpContainer();
        spContainer.add(new Sp(this.type, this.shapeId, 2560));
        Opt opt = new Opt();
        opt.addProperty(127, false, false, 17039620);
        opt.addProperty(191, false, false, 524296);
        opt.addProperty(511, false, false, 524288);
        opt.addProperty(959, false, false, 131072);
        spContainer.add(opt);
        int n = this.column;
        double d = n;
        int n2 = this.row;
        ClientAnchor clientAnchor = new ClientAnchor(d, n2, n + 1, n2 + 1, 1);
        spContainer.add(clientAnchor);
        spContainer.add(new ClientData());
        return spContainer;
    }

    @Override
    public ShapeType getType() {
        return this.type;
    }

    @Override
    public double getWidth() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.width;
    }

    @Override
    public double getX() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.column;
    }

    @Override
    public double getY() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.row;
    }

    public int hashCode() {
        return this.getClass().getName().hashCode();
    }

    @Override
    public boolean isFirst() {
        return this.msoDrawingRecord.isFirst();
    }

    @Override
    public boolean isFormObject() {
        return false;
    }

    @Override
    public void setDrawingGroup(DrawingGroup drawingGroup) {
        this.drawingGroup = drawingGroup;
    }

    public void setFormatting(ContinueRecord continueRecord) {
        this.formatting = continueRecord;
    }

    @Override
    public void setHeight(double d) {
        if (this.origin == Origin.READ) {
            if (!this.initialized) {
                this.initialize();
            }
            this.origin = Origin.READ_WRITE;
        }
        this.height = d;
    }

    @Override
    public final void setObjectId(int n, int n2, int n3) {
        this.objectId = n;
        this.blipId = n2;
        this.shapeId = n3;
        if (this.origin == Origin.READ) {
            this.origin = Origin.READ_WRITE;
        }
    }

    @Override
    public void setReferenceCount(int n) {
        this.referenceCount = n;
    }

    public void setText(ContinueRecord continueRecord) {
        this.text = continueRecord;
    }

    public void setTextObject(TextObjectRecord textObjectRecord) {
        this.txo = textObjectRecord;
    }

    @Override
    public void setWidth(double d) {
        if (this.origin == Origin.READ) {
            if (!this.initialized) {
                this.initialize();
            }
            this.origin = Origin.READ_WRITE;
        }
        this.width = d;
    }

    @Override
    public void setX(double d) {
        if (this.origin == Origin.READ) {
            if (!this.initialized) {
                this.initialize();
            }
            this.origin = Origin.READ_WRITE;
        }
        this.column = (int)d;
    }

    @Override
    public void setY(double d) {
        if (this.origin == Origin.READ) {
            if (!this.initialized) {
                this.initialize();
            }
            this.origin = Origin.READ_WRITE;
        }
        this.row = (int)d;
    }

    @Override
    public void writeAdditionalRecords(File file) throws IOException {
        if (this.origin == Origin.READ) {
            file.write(this.objRecord);
            MsoDrawingRecord msoDrawingRecord = this.mso;
            if (msoDrawingRecord != null) {
                file.write(msoDrawingRecord);
            }
            file.write(this.txo);
            file.write(this.text);
            ContinueRecord continueRecord = this.formatting;
            if (continueRecord != null) {
                file.write(continueRecord);
            }
            return;
        }
        file.write(new ObjRecord(this.objectId, ObjRecord.CHECKBOX));
        logger.warn("Writing of additional records for checkboxes not implemented");
    }

    @Override
    public void writeTailRecords(File file) {
    }
}

