/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.File
 *  java.io.FileInputStream
 *  java.io.IOException
 *  java.lang.Double
 *  java.lang.Integer
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.System
 */
package jxl.biff.drawing;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import jxl.CellView;
import jxl.Image;
import jxl.Sheet;
import jxl.biff.ByteData;
import jxl.biff.drawing.ClientAnchor;
import jxl.biff.drawing.ClientData;
import jxl.biff.drawing.DrawingData;
import jxl.biff.drawing.DrawingGroup;
import jxl.biff.drawing.DrawingGroupObject;
import jxl.biff.drawing.EscherContainer;
import jxl.biff.drawing.EscherRecord;
import jxl.biff.drawing.EscherRecordType;
import jxl.biff.drawing.MsoDrawingRecord;
import jxl.biff.drawing.ObjRecord;
import jxl.biff.drawing.Opt;
import jxl.biff.drawing.Origin;
import jxl.biff.drawing.PNGReader;
import jxl.biff.drawing.ShapeType;
import jxl.biff.drawing.Sp;
import jxl.biff.drawing.SpContainer;
import jxl.common.Assert;
import jxl.common.LengthConverter;
import jxl.common.LengthUnit;
import jxl.common.Logger;
import jxl.format.CellFormat;
import jxl.format.Font;

public class Drawing
implements DrawingGroupObject,
Image {
    private static final double DEFAULT_FONT_SIZE = 10.0;
    public static ImageAnchorProperties MOVE_AND_SIZE_WITH_CELLS;
    public static ImageAnchorProperties MOVE_WITH_CELLS;
    public static ImageAnchorProperties NO_MOVE_OR_SIZE_WITH_CELLS;
    private static Logger logger;
    private int blipId;
    private DrawingData drawingData;
    private DrawingGroup drawingGroup;
    private int drawingNumber;
    private EscherContainer escherData;
    private double height;
    private ImageAnchorProperties imageAnchorProperties;
    private byte[] imageData;
    private File imageFile;
    private boolean initialized = false;
    private MsoDrawingRecord msoDrawingRecord;
    private ObjRecord objRecord;
    private int objectId;
    private Origin origin;
    private PNGReader pngReader;
    private EscherContainer readSpContainer;
    private int referenceCount;
    private int shapeId;
    private Sheet sheet;
    private ShapeType type;
    private double width;
    private double x;
    private double y;

    static {
        logger = Logger.getLogger(Drawing.class);
        MOVE_AND_SIZE_WITH_CELLS = new Object(1){
            private static ImageAnchorProperties[] o = new ImageAnchorProperties[0];
            private int value;
            {
                this.value = n;
                ImageAnchorProperties[] arrimageAnchorProperties = o;
                o = new ImageAnchorProperties[1 + arrimageAnchorProperties.length];
                System.arraycopy((Object)arrimageAnchorProperties, (int)0, (Object)o, (int)0, (int)arrimageAnchorProperties.length);
                ImageAnchorProperties.o[arrimageAnchorProperties.length] = this;
            }

            static ImageAnchorProperties getImageAnchorProperties(int n) {
                ImageAnchorProperties[] arrimageAnchorProperties;
                ImageAnchorProperties imageAnchorProperties = Drawing.MOVE_AND_SIZE_WITH_CELLS;
                for (int i = 0; i < (arrimageAnchorProperties = o).length; ++i) {
                    if (arrimageAnchorProperties[i].getValue() != n) continue;
                    return o[i];
                }
                return imageAnchorProperties;
            }

            int getValue() {
                return this.value;
            }
        };
        MOVE_WITH_CELLS = new /* invalid duplicate definition of identical inner class */;
        NO_MOVE_OR_SIZE_WITH_CELLS = new /* invalid duplicate definition of identical inner class */;
    }

    public Drawing(double d, double d2, double d3, double d4, File file) {
        this.imageFile = file;
        this.initialized = true;
        this.origin = Origin.WRITE;
        this.x = d;
        this.y = d2;
        this.width = d3;
        this.height = d4;
        this.referenceCount = 1;
        this.imageAnchorProperties = MOVE_WITH_CELLS;
        this.type = ShapeType.PICTURE_FRAME;
    }

    public Drawing(double d, double d2, double d3, double d4, byte[] arrby) {
        this.imageData = arrby;
        this.initialized = true;
        this.origin = Origin.WRITE;
        this.x = d;
        this.y = d2;
        this.width = d3;
        this.height = d4;
        this.referenceCount = 1;
        this.imageAnchorProperties = MOVE_WITH_CELLS;
        this.type = ShapeType.PICTURE_FRAME;
    }

    protected Drawing(DrawingGroupObject drawingGroupObject, DrawingGroup drawingGroup) {
        Drawing drawing = (Drawing)drawingGroupObject;
        boolean bl = drawing.origin == Origin.READ;
        Assert.verify(bl);
        this.msoDrawingRecord = drawing.msoDrawingRecord;
        this.objRecord = drawing.objRecord;
        this.initialized = false;
        this.origin = Origin.READ;
        this.drawingData = drawing.drawingData;
        this.drawingGroup = drawingGroup;
        this.drawingNumber = drawing.drawingNumber;
        this.drawingGroup.addDrawing(this);
    }

    public Drawing(MsoDrawingRecord msoDrawingRecord, ObjRecord objRecord, DrawingData drawingData, DrawingGroup drawingGroup, Sheet sheet) {
        this.drawingGroup = drawingGroup;
        this.msoDrawingRecord = msoDrawingRecord;
        this.drawingData = drawingData;
        this.objRecord = objRecord;
        this.sheet = sheet;
        this.initialized = false;
        this.origin = Origin.READ;
        this.drawingData.addData(this.msoDrawingRecord.getData());
        int n = this.drawingData.getNumDrawings();
        boolean bl = true;
        this.drawingNumber = n - bl;
        this.drawingGroup.addDrawing(this);
        if (msoDrawingRecord == null || objRecord == null) {
            bl = false;
        }
        Assert.verify(bl);
        this.initialize();
    }

    private double getHeightInPoints() {
        int n;
        Sheet sheet = this.sheet;
        double d = 0.0;
        if (sheet == null) {
            logger.warn("calculating image height:  sheet is null");
            return d;
        }
        double d2 = this.y;
        int n2 = (int)d2;
        int n3 = -1 + (int)Math.ceil((double)(d2 + this.height));
        int n4 = this.sheet.getRowView(n2).getSize();
        double d3 = n4;
        int n5 = 0;
        if (n3 != n2) {
            n = this.sheet.getRowView(n3).getSize();
            n5 = 0;
        } else {
            n = 0;
        }
        while (n5 < -1 + (n3 - n2)) {
            double d4 = this.sheet.getRowView(n5 + (n2 + 1)).getSize();
            Double.isNaN((double)d4);
            d += d4;
            ++n5;
        }
        Double.isNaN((double)d3);
        double d5 = d + d3;
        double d6 = n;
        Double.isNaN((double)d6);
        return (d5 + d6) / 20.0;
    }

    /*
     * Exception decompiling
     */
    private PNGReader getPngReader() {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl31 : ALOAD_0 : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }

    private EscherContainer getReadSpContainer() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.readSpContainer;
    }

    private double getWidthInPoints() {
        double d;
        if (this.sheet == null) {
            logger.warn("calculating image width:  sheet is null");
            return 0.0;
        }
        double d2 = this.x;
        int n = (int)d2;
        int n2 = -1 + (int)Math.ceil((double)(d2 + this.width));
        CellView cellView = this.sheet.getColumnView(n);
        int n3 = cellView.getSize();
        double d3 = this.x;
        double d4 = n;
        Double.isNaN((double)d4);
        double d5 = 1.0 - (d3 - d4);
        double d6 = n3;
        Double.isNaN((double)d6);
        double d7 = d5 * d6;
        double d8 = cellView.getFormat() != null ? (double)cellView.getFormat().getFont().getPointSize() : 10.0;
        double d9 = d8 * (d7 * 0.59) / 256.0;
        if (n2 != n) {
            CellView cellView2 = this.sheet.getColumnView(n2);
            int n4 = cellView2.getSize();
            double d10 = this.x + this.width;
            double d11 = n2;
            Double.isNaN((double)d11);
            double d12 = d10 - d11;
            double d13 = n4;
            Double.isNaN((double)d13);
            double d14 = d12 * d13;
            double d15 = cellView2.getFormat() != null ? (double)cellView2.getFormat().getFont().getPointSize() : 10.0;
            d = d15 * (d14 * 0.59) / 256.0;
        } else {
            d = 0.0;
        }
        double d16 = 0.0;
        for (int i = 0; i < -1 + (n2 - n); ++i) {
            CellView cellView3 = this.sheet.getColumnView(i + (n + 1));
            double d17 = cellView3.getFormat() != null ? (double)cellView3.getFormat().getFont().getPointSize() : 10.0;
            double d18 = cellView3.getSize();
            Double.isNaN((double)d18);
            d16 += d17 * (d18 * 0.59) / 256.0;
        }
        return d + (d16 + d9);
    }

    private void initialize() {
        Opt opt;
        EscherContainer escherContainer = this.readSpContainer = this.drawingData.getSpContainer(this.drawingNumber);
        int n = 0;
        boolean bl = escherContainer != null;
        Assert.verify(bl);
        EscherRecord[] arrescherRecord = this.readSpContainer.getChildren();
        Sp sp = (Sp)this.readSpContainer.getChildren()[0];
        this.shapeId = sp.getShapeId();
        this.objectId = this.objRecord.getObjectId();
        this.type = ShapeType.getType(sp.getShapeType());
        if (this.type == ShapeType.UNKNOWN) {
            logger.warn("Unknown shape type");
        }
        if ((opt = (Opt)this.readSpContainer.getChildren()[1]).getProperty(260) != null) {
            this.blipId = opt.getProperty((int)260).value;
        }
        if (opt.getProperty(261) != null) {
            this.imageFile = new File(opt.getProperty((int)261).stringValue);
        } else if (this.type == ShapeType.PICTURE_FRAME) {
            logger.warn("no filename property for drawing");
            this.imageFile = new File(Integer.toString((int)this.blipId));
        }
        ClientAnchor clientAnchor = null;
        while (n < arrescherRecord.length && clientAnchor == null) {
            if (arrescherRecord[n].getType() == EscherRecordType.CLIENT_ANCHOR) {
                clientAnchor = (ClientAnchor)arrescherRecord[n];
            }
            ++n;
        }
        if (clientAnchor == null) {
            logger.warn("client anchor not found");
        } else {
            this.x = clientAnchor.getX1();
            this.y = clientAnchor.getY1();
            this.width = clientAnchor.getX2() - this.x;
            this.height = clientAnchor.getY2() - this.y;
            this.imageAnchorProperties = ImageAnchorProperties.getImageAnchorProperties(clientAnchor.getProperties());
        }
        if (this.blipId == 0) {
            logger.warn("linked drawings are not supported");
        }
        this.initialized = true;
    }

    @Override
    public final int getBlipId() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.blipId;
    }

    @Override
    public double getColumn() {
        return this.getX();
    }

    @Override
    public DrawingGroup getDrawingGroup() {
        return this.drawingGroup;
    }

    @Override
    public double getHeight() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.height;
    }

    @Override
    public double getHeight(LengthUnit lengthUnit) {
        return this.getHeightInPoints() * LengthConverter.getConversionFactor(LengthUnit.POINTS, lengthUnit);
    }

    @Override
    public double getHorizontalResolution(LengthUnit lengthUnit) {
        double d = this.getPngReader().getHorizontalResolution();
        double d2 = LengthConverter.getConversionFactor(LengthUnit.METRES, lengthUnit);
        Double.isNaN((double)d);
        return d / d2;
    }

    protected ImageAnchorProperties getImageAnchor() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.imageAnchorProperties;
    }

    @Override
    public byte[] getImageBytes() throws IOException {
        if (this.origin != Origin.READ && this.origin != Origin.READ_WRITE) {
            Origin origin = this.origin;
            Origin origin2 = Origin.WRITE;
            boolean bl = true;
            boolean bl2 = origin == origin2;
            Assert.verify(bl2);
            File file = this.imageFile;
            if (file == null) {
                if (this.imageData == null) {
                    bl = false;
                }
                Assert.verify(bl);
                return this.imageData;
            }
            byte[] arrby = new byte[(int)file.length()];
            FileInputStream fileInputStream = new FileInputStream(this.imageFile);
            fileInputStream.read(arrby, 0, arrby.length);
            fileInputStream.close();
            return arrby;
        }
        return this.getImageData();
    }

    @Override
    public byte[] getImageData() {
        boolean bl = this.origin == Origin.READ || this.origin == Origin.READ_WRITE;
        Assert.verify(bl);
        if (!this.initialized) {
            this.initialize();
        }
        return this.drawingGroup.getImageData(this.blipId);
    }

    @Override
    public File getImageFile() {
        return this.imageFile;
    }

    @Override
    public String getImageFilePath() {
        File file = this.imageFile;
        if (file == null) {
            int n = this.blipId;
            if (n != 0) {
                return Integer.toString((int)n);
            }
            return "__new__image__";
        }
        return file.getPath();
    }

    @Override
    public int getImageHeight() {
        return this.getPngReader().getHeight();
    }

    @Override
    public int getImageWidth() {
        return this.getPngReader().getWidth();
    }

    @Override
    public MsoDrawingRecord getMsoDrawingRecord() {
        return this.msoDrawingRecord;
    }

    @Override
    public final int getObjectId() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.objectId;
    }

    @Override
    public Origin getOrigin() {
        return this.origin;
    }

    @Override
    public int getReferenceCount() {
        return this.referenceCount;
    }

    @Override
    public double getRow() {
        return this.getY();
    }

    @Override
    public int getShapeId() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.shapeId;
    }

    @Override
    public EscherContainer getSpContainer() {
        if (!this.initialized) {
            this.initialize();
        }
        if (this.origin == Origin.READ) {
            return this.getReadSpContainer();
        }
        SpContainer spContainer = new SpContainer();
        spContainer.add(new Sp(this.type, this.shapeId, 2560));
        Opt opt = new Opt();
        opt.addProperty(260, true, false, this.blipId);
        if (this.type == ShapeType.PICTURE_FRAME) {
            File file = this.imageFile;
            String string = file != null ? file.getPath() : "";
            String string2 = string;
            opt.addProperty(261, true, true, 2 * string2.length(), string2);
            opt.addProperty(447, false, false, 65536);
            opt.addProperty(959, false, false, 524288);
            spContainer.add(opt);
        }
        double d = this.x;
        double d2 = this.y;
        ClientAnchor clientAnchor = new ClientAnchor(d, d2, d + this.width, d2 + this.height, this.imageAnchorProperties.getValue());
        spContainer.add(clientAnchor);
        spContainer.add(new ClientData());
        return spContainer;
    }

    @Override
    public ShapeType getType() {
        return this.type;
    }

    @Override
    public double getVerticalResolution(LengthUnit lengthUnit) {
        double d = this.getPngReader().getVerticalResolution();
        double d2 = LengthConverter.getConversionFactor(LengthUnit.METRES, lengthUnit);
        Double.isNaN((double)d);
        return d / d2;
    }

    @Override
    public double getWidth() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.width;
    }

    @Override
    public double getWidth(LengthUnit lengthUnit) {
        return this.getWidthInPoints() * LengthConverter.getConversionFactor(LengthUnit.POINTS, lengthUnit);
    }

    @Override
    public double getX() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.x;
    }

    @Override
    public double getY() {
        if (!this.initialized) {
            this.initialize();
        }
        return this.y;
    }

    @Override
    public boolean isFirst() {
        return this.msoDrawingRecord.isFirst();
    }

    @Override
    public boolean isFormObject() {
        return false;
    }

    public void removeRow(int n) {
        double d = this.y;
        double d2 = n;
        if (d > d2) {
            this.setY(d2);
        }
    }

    @Override
    public void setDrawingGroup(DrawingGroup drawingGroup) {
        this.drawingGroup = drawingGroup;
    }

    @Override
    public void setHeight(double d) {
        if (this.origin == Origin.READ) {
            if (!this.initialized) {
                this.initialize();
            }
            this.origin = Origin.READ_WRITE;
        }
        this.height = d;
    }

    protected void setImageAnchor(ImageAnchorProperties imageAnchorProperties) {
        this.imageAnchorProperties = imageAnchorProperties;
        if (this.origin == Origin.READ) {
            this.origin = Origin.READ_WRITE;
        }
    }

    @Override
    public final void setObjectId(int n, int n2, int n3) {
        this.objectId = n;
        this.blipId = n2;
        this.shapeId = n3;
        if (this.origin == Origin.READ) {
            this.origin = Origin.READ_WRITE;
        }
    }

    @Override
    public void setReferenceCount(int n) {
        this.referenceCount = n;
    }

    @Override
    public void setWidth(double d) {
        if (this.origin == Origin.READ) {
            if (!this.initialized) {
                this.initialize();
            }
            this.origin = Origin.READ_WRITE;
        }
        this.width = d;
    }

    @Override
    public void setX(double d) {
        if (this.origin == Origin.READ) {
            if (!this.initialized) {
                this.initialize();
            }
            this.origin = Origin.READ_WRITE;
        }
        this.x = d;
    }

    @Override
    public void setY(double d) {
        if (this.origin == Origin.READ) {
            if (!this.initialized) {
                this.initialize();
            }
            this.origin = Origin.READ_WRITE;
        }
        this.y = d;
    }

    @Override
    public void writeAdditionalRecords(jxl.write.biff.File file) throws IOException {
        if (this.origin == Origin.READ) {
            file.write(this.objRecord);
            return;
        }
        file.write(new ObjRecord(this.objectId, ObjRecord.PICTURE));
    }

    @Override
    public void writeTailRecords(jxl.write.biff.File file) throws IOException {
    }

}

