/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.IOException
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.util.ArrayList
 *  java.util.HashMap
 */
package jxl.biff.drawing;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import jxl.biff.ByteData;
import jxl.biff.drawing.BStoreContainer;
import jxl.biff.drawing.BlipStoreEntry;
import jxl.biff.drawing.Chart;
import jxl.biff.drawing.Dgg;
import jxl.biff.drawing.DggContainer;
import jxl.biff.drawing.Drawing;
import jxl.biff.drawing.DrawingGroupObject;
import jxl.biff.drawing.EscherContainer;
import jxl.biff.drawing.EscherRecord;
import jxl.biff.drawing.EscherRecordData;
import jxl.biff.drawing.EscherRecordType;
import jxl.biff.drawing.EscherStream;
import jxl.biff.drawing.MsoDrawingGroupRecord;
import jxl.biff.drawing.MsoDrawingRecord;
import jxl.biff.drawing.ObjRecord;
import jxl.biff.drawing.Opt;
import jxl.biff.drawing.Origin;
import jxl.biff.drawing.SplitMenuColors;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.Record;
import jxl.write.biff.File;

public class DrawingGroup
implements EscherStream {
    private static Logger logger = Logger.getLogger(DrawingGroup.class);
    private BStoreContainer bstoreContainer;
    private byte[] drawingData;
    private int drawingGroupId;
    private ArrayList drawings;
    private boolean drawingsOmitted;
    private EscherContainer escherData;
    private HashMap imageFiles;
    private boolean initialized;
    private int maxObjectId;
    private int maxShapeId;
    private int numBlips;
    private int numCharts;
    private Origin origin;

    public DrawingGroup(DrawingGroup drawingGroup) {
        this.drawingData = drawingGroup.drawingData;
        this.escherData = drawingGroup.escherData;
        this.bstoreContainer = drawingGroup.bstoreContainer;
        this.initialized = drawingGroup.initialized;
        this.drawingData = drawingGroup.drawingData;
        this.escherData = drawingGroup.escherData;
        this.bstoreContainer = drawingGroup.bstoreContainer;
        this.numBlips = drawingGroup.numBlips;
        this.numCharts = drawingGroup.numCharts;
        this.drawingGroupId = drawingGroup.drawingGroupId;
        this.drawingsOmitted = drawingGroup.drawingsOmitted;
        this.origin = drawingGroup.origin;
        this.imageFiles = (HashMap)drawingGroup.imageFiles.clone();
        this.maxObjectId = drawingGroup.maxObjectId;
        this.maxShapeId = drawingGroup.maxShapeId;
        this.drawings = new ArrayList();
    }

    public DrawingGroup(Origin origin) {
        this.origin = origin;
        boolean bl = origin == Origin.WRITE;
        this.initialized = bl;
        this.drawings = new ArrayList();
        this.imageFiles = new HashMap();
        this.drawingsOmitted = false;
        this.maxObjectId = 1;
        this.maxShapeId = 1024;
    }

    private void addData(byte[] arrby) {
        byte[] arrby2 = this.drawingData;
        if (arrby2 == null) {
            this.drawingData = new byte[arrby.length];
            System.arraycopy((Object)arrby, (int)0, (Object)this.drawingData, (int)0, (int)arrby.length);
            return;
        }
        byte[] arrby3 = new byte[arrby2.length + arrby.length];
        System.arraycopy((Object)arrby2, (int)0, (Object)arrby3, (int)0, (int)arrby2.length);
        System.arraycopy((Object)arrby, (int)0, (Object)arrby3, (int)this.drawingData.length, (int)arrby.length);
        this.drawingData = arrby3;
    }

    private BStoreContainer getBStoreContainer() {
        if (this.bstoreContainer == null) {
            EscherRecord[] arrescherRecord;
            if (!this.initialized) {
                this.initialize();
            }
            if ((arrescherRecord = this.escherData.getChildren()).length > 1 && arrescherRecord[1].getType() == EscherRecordType.BSTORE_CONTAINER) {
                this.bstoreContainer = (BStoreContainer)arrescherRecord[1];
            }
        }
        return this.bstoreContainer;
    }

    private void initialize() {
        EscherRecordData escherRecordData = new EscherRecordData(this, 0);
        Assert.verify(escherRecordData.isContainer());
        this.escherData = new EscherContainer(escherRecordData);
        boolean bl = this.escherData.getLength() == this.drawingData.length;
        Assert.verify(bl);
        EscherRecordType escherRecordType = this.escherData.getType();
        EscherRecordType escherRecordType2 = EscherRecordType.DGG_CONTAINER;
        boolean bl2 = false;
        if (escherRecordType == escherRecordType2) {
            bl2 = true;
        }
        Assert.verify(bl2);
        this.initialized = true;
    }

    public void add(Chart chart) {
        this.numCharts = 1 + this.numCharts;
    }

    public void add(DrawingGroupObject drawingGroupObject) {
        if (this.origin == Origin.READ) {
            this.origin = Origin.READ_WRITE;
            BStoreContainer bStoreContainer = this.getBStoreContainer();
            this.drawingGroupId = ((Dgg)this.escherData.getChildren()[0]).getCluster((int)1).drawingGroupId - this.numBlips - 1;
            int n = bStoreContainer != null ? bStoreContainer.getNumBlips() : 0;
            this.numBlips = n;
            if (bStoreContainer != null) {
                int n2 = this.numBlips;
                int n3 = bStoreContainer.getNumBlips();
                boolean bl = false;
                if (n2 == n3) {
                    bl = true;
                }
                Assert.verify(bl);
            }
        }
        if (!(drawingGroupObject instanceof Drawing)) {
            this.maxObjectId = 1 + this.maxObjectId;
            this.maxShapeId = 1 + this.maxShapeId;
            drawingGroupObject.setDrawingGroup(this);
            drawingGroupObject.setObjectId(this.maxObjectId, 1 + this.numBlips, this.maxShapeId);
            if (this.drawings.size() > this.maxObjectId) {
                Logger logger = DrawingGroup.logger;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("drawings length ");
                stringBuilder.append(this.drawings.size());
                stringBuilder.append(" exceeds the max object id ");
                stringBuilder.append(this.maxObjectId);
                logger.warn(stringBuilder.toString());
            }
            return;
        }
        Drawing drawing = (Drawing)drawingGroupObject;
        Drawing drawing2 = (Drawing)this.imageFiles.get((Object)drawingGroupObject.getImageFilePath());
        if (drawing2 == null) {
            this.maxObjectId = 1 + this.maxObjectId;
            this.maxShapeId = 1 + this.maxShapeId;
            this.drawings.add((Object)drawing);
            drawing.setDrawingGroup(this);
            drawing.setObjectId(this.maxObjectId, 1 + this.numBlips, this.maxShapeId);
            this.numBlips = 1 + this.numBlips;
            this.imageFiles.put((Object)drawing.getImageFilePath(), (Object)drawing);
            return;
        }
        drawing2.setReferenceCount(1 + drawing2.getReferenceCount());
        drawing.setDrawingGroup(this);
        drawing.setObjectId(drawing2.getObjectId(), drawing2.getBlipId(), drawing2.getShapeId());
    }

    public void add(MsoDrawingGroupRecord msoDrawingGroupRecord) {
        this.addData(msoDrawingGroupRecord.getData());
    }

    public void add(Record record) {
        this.addData(record.getData());
    }

    final void addDrawing(DrawingGroupObject drawingGroupObject) {
        this.drawings.add((Object)drawingGroupObject);
        this.maxObjectId = Math.max((int)this.maxObjectId, (int)drawingGroupObject.getObjectId());
        this.maxShapeId = Math.max((int)this.maxShapeId, (int)drawingGroupObject.getShapeId());
    }

    @Override
    public byte[] getData() {
        return this.drawingData;
    }

    byte[] getImageData(int n) {
        boolean bl;
        block3 : {
            block2 : {
                this.numBlips = this.getBStoreContainer().getNumBlips();
                boolean bl2 = n <= this.numBlips;
                Assert.verify(bl2);
                if (this.origin == Origin.READ) break block2;
                Origin origin = this.origin;
                Origin origin2 = Origin.READ_WRITE;
                bl = false;
                if (origin != origin2) break block3;
            }
            bl = true;
        }
        Assert.verify(bl);
        return ((BlipStoreEntry)this.getBStoreContainer().getChildren()[n - 1]).getImageData();
    }

    final int getNumberOfBlips() {
        return this.numBlips;
    }

    public boolean hasDrawingsOmitted() {
        return this.drawingsOmitted;
    }

    public void remove(DrawingGroupObject drawingGroupObject) {
        if (this.getBStoreContainer() == null) {
            return;
        }
        if (this.origin == Origin.READ) {
            this.origin = Origin.READ_WRITE;
            this.numBlips = this.getBStoreContainer().getNumBlips();
            this.drawingGroupId = ((Dgg)this.escherData.getChildren()[0]).getCluster((int)1).drawingGroupId - this.numBlips - 1;
        }
        BlipStoreEntry blipStoreEntry = (BlipStoreEntry)this.getBStoreContainer().getChildren()[drawingGroupObject.getBlipId() - 1];
        blipStoreEntry.dereference();
        if (blipStoreEntry.getReferenceCount() == 0) {
            this.getBStoreContainer().remove(blipStoreEntry);
            for (DrawingGroupObject drawingGroupObject2 : this.drawings) {
                if (drawingGroupObject2.getBlipId() <= drawingGroupObject.getBlipId()) continue;
                drawingGroupObject2.setObjectId(drawingGroupObject2.getObjectId(), drawingGroupObject2.getBlipId() - 1, drawingGroupObject2.getShapeId());
            }
            --this.numBlips;
        }
    }

    public void setDrawingsOmitted(MsoDrawingRecord msoDrawingRecord, ObjRecord objRecord) {
        this.drawingsOmitted = true;
        if (objRecord != null) {
            this.maxObjectId = Math.max((int)this.maxObjectId, (int)objRecord.getObjectId());
        }
    }

    public void updateData(DrawingGroup drawingGroup) {
        this.drawingsOmitted = drawingGroup.drawingsOmitted;
        this.maxObjectId = drawingGroup.maxObjectId;
        this.maxShapeId = drawingGroup.maxShapeId;
    }

    public void write(File file) throws IOException {
        Origin origin = this.origin;
        Origin origin2 = Origin.WRITE;
        int n = 0;
        if (origin == origin2) {
            DggContainer dggContainer = new DggContainer();
            int n2 = this.numBlips;
            Dgg dgg = new Dgg(1 + (n2 + this.numCharts), n2);
            dgg.addCluster(1, 0);
            dgg.addCluster(1 + this.numBlips, 0);
            dggContainer.add(dgg);
            BStoreContainer bStoreContainer = new BStoreContainer();
            for (Object object : this.drawings) {
                if (!(object instanceof Drawing)) continue;
                bStoreContainer.add(new BlipStoreEntry((Drawing)object));
                ++n;
            }
            if (n > 0) {
                bStoreContainer.setNumBlips(n);
                dggContainer.add(bStoreContainer);
            }
            dggContainer.add(new Opt());
            dggContainer.add(new SplitMenuColors());
            this.drawingData = dggContainer.getData();
        } else if (this.origin == Origin.READ_WRITE) {
            DggContainer dggContainer = new DggContainer();
            int n3 = this.numBlips;
            Dgg dgg = new Dgg(1 + (n3 + this.numCharts), n3);
            dgg.addCluster(1, 0);
            dgg.addCluster(1 + (this.drawingGroupId + this.numBlips), 0);
            dggContainer.add(dgg);
            BStoreContainer bStoreContainer = new BStoreContainer();
            bStoreContainer.setNumBlips(this.numBlips);
            BStoreContainer bStoreContainer2 = this.getBStoreContainer();
            if (bStoreContainer2 != null) {
                EscherRecord[] arrescherRecord = bStoreContainer2.getChildren();
                for (int i = 0; i < arrescherRecord.length; ++i) {
                    bStoreContainer.add((BlipStoreEntry)arrescherRecord[i]);
                }
            }
            for (DrawingGroupObject drawingGroupObject : this.drawings) {
                Drawing drawing;
                if (!(drawingGroupObject instanceof Drawing) || (drawing = (Drawing)drawingGroupObject).getOrigin() != Origin.WRITE) continue;
                bStoreContainer.add(new BlipStoreEntry(drawing));
            }
            dggContainer.add(bStoreContainer);
            Opt opt = new Opt();
            opt.addProperty(191, false, false, 524296);
            opt.addProperty(385, false, false, 134217737);
            opt.addProperty(448, false, false, 134217792);
            dggContainer.add(opt);
            dggContainer.add(new SplitMenuColors());
            this.drawingData = dggContainer.getData();
        }
        file.write(new MsoDrawingGroupRecord(this.drawingData));
    }
}

