/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.BufferedWriter
 *  java.io.IOException
 *  java.lang.Integer
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  jxl.biff.drawing.Dg
 *  jxl.biff.drawing.EscherContainer
 *  jxl.biff.drawing.Opt
 *  jxl.biff.drawing.Sp
 */
package jxl.biff.drawing;

import java.io.BufferedWriter;
import java.io.IOException;
import jxl.biff.drawing.Dg;
import jxl.biff.drawing.EscherContainer;
import jxl.biff.drawing.EscherRecord;
import jxl.biff.drawing.EscherRecordData;
import jxl.biff.drawing.EscherRecordType;
import jxl.biff.drawing.EscherStream;
import jxl.biff.drawing.Opt;
import jxl.biff.drawing.Sp;

public class EscherDisplay {
    private EscherStream stream;
    private BufferedWriter writer;

    public EscherDisplay(EscherStream escherStream, BufferedWriter bufferedWriter) {
        this.stream = escherStream;
        this.writer = bufferedWriter;
    }

    private void displayContainer(EscherContainer escherContainer, int n) throws IOException {
        this.displayRecord((EscherRecord)escherContainer, n);
        int n2 = n + 1;
        EscherRecord[] arrescherRecord = escherContainer.getChildren();
        for (int i = 0; i < arrescherRecord.length; ++i) {
            EscherRecord escherRecord = arrescherRecord[i];
            if (escherRecord.getEscherData().isContainer()) {
                this.displayContainer((EscherContainer)escherRecord, n2);
                continue;
            }
            this.displayRecord(escherRecord, n2);
        }
    }

    private void displayRecord(EscherRecord escherRecord, int n) throws IOException {
        this.indent(n);
        EscherRecordType escherRecordType = escherRecord.getType();
        this.writer.write(Integer.toString((int)escherRecordType.getValue(), (int)16));
        this.writer.write(" - ");
        if (escherRecordType == EscherRecordType.DGG_CONTAINER) {
            this.writer.write("Dgg Container");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.BSTORE_CONTAINER) {
            this.writer.write("BStore Container");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.DG_CONTAINER) {
            this.writer.write("Dg Container");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.SPGR_CONTAINER) {
            this.writer.write("Spgr Container");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.SP_CONTAINER) {
            this.writer.write("Sp Container");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.DGG) {
            this.writer.write("Dgg");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.BSE) {
            this.writer.write("Bse");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.DG) {
            Dg dg = new Dg(escherRecord.getEscherData());
            BufferedWriter bufferedWriter = this.writer;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Dg:  drawing id ");
            stringBuilder.append(dg.getDrawingId());
            stringBuilder.append(" shape count ");
            stringBuilder.append(dg.getShapeCount());
            bufferedWriter.write(stringBuilder.toString());
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.SPGR) {
            this.writer.write("Spgr");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.SP) {
            Sp sp = new Sp(escherRecord.getEscherData());
            BufferedWriter bufferedWriter = this.writer;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Sp:  shape id ");
            stringBuilder.append(sp.getShapeId());
            stringBuilder.append(" shape type ");
            stringBuilder.append(sp.getShapeType());
            bufferedWriter.write(stringBuilder.toString());
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.OPT) {
            Opt opt = new Opt(escherRecord.getEscherData());
            Opt.Property property = opt.getProperty(260);
            Opt.Property property2 = opt.getProperty(261);
            this.writer.write("Opt (value, stringValue): ");
            if (property != null) {
                BufferedWriter bufferedWriter = this.writer;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("260: ");
                stringBuilder.append(property.value);
                stringBuilder.append(", ");
                stringBuilder.append(property.stringValue);
                stringBuilder.append(";");
                bufferedWriter.write(stringBuilder.toString());
            }
            if (property2 != null) {
                BufferedWriter bufferedWriter = this.writer;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("261: ");
                stringBuilder.append(property2.value);
                stringBuilder.append(", ");
                stringBuilder.append(property2.stringValue);
                stringBuilder.append(";");
                bufferedWriter.write(stringBuilder.toString());
            }
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.CLIENT_ANCHOR) {
            this.writer.write("Client Anchor");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.CLIENT_DATA) {
            this.writer.write("Client Data");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.CLIENT_TEXT_BOX) {
            this.writer.write("Client Text Box");
            this.writer.newLine();
            return;
        }
        if (escherRecordType == EscherRecordType.SPLIT_MENU_COLORS) {
            this.writer.write("Split Menu Colors");
            this.writer.newLine();
            return;
        }
        this.writer.write("???");
        this.writer.newLine();
    }

    private void indent(int n) throws IOException {
        for (int i = 0; i < n * 2; ++i) {
            this.writer.write(32);
        }
    }

    public void display() throws IOException {
        this.displayContainer(new EscherContainer(new EscherRecordData(this.stream, 0)), 0);
    }
}

