/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 */
package jxl.biff.drawing;

import jxl.biff.IntegerHelper;
import jxl.biff.Type;
import jxl.biff.WritableRecordData;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.Record;

public class ObjRecord
extends WritableRecordData {
    public static final ObjType ARC;
    public static final ObjType BUTTON;
    public static final ObjType CHART;
    public static final ObjType CHECKBOX;
    private static final int CLIPBOARD_FORMAT_LENGTH = 6;
    public static final ObjType COMBOBOX;
    private static final int COMBOBOX_STRUCTURE_LENGTH = 44;
    private static final int COMMON_DATA_LENGTH = 22;
    public static final ObjType DIALOGUEBOX;
    public static final ObjType EDITBOX;
    private static final int END_LENGTH = 4;
    public static final ObjType EXCELNOTE;
    public static final ObjType FORMCONTROL;
    public static final ObjType GROUP;
    public static final ObjType GROUPBOX;
    public static final ObjType LABEL;
    public static final ObjType LINE;
    public static final ObjType LISTBOX;
    public static final ObjType MSOFFICEDRAWING;
    private static final int NOTE_STRUCTURE_LENGTH = 26;
    public static final ObjType OPTION;
    public static final ObjType OVAL;
    public static final ObjType PICTURE;
    private static final int PICTURE_OPTION_LENGTH = 6;
    public static final ObjType POLYGON;
    public static final ObjType RECTANGLE;
    public static final ObjType SCROLLBAR;
    public static final ObjType SPINBOX;
    public static final ObjType TEXT;
    public static final ObjType UNKNOWN;
    private static final Logger logger;
    private int objectId;
    private boolean read;
    private ObjType type;

    static {
        logger = Logger.getLogger(ObjRecord.class);
        GROUP = new Object(0, "Group"){
            private static ObjType[] types = new ObjType[0];
            public String desc;
            public int value;
            {
                this.value = n;
                this.desc = string;
                ObjType[] arrobjType = types;
                types = new ObjType[1 + arrobjType.length];
                System.arraycopy((Object)arrobjType, (int)0, (Object)types, (int)0, (int)arrobjType.length);
                ObjType.types[arrobjType.length] = this;
            }

            public static ObjType getType(int n) {
                ObjType objType = ObjRecord.UNKNOWN;
                for (int i = 0; i < types.length && objType == ObjRecord.UNKNOWN; ++i) {
                    ObjType[] arrobjType = types;
                    if (arrobjType[i].value != n) continue;
                    objType = arrobjType[i];
                }
                return objType;
            }

            public String toString() {
                return this.desc;
            }
        };
        LINE = new /* invalid duplicate definition of identical inner class */;
        RECTANGLE = new /* invalid duplicate definition of identical inner class */;
        OVAL = new /* invalid duplicate definition of identical inner class */;
        ARC = new /* invalid duplicate definition of identical inner class */;
        CHART = new /* invalid duplicate definition of identical inner class */;
        TEXT = new /* invalid duplicate definition of identical inner class */;
        BUTTON = new /* invalid duplicate definition of identical inner class */;
        PICTURE = new /* invalid duplicate definition of identical inner class */;
        POLYGON = new /* invalid duplicate definition of identical inner class */;
        CHECKBOX = new /* invalid duplicate definition of identical inner class */;
        OPTION = new /* invalid duplicate definition of identical inner class */;
        EDITBOX = new /* invalid duplicate definition of identical inner class */;
        LABEL = new /* invalid duplicate definition of identical inner class */;
        DIALOGUEBOX = new /* invalid duplicate definition of identical inner class */;
        SPINBOX = new /* invalid duplicate definition of identical inner class */;
        SCROLLBAR = new /* invalid duplicate definition of identical inner class */;
        LISTBOX = new /* invalid duplicate definition of identical inner class */;
        GROUPBOX = new /* invalid duplicate definition of identical inner class */;
        COMBOBOX = new /* invalid duplicate definition of identical inner class */;
        MSOFFICEDRAWING = new /* invalid duplicate definition of identical inner class */;
        FORMCONTROL = new /* invalid duplicate definition of identical inner class */;
        EXCELNOTE = new /* invalid duplicate definition of identical inner class */;
        UNKNOWN = new /* invalid duplicate definition of identical inner class */;
    }

    ObjRecord(int n, ObjType objType) {
        super(Type.OBJ);
        this.objectId = n;
        this.type = objType;
    }

    public ObjRecord(Record record) {
        super(record);
        byte[] arrby = record.getData();
        int n = IntegerHelper.getInt(arrby[4], arrby[5]);
        this.read = true;
        this.type = ObjType.getType(n);
        if (this.type == UNKNOWN) {
            Logger logger = ObjRecord.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("unknown object type code ");
            stringBuilder.append(n);
            logger.warn(stringBuilder.toString());
        }
        this.objectId = IntegerHelper.getInt(arrby[6], arrby[7]);
    }

    private byte[] getComboBoxData() {
        byte[] arrby = new byte[70];
        IntegerHelper.getTwoBytes(21, arrby, 0);
        IntegerHelper.getTwoBytes(18, arrby, 2);
        IntegerHelper.getTwoBytes(this.type.value, arrby, 4);
        IntegerHelper.getTwoBytes(this.objectId, arrby, 6);
        IntegerHelper.getTwoBytes(0, arrby, 8);
        IntegerHelper.getTwoBytes(12, arrby, 22);
        IntegerHelper.getTwoBytes(20, arrby, 24);
        arrby[36] = 1;
        arrby[38] = 4;
        arrby[42] = 16;
        arrby[46] = 19;
        arrby[48] = -18;
        arrby[49] = 31;
        arrby[52] = 4;
        arrby[56] = 1;
        arrby[57] = 6;
        arrby[60] = 2;
        arrby[62] = 8;
        arrby[64] = 64;
        IntegerHelper.getTwoBytes(0, arrby, 66);
        IntegerHelper.getTwoBytes(0, arrby, 68);
        return arrby;
    }

    private byte[] getNoteData() {
        byte[] arrby = new byte[52];
        IntegerHelper.getTwoBytes(21, arrby, 0);
        IntegerHelper.getTwoBytes(18, arrby, 2);
        IntegerHelper.getTwoBytes(this.type.value, arrby, 4);
        IntegerHelper.getTwoBytes(this.objectId, arrby, 6);
        IntegerHelper.getTwoBytes(16401, arrby, 8);
        IntegerHelper.getTwoBytes(13, arrby, 22);
        IntegerHelper.getTwoBytes(22, arrby, 24);
        IntegerHelper.getTwoBytes(0, arrby, 48);
        IntegerHelper.getTwoBytes(0, arrby, 50);
        return arrby;
    }

    private byte[] getPictureData() {
        byte[] arrby = new byte[38];
        IntegerHelper.getTwoBytes(21, arrby, 0);
        IntegerHelper.getTwoBytes(18, arrby, 2);
        IntegerHelper.getTwoBytes(this.type.value, arrby, 4);
        IntegerHelper.getTwoBytes(this.objectId, arrby, 6);
        IntegerHelper.getTwoBytes(24593, arrby, 8);
        IntegerHelper.getTwoBytes(7, arrby, 22);
        IntegerHelper.getTwoBytes(2, arrby, 24);
        IntegerHelper.getTwoBytes(65535, arrby, 26);
        IntegerHelper.getTwoBytes(8, arrby, 28);
        IntegerHelper.getTwoBytes(2, arrby, 30);
        IntegerHelper.getTwoBytes(1, arrby, 32);
        IntegerHelper.getTwoBytes(0, arrby, 34);
        IntegerHelper.getTwoBytes(0, arrby, 36);
        return arrby;
    }

    @Override
    public byte[] getData() {
        if (this.read) {
            return this.getRecord().getData();
        }
        ObjType objType = this.type;
        if (objType != PICTURE && objType != CHART) {
            if (objType == EXCELNOTE) {
                return this.getNoteData();
            }
            if (objType == COMBOBOX) {
                return this.getComboBoxData();
            }
            Assert.verify(false);
            return null;
        }
        return this.getPictureData();
    }

    public int getObjectId() {
        return this.objectId;
    }

    @Override
    public Record getRecord() {
        return super.getRecord();
    }

    public ObjType getType() {
        return this.type;
    }

}

