/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.String
 *  java.lang.StringBuffer
 */
package jxl.biff.formula;

import jxl.biff.CellReferenceHelper;
import jxl.biff.IntegerHelper;
import jxl.biff.formula.Operand;
import jxl.biff.formula.ParsedThing;
import jxl.biff.formula.Token;
import jxl.common.Assert;
import jxl.common.Logger;

class Area
extends Operand
implements ParsedThing {
    private static Logger logger = Logger.getLogger(Area.class);
    private int columnFirst;
    private boolean columnFirstRelative;
    private int columnLast;
    private boolean columnLastRelative;
    private int rowFirst;
    private boolean rowFirstRelative;
    private int rowLast;
    private boolean rowLastRelative;

    Area() {
    }

    Area(String string) {
        int n = string.indexOf(":");
        boolean bl = n != -1;
        Assert.verify(bl);
        String string2 = string.substring(0, n);
        String string3 = string.substring(n + 1);
        this.columnFirst = CellReferenceHelper.getColumn(string2);
        this.rowFirst = CellReferenceHelper.getRow(string2);
        this.columnLast = CellReferenceHelper.getColumn(string3);
        this.rowLast = CellReferenceHelper.getRow(string3);
        this.columnFirstRelative = CellReferenceHelper.isColumnRelative(string2);
        this.rowFirstRelative = CellReferenceHelper.isRowRelative(string2);
        this.columnLastRelative = CellReferenceHelper.isColumnRelative(string3);
        this.rowLastRelative = CellReferenceHelper.isRowRelative(string3);
    }

    @Override
    public void adjustRelativeCellReferences(int n, int n2) {
        if (this.columnFirstRelative) {
            this.columnFirst = n + this.columnFirst;
        }
        if (this.columnLastRelative) {
            this.columnLast = n + this.columnLast;
        }
        if (this.rowFirstRelative) {
            this.rowFirst = n2 + this.rowFirst;
        }
        if (this.rowLastRelative) {
            this.rowLast = n2 + this.rowLast;
        }
    }

    @Override
    void columnInserted(int n, int n2, boolean bl) {
        int n3;
        if (!bl) {
            return;
        }
        int n4 = this.columnFirst;
        if (n2 <= n4) {
            this.columnFirst = n4 + 1;
        }
        if (n2 <= (n3 = this.columnLast)) {
            this.columnLast = n3 + 1;
        }
    }

    @Override
    void columnRemoved(int n, int n2, boolean bl) {
        int n3;
        if (!bl) {
            return;
        }
        int n4 = this.columnFirst;
        if (n2 < n4) {
            this.columnFirst = n4 - 1;
        }
        if (n2 <= (n3 = this.columnLast)) {
            this.columnLast = n3 - 1;
        }
    }

    @Override
    byte[] getBytes() {
        byte[] arrby = new byte[9];
        byte by = !this.useAlternateCode() ? Token.AREA.getCode() : Token.AREA.getCode2();
        arrby[0] = by;
        IntegerHelper.getTwoBytes(this.rowFirst, arrby, 1);
        IntegerHelper.getTwoBytes(this.rowLast, arrby, 3);
        int n = this.columnFirst;
        if (this.rowFirstRelative) {
            n |= 32768;
        }
        if (this.columnFirstRelative) {
            n |= 16384;
        }
        IntegerHelper.getTwoBytes(n, arrby, 5);
        int n2 = this.columnLast;
        if (this.rowLastRelative) {
            n2 |= 32768;
        }
        if (this.columnLastRelative) {
            n2 |= 16384;
        }
        IntegerHelper.getTwoBytes(n2, arrby, 7);
        return arrby;
    }

    int getFirstColumn() {
        return this.columnFirst;
    }

    int getFirstRow() {
        return this.rowFirst;
    }

    int getLastColumn() {
        return this.columnLast;
    }

    int getLastRow() {
        return this.rowLast;
    }

    @Override
    public void getString(StringBuffer stringBuffer) {
        CellReferenceHelper.getCellReference(this.columnFirst, this.rowFirst, stringBuffer);
        stringBuffer.append(':');
        CellReferenceHelper.getCellReference(this.columnLast, this.rowLast, stringBuffer);
    }

    @Override
    void handleImportedCellReferences() {
    }

    @Override
    public int read(byte[] arrby, int n) {
        this.rowFirst = IntegerHelper.getInt(arrby[n], arrby[n + 1]);
        this.rowLast = IntegerHelper.getInt(arrby[n + 2], arrby[n + 3]);
        int n2 = IntegerHelper.getInt(arrby[n + 4], arrby[n + 5]);
        this.columnFirst = n2 & 255;
        boolean bl = (n2 & 16384) != 0;
        this.columnFirstRelative = bl;
        boolean bl2 = (n2 & 32768) != 0;
        this.rowFirstRelative = bl2;
        int n3 = IntegerHelper.getInt(arrby[n + 6], arrby[n + 7]);
        this.columnLast = n3 & 255;
        boolean bl3 = (n3 & 16384) != 0;
        this.columnLastRelative = bl3;
        int n4 = n3 & 32768;
        boolean bl4 = false;
        if (n4 != 0) {
            bl4 = true;
        }
        this.rowLastRelative = bl4;
        return 8;
    }

    @Override
    void rowInserted(int n, int n2, boolean bl) {
        int n3;
        if (!bl) {
            return;
        }
        if (this.rowLast == 65535) {
            return;
        }
        int n4 = this.rowFirst;
        if (n2 <= n4) {
            this.rowFirst = n4 + 1;
        }
        if (n2 <= (n3 = this.rowLast)) {
            this.rowLast = n3 + 1;
        }
    }

    @Override
    void rowRemoved(int n, int n2, boolean bl) {
        int n3;
        if (!bl) {
            return;
        }
        if (this.rowLast == 65535) {
            return;
        }
        int n4 = this.rowFirst;
        if (n2 < n4) {
            this.rowFirst = n4 - 1;
        }
        if (n2 <= (n3 = this.rowLast)) {
            this.rowLast = n3 - 1;
        }
    }

    protected void setRangeData(int n, int n2, int n3, int n4, boolean bl, boolean bl2, boolean bl3, boolean bl4) {
        this.columnFirst = n;
        this.columnLast = n2;
        this.rowFirst = n3;
        this.rowLast = n4;
        this.columnFirstRelative = bl;
        this.columnLastRelative = bl2;
        this.rowFirstRelative = bl3;
        this.rowLastRelative = bl4;
    }
}

