/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.String
 *  java.lang.StringBuffer
 */
package jxl.biff.formula;

import jxl.biff.CellReferenceHelper;
import jxl.biff.IntegerHelper;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.Operand;
import jxl.biff.formula.ParsedThing;
import jxl.biff.formula.Token;
import jxl.common.Assert;
import jxl.common.Logger;

class Area3d
extends Operand
implements ParsedThing {
    private static Logger logger = Logger.getLogger(Area3d.class);
    private int columnFirst;
    private boolean columnFirstRelative;
    private int columnLast;
    private boolean columnLastRelative;
    private int rowFirst;
    private boolean rowFirstRelative;
    private int rowLast;
    private boolean rowLastRelative;
    private int sheet;
    private ExternalSheet workbook;

    Area3d(String string, ExternalSheet externalSheet) throws FormulaException {
        this.workbook = externalSheet;
        int n = string.lastIndexOf(":");
        boolean bl = n != -1;
        Assert.verify(bl);
        String string2 = string.substring(n + 1);
        int n2 = string.indexOf(33);
        String string3 = string.substring(n2 + 1, n);
        this.columnFirst = CellReferenceHelper.getColumn(string3);
        this.rowFirst = CellReferenceHelper.getRow(string3);
        String string4 = string.substring(0, n2);
        if (string4.charAt(0) == '\'' && string4.charAt(string4.length() - 1) == '\'') {
            string4 = string4.substring(1, string4.length() - 1);
        }
        this.sheet = externalSheet.getExternalSheetIndex(string4);
        if (this.sheet >= 0) {
            this.columnLast = CellReferenceHelper.getColumn(string2);
            this.rowLast = CellReferenceHelper.getRow(string2);
            this.columnFirstRelative = true;
            this.rowFirstRelative = true;
            this.columnLastRelative = true;
            this.rowLastRelative = true;
            return;
        }
        throw new FormulaException(FormulaException.SHEET_REF_NOT_FOUND, string4);
    }

    Area3d(ExternalSheet externalSheet) {
        this.workbook = externalSheet;
    }

    @Override
    public void adjustRelativeCellReferences(int n, int n2) {
        if (this.columnFirstRelative) {
            this.columnFirst = n + this.columnFirst;
        }
        if (this.columnLastRelative) {
            this.columnLast = n + this.columnLast;
        }
        if (this.rowFirstRelative) {
            this.rowFirst = n2 + this.rowFirst;
        }
        if (this.rowLastRelative) {
            this.rowLast = n2 + this.rowLast;
        }
    }

    @Override
    public void columnInserted(int n, int n2, boolean bl) {
        int n3;
        if (n != this.sheet) {
            return;
        }
        int n4 = this.columnFirst;
        if (n4 >= n2) {
            this.columnFirst = n4 + 1;
        }
        if ((n3 = this.columnLast) >= n2) {
            this.columnLast = n3 + 1;
        }
    }

    @Override
    void columnRemoved(int n, int n2, boolean bl) {
        int n3;
        if (n != this.sheet) {
            return;
        }
        int n4 = this.columnFirst;
        if (n2 < n4) {
            this.columnFirst = n4 - 1;
        }
        if (n2 <= (n3 = this.columnLast)) {
            this.columnLast = n3 - 1;
        }
    }

    @Override
    byte[] getBytes() {
        byte[] arrby = new byte[11];
        arrby[0] = Token.AREA3D.getCode();
        IntegerHelper.getTwoBytes(this.sheet, arrby, 1);
        IntegerHelper.getTwoBytes(this.rowFirst, arrby, 3);
        IntegerHelper.getTwoBytes(this.rowLast, arrby, 5);
        int n = this.columnFirst;
        if (this.rowFirstRelative) {
            n |= 32768;
        }
        if (this.columnFirstRelative) {
            n |= 16384;
        }
        IntegerHelper.getTwoBytes(n, arrby, 7);
        int n2 = this.columnLast;
        if (this.rowLastRelative) {
            n2 |= 32768;
        }
        if (this.columnLastRelative) {
            n2 |= 16384;
        }
        IntegerHelper.getTwoBytes(n2, arrby, 9);
        return arrby;
    }

    int getFirstColumn() {
        return this.columnFirst;
    }

    int getFirstRow() {
        return this.rowFirst;
    }

    int getLastColumn() {
        return this.columnLast;
    }

    int getLastRow() {
        return this.rowLast;
    }

    @Override
    public void getString(StringBuffer stringBuffer) {
        CellReferenceHelper.getCellReference(this.sheet, this.columnFirst, this.rowFirst, this.workbook, stringBuffer);
        stringBuffer.append(':');
        CellReferenceHelper.getCellReference(this.columnLast, this.rowLast, stringBuffer);
    }

    @Override
    void handleImportedCellReferences() {
        this.setInvalid();
    }

    @Override
    public int read(byte[] arrby, int n) {
        this.sheet = IntegerHelper.getInt(arrby[n], arrby[n + 1]);
        this.rowFirst = IntegerHelper.getInt(arrby[n + 2], arrby[n + 3]);
        this.rowLast = IntegerHelper.getInt(arrby[n + 4], arrby[n + 5]);
        int n2 = IntegerHelper.getInt(arrby[n + 6], arrby[n + 7]);
        this.columnFirst = n2 & 255;
        boolean bl = (n2 & 16384) != 0;
        this.columnFirstRelative = bl;
        boolean bl2 = (n2 & 32768) != 0;
        this.rowFirstRelative = bl2;
        int n3 = IntegerHelper.getInt(arrby[n + 8], arrby[n + 9]);
        this.columnLast = n3 & 255;
        boolean bl3 = (n3 & 16384) != 0;
        this.columnLastRelative = bl3;
        int n4 = n3 & 32768;
        boolean bl4 = false;
        if (n4 != 0) {
            bl4 = true;
        }
        this.rowLastRelative = bl4;
        return 10;
    }

    @Override
    void rowInserted(int n, int n2, boolean bl) {
        int n3;
        if (n != this.sheet) {
            return;
        }
        if (this.rowLast == 65535) {
            return;
        }
        int n4 = this.rowFirst;
        if (n2 <= n4) {
            this.rowFirst = n4 + 1;
        }
        if (n2 <= (n3 = this.rowLast)) {
            this.rowLast = n3 + 1;
        }
    }

    @Override
    void rowRemoved(int n, int n2, boolean bl) {
        int n3;
        if (n != this.sheet) {
            return;
        }
        if (this.rowLast == 65535) {
            return;
        }
        int n4 = this.rowFirst;
        if (n2 < n4) {
            this.rowFirst = n4 - 1;
        }
        if (n2 <= (n3 = this.rowLast)) {
            this.rowLast = n3 - 1;
        }
    }

    protected void setRangeData(int n, int n2, int n3, int n4, int n5, boolean bl, boolean bl2, boolean bl3, boolean bl4) {
        this.sheet = n;
        this.columnFirst = n2;
        this.columnLast = n3;
        this.rowFirst = n4;
        this.rowLast = n5;
        this.columnFirstRelative = bl;
        this.columnLastRelative = bl2;
        this.rowFirstRelative = bl3;
        this.rowLastRelative = bl4;
    }
}

