/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuffer
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.util.Stack
 */
package jxl.biff.formula;

import java.util.Stack;
import jxl.WorkbookSettings;
import jxl.biff.IntegerHelper;
import jxl.biff.formula.Function;
import jxl.biff.formula.Operator;
import jxl.biff.formula.ParseItem;
import jxl.biff.formula.ParsedThing;
import jxl.biff.formula.Token;
import jxl.common.Assert;
import jxl.common.Logger;

class BuiltInFunction
extends Operator
implements ParsedThing {
    private static Logger logger = Logger.getLogger(BuiltInFunction.class);
    private Function function;
    private WorkbookSettings settings;

    public BuiltInFunction(WorkbookSettings workbookSettings) {
        this.settings = workbookSettings;
    }

    public BuiltInFunction(Function function, WorkbookSettings workbookSettings) {
        this.function = function;
        this.settings = workbookSettings;
    }

    @Override
    public void adjustRelativeCellReferences(int n, int n2) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].adjustRelativeCellReferences(n, n2);
        }
    }

    @Override
    void columnInserted(int n, int n2, boolean bl) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].columnInserted(n, n2, bl);
        }
    }

    @Override
    void columnRemoved(int n, int n2, boolean bl) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].columnRemoved(n, n2, bl);
        }
    }

    @Override
    byte[] getBytes() {
        ParseItem[] arrparseItem = this.getOperands();
        byte[] arrby = new byte[]{};
        for (int i = 0; i < arrparseItem.length; ++i) {
            byte[] arrby2 = arrparseItem[i].getBytes();
            byte[] arrby3 = new byte[arrby.length + arrby2.length];
            System.arraycopy((Object)arrby, (int)0, (Object)arrby3, (int)0, (int)arrby.length);
            System.arraycopy((Object)arrby2, (int)0, (Object)arrby3, (int)arrby.length, (int)arrby2.length);
            arrby = arrby3;
        }
        byte[] arrby4 = new byte[3 + arrby.length];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby4, (int)0, (int)arrby.length);
        int n = arrby.length;
        byte by = !this.useAlternateCode() ? Token.FUNCTION.getCode() : Token.FUNCTION.getCode2();
        arrby4[n] = by;
        IntegerHelper.getTwoBytes(this.function.getCode(), arrby4, 1 + arrby.length);
        return arrby4;
    }

    @Override
    public void getOperands(Stack stack) {
        ParseItem[] arrparseItem = new ParseItem[this.function.getNumArgs()];
        for (int i = -1 + this.function.getNumArgs(); i >= 0; --i) {
            arrparseItem[i] = (ParseItem)stack.pop();
        }
        for (int i = 0; i < this.function.getNumArgs(); ++i) {
            this.add(arrparseItem[i]);
        }
    }

    @Override
    int getPrecedence() {
        return 3;
    }

    @Override
    public void getString(StringBuffer stringBuffer) {
        stringBuffer.append(this.function.getName(this.settings));
        stringBuffer.append('(');
        int n = this.function.getNumArgs();
        if (n > 0) {
            ParseItem[] arrparseItem = this.getOperands();
            arrparseItem[0].getString(stringBuffer);
            for (int i = 1; i < n; ++i) {
                stringBuffer.append(',');
                arrparseItem[i].getString(stringBuffer);
            }
        }
        stringBuffer.append(')');
    }

    @Override
    void handleImportedCellReferences() {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].handleImportedCellReferences();
        }
    }

    @Override
    public int read(byte[] arrby, int n) {
        byte by = arrby[n];
        boolean bl = true;
        int n2 = IntegerHelper.getInt(by, arrby[n + bl]);
        this.function = Function.getFunction(n2);
        if (this.function == Function.UNKNOWN) {
            bl = false;
        }
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append("function code ");
        stringBuilder.append(n2);
        Assert.verify(bl, stringBuilder.toString());
        return 2;
    }

    @Override
    void rowInserted(int n, int n2, boolean bl) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].rowInserted(n, n2, bl);
        }
    }

    @Override
    void rowRemoved(int n, int n2, boolean bl) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].rowRemoved(n, n2, bl);
        }
    }
}

