/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.String
 *  java.lang.StringBuffer
 */
package jxl.biff.formula;

import jxl.Cell;
import jxl.biff.CellReferenceHelper;
import jxl.biff.IntegerHelper;
import jxl.biff.formula.Operand;
import jxl.biff.formula.ParsedThing;
import jxl.biff.formula.Token;
import jxl.common.Logger;

class CellReference
extends Operand
implements ParsedThing {
    private static Logger logger = Logger.getLogger(CellReference.class);
    private int column;
    private boolean columnRelative;
    private Cell relativeTo;
    private int row;
    private boolean rowRelative;

    public CellReference() {
    }

    public CellReference(String string) {
        this.column = CellReferenceHelper.getColumn(string);
        this.row = CellReferenceHelper.getRow(string);
        this.columnRelative = CellReferenceHelper.isColumnRelative(string);
        this.rowRelative = CellReferenceHelper.isRowRelative(string);
    }

    public CellReference(Cell cell) {
        this.relativeTo = cell;
    }

    @Override
    public void adjustRelativeCellReferences(int n, int n2) {
        if (this.columnRelative) {
            this.column = n + this.column;
        }
        if (this.rowRelative) {
            this.row = n2 + this.row;
        }
    }

    @Override
    public void columnInserted(int n, int n2, boolean bl) {
        if (!bl) {
            return;
        }
        int n3 = this.column;
        if (n3 >= n2) {
            this.column = n3 + 1;
        }
    }

    @Override
    void columnRemoved(int n, int n2, boolean bl) {
        if (!bl) {
            return;
        }
        int n3 = this.column;
        if (n3 >= n2) {
            this.column = n3 - 1;
        }
    }

    @Override
    byte[] getBytes() {
        byte[] arrby = new byte[5];
        byte by = !this.useAlternateCode() ? Token.REF.getCode() : Token.REF.getCode2();
        arrby[0] = by;
        IntegerHelper.getTwoBytes(this.row, arrby, 1);
        int n = this.column;
        if (this.rowRelative) {
            n |= 32768;
        }
        if (this.columnRelative) {
            n |= 16384;
        }
        IntegerHelper.getTwoBytes(n, arrby, 3);
        return arrby;
    }

    public int getColumn() {
        return this.column;
    }

    public int getRow() {
        return this.row;
    }

    @Override
    public void getString(StringBuffer stringBuffer) {
        CellReferenceHelper.getCellReference(this.column, true ^ this.columnRelative, this.row, true ^ this.rowRelative, stringBuffer);
    }

    @Override
    void handleImportedCellReferences() {
    }

    @Override
    public int read(byte[] arrby, int n) {
        this.row = IntegerHelper.getInt(arrby[n], arrby[n + 1]);
        int n2 = IntegerHelper.getInt(arrby[n + 2], arrby[n + 3]);
        this.column = n2 & 255;
        boolean bl = (n2 & 16384) != 0;
        this.columnRelative = bl;
        int n3 = n2 & 32768;
        boolean bl2 = false;
        if (n3 != 0) {
            bl2 = true;
        }
        this.rowRelative = bl2;
        return 4;
    }

    @Override
    void rowInserted(int n, int n2, boolean bl) {
        if (!bl) {
            return;
        }
        int n3 = this.row;
        if (n3 >= n2) {
            this.row = n3 + 1;
        }
    }

    @Override
    void rowRemoved(int n, int n2, boolean bl) {
        if (!bl) {
            return;
        }
        int n3 = this.row;
        if (n3 >= n2) {
            this.row = n3 - 1;
        }
    }
}

