/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.String
 *  java.lang.StringBuffer
 */
package jxl.biff.formula;

import jxl.Cell;
import jxl.biff.CellReferenceHelper;
import jxl.biff.IntegerHelper;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.Operand;
import jxl.biff.formula.ParsedThing;
import jxl.biff.formula.Token;
import jxl.common.Logger;

class CellReference3d
extends Operand
implements ParsedThing {
    private static Logger logger = Logger.getLogger(CellReference3d.class);
    private int column;
    private boolean columnRelative;
    private Cell relativeTo;
    private int row;
    private boolean rowRelative;
    private int sheet;
    private ExternalSheet workbook;

    public CellReference3d(String string, ExternalSheet externalSheet) throws FormulaException {
        this.workbook = externalSheet;
        this.columnRelative = true;
        this.rowRelative = true;
        int n = string.indexOf(33);
        String string2 = string.substring(n + 1);
        this.column = CellReferenceHelper.getColumn(string2);
        this.row = CellReferenceHelper.getRow(string2);
        String string3 = string.substring(0, n);
        if (string3.charAt(0) == '\'' && string3.charAt(string3.length() - 1) == '\'') {
            string3 = string3.substring(1, string3.length() - 1);
        }
        this.sheet = externalSheet.getExternalSheetIndex(string3);
        if (this.sheet >= 0) {
            return;
        }
        throw new FormulaException(FormulaException.SHEET_REF_NOT_FOUND, string3);
    }

    public CellReference3d(Cell cell, ExternalSheet externalSheet) {
        this.relativeTo = cell;
        this.workbook = externalSheet;
    }

    @Override
    public void adjustRelativeCellReferences(int n, int n2) {
        if (this.columnRelative) {
            this.column = n + this.column;
        }
        if (this.rowRelative) {
            this.row = n2 + this.row;
        }
    }

    @Override
    public void columnInserted(int n, int n2, boolean bl) {
        if (n != this.sheet) {
            return;
        }
        int n3 = this.column;
        if (n3 >= n2) {
            this.column = n3 + 1;
        }
    }

    @Override
    void columnRemoved(int n, int n2, boolean bl) {
        if (n != this.sheet) {
            return;
        }
        int n3 = this.column;
        if (n3 >= n2) {
            this.column = n3 - 1;
        }
    }

    @Override
    byte[] getBytes() {
        byte[] arrby = new byte[7];
        arrby[0] = Token.REF3D.getCode();
        IntegerHelper.getTwoBytes(this.sheet, arrby, 1);
        IntegerHelper.getTwoBytes(this.row, arrby, 3);
        int n = this.column;
        if (this.rowRelative) {
            n |= 32768;
        }
        if (this.columnRelative) {
            n |= 16384;
        }
        IntegerHelper.getTwoBytes(n, arrby, 5);
        return arrby;
    }

    public int getColumn() {
        return this.column;
    }

    public int getRow() {
        return this.row;
    }

    @Override
    public void getString(StringBuffer stringBuffer) {
        CellReferenceHelper.getCellReference(this.sheet, this.column, true ^ this.columnRelative, this.row, true ^ this.rowRelative, this.workbook, stringBuffer);
    }

    @Override
    void handleImportedCellReferences() {
        this.setInvalid();
    }

    @Override
    public int read(byte[] arrby, int n) {
        this.sheet = IntegerHelper.getInt(arrby[n], arrby[n + 1]);
        this.row = IntegerHelper.getInt(arrby[n + 2], arrby[n + 3]);
        int n2 = IntegerHelper.getInt(arrby[n + 4], arrby[n + 5]);
        this.column = n2 & 255;
        boolean bl = (n2 & 16384) != 0;
        this.columnRelative = bl;
        int n3 = n2 & 32768;
        boolean bl2 = false;
        if (n3 != 0) {
            bl2 = true;
        }
        this.rowRelative = bl2;
        return 6;
    }

    @Override
    void rowInserted(int n, int n2, boolean bl) {
        if (n != this.sheet) {
            return;
        }
        int n3 = this.row;
        if (n3 >= n2) {
            this.row = n3 + 1;
        }
    }

    @Override
    void rowRemoved(int n, int n2, boolean bl) {
        if (n != this.sheet) {
            return;
        }
        int n3 = this.row;
        if (n3 >= n2) {
            this.row = n3 - 1;
        }
    }
}

