/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  jxl.biff.formula.FormulaException
 *  jxl.biff.formula.StringFormulaParser
 *  jxl.biff.formula.TokenFormulaParser
 *  jxl.read.biff.BOFRecord
 */
package jxl.biff.formula;

import jxl.Cell;
import jxl.WorkbookSettings;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.ParseContext;
import jxl.biff.formula.Parser;
import jxl.biff.formula.StringFormulaParser;
import jxl.biff.formula.TokenFormulaParser;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.BOFRecord;

public class FormulaParser {
    private static final Logger logger = Logger.getLogger(FormulaParser.class);
    private Parser parser;

    public FormulaParser(String string2, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings) {
        StringFormulaParser stringFormulaParser = new StringFormulaParser(string2, externalSheet, workbookMethods, workbookSettings, ParseContext.DEFAULT);
        this.parser = stringFormulaParser;
    }

    public FormulaParser(String string2, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings, ParseContext parseContext) {
        StringFormulaParser stringFormulaParser = new StringFormulaParser(string2, externalSheet, workbookMethods, workbookSettings, parseContext);
        this.parser = stringFormulaParser;
    }

    public FormulaParser(byte[] arrby, Cell cell, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings) throws FormulaException {
        if (externalSheet.getWorkbookBof() != null && !externalSheet.getWorkbookBof().isBiff8()) {
            throw new FormulaException(FormulaException.BIFF8_SUPPORTED);
        }
        boolean bl = workbookMethods != null;
        Assert.verify(bl);
        TokenFormulaParser tokenFormulaParser = new TokenFormulaParser(arrby, cell, externalSheet, workbookMethods, workbookSettings, ParseContext.DEFAULT);
        this.parser = tokenFormulaParser;
    }

    public FormulaParser(byte[] arrby, Cell cell, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings, ParseContext parseContext) throws FormulaException {
        if (externalSheet.getWorkbookBof() != null && !externalSheet.getWorkbookBof().isBiff8()) {
            throw new FormulaException(FormulaException.BIFF8_SUPPORTED);
        }
        boolean bl = workbookMethods != null;
        Assert.verify(bl);
        TokenFormulaParser tokenFormulaParser = new TokenFormulaParser(arrby, cell, externalSheet, workbookMethods, workbookSettings, parseContext);
        this.parser = tokenFormulaParser;
    }

    public void adjustRelativeCellReferences(int n, int n2) {
        this.parser.adjustRelativeCellReferences(n, n2);
    }

    public void columnInserted(int n, int n2, boolean bl) {
        this.parser.columnInserted(n, n2, bl);
    }

    public void columnRemoved(int n, int n2, boolean bl) {
        this.parser.columnRemoved(n, n2, bl);
    }

    public byte[] getBytes() {
        return this.parser.getBytes();
    }

    public String getFormula() throws FormulaException {
        return this.parser.getFormula();
    }

    public boolean handleImportedCellReferences() {
        return this.parser.handleImportedCellReferences();
    }

    public void parse() throws FormulaException {
        this.parser.parse();
    }

    public void rowInserted(int n, int n2, boolean bl) {
        this.parser.rowInserted(n, n2, bl);
    }

    public void rowRemoved(int n, int n2, boolean bl) {
        this.parser.rowRemoved(n, n2, bl);
    }
}

