/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.IOException
 *  java.io.Reader
 *  java.io.StringReader
 *  java.lang.Error
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuffer
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.util.ArrayList
 *  java.util.Iterator
 *  java.util.Stack
 */
package jxl.biff.formula;

import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Stack;
import jxl.WorkbookSettings;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ArgumentSeparator;
import jxl.biff.formula.Attribute;
import jxl.biff.formula.BuiltInFunction;
import jxl.biff.formula.CloseParentheses;
import jxl.biff.formula.DoubleValue;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.Function;
import jxl.biff.formula.IntegerValue;
import jxl.biff.formula.OpenParentheses;
import jxl.biff.formula.Operand;
import jxl.biff.formula.Operator;
import jxl.biff.formula.Parenthesis;
import jxl.biff.formula.ParseContext;
import jxl.biff.formula.ParseItem;
import jxl.biff.formula.Parser;
import jxl.biff.formula.StringFunction;
import jxl.biff.formula.StringOperator;
import jxl.biff.formula.Token;
import jxl.biff.formula.UnaryOperator;
import jxl.biff.formula.VariableArgFunction;
import jxl.biff.formula.Yylex;
import jxl.common.Logger;

class StringFormulaParser
implements Parser {
    private static Logger logger = Logger.getLogger(StringFormulaParser.class);
    private Stack arguments;
    private ExternalSheet externalSheet;
    private String formula;
    private WorkbookMethods nameTable;
    private ParseContext parseContext;
    private String parsedFormula;
    private ParseItem root;
    private WorkbookSettings settings;

    public StringFormulaParser(String string, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings, ParseContext parseContext) {
        this.formula = string;
        this.settings = workbookSettings;
        this.externalSheet = externalSheet;
        this.nameTable = workbookMethods;
        this.parseContext = parseContext;
    }

    private ArrayList getTokens() throws FormulaException {
        ArrayList arrayList = new ArrayList();
        Yylex yylex = new Yylex((Reader)new StringReader(this.formula));
        yylex.setExternalSheet(this.externalSheet);
        yylex.setNameTable(this.nameTable);
        ParseItem parseItem = yylex.yylex();
        while (parseItem != null) {
            try {
                arrayList.add((Object)parseItem);
                parseItem = yylex.yylex();
            }
            catch (Error error) {
                FormulaException.FormulaMessage formulaMessage = FormulaException.LEXICAL_ERROR;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append(this.formula);
                stringBuilder.append(" at char  ");
                stringBuilder.append(yylex.getPos());
                throw new FormulaException(formulaMessage, stringBuilder.toString());
            }
            catch (IOException iOException) {
                logger.warn(iOException.toString());
                break;
            }
        }
        return arrayList;
    }

    /*
     * Enabled force condition propagation
     * Lifted jumps to return sites
     */
    private void handleFunction(StringFunction stringFunction, Iterator iterator, Stack stack) throws FormulaException {
        ParseItem parseItem = this.parseCurrent(iterator);
        if (stringFunction.getFunction(this.settings) != Function.UNKNOWN) {
            if (stringFunction.getFunction(this.settings) == Function.SUM && this.arguments == null) {
                Attribute attribute = new Attribute(stringFunction, this.settings);
                attribute.add(parseItem);
                stack.push((Object)attribute);
                return;
            }
            Function function = stringFunction.getFunction(this.settings);
            Function function2 = Function.IF;
            if (function == function2) {
                Attribute attribute = new Attribute(stringFunction, this.settings);
                VariableArgFunction variableArgFunction = new VariableArgFunction(this.settings);
                int n = this.arguments.size();
                for (int i = 0; i < n; ++i) {
                    variableArgFunction.add((ParseItem)this.arguments.get(i));
                }
                attribute.setIfConditions(variableArgFunction);
                stack.push((Object)attribute);
                return;
            }
            if (stringFunction.getFunction(this.settings).getNumArgs() == 255) {
                Stack stack2 = this.arguments;
                if (stack2 == null) {
                    int n = 0;
                    if (parseItem != null) {
                        n = 1;
                    }
                    VariableArgFunction variableArgFunction = new VariableArgFunction(stringFunction.getFunction(this.settings), n, this.settings);
                    if (parseItem != null) {
                        variableArgFunction.add(parseItem);
                    }
                    stack.push((Object)variableArgFunction);
                    return;
                }
                int n = stack2.size();
                VariableArgFunction variableArgFunction = new VariableArgFunction(stringFunction.getFunction(this.settings), n, this.settings);
                ParseItem[] arrparseItem = new ParseItem[n];
                int n2 = 0;
                do {
                    ParseItem parseItem2;
                    if (n2 >= n) break;
                    arrparseItem[n - n2 - 1] = parseItem2 = (ParseItem)this.arguments.pop();
                    ++n2;
                } while (true);
                for (int i = 0; i < arrparseItem.length; ++i) {
                    variableArgFunction.add(arrparseItem[i]);
                }
                stack.push((Object)variableArgFunction);
                this.arguments.clear();
                this.arguments = null;
                return;
            }
            BuiltInFunction builtInFunction = new BuiltInFunction(stringFunction.getFunction(this.settings), this.settings);
            int n = stringFunction.getFunction(this.settings).getNumArgs();
            if (n == 1) {
                builtInFunction.add(parseItem);
            } else {
                if (this.arguments == null && n != 0) throw new FormulaException(FormulaException.INCORRECT_ARGUMENTS);
                Stack stack3 = this.arguments;
                int n3 = 0;
                if (stack3 != null) {
                    if (n != stack3.size()) throw new FormulaException(FormulaException.INCORRECT_ARGUMENTS);
                    n3 = 0;
                }
                while (n3 < n) {
                    builtInFunction.add((ParseItem)this.arguments.get(n3));
                    ++n3;
                }
            }
            stack.push((Object)builtInFunction);
            return;
        }
        FormulaException formulaException = new FormulaException(FormulaException.UNRECOGNIZED_FUNCTION);
        throw formulaException;
    }

    private void handleOperand(Operand operand, Stack stack) {
        boolean bl = operand instanceof IntegerValue;
        if (!bl) {
            stack.push((Object)operand);
            return;
        }
        if (bl) {
            IntegerValue integerValue = (IntegerValue)operand;
            if (!integerValue.isOutOfRange()) {
                stack.push((Object)integerValue);
                return;
            }
            stack.push((Object)new DoubleValue(integerValue.getValue()));
        }
    }

    private ParseItem parseCurrent(Iterator iterator) throws FormulaException {
        Stack stack = new Stack();
        Stack stack2 = new Stack();
        boolean bl = false;
        Stack stack3 = null;
        ParseItem parseItem = null;
        while (iterator.hasNext() && !bl) {
            ParseItem parseItem2 = (ParseItem)iterator.next();
            parseItem2.setParseContext(this.parseContext);
            if (parseItem2 instanceof Operand) {
                this.handleOperand((Operand)parseItem2, stack);
            } else if (parseItem2 instanceof StringFunction) {
                this.handleFunction((StringFunction)parseItem2, iterator, stack);
            } else if (parseItem2 instanceof Operator) {
                Operator operator = (Operator)parseItem2;
                if (operator instanceof StringOperator) {
                    StringOperator stringOperator = (StringOperator)operator;
                    operator = !stack.isEmpty() && !(parseItem instanceof Operator) ? stringOperator.getBinaryOperator() : stringOperator.getUnaryOperator();
                }
                if (stack2.empty()) {
                    stack2.push((Object)operator);
                } else {
                    Operator operator2 = (Operator)stack2.peek();
                    if (operator.getPrecedence() < operator2.getPrecedence()) {
                        stack2.push((Object)operator);
                    } else if (operator.getPrecedence() == operator2.getPrecedence() && operator instanceof UnaryOperator) {
                        stack2.push((Object)operator);
                    } else {
                        stack2.pop();
                        operator2.getOperands(stack);
                        stack.push((Object)operator2);
                        stack2.push((Object)operator);
                    }
                }
            } else if (parseItem2 instanceof ArgumentSeparator) {
                while (!stack2.isEmpty()) {
                    Operator operator = (Operator)stack2.pop();
                    operator.getOperands(stack);
                    stack.push((Object)operator);
                }
                if (stack3 == null) {
                    stack3 = new Stack();
                }
                stack3.push(stack.pop());
                stack.clear();
            } else if (parseItem2 instanceof OpenParentheses) {
                ParseItem parseItem3 = this.parseCurrent(iterator);
                Parenthesis parenthesis = new Parenthesis();
                parseItem3.setParent(parenthesis);
                parenthesis.add(parseItem3);
                stack.push((Object)parenthesis);
            } else if (parseItem2 instanceof CloseParentheses) {
                bl = true;
            }
            parseItem = parseItem2;
        }
        while (!stack2.isEmpty()) {
            Operator operator = (Operator)stack2.pop();
            operator.getOperands(stack);
            stack.push((Object)operator);
        }
        boolean bl2 = stack.empty();
        ParseItem parseItem4 = null;
        if (!bl2) {
            parseItem4 = (ParseItem)stack.pop();
        }
        if (stack3 != null && parseItem4 != null) {
            stack3.push((Object)parseItem4);
        }
        this.arguments = stack3;
        if (!stack.empty() || !stack2.empty()) {
            Logger logger = StringFormulaParser.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Formula ");
            stringBuilder.append(this.formula);
            stringBuilder.append(" has a non-empty parse stack");
            logger.warn(stringBuilder.toString());
        }
        return parseItem4;
    }

    @Override
    public void adjustRelativeCellReferences(int n, int n2) {
        this.root.adjustRelativeCellReferences(n, n2);
    }

    @Override
    public void columnInserted(int n, int n2, boolean bl) {
        this.root.columnInserted(n, n2, bl);
    }

    @Override
    public void columnRemoved(int n, int n2, boolean bl) {
        this.root.columnRemoved(n, n2, bl);
    }

    @Override
    public byte[] getBytes() {
        byte[] arrby = this.root.getBytes();
        if (this.root.isVolatile()) {
            byte[] arrby2 = new byte[4 + arrby.length];
            System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)4, (int)arrby.length);
            arrby2[0] = Token.ATTRIBUTE.getCode();
            arrby2[1] = 1;
            arrby = arrby2;
        }
        return arrby;
    }

    @Override
    public String getFormula() {
        if (this.parsedFormula == null) {
            StringBuffer stringBuffer = new StringBuffer();
            this.root.getString(stringBuffer);
            this.parsedFormula = stringBuffer.toString();
        }
        return this.parsedFormula;
    }

    @Override
    public boolean handleImportedCellReferences() {
        this.root.handleImportedCellReferences();
        return this.root.isValid();
    }

    @Override
    public void parse() throws FormulaException {
        this.root = this.parseCurrent(this.getTokens().iterator());
    }

    @Override
    public void rowInserted(int n, int n2, boolean bl) {
        this.root.rowInserted(n, n2, bl);
    }

    @Override
    public void rowRemoved(int n, int n2, boolean bl) {
        this.root.rowRemoved(n, n2, bl);
    }
}

