/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuffer
 *  java.util.Stack
 */
package jxl.biff.formula;

import java.util.Stack;
import jxl.Cell;
import jxl.WorkbookSettings;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.Add;
import jxl.biff.formula.Area;
import jxl.biff.formula.Area3d;
import jxl.biff.formula.Attribute;
import jxl.biff.formula.BooleanValue;
import jxl.biff.formula.BuiltInFunction;
import jxl.biff.formula.CellReference;
import jxl.biff.formula.CellReference3d;
import jxl.biff.formula.CellReferenceError;
import jxl.biff.formula.Concatenate;
import jxl.biff.formula.Divide;
import jxl.biff.formula.DoubleValue;
import jxl.biff.formula.Equal;
import jxl.biff.formula.ErrorConstant;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.Function;
import jxl.biff.formula.GreaterEqual;
import jxl.biff.formula.GreaterThan;
import jxl.biff.formula.IntegerValue;
import jxl.biff.formula.LessEqual;
import jxl.biff.formula.LessThan;
import jxl.biff.formula.MemArea;
import jxl.biff.formula.MemFunc;
import jxl.biff.formula.MissingArg;
import jxl.biff.formula.Multiply;
import jxl.biff.formula.Name;
import jxl.biff.formula.NameRange;
import jxl.biff.formula.NotEqual;
import jxl.biff.formula.Operator;
import jxl.biff.formula.Parenthesis;
import jxl.biff.formula.ParseContext;
import jxl.biff.formula.ParseItem;
import jxl.biff.formula.Parser;
import jxl.biff.formula.Percent;
import jxl.biff.formula.Power;
import jxl.biff.formula.SharedFormulaArea;
import jxl.biff.formula.SharedFormulaCellReference;
import jxl.biff.formula.StringValue;
import jxl.biff.formula.SubExpression;
import jxl.biff.formula.Subtract;
import jxl.biff.formula.Token;
import jxl.biff.formula.UnaryMinus;
import jxl.biff.formula.UnaryPlus;
import jxl.biff.formula.VariableArgFunction;
import jxl.common.Assert;
import jxl.common.Logger;

class TokenFormulaParser
implements Parser {
    private static Logger logger = Logger.getLogger(TokenFormulaParser.class);
    private WorkbookMethods nameTable;
    private ParseContext parseContext;
    private int pos;
    private Cell relativeTo;
    private ParseItem root;
    private WorkbookSettings settings;
    private byte[] tokenData;
    private Stack tokenStack;
    private ExternalSheet workbook;

    public TokenFormulaParser(byte[] arrby, Cell cell, ExternalSheet externalSheet, WorkbookMethods workbookMethods, WorkbookSettings workbookSettings, ParseContext parseContext) {
        this.tokenData = arrby;
        this.pos = 0;
        this.relativeTo = cell;
        this.workbook = externalSheet;
        this.nameTable = workbookMethods;
        this.tokenStack = new Stack();
        this.settings = workbookSettings;
        this.parseContext = parseContext;
        WorkbookMethods workbookMethods2 = this.nameTable;
        boolean bl = false;
        if (workbookMethods2 != null) {
            bl = true;
        }
        Assert.verify(bl);
    }

    private void addOperator(Operator operator) {
        operator.getOperands(this.tokenStack);
        this.tokenStack.push((Object)operator);
    }

    private void handleMemoryFunction(SubExpression subExpression) throws FormulaException {
        int n = this.pos;
        this.pos = n + subExpression.read(this.tokenData, n);
        Stack stack = this.tokenStack;
        this.tokenStack = new Stack();
        this.parseSubExpression(subExpression.getLength());
        ParseItem[] arrparseItem = new ParseItem[this.tokenStack.size()];
        int n2 = 0;
        while (!this.tokenStack.isEmpty()) {
            arrparseItem[n2] = (ParseItem)this.tokenStack.pop();
            ++n2;
        }
        subExpression.setSubExpression(arrparseItem);
        this.tokenStack = stack;
        this.tokenStack.push((Object)subExpression);
    }

    private void parseSubExpression(int n) throws FormulaException {
        int n2;
        Stack stack = new Stack();
        int n3 = n + this.pos;
        while ((n2 = this.pos) < n3) {
            byte by = this.tokenData[n2];
            this.pos = n2 + 1;
            Token token = Token.getToken(by);
            if (token != Token.UNKNOWN) {
                boolean bl = token != Token.UNKNOWN;
                Assert.verify(bl);
                if (token == Token.REF) {
                    CellReference cellReference = new CellReference(this.relativeTo);
                    int n4 = this.pos;
                    this.pos = n4 + cellReference.read(this.tokenData, n4);
                    this.tokenStack.push((Object)cellReference);
                    continue;
                }
                if (token == Token.REFERR) {
                    CellReferenceError cellReferenceError = new CellReferenceError();
                    int n5 = this.pos;
                    this.pos = n5 + cellReferenceError.read(this.tokenData, n5);
                    this.tokenStack.push((Object)cellReferenceError);
                    continue;
                }
                if (token == Token.ERR) {
                    ErrorConstant errorConstant = new ErrorConstant();
                    int n6 = this.pos;
                    this.pos = n6 + errorConstant.read(this.tokenData, n6);
                    this.tokenStack.push((Object)errorConstant);
                    continue;
                }
                if (token == Token.REFV) {
                    SharedFormulaCellReference sharedFormulaCellReference = new SharedFormulaCellReference(this.relativeTo);
                    int n7 = this.pos;
                    this.pos = n7 + sharedFormulaCellReference.read(this.tokenData, n7);
                    this.tokenStack.push((Object)sharedFormulaCellReference);
                    continue;
                }
                if (token == Token.REF3D) {
                    CellReference3d cellReference3d = new CellReference3d(this.relativeTo, this.workbook);
                    int n8 = this.pos;
                    this.pos = n8 + cellReference3d.read(this.tokenData, n8);
                    this.tokenStack.push((Object)cellReference3d);
                    continue;
                }
                if (token == Token.AREA) {
                    Area area = new Area();
                    int n9 = this.pos;
                    this.pos = n9 + area.read(this.tokenData, n9);
                    this.tokenStack.push((Object)area);
                    continue;
                }
                if (token == Token.AREAV) {
                    SharedFormulaArea sharedFormulaArea = new SharedFormulaArea(this.relativeTo);
                    int n10 = this.pos;
                    this.pos = n10 + sharedFormulaArea.read(this.tokenData, n10);
                    this.tokenStack.push((Object)sharedFormulaArea);
                    continue;
                }
                if (token == Token.AREA3D) {
                    Area3d area3d = new Area3d(this.workbook);
                    int n11 = this.pos;
                    this.pos = n11 + area3d.read(this.tokenData, n11);
                    this.tokenStack.push((Object)area3d);
                    continue;
                }
                if (token == Token.NAME) {
                    Name name = new Name();
                    int n12 = this.pos;
                    this.pos = n12 + name.read(this.tokenData, n12);
                    name.setParseContext(this.parseContext);
                    this.tokenStack.push((Object)name);
                    continue;
                }
                if (token == Token.NAMED_RANGE) {
                    NameRange nameRange = new NameRange(this.nameTable);
                    int n13 = this.pos;
                    this.pos = n13 + nameRange.read(this.tokenData, n13);
                    nameRange.setParseContext(this.parseContext);
                    this.tokenStack.push((Object)nameRange);
                    continue;
                }
                if (token == Token.INTEGER) {
                    IntegerValue integerValue = new IntegerValue();
                    int n14 = this.pos;
                    this.pos = n14 + integerValue.read(this.tokenData, n14);
                    this.tokenStack.push((Object)integerValue);
                    continue;
                }
                if (token == Token.DOUBLE) {
                    DoubleValue doubleValue = new DoubleValue();
                    int n15 = this.pos;
                    this.pos = n15 + doubleValue.read(this.tokenData, n15);
                    this.tokenStack.push((Object)doubleValue);
                    continue;
                }
                if (token == Token.BOOL) {
                    BooleanValue booleanValue = new BooleanValue();
                    int n16 = this.pos;
                    this.pos = n16 + booleanValue.read(this.tokenData, n16);
                    this.tokenStack.push((Object)booleanValue);
                    continue;
                }
                if (token == Token.STRING) {
                    StringValue stringValue = new StringValue(this.settings);
                    int n17 = this.pos;
                    this.pos = n17 + stringValue.read(this.tokenData, n17);
                    this.tokenStack.push((Object)stringValue);
                    continue;
                }
                if (token == Token.MISSING_ARG) {
                    MissingArg missingArg = new MissingArg();
                    int n18 = this.pos;
                    this.pos = n18 + missingArg.read(this.tokenData, n18);
                    this.tokenStack.push((Object)missingArg);
                    continue;
                }
                if (token == Token.UNARY_PLUS) {
                    UnaryPlus unaryPlus = new UnaryPlus();
                    int n19 = this.pos;
                    this.pos = n19 + unaryPlus.read(this.tokenData, n19);
                    this.addOperator(unaryPlus);
                    continue;
                }
                if (token == Token.UNARY_MINUS) {
                    UnaryMinus unaryMinus = new UnaryMinus();
                    int n20 = this.pos;
                    this.pos = n20 + unaryMinus.read(this.tokenData, n20);
                    this.addOperator(unaryMinus);
                    continue;
                }
                if (token == Token.PERCENT) {
                    Percent percent = new Percent();
                    int n21 = this.pos;
                    this.pos = n21 + percent.read(this.tokenData, n21);
                    this.addOperator(percent);
                    continue;
                }
                if (token == Token.SUBTRACT) {
                    Subtract subtract = new Subtract();
                    int n22 = this.pos;
                    this.pos = n22 + subtract.read(this.tokenData, n22);
                    this.addOperator(subtract);
                    continue;
                }
                if (token == Token.ADD) {
                    Add add = new Add();
                    int n23 = this.pos;
                    this.pos = n23 + add.read(this.tokenData, n23);
                    this.addOperator(add);
                    continue;
                }
                if (token == Token.MULTIPLY) {
                    Multiply multiply = new Multiply();
                    int n24 = this.pos;
                    this.pos = n24 + multiply.read(this.tokenData, n24);
                    this.addOperator(multiply);
                    continue;
                }
                if (token == Token.DIVIDE) {
                    Divide divide = new Divide();
                    int n25 = this.pos;
                    this.pos = n25 + divide.read(this.tokenData, n25);
                    this.addOperator(divide);
                    continue;
                }
                if (token == Token.CONCAT) {
                    Concatenate concatenate = new Concatenate();
                    int n26 = this.pos;
                    this.pos = n26 + concatenate.read(this.tokenData, n26);
                    this.addOperator(concatenate);
                    continue;
                }
                if (token == Token.POWER) {
                    Power power = new Power();
                    int n27 = this.pos;
                    this.pos = n27 + power.read(this.tokenData, n27);
                    this.addOperator(power);
                    continue;
                }
                if (token == Token.LESS_THAN) {
                    LessThan lessThan = new LessThan();
                    int n28 = this.pos;
                    this.pos = n28 + lessThan.read(this.tokenData, n28);
                    this.addOperator(lessThan);
                    continue;
                }
                if (token == Token.LESS_EQUAL) {
                    LessEqual lessEqual = new LessEqual();
                    int n29 = this.pos;
                    this.pos = n29 + lessEqual.read(this.tokenData, n29);
                    this.addOperator(lessEqual);
                    continue;
                }
                if (token == Token.GREATER_THAN) {
                    GreaterThan greaterThan = new GreaterThan();
                    int n30 = this.pos;
                    this.pos = n30 + greaterThan.read(this.tokenData, n30);
                    this.addOperator(greaterThan);
                    continue;
                }
                if (token == Token.GREATER_EQUAL) {
                    GreaterEqual greaterEqual = new GreaterEqual();
                    int n31 = this.pos;
                    this.pos = n31 + greaterEqual.read(this.tokenData, n31);
                    this.addOperator(greaterEqual);
                    continue;
                }
                if (token == Token.NOT_EQUAL) {
                    NotEqual notEqual = new NotEqual();
                    int n32 = this.pos;
                    this.pos = n32 + notEqual.read(this.tokenData, n32);
                    this.addOperator(notEqual);
                    continue;
                }
                if (token == Token.EQUAL) {
                    Equal equal = new Equal();
                    int n33 = this.pos;
                    this.pos = n33 + equal.read(this.tokenData, n33);
                    this.addOperator(equal);
                    continue;
                }
                if (token == Token.PARENTHESIS) {
                    Parenthesis parenthesis = new Parenthesis();
                    int n34 = this.pos;
                    this.pos = n34 + parenthesis.read(this.tokenData, n34);
                    this.addOperator(parenthesis);
                    continue;
                }
                if (token == Token.ATTRIBUTE) {
                    Attribute attribute = new Attribute(this.settings);
                    int n35 = this.pos;
                    this.pos = n35 + attribute.read(this.tokenData, n35);
                    if (attribute.isSum()) {
                        this.addOperator(attribute);
                        continue;
                    }
                    if (!attribute.isIf()) continue;
                    stack.push((Object)attribute);
                    continue;
                }
                if (token == Token.FUNCTION) {
                    BuiltInFunction builtInFunction = new BuiltInFunction(this.settings);
                    int n36 = this.pos;
                    this.pos = n36 + builtInFunction.read(this.tokenData, n36);
                    this.addOperator(builtInFunction);
                    continue;
                }
                if (token == Token.FUNCTIONVARARG) {
                    VariableArgFunction variableArgFunction = new VariableArgFunction(this.settings);
                    int n37 = this.pos;
                    this.pos = n37 + variableArgFunction.read(this.tokenData, n37);
                    if (variableArgFunction.getFunction() != Function.ATTRIBUTE) {
                        this.addOperator(variableArgFunction);
                        continue;
                    }
                    variableArgFunction.getOperands(this.tokenStack);
                    Attribute attribute = stack.empty() ? new Attribute(this.settings) : (Attribute)stack.pop();
                    attribute.setIfConditions(variableArgFunction);
                    this.tokenStack.push((Object)attribute);
                    continue;
                }
                if (token == Token.MEM_FUNC) {
                    this.handleMemoryFunction(new MemFunc());
                    continue;
                }
                if (token != Token.MEM_AREA) continue;
                this.handleMemoryFunction(new MemArea());
                continue;
            }
            throw new FormulaException(FormulaException.UNRECOGNIZED_TOKEN, by);
        }
    }

    @Override
    public void adjustRelativeCellReferences(int n, int n2) {
        this.root.adjustRelativeCellReferences(n, n2);
    }

    @Override
    public void columnInserted(int n, int n2, boolean bl) {
        this.root.columnInserted(n, n2, bl);
    }

    @Override
    public void columnRemoved(int n, int n2, boolean bl) {
        this.root.columnRemoved(n, n2, bl);
    }

    @Override
    public byte[] getBytes() {
        return this.root.getBytes();
    }

    @Override
    public String getFormula() {
        StringBuffer stringBuffer = new StringBuffer();
        this.root.getString(stringBuffer);
        return stringBuffer.toString();
    }

    @Override
    public boolean handleImportedCellReferences() {
        this.root.handleImportedCellReferences();
        return this.root.isValid();
    }

    @Override
    public void parse() throws FormulaException {
        this.parseSubExpression(this.tokenData.length);
        this.root = (ParseItem)this.tokenStack.pop();
        Assert.verify(this.tokenStack.empty());
    }

    @Override
    public void rowInserted(int n, int n2, boolean bl) {
        this.root.rowInserted(n, n2, bl);
    }

    @Override
    public void rowRemoved(int n, int n2, boolean bl) {
        this.root.rowRemoved(n, n2, bl);
    }
}

