/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuffer
 *  java.lang.System
 *  java.util.Stack
 */
package jxl.biff.formula;

import java.util.Stack;
import jxl.WorkbookSettings;
import jxl.biff.IntegerHelper;
import jxl.biff.formula.Area;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.Function;
import jxl.biff.formula.Operator;
import jxl.biff.formula.ParseItem;
import jxl.biff.formula.ParsedThing;
import jxl.biff.formula.Token;
import jxl.common.Logger;

class VariableArgFunction
extends Operator
implements ParsedThing {
    private static Logger logger = Logger.getLogger(VariableArgFunction.class);
    private int arguments;
    private Function function;
    private boolean readFromSheet;
    private WorkbookSettings settings;

    public VariableArgFunction(WorkbookSettings workbookSettings) {
        this.readFromSheet = true;
        this.settings = workbookSettings;
    }

    public VariableArgFunction(Function function, int n, WorkbookSettings workbookSettings) {
        this.function = function;
        this.arguments = n;
        this.readFromSheet = false;
        this.settings = workbookSettings;
    }

    private void handleSpecialCases() {
        if (this.function == Function.SUMPRODUCT) {
            ParseItem[] arrparseItem = this.getOperands();
            for (int i = -1 + arrparseItem.length; i >= 0; --i) {
                if (!(arrparseItem[i] instanceof Area)) continue;
                arrparseItem[i].setAlternateCode();
            }
        }
    }

    @Override
    public void adjustRelativeCellReferences(int n, int n2) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].adjustRelativeCellReferences(n, n2);
        }
    }

    @Override
    void columnInserted(int n, int n2, boolean bl) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].columnInserted(n, n2, bl);
        }
    }

    @Override
    void columnRemoved(int n, int n2, boolean bl) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].columnRemoved(n, n2, bl);
        }
    }

    @Override
    byte[] getBytes() {
        this.handleSpecialCases();
        ParseItem[] arrparseItem = this.getOperands();
        byte[] arrby = new byte[]{};
        for (int i = 0; i < arrparseItem.length; ++i) {
            byte[] arrby2 = arrparseItem[i].getBytes();
            byte[] arrby3 = new byte[arrby.length + arrby2.length];
            System.arraycopy((Object)arrby, (int)0, (Object)arrby3, (int)0, (int)arrby.length);
            System.arraycopy((Object)arrby2, (int)0, (Object)arrby3, (int)arrby.length, (int)arrby2.length);
            arrby = arrby3;
        }
        byte[] arrby4 = new byte[4 + arrby.length];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby4, (int)0, (int)arrby.length);
        int n = arrby.length;
        byte by = !this.useAlternateCode() ? Token.FUNCTIONVARARG.getCode() : Token.FUNCTIONVARARG.getCode2();
        arrby4[n] = by;
        arrby4[1 + arrby.length] = (byte)this.arguments;
        IntegerHelper.getTwoBytes(this.function.getCode(), arrby4, 2 + arrby.length);
        return arrby4;
    }

    Function getFunction() {
        return this.function;
    }

    @Override
    public void getOperands(Stack stack) {
        int n = this.arguments;
        ParseItem[] arrparseItem = new ParseItem[n];
        for (int i = n - 1; i >= 0; --i) {
            arrparseItem[i] = (ParseItem)stack.pop();
        }
        for (int i = 0; i < this.arguments; ++i) {
            this.add(arrparseItem[i]);
        }
    }

    @Override
    int getPrecedence() {
        return 3;
    }

    @Override
    public void getString(StringBuffer stringBuffer) {
        stringBuffer.append(this.function.getName(this.settings));
        stringBuffer.append('(');
        if (this.arguments > 0) {
            int n;
            ParseItem[] arrparseItem = this.getOperands();
            boolean bl = this.readFromSheet;
            if (bl) {
                arrparseItem[0].getString(stringBuffer);
                for (n = 1; n < this.arguments; ++n) {
                    stringBuffer.append(',');
                    arrparseItem[n].getString(stringBuffer);
                }
            } else {
                arrparseItem[this.arguments - n].getString(stringBuffer);
                for (int i = -2 + this.arguments; i >= 0; --i) {
                    stringBuffer.append(',');
                    arrparseItem[i].getString(stringBuffer);
                }
            }
        }
        stringBuffer.append(')');
    }

    @Override
    void handleImportedCellReferences() {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].handleImportedCellReferences();
        }
    }

    @Override
    public int read(byte[] arrby, int n) throws FormulaException {
        this.arguments = arrby[n];
        int n2 = IntegerHelper.getInt(arrby[n + 1], arrby[n + 2]);
        this.function = Function.getFunction(n2);
        if (this.function != Function.UNKNOWN) {
            return 3;
        }
        throw new FormulaException(FormulaException.UNRECOGNIZED_FUNCTION, n2);
    }

    @Override
    void rowInserted(int n, int n2, boolean bl) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].rowInserted(n, n2, bl);
        }
    }

    @Override
    void rowRemoved(int n, int n2, boolean bl) {
        ParseItem[] arrparseItem = this.getOperands();
        for (int i = 0; i < arrparseItem.length; ++i) {
            arrparseItem[i].rowRemoved(n, n2, bl);
        }
    }
}

