/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.BufferedWriter
 *  java.io.File
 *  java.io.FileInputStream
 *  java.io.IOException
 *  java.io.InputStream
 *  java.io.OutputStream
 *  java.io.OutputStreamWriter
 *  java.io.Writer
 *  java.lang.Integer
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuffer
 *  java.lang.System
 *  java.util.HashMap
 *  jxl.read.biff.BiffException
 */
package jxl.demo;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.HashMap;
import jxl.WorkbookSettings;
import jxl.biff.Type;
import jxl.read.biff.BiffException;
import jxl.read.biff.BiffRecordReader;
import jxl.read.biff.Record;

class BiffDump {
    private static final int bytesPerLine = 16;
    private int bofs;
    private int fontIndex;
    private BiffRecordReader reader;
    private HashMap recordNames;
    private BufferedWriter writer;
    private int xfIndex;

    public BiffDump(File file, OutputStream outputStream) throws IOException, BiffException {
        this.writer = new BufferedWriter((Writer)new OutputStreamWriter(outputStream));
        FileInputStream fileInputStream = new FileInputStream(file);
        this.reader = new BiffRecordReader(new jxl.read.biff.File((InputStream)fileInputStream, new WorkbookSettings()));
        this.buildNameHash();
        this.dump();
        this.writer.flush();
        this.writer.close();
        fileInputStream.close();
    }

    private void buildNameHash() {
        this.recordNames = new HashMap(50);
        this.recordNames.put((Object)Type.BOF, (Object)"BOF");
        this.recordNames.put((Object)Type.EOF, (Object)"EOF");
        this.recordNames.put((Object)Type.FONT, (Object)"FONT");
        this.recordNames.put((Object)Type.SST, (Object)"SST");
        this.recordNames.put((Object)Type.LABELSST, (Object)"LABELSST");
        this.recordNames.put((Object)Type.WRITEACCESS, (Object)"WRITEACCESS");
        this.recordNames.put((Object)Type.FORMULA, (Object)"FORMULA");
        this.recordNames.put((Object)Type.FORMULA2, (Object)"FORMULA");
        this.recordNames.put((Object)Type.XF, (Object)"XF");
        this.recordNames.put((Object)Type.MULRK, (Object)"MULRK");
        this.recordNames.put((Object)Type.NUMBER, (Object)"NUMBER");
        this.recordNames.put((Object)Type.BOUNDSHEET, (Object)"BOUNDSHEET");
        this.recordNames.put((Object)Type.CONTINUE, (Object)"CONTINUE");
        this.recordNames.put((Object)Type.FORMAT, (Object)"FORMAT");
        this.recordNames.put((Object)Type.EXTERNSHEET, (Object)"EXTERNSHEET");
        this.recordNames.put((Object)Type.INDEX, (Object)"INDEX");
        this.recordNames.put((Object)Type.DIMENSION, (Object)"DIMENSION");
        this.recordNames.put((Object)Type.ROW, (Object)"ROW");
        this.recordNames.put((Object)Type.DBCELL, (Object)"DBCELL");
        this.recordNames.put((Object)Type.BLANK, (Object)"BLANK");
        this.recordNames.put((Object)Type.MULBLANK, (Object)"MULBLANK");
        this.recordNames.put((Object)Type.RK, (Object)"RK");
        this.recordNames.put((Object)Type.RK2, (Object)"RK");
        this.recordNames.put((Object)Type.COLINFO, (Object)"COLINFO");
        this.recordNames.put((Object)Type.LABEL, (Object)"LABEL");
        this.recordNames.put((Object)Type.SHAREDFORMULA, (Object)"SHAREDFORMULA");
        this.recordNames.put((Object)Type.CODEPAGE, (Object)"CODEPAGE");
        this.recordNames.put((Object)Type.WINDOW1, (Object)"WINDOW1");
        this.recordNames.put((Object)Type.WINDOW2, (Object)"WINDOW2");
        this.recordNames.put((Object)Type.MERGEDCELLS, (Object)"MERGEDCELLS");
        this.recordNames.put((Object)Type.HLINK, (Object)"HLINK");
        this.recordNames.put((Object)Type.HEADER, (Object)"HEADER");
        this.recordNames.put((Object)Type.FOOTER, (Object)"FOOTER");
        this.recordNames.put((Object)Type.INTERFACEHDR, (Object)"INTERFACEHDR");
        this.recordNames.put((Object)Type.MMS, (Object)"MMS");
        this.recordNames.put((Object)Type.INTERFACEEND, (Object)"INTERFACEEND");
        this.recordNames.put((Object)Type.DSF, (Object)"DSF");
        this.recordNames.put((Object)Type.FNGROUPCOUNT, (Object)"FNGROUPCOUNT");
        this.recordNames.put((Object)Type.COUNTRY, (Object)"COUNTRY");
        this.recordNames.put((Object)Type.TABID, (Object)"TABID");
        this.recordNames.put((Object)Type.PROTECT, (Object)"PROTECT");
        this.recordNames.put((Object)Type.SCENPROTECT, (Object)"SCENPROTECT");
        this.recordNames.put((Object)Type.OBJPROTECT, (Object)"OBJPROTECT");
        this.recordNames.put((Object)Type.WINDOWPROTECT, (Object)"WINDOWPROTECT");
        this.recordNames.put((Object)Type.PASSWORD, (Object)"PASSWORD");
        this.recordNames.put((Object)Type.PROT4REV, (Object)"PROT4REV");
        this.recordNames.put((Object)Type.PROT4REVPASS, (Object)"PROT4REVPASS");
        this.recordNames.put((Object)Type.BACKUP, (Object)"BACKUP");
        this.recordNames.put((Object)Type.HIDEOBJ, (Object)"HIDEOBJ");
        this.recordNames.put((Object)Type.NINETEENFOUR, (Object)"1904");
        this.recordNames.put((Object)Type.PRECISION, (Object)"PRECISION");
        this.recordNames.put((Object)Type.BOOKBOOL, (Object)"BOOKBOOL");
        this.recordNames.put((Object)Type.STYLE, (Object)"STYLE");
        this.recordNames.put((Object)Type.EXTSST, (Object)"EXTSST");
        this.recordNames.put((Object)Type.REFRESHALL, (Object)"REFRESHALL");
        this.recordNames.put((Object)Type.CALCMODE, (Object)"CALCMODE");
        this.recordNames.put((Object)Type.CALCCOUNT, (Object)"CALCCOUNT");
        this.recordNames.put((Object)Type.NAME, (Object)"NAME");
        this.recordNames.put((Object)Type.MSODRAWINGGROUP, (Object)"MSODRAWINGGROUP");
        this.recordNames.put((Object)Type.MSODRAWING, (Object)"MSODRAWING");
        this.recordNames.put((Object)Type.OBJ, (Object)"OBJ");
        this.recordNames.put((Object)Type.USESELFS, (Object)"USESELFS");
        this.recordNames.put((Object)Type.SUPBOOK, (Object)"SUPBOOK");
        this.recordNames.put((Object)Type.LEFTMARGIN, (Object)"LEFTMARGIN");
        this.recordNames.put((Object)Type.RIGHTMARGIN, (Object)"RIGHTMARGIN");
        this.recordNames.put((Object)Type.TOPMARGIN, (Object)"TOPMARGIN");
        this.recordNames.put((Object)Type.BOTTOMMARGIN, (Object)"BOTTOMMARGIN");
        this.recordNames.put((Object)Type.HCENTER, (Object)"HCENTER");
        this.recordNames.put((Object)Type.VCENTER, (Object)"VCENTER");
        this.recordNames.put((Object)Type.ITERATION, (Object)"ITERATION");
        this.recordNames.put((Object)Type.DELTA, (Object)"DELTA");
        this.recordNames.put((Object)Type.SAVERECALC, (Object)"SAVERECALC");
        this.recordNames.put((Object)Type.PRINTHEADERS, (Object)"PRINTHEADERS");
        this.recordNames.put((Object)Type.PRINTGRIDLINES, (Object)"PRINTGRIDLINES");
        this.recordNames.put((Object)Type.SETUP, (Object)"SETUP");
        this.recordNames.put((Object)Type.SELECTION, (Object)"SELECTION");
        this.recordNames.put((Object)Type.STRING, (Object)"STRING");
        this.recordNames.put((Object)Type.FONTX, (Object)"FONTX");
        this.recordNames.put((Object)Type.IFMT, (Object)"IFMT");
        this.recordNames.put((Object)Type.WSBOOL, (Object)"WSBOOL");
        this.recordNames.put((Object)Type.GRIDSET, (Object)"GRIDSET");
        this.recordNames.put((Object)Type.REFMODE, (Object)"REFMODE");
        this.recordNames.put((Object)Type.GUTS, (Object)"GUTS");
        this.recordNames.put((Object)Type.EXTERNNAME, (Object)"EXTERNNAME");
        this.recordNames.put((Object)Type.FBI, (Object)"FBI");
        this.recordNames.put((Object)Type.CRN, (Object)"CRN");
        this.recordNames.put((Object)Type.HORIZONTALPAGEBREAKS, (Object)"HORIZONTALPAGEBREAKS");
        this.recordNames.put((Object)Type.VERTICALPAGEBREAKS, (Object)"VERTICALPAGEBREAKS");
        this.recordNames.put((Object)Type.DEFAULTROWHEIGHT, (Object)"DEFAULTROWHEIGHT");
        this.recordNames.put((Object)Type.TEMPLATE, (Object)"TEMPLATE");
        this.recordNames.put((Object)Type.PANE, (Object)"PANE");
        this.recordNames.put((Object)Type.SCL, (Object)"SCL");
        this.recordNames.put((Object)Type.PALETTE, (Object)"PALETTE");
        this.recordNames.put((Object)Type.PLS, (Object)"PLS");
        this.recordNames.put((Object)Type.OBJPROJ, (Object)"OBJPROJ");
        this.recordNames.put((Object)Type.DEFCOLWIDTH, (Object)"DEFCOLWIDTH");
        this.recordNames.put((Object)Type.ARRAY, (Object)"ARRAY");
        this.recordNames.put((Object)Type.WEIRD1, (Object)"WEIRD1");
        this.recordNames.put((Object)Type.BOOLERR, (Object)"BOOLERR");
        this.recordNames.put((Object)Type.SORT, (Object)"SORT");
        this.recordNames.put((Object)Type.BUTTONPROPERTYSET, (Object)"BUTTONPROPERTYSET");
        this.recordNames.put((Object)Type.NOTE, (Object)"NOTE");
        this.recordNames.put((Object)Type.TXO, (Object)"TXO");
        this.recordNames.put((Object)Type.DV, (Object)"DV");
        this.recordNames.put((Object)Type.DVAL, (Object)"DVAL");
        this.recordNames.put((Object)Type.SERIES, (Object)"SERIES");
        this.recordNames.put((Object)Type.SERIESLIST, (Object)"SERIESLIST");
        this.recordNames.put((Object)Type.SBASEREF, (Object)"SBASEREF");
        this.recordNames.put((Object)Type.CONDFMT, (Object)"CONDFMT");
        this.recordNames.put((Object)Type.CF, (Object)"CF");
        this.recordNames.put((Object)Type.FILTERMODE, (Object)"FILTERMODE");
        this.recordNames.put((Object)Type.AUTOFILTER, (Object)"AUTOFILTER");
        this.recordNames.put((Object)Type.AUTOFILTERINFO, (Object)"AUTOFILTERINFO");
        this.recordNames.put((Object)Type.XCT, (Object)"XCT");
        this.recordNames.put((Object)Type.UNKNOWN, (Object)"???");
    }

    private void dump() throws IOException {
        boolean bl = true;
        while (this.reader.hasNext() && bl) {
            bl = this.writeRecord(this.reader.next());
        }
    }

    private void writeByte(byte by, StringBuffer stringBuffer) {
        String string2 = Integer.toHexString((int)(by & 255));
        if (string2.length() == 1) {
            stringBuffer.append('0');
        }
        stringBuffer.append(string2);
    }

    private boolean writeRecord(Record record) throws IOException {
        int n;
        int n2 = this.reader.getPos();
        int n3 = record.getCode();
        boolean bl = this.bofs != 0 || record.getType() == Type.BOF;
        if (!bl) {
            return bl;
        }
        if (record.getType() == Type.BOF) {
            this.bofs = 1 + this.bofs;
        }
        if (record.getType() == Type.EOF) {
            --this.bofs;
        }
        StringBuffer stringBuffer = new StringBuffer();
        this.writeSixDigitValue(n2, stringBuffer);
        stringBuffer.append(" [");
        stringBuffer.append(this.recordNames.get((Object)record.getType()));
        stringBuffer.append("]");
        stringBuffer.append("  (0x");
        stringBuffer.append(Integer.toHexString((int)n3));
        stringBuffer.append(")");
        if (n3 == Type.XF.value) {
            stringBuffer.append(" (0x");
            stringBuffer.append(Integer.toHexString((int)this.xfIndex));
            stringBuffer.append(")");
            this.xfIndex = 1 + this.xfIndex;
        }
        if (n3 == Type.FONT.value) {
            int n4 = this.fontIndex;
            if (n4 == 4) {
                this.fontIndex = n4 + 1;
            }
            stringBuffer.append(" (0x");
            stringBuffer.append(Integer.toHexString((int)this.fontIndex));
            stringBuffer.append(")");
            this.fontIndex = 1 + this.fontIndex;
        }
        this.writer.write(stringBuffer.toString());
        this.writer.newLine();
        byte[] arrby = new byte[]{(byte)(n3 & 255), (byte)((n3 & 65280) >> 8), (byte)(255 & record.getLength()), (byte)((65280 & record.getLength()) >> 8)};
        byte[] arrby2 = record.getData();
        byte[] arrby3 = new byte[arrby.length + arrby2.length];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby3, (int)0, (int)arrby.length);
        System.arraycopy((Object)arrby2, (int)0, (Object)arrby3, (int)arrby.length, (int)arrby2.length);
        for (int i = 0; i < arrby3.length; i += n) {
            StringBuffer stringBuffer2 = new StringBuffer();
            this.writeSixDigitValue(n2 + i, stringBuffer2);
            stringBuffer2.append("   ");
            n = Math.min((int)16, (int)(arrby3.length - i));
            for (int j = 0; j < n; ++j) {
                this.writeByte(arrby3[j + i], stringBuffer2);
                stringBuffer2.append(' ');
            }
            if (n < 16) {
                for (int j = 0; j < 16 - n; ++j) {
                    stringBuffer2.append("   ");
                }
            }
            stringBuffer2.append("  ");
            for (int j = 0; j < n; ++j) {
                char c = (char)arrby3[j + i];
                if (c < ' ' || c > 'z') {
                    c = '.';
                }
                stringBuffer2.append(c);
            }
            this.writer.write(stringBuffer2.toString());
            this.writer.newLine();
        }
        return bl;
    }

    private void writeSixDigitValue(int n, StringBuffer stringBuffer) {
        String string2 = Integer.toHexString((int)n);
        for (int i = 6; i > string2.length(); --i) {
            stringBuffer.append('0');
        }
        stringBuffer.append(string2);
    }
}

