/*
 * Decompiled with CFR 0.0.
 */
package jxl.read.biff;

import jxl.biff.IntegerHelper;
import jxl.biff.RecordData;
import jxl.common.Logger;
import jxl.read.biff.Record;

public class BOFRecord
extends RecordData {
    private static final int Biff7 = 1280;
    private static final int Biff8 = 1536;
    private static final int Chart = 32;
    private static final int MacroSheet = 64;
    private static final int WorkbookGlobals = 5;
    private static final int Worksheet = 16;
    private static Logger logger = Logger.getLogger(BOFRecord.class);
    private int substreamType;
    private int version;

    BOFRecord(Record record) {
        super(record);
        byte[] arrby = this.getRecord().getData();
        this.version = IntegerHelper.getInt(arrby[0], arrby[1]);
        this.substreamType = IntegerHelper.getInt(arrby[2], arrby[3]);
    }

    int getLength() {
        return this.getRecord().getLength();
    }

    public boolean isBiff7() {
        return this.version == 1280;
    }

    public boolean isBiff8() {
        return this.version == 1536;
    }

    public boolean isChart() {
        return this.substreamType == 32;
    }

    public boolean isMacroSheet() {
        return this.substreamType == 64;
    }

    boolean isWorkbookGlobals() {
        return this.substreamType == 5;
    }

    public boolean isWorksheet() {
        return this.substreamType == 16;
    }
}

