/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.util.ArrayList
 *  java.util.Iterator
 */
package jxl.read.biff;

import java.util.ArrayList;
import java.util.Iterator;
import jxl.WorkbookSettings;
import jxl.biff.BaseCompoundFile;
import jxl.biff.IntegerHelper;
import jxl.common.Logger;
import jxl.read.biff.BiffException;

public final class CompoundFile
extends BaseCompoundFile {
    private static Logger logger = Logger.getLogger(CompoundFile.class);
    private int[] bigBlockChain;
    private int[] bigBlockDepotBlocks;
    private byte[] data;
    private int extensionBlock;
    private int numBigBlockDepotBlocks;
    private int numExtensionBlocks;
    private ArrayList propertySets;
    private byte[] rootEntry;
    private BaseCompoundFile.PropertyStorage rootEntryPropertyStorage;
    private int rootStartBlock;
    private int sbdStartBlock;
    private WorkbookSettings settings;
    private int[] smallBlockChain;

    public CompoundFile(byte[] arrby, WorkbookSettings workbookSettings) throws BiffException {
        this.data = arrby;
        this.settings = workbookSettings;
        for (int i = 0; i < IDENTIFIER.length; ++i) {
            if (this.data[i] == IDENTIFIER[i]) {
                continue;
            }
            throw new BiffException(BiffException.unrecognizedOLEFile);
        }
        this.propertySets = new ArrayList();
        byte[] arrby2 = this.data;
        this.numBigBlockDepotBlocks = IntegerHelper.getInt(arrby2[44], arrby2[45], arrby2[46], arrby2[47]);
        byte[] arrby3 = this.data;
        this.sbdStartBlock = IntegerHelper.getInt(arrby3[60], arrby3[61], arrby3[62], arrby3[63]);
        byte[] arrby4 = this.data;
        this.rootStartBlock = IntegerHelper.getInt(arrby4[48], arrby4[49], arrby4[50], arrby4[51]);
        byte[] arrby5 = this.data;
        this.extensionBlock = IntegerHelper.getInt(arrby5[68], arrby5[69], arrby5[70], arrby5[71]);
        byte[] arrby6 = this.data;
        this.numExtensionBlocks = IntegerHelper.getInt(arrby6[72], arrby6[73], arrby6[74], arrby6[75]);
        int n = this.numBigBlockDepotBlocks;
        this.bigBlockDepotBlocks = new int[n];
        if (this.numExtensionBlocks != 0) {
            n = 109;
        }
        int n2 = 0;
        int n3 = 76;
        do {
            if (n2 >= n) break;
            this.bigBlockDepotBlocks[n2] = IntegerHelper.getInt(arrby[n3], arrby[n3 + 1], arrby[n3 + 2], arrby[n3 + 3]);
            n3 += 4;
            ++n2;
        } while (true);
        for (int i = 0; i < this.numExtensionBlocks; ++i) {
            int n4;
            int n5 = 512 * (1 + this.extensionBlock);
            int n6 = Math.min((int)(this.numBigBlockDepotBlocks - n), (int)127);
            int n7 = n5;
            for (int j = n; j < (n4 = n + n6); ++j) {
                this.bigBlockDepotBlocks[j] = IntegerHelper.getInt(arrby[n7], arrby[n7 + 1], arrby[n7 + 2], arrby[n7 + 3]);
                n7 += 4;
            }
            if (n4 < this.numBigBlockDepotBlocks) {
                this.extensionBlock = IntegerHelper.getInt(arrby[n7], arrby[n7 + 1], arrby[n7 + 2], arrby[n7 + 3]);
            }
            n = n4;
        }
        this.readBigBlockDepot();
        this.readSmallBlockDepot();
        this.rootEntry = this.readData(this.rootStartBlock);
        this.readPropertySets();
    }

    private BaseCompoundFile.PropertyStorage findPropertyStorage(String string, BaseCompoundFile.PropertyStorage propertyStorage) {
        if (propertyStorage.child == -1) {
            return null;
        }
        BaseCompoundFile.PropertyStorage propertyStorage2 = this.getPropertyStorage(propertyStorage.child);
        if (propertyStorage2.name.equalsIgnoreCase(string)) {
            return propertyStorage2;
        }
        BaseCompoundFile.PropertyStorage propertyStorage3 = propertyStorage2;
        while (propertyStorage3.previous != -1) {
            propertyStorage3 = this.getPropertyStorage(propertyStorage3.previous);
            if (!propertyStorage3.name.equalsIgnoreCase(string)) continue;
            return propertyStorage3;
        }
        BaseCompoundFile.PropertyStorage propertyStorage4 = propertyStorage2;
        while (propertyStorage4.next != -1) {
            propertyStorage4 = this.getPropertyStorage(propertyStorage4.next);
            if (!propertyStorage4.name.equalsIgnoreCase(string)) continue;
            return propertyStorage4;
        }
        return this.findPropertyStorage(string, propertyStorage2);
    }

    private byte[] getBigBlockStream(BaseCompoundFile.PropertyStorage propertyStorage) {
        int n;
        int n2 = propertyStorage.size / 512;
        if (propertyStorage.size % 512 != 0) {
            ++n2;
        }
        byte[] arrby = new byte[n2 * 512];
        int n3 = propertyStorage.startBlock;
        for (n = 0; n3 != -2 && n < n2; ++n) {
            int n4 = 512 * (n3 + 1);
            System.arraycopy((Object)this.data, (int)n4, (Object)arrby, (int)(n * 512), (int)512);
            n3 = this.bigBlockChain[n3];
        }
        if (n3 != -2 && n == n2) {
            logger.warn("Property storage size inconsistent with block chain.");
        }
        return arrby;
    }

    private BaseCompoundFile.PropertyStorage getPropertyStorage(int n) {
        return (BaseCompoundFile.PropertyStorage)this.propertySets.get(n);
    }

    private BaseCompoundFile.PropertyStorage getPropertyStorage(String string) throws BiffException {
        BiffException biffException;
        Iterator iterator = this.propertySets.iterator();
        BaseCompoundFile.PropertyStorage propertyStorage = null;
        boolean bl = false;
        boolean bl2 = false;
        while (iterator.hasNext()) {
            BaseCompoundFile.PropertyStorage propertyStorage2 = (BaseCompoundFile.PropertyStorage)iterator.next();
            if (!propertyStorage2.name.equalsIgnoreCase(string)) continue;
            bl = bl2;
            propertyStorage = propertyStorage2;
            bl2 = true;
        }
        if (bl) {
            Logger logger = CompoundFile.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("found multiple copies of property set ");
            stringBuilder.append(string);
            logger.warn(stringBuilder.toString());
        }
        if (bl2) {
            return propertyStorage;
        }
        biffException = new BiffException(BiffException.streamNotFound);
        throw biffException;
    }

    private byte[] getSmallBlockStream(BaseCompoundFile.PropertyStorage propertyStorage) throws BiffException {
        BiffException biffException;
        int n;
        byte[] arrby = this.readData(this.rootEntryPropertyStorage.startBlock);
        byte[] arrby2 = new byte[]{};
        int n2 = propertyStorage.startBlock;
        byte[] arrby3 = arrby2;
        for (n = 0; n <= this.smallBlockChain.length && n2 != -2; ++n) {
            byte[] arrby4 = new byte[64 + arrby3.length];
            System.arraycopy((Object)arrby3, (int)0, (Object)arrby4, (int)0, (int)arrby3.length);
            System.arraycopy((Object)arrby, (int)(n2 * 64), (Object)arrby4, (int)arrby3.length, (int)64);
            n2 = this.smallBlockChain[n2];
            if (n2 == -1) {
                Logger logger = CompoundFile.logger;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("Incorrect terminator for small block stream ");
                stringBuilder.append(propertyStorage.name);
                logger.warn(stringBuilder.toString());
                n2 = -2;
            }
            arrby3 = arrby4;
        }
        if (n <= this.smallBlockChain.length) {
            return arrby3;
        }
        biffException = new BiffException(BiffException.corruptFileFormat);
        throw biffException;
    }

    private void readBigBlockDepot() {
        this.bigBlockChain = new int[512 * this.numBigBlockDepotBlocks / 4];
        int n = 0;
        for (int i = 0; i < this.numBigBlockDepotBlocks; ++i) {
            int n2 = 512 * (1 + this.bigBlockDepotBlocks[i]);
            int n3 = n;
            for (int j = 0; j < 128; ++j) {
                int[] arrn = this.bigBlockChain;
                byte[] arrby = this.data;
                arrn[n3] = IntegerHelper.getInt(arrby[n2], arrby[n2 + 1], arrby[n2 + 2], arrby[n2 + 3]);
                n2 += 4;
                ++n3;
            }
            n = n3;
        }
    }

    private byte[] readData(int n) throws BiffException {
        BiffException biffException;
        int n2;
        byte[] arrby = new byte[]{};
        int n3 = n;
        for (n2 = 0; n2 <= this.bigBlockChain.length && n3 != -2; ++n2) {
            byte[] arrby2 = new byte[512 + arrby.length];
            System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby.length);
            int n4 = 512 * (n3 + 1);
            System.arraycopy((Object)this.data, (int)n4, (Object)arrby2, (int)arrby.length, (int)512);
            int[] arrn = this.bigBlockChain;
            if (arrn[n3] != n3) {
                n3 = arrn[n3];
                arrby = arrby2;
                continue;
            }
            throw new BiffException(BiffException.corruptFileFormat);
        }
        if (n2 <= this.bigBlockChain.length) {
            return arrby;
        }
        biffException = new BiffException(BiffException.corruptFileFormat);
        throw biffException;
    }

    private void readPropertySets() {
        byte[] arrby;
        for (int i = 0; i < (arrby = this.rootEntry).length; i += 128) {
            byte[] arrby2 = new byte[128];
            System.arraycopy((Object)arrby, (int)i, (Object)arrby2, (int)0, (int)arrby2.length);
            BaseCompoundFile.PropertyStorage propertyStorage = new BaseCompoundFile.PropertyStorage((BaseCompoundFile)this, arrby2);
            if (propertyStorage.name == null || propertyStorage.name.length() == 0) {
                if (propertyStorage.type == 5) {
                    propertyStorage.name = "Root Entry";
                    Logger logger = CompoundFile.logger;
                    StringBuilder stringBuilder = new StringBuilder();
                    stringBuilder.append("Property storage name for ");
                    stringBuilder.append(propertyStorage.type);
                    stringBuilder.append(" is empty - setting to ");
                    stringBuilder.append("Root Entry");
                    logger.warn(stringBuilder.toString());
                } else if (propertyStorage.size != 0) {
                    Logger logger = CompoundFile.logger;
                    StringBuilder stringBuilder = new StringBuilder();
                    stringBuilder.append("Property storage type ");
                    stringBuilder.append(propertyStorage.type);
                    stringBuilder.append(" is non-empty and has no associated name");
                    logger.warn(stringBuilder.toString());
                }
            }
            this.propertySets.add((Object)propertyStorage);
            if (!propertyStorage.name.equalsIgnoreCase("Root Entry")) continue;
            this.rootEntryPropertyStorage = propertyStorage;
        }
        if (this.rootEntryPropertyStorage == null) {
            this.rootEntryPropertyStorage = (BaseCompoundFile.PropertyStorage)this.propertySets.get(0);
        }
    }

    private void readSmallBlockDepot() throws BiffException {
        BiffException biffException;
        int n;
        int n2 = this.sbdStartBlock;
        this.smallBlockChain = new int[0];
        if (n2 == -1) {
            logger.warn("invalid small block depot number");
            return;
        }
        int n3 = n2;
        int n4 = 0;
        for (n = 0; n <= this.bigBlockChain.length && n3 != -2; ++n) {
            int[] arrn = this.smallBlockChain;
            this.smallBlockChain = new int[128 + arrn.length];
            System.arraycopy((Object)arrn, (int)0, (Object)this.smallBlockChain, (int)0, (int)arrn.length);
            int n5 = 512 * (n3 + 1);
            int n6 = n4;
            for (int i = 0; i < 128; ++i) {
                int[] arrn2 = this.smallBlockChain;
                byte[] arrby = this.data;
                arrn2[n6] = IntegerHelper.getInt(arrby[n5], arrby[n5 + 1], arrby[n5 + 2], arrby[n5 + 3]);
                n5 += 4;
                ++n6;
            }
            n3 = this.bigBlockChain[n3];
            n4 = n6;
        }
        if (n <= this.bigBlockChain.length) {
            return;
        }
        biffException = new BiffException(BiffException.corruptFileFormat);
        throw biffException;
    }

    public BaseCompoundFile.PropertyStorage findPropertyStorage(String string) {
        return this.findPropertyStorage(string, this.rootEntryPropertyStorage);
    }

    public int getNumberOfPropertySets() {
        return this.propertySets.size();
    }

    public BaseCompoundFile.PropertyStorage getPropertySet(int n) {
        return this.getPropertyStorage(n);
    }

    public byte[] getStream(int n) throws BiffException {
        BaseCompoundFile.PropertyStorage propertyStorage = this.getPropertyStorage(n);
        if (propertyStorage.size < 4096 && !propertyStorage.name.equalsIgnoreCase("Root Entry")) {
            return this.getSmallBlockStream(propertyStorage);
        }
        return this.getBigBlockStream(propertyStorage);
    }

    public byte[] getStream(String string) throws BiffException {
        BaseCompoundFile.PropertyStorage propertyStorage = this.findPropertyStorage(string, this.rootEntryPropertyStorage);
        if (propertyStorage == null) {
            propertyStorage = this.getPropertyStorage(string);
        }
        if (propertyStorage.size < 4096 && !string.equalsIgnoreCase("Root Entry")) {
            return this.getSmallBlockStream(propertyStorage);
        }
        return this.getBigBlockStream(propertyStorage);
    }
}

