/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Double
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.text.DateFormat
 *  java.text.SimpleDateFormat
 *  java.util.Date
 *  java.util.TimeZone
 */
package jxl.read.biff;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;
import jxl.CellFeatures;
import jxl.CellType;
import jxl.DateCell;
import jxl.NumberCell;
import jxl.biff.FormattingRecords;
import jxl.biff.XFRecord;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.format.CellFormat;
import jxl.read.biff.CellFeaturesAccessor;
import jxl.read.biff.ColumnInfoRecord;
import jxl.read.biff.RowRecord;
import jxl.read.biff.SheetImpl;

class DateRecord
implements DateCell,
CellFeaturesAccessor {
    private static final SimpleDateFormat dateFormat;
    private static final TimeZone gmtZone;
    private static Logger logger;
    private static final long msInADay = 86400000L;
    private static final long msInASecond = 1000L;
    private static final int nonLeapDay = 61;
    private static final long secondsInADay = 86400L;
    private static final SimpleDateFormat timeFormat;
    private static final int utcOffsetDays = 25569;
    private static final int utcOffsetDays1904 = 24107;
    private CellFormat cellFormat;
    private int column;
    private Date date;
    private CellFeatures features;
    private DateFormat format;
    private FormattingRecords formattingRecords;
    private boolean initialized;
    private int row;
    private SheetImpl sheet;
    private boolean time;
    private int xfIndex;

    static {
        logger = Logger.getLogger(DateRecord.class);
        dateFormat = new SimpleDateFormat("dd MMM yyyy");
        timeFormat = new SimpleDateFormat("HH:mm:ss");
        gmtZone = TimeZone.getTimeZone((String)"GMT");
    }

    public DateRecord(NumberCell numberCell, int n, FormattingRecords formattingRecords, boolean bl, SheetImpl sheetImpl) {
        this.row = numberCell.getRow();
        this.column = numberCell.getColumn();
        this.xfIndex = n;
        this.formattingRecords = formattingRecords;
        this.sheet = sheetImpl;
        this.initialized = false;
        this.format = this.formattingRecords.getDateFormat(this.xfIndex);
        double d = numberCell.getValue();
        if (Math.abs((double)d) < 1.0) {
            if (this.format == null) {
                this.format = timeFormat;
            }
            this.time = true;
        } else {
            if (this.format == null) {
                this.format = dateFormat;
            }
            this.time = false;
        }
        if (!bl && !this.time && d < 61.0) {
            d += 1.0;
        }
        this.format.setTimeZone(gmtZone);
        int n2 = bl ? 24107 : 25569;
        double d2 = n2;
        Double.isNaN((double)d2);
        this.date = new Date(1000L * Math.round((double)(86400.0 * (d - d2))));
    }

    @Override
    public CellFeatures getCellFeatures() {
        return this.features;
    }

    @Override
    public CellFormat getCellFormat() {
        if (!this.initialized) {
            this.cellFormat = this.formattingRecords.getXFRecord(this.xfIndex);
            this.initialized = true;
        }
        return this.cellFormat;
    }

    @Override
    public final int getColumn() {
        return this.column;
    }

    @Override
    public String getContents() {
        return this.format.format(this.date);
    }

    @Override
    public Date getDate() {
        return this.date;
    }

    @Override
    public DateFormat getDateFormat() {
        boolean bl = this.format != null;
        Assert.verify(bl);
        return this.format;
    }

    @Override
    public final int getRow() {
        return this.row;
    }

    protected final SheetImpl getSheet() {
        return this.sheet;
    }

    @Override
    public CellType getType() {
        return CellType.DATE;
    }

    @Override
    public boolean isHidden() {
        ColumnInfoRecord columnInfoRecord = this.sheet.getColumnInfo(this.column);
        if (columnInfoRecord != null && columnInfoRecord.getWidth() == 0) {
            return true;
        }
        RowRecord rowRecord = this.sheet.getRowInfo(this.row);
        return rowRecord != null && (rowRecord.getRowHeight() == 0 || rowRecord.isCollapsed());
    }

    @Override
    public boolean isTime() {
        return this.time;
    }

    @Override
    public void setCellFeatures(CellFeatures cellFeatures) {
        this.features = cellFeatures;
    }
}

