/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Double
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.System
 *  java.text.DecimalFormat
 *  java.text.NumberFormat
 */
package jxl.read.biff;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import jxl.Cell;
import jxl.CellType;
import jxl.NumberCell;
import jxl.NumberFormulaCell;
import jxl.WorkbookSettings;
import jxl.biff.DoubleHelper;
import jxl.biff.FormattingRecords;
import jxl.biff.FormulaData;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.FormulaParser;
import jxl.common.Logger;
import jxl.read.biff.BOFRecord;
import jxl.read.biff.CellValue;
import jxl.read.biff.Record;
import jxl.read.biff.SheetImpl;
import jxl.read.biff.WorkbookParser;

class NumberFormulaRecord
extends CellValue
implements NumberCell,
FormulaData,
NumberFormulaCell {
    private static final DecimalFormat defaultFormat;
    private static Logger logger;
    private byte[] data;
    private ExternalSheet externalSheet;
    private NumberFormat format;
    private String formulaString;
    private WorkbookMethods nameTable;
    private double value;

    static {
        logger = Logger.getLogger(NumberFormulaRecord.class);
        defaultFormat = new DecimalFormat("#.###");
    }

    public NumberFormulaRecord(Record record, FormattingRecords formattingRecords, ExternalSheet externalSheet, WorkbookMethods workbookMethods, SheetImpl sheetImpl) {
        super(record, formattingRecords, sheetImpl);
        this.externalSheet = externalSheet;
        this.nameTable = workbookMethods;
        this.data = this.getRecord().getData();
        this.format = formattingRecords.getNumberFormat(this.getXFIndex());
        if (this.format == null) {
            this.format = defaultFormat;
        }
        this.value = DoubleHelper.getIEEEDouble(this.data, 6);
    }

    @Override
    public String getContents() {
        if (!Double.isNaN((double)this.value)) {
            return this.format.format(this.value);
        }
        return "";
    }

    @Override
    public String getFormula() throws FormulaException {
        if (this.formulaString == null) {
            byte[] arrby = this.data;
            byte[] arrby2 = new byte[arrby.length - 22];
            System.arraycopy((Object)arrby, (int)22, (Object)arrby2, (int)0, (int)arrby2.length);
            FormulaParser formulaParser = new FormulaParser(arrby2, this, this.externalSheet, this.nameTable, this.getSheet().getWorkbook().getSettings());
            formulaParser.parse();
            this.formulaString = formulaParser.getFormula();
        }
        return this.formulaString;
    }

    @Override
    public byte[] getFormulaData() throws FormulaException {
        if (this.getSheet().getWorkbookBof().isBiff8()) {
            byte[] arrby = this.data;
            byte[] arrby2 = new byte[arrby.length - 6];
            System.arraycopy((Object)arrby, (int)6, (Object)arrby2, (int)0, (int)(arrby.length - 6));
            return arrby2;
        }
        throw new FormulaException(FormulaException.BIFF8_SUPPORTED);
    }

    @Override
    public NumberFormat getNumberFormat() {
        return this.format;
    }

    @Override
    public CellType getType() {
        return CellType.NUMBER_FORMULA;
    }

    @Override
    public double getValue() {
        return this.value;
    }
}

