/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 */
package jxl.read.biff;

import jxl.Cell;
import jxl.CellType;
import jxl.ErrorCell;
import jxl.ErrorFormulaCell;
import jxl.WorkbookSettings;
import jxl.biff.FormattingRecords;
import jxl.biff.FormulaData;
import jxl.biff.IntegerHelper;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaErrorCode;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.FormulaParser;
import jxl.common.Logger;
import jxl.read.biff.BOFRecord;
import jxl.read.biff.BaseSharedFormulaRecord;
import jxl.read.biff.File;
import jxl.read.biff.Record;
import jxl.read.biff.SheetImpl;
import jxl.read.biff.WorkbookParser;

public class SharedErrorFormulaRecord
extends BaseSharedFormulaRecord
implements ErrorCell,
FormulaData,
ErrorFormulaCell {
    private static Logger logger = Logger.getLogger(SharedErrorFormulaRecord.class);
    private byte[] data;
    private FormulaErrorCode error;
    private int errorCode;

    public SharedErrorFormulaRecord(Record record, File file, int n, FormattingRecords formattingRecords, ExternalSheet externalSheet, WorkbookMethods workbookMethods, SheetImpl sheetImpl) {
        super(record, formattingRecords, externalSheet, workbookMethods, sheetImpl, file.getPos());
        this.errorCode = n;
    }

    @Override
    public String getContents() {
        if (this.error == null) {
            this.error = FormulaErrorCode.getErrorCode(this.errorCode);
        }
        if (this.error != FormulaErrorCode.UNKNOWN) {
            return this.error.getDescription();
        }
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append("ERROR ");
        stringBuilder.append(this.errorCode);
        return stringBuilder.toString();
    }

    @Override
    public int getErrorCode() {
        return this.errorCode;
    }

    @Override
    public byte[] getFormulaData() throws FormulaException {
        if (this.getSheet().getWorkbookBof().isBiff8()) {
            FormulaParser formulaParser = new FormulaParser(this.getTokens(), this, this.getExternalSheet(), this.getNameTable(), this.getSheet().getWorkbook().getSettings());
            formulaParser.parse();
            byte[] arrby = formulaParser.getBytes();
            byte[] arrby2 = new byte[22 + arrby.length];
            IntegerHelper.getTwoBytes(this.getRow(), arrby2, 0);
            IntegerHelper.getTwoBytes(this.getColumn(), arrby2, 2);
            IntegerHelper.getTwoBytes(this.getXFIndex(), arrby2, 4);
            arrby2[6] = 2;
            arrby2[8] = (byte)this.errorCode;
            arrby2[12] = -1;
            arrby2[13] = -1;
            System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)22, (int)arrby.length);
            IntegerHelper.getTwoBytes(arrby.length, arrby2, 20);
            byte[] arrby3 = new byte[arrby2.length - 6];
            System.arraycopy((Object)arrby2, (int)6, (Object)arrby3, (int)0, (int)(arrby2.length - 6));
            return arrby3;
        }
        throw new FormulaException(FormulaException.BIFF8_SUPPORTED);
    }

    @Override
    public CellType getType() {
        return CellType.FORMULA_ERROR;
    }
}

