/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Double
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.System
 *  java.text.DecimalFormat
 *  java.text.NumberFormat
 */
package jxl.read.biff;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import jxl.Cell;
import jxl.CellType;
import jxl.NumberCell;
import jxl.NumberFormulaCell;
import jxl.WorkbookSettings;
import jxl.biff.DoubleHelper;
import jxl.biff.FormattingRecords;
import jxl.biff.FormulaData;
import jxl.biff.IntegerHelper;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.FormulaParser;
import jxl.common.Logger;
import jxl.read.biff.BOFRecord;
import jxl.read.biff.BaseSharedFormulaRecord;
import jxl.read.biff.File;
import jxl.read.biff.Record;
import jxl.read.biff.SheetImpl;
import jxl.read.biff.WorkbookParser;

public class SharedNumberFormulaRecord
extends BaseSharedFormulaRecord
implements NumberCell,
FormulaData,
NumberFormulaCell {
    private static DecimalFormat defaultFormat;
    private static Logger logger;
    private NumberFormat format;
    private FormattingRecords formattingRecords;
    private double value;

    static {
        logger = Logger.getLogger(SharedNumberFormulaRecord.class);
        defaultFormat = new DecimalFormat("#.###");
    }

    public SharedNumberFormulaRecord(Record record, File file, double d, FormattingRecords formattingRecords, ExternalSheet externalSheet, WorkbookMethods workbookMethods, SheetImpl sheetImpl) {
        super(record, formattingRecords, externalSheet, workbookMethods, sheetImpl, file.getPos());
        this.value = d;
        this.format = defaultFormat;
    }

    @Override
    public String getContents() {
        if (!Double.isNaN((double)this.value)) {
            return this.format.format(this.value);
        }
        return "";
    }

    @Override
    public byte[] getFormulaData() throws FormulaException {
        if (this.getSheet().getWorkbookBof().isBiff8()) {
            FormulaParser formulaParser = new FormulaParser(this.getTokens(), this, this.getExternalSheet(), this.getNameTable(), this.getSheet().getWorkbook().getSettings());
            formulaParser.parse();
            byte[] arrby = formulaParser.getBytes();
            byte[] arrby2 = new byte[22 + arrby.length];
            IntegerHelper.getTwoBytes(this.getRow(), arrby2, 0);
            IntegerHelper.getTwoBytes(this.getColumn(), arrby2, 2);
            IntegerHelper.getTwoBytes(this.getXFIndex(), arrby2, 4);
            DoubleHelper.getIEEEBytes(this.value, arrby2, 6);
            System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)22, (int)arrby.length);
            IntegerHelper.getTwoBytes(arrby.length, arrby2, 20);
            byte[] arrby3 = new byte[arrby2.length - 6];
            System.arraycopy((Object)arrby2, (int)6, (Object)arrby3, (int)0, (int)(arrby2.length - 6));
            return arrby3;
        }
        throw new FormulaException(FormulaException.BIFF8_SUPPORTED);
    }

    @Override
    public NumberFormat getNumberFormat() {
        return this.format;
    }

    @Override
    public CellType getType() {
        return CellType.NUMBER_FORMULA;
    }

    @Override
    public double getValue() {
        return this.value;
    }

    final void setNumberFormat(NumberFormat numberFormat) {
        if (numberFormat != null) {
            this.format = numberFormat;
        }
    }
}

