/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.System
 *  java.lang.reflect.Array
 *  java.util.ArrayList
 *  java.util.regex.Pattern
 */
package jxl.read.biff;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.regex.Pattern;
import jxl.Cell;
import jxl.CellView;
import jxl.Hyperlink;
import jxl.Image;
import jxl.LabelCell;
import jxl.Range;
import jxl.Sheet;
import jxl.SheetSettings;
import jxl.WorkbookSettings;
import jxl.biff.AutoFilter;
import jxl.biff.BuiltInName;
import jxl.biff.CellFinder;
import jxl.biff.CellReferenceHelper;
import jxl.biff.ConditionalFormat;
import jxl.biff.DataValidation;
import jxl.biff.EmptyCell;
import jxl.biff.FormattingRecords;
import jxl.biff.Type;
import jxl.biff.WorkspaceInformationRecord;
import jxl.biff.XFRecord;
import jxl.biff.drawing.Chart;
import jxl.biff.drawing.Drawing;
import jxl.biff.drawing.DrawingData;
import jxl.biff.drawing.DrawingGroupObject;
import jxl.common.Logger;
import jxl.format.CellFormat;
import jxl.read.biff.BOFRecord;
import jxl.read.biff.BiffException;
import jxl.read.biff.ButtonPropertySetRecord;
import jxl.read.biff.ColumnInfoRecord;
import jxl.read.biff.File;
import jxl.read.biff.NameRecord;
import jxl.read.biff.PLSRecord;
import jxl.read.biff.Record;
import jxl.read.biff.RowRecord;
import jxl.read.biff.SSTRecord;
import jxl.read.biff.SheetReader;
import jxl.read.biff.WorkbookParser;

public class SheetImpl
implements Sheet {
    private static Logger logger = Logger.getLogger(SheetImpl.class);
    private AutoFilter autoFilter;
    private ButtonPropertySetRecord buttonPropertySet;
    private Cell[][] cells;
    private ArrayList charts;
    private int[] columnBreaks;
    private ColumnInfoRecord[] columnInfos;
    private ArrayList columnInfosArray;
    private boolean columnInfosInitialized;
    private ArrayList conditionalFormats;
    private DataValidation dataValidation;
    private ArrayList drawings;
    private File excelFile;
    private FormattingRecords formattingRecords;
    private boolean hidden;
    private ArrayList hyperlinks;
    private ArrayList images;
    private ArrayList localNames;
    private int maxColumnOutlineLevel;
    private int maxRowOutlineLevel;
    private Range[] mergedCells;
    private String name;
    private boolean nineteenFour;
    private int numCols;
    private int numRows;
    private PLSRecord plsRecord;
    private int[] rowBreaks;
    private ArrayList rowProperties;
    private RowRecord[] rowRecords;
    private boolean rowRecordsInitialized;
    private SheetSettings settings;
    private ArrayList sharedFormulas;
    private SSTRecord sharedStrings;
    private BOFRecord sheetBof;
    private int startPosition;
    private WorkbookParser workbook;
    private BOFRecord workbookBof;
    private WorkbookSettings workbookSettings;
    private WorkspaceInformationRecord workspaceOptions;

    SheetImpl(File file, SSTRecord sSTRecord, FormattingRecords formattingRecords, BOFRecord bOFRecord, BOFRecord bOFRecord2, boolean bl, WorkbookParser workbookParser) throws BiffException {
        this.excelFile = file;
        this.sharedStrings = sSTRecord;
        this.formattingRecords = formattingRecords;
        this.sheetBof = bOFRecord;
        this.workbookBof = bOFRecord2;
        this.columnInfosArray = new ArrayList();
        this.sharedFormulas = new ArrayList();
        this.hyperlinks = new ArrayList();
        this.rowProperties = new ArrayList(10);
        this.columnInfosInitialized = false;
        this.rowRecordsInitialized = false;
        this.nineteenFour = bl;
        this.workbook = workbookParser;
        this.workbookSettings = this.workbook.getSettings();
        this.startPosition = file.getPos();
        if (this.sheetBof.isChart()) {
            this.startPosition -= 4 + this.sheetBof.getLength();
        }
        int n = 1;
        while (n >= 1) {
            Record record = file.next();
            if (record.getCode() == Type.EOF.value) {
                --n;
            }
            if (record.getCode() != Type.BOF.value) continue;
            ++n;
        }
    }

    private void initializeImages() {
        if (this.images != null) {
            return;
        }
        this.images = new ArrayList();
        DrawingGroupObject[] arrdrawingGroupObject = this.getDrawings();
        for (int i = 0; i < arrdrawingGroupObject.length; ++i) {
            if (!(arrdrawingGroupObject[i] instanceof Drawing)) continue;
            this.images.add((Object)arrdrawingGroupObject[i]);
        }
    }

    void addLocalName(NameRecord nameRecord) {
        if (this.localNames == null) {
            this.localNames = new ArrayList();
        }
        this.localNames.add((Object)nameRecord);
    }

    final void clear() {
        this.cells = null;
        this.mergedCells = null;
        this.columnInfosArray.clear();
        this.sharedFormulas.clear();
        this.hyperlinks.clear();
        this.columnInfosInitialized = false;
        if (!this.workbookSettings.getGCDisabled()) {
            System.gc();
        }
    }

    @Override
    public Cell findCell(String string) {
        return new CellFinder(this).findCell(string);
    }

    @Override
    public Cell findCell(String string, int n, int n2, int n3, int n4, boolean bl) {
        return new CellFinder(this).findCell(string, n, n2, n3, n4, bl);
    }

    @Override
    public Cell findCell(Pattern pattern, int n, int n2, int n3, int n4, boolean bl) {
        return new CellFinder(this).findCell(pattern, n, n2, n3, n4, bl);
    }

    @Override
    public LabelCell findLabelCell(String string) {
        return new CellFinder(this).findLabelCell(string);
    }

    public AutoFilter getAutoFilter() {
        return this.autoFilter;
    }

    public ButtonPropertySetRecord getButtonPropertySet() {
        return this.buttonPropertySet;
    }

    @Override
    public Cell getCell(int n, int n2) {
        Cell cell;
        if (this.cells == null) {
            this.readSheet();
        }
        if ((cell = this.cells[n2][n]) == null) {
            this.cells[n2][n] = cell = new EmptyCell(n, n2);
        }
        return cell;
    }

    @Override
    public Cell getCell(String string) {
        return this.getCell(CellReferenceHelper.getColumn(string), CellReferenceHelper.getRow(string));
    }

    public final Chart[] getCharts() {
        Chart[] arrchart = new Chart[this.charts.size()];
        for (int i = 0; i < arrchart.length; ++i) {
            arrchart[i] = (Chart)this.charts.get(i);
        }
        return arrchart;
    }

    @Override
    public Cell[] getColumn(int n) {
        if (this.cells == null) {
            this.readSheet();
        }
        int n2 = this.numRows - 1;
        int n3 = 0;
        boolean bl = false;
        while (n2 >= 0 && !bl) {
            if (this.cells[n2][n] != null) {
                bl = true;
                continue;
            }
            --n2;
        }
        Cell[] arrcell = new Cell[n2 + 1];
        while (n3 <= n2) {
            arrcell[n3] = this.getCell(n, n3);
            ++n3;
        }
        return arrcell;
    }

    @Override
    public CellFormat getColumnFormat(int n) {
        return this.getColumnView(n).getFormat();
    }

    public ColumnInfoRecord getColumnInfo(int n) {
        ColumnInfoRecord[] arrcolumnInfoRecord;
        if (!this.columnInfosInitialized) {
            for (ColumnInfoRecord columnInfoRecord : this.columnInfosArray) {
                int n2 = Math.max((int)0, (int)columnInfoRecord.getStartColumn());
                int n3 = Math.min((int)(this.columnInfos.length - 1), (int)columnInfoRecord.getEndColumn());
                for (int i = n2; i <= n3; ++i) {
                    this.columnInfos[i] = columnInfoRecord;
                }
                if (n3 >= n2) continue;
                this.columnInfos[n2] = columnInfoRecord;
            }
            this.columnInfosInitialized = true;
        }
        if (n < (arrcolumnInfoRecord = this.columnInfos).length) {
            return arrcolumnInfoRecord[n];
        }
        return null;
    }

    public ColumnInfoRecord[] getColumnInfos() {
        ColumnInfoRecord[] arrcolumnInfoRecord = new ColumnInfoRecord[this.columnInfosArray.size()];
        for (int i = 0; i < this.columnInfosArray.size(); ++i) {
            arrcolumnInfoRecord[i] = (ColumnInfoRecord)this.columnInfosArray.get(i);
        }
        return arrcolumnInfoRecord;
    }

    @Override
    public final int[] getColumnPageBreaks() {
        return this.columnBreaks;
    }

    @Override
    public CellView getColumnView(int n) {
        ColumnInfoRecord columnInfoRecord = this.getColumnInfo(n);
        CellView cellView = new CellView();
        if (columnInfoRecord != null) {
            cellView.setDimension(columnInfoRecord.getWidth() / 256);
            cellView.setSize(columnInfoRecord.getWidth());
            cellView.setHidden(columnInfoRecord.getHidden());
            cellView.setFormat(this.formattingRecords.getXFRecord(columnInfoRecord.getXFIndex()));
            return cellView;
        }
        cellView.setDimension(this.settings.getDefaultColumnWidth());
        cellView.setSize(256 * this.settings.getDefaultColumnWidth());
        return cellView;
    }

    @Override
    public int getColumnWidth(int n) {
        return this.getColumnView(n).getSize() / 256;
    }

    @Override
    public int getColumns() {
        if (this.cells == null) {
            this.readSheet();
        }
        return this.numCols;
    }

    public ConditionalFormat[] getConditionalFormats() {
        Object[] arrobject = new ConditionalFormat[this.conditionalFormats.size()];
        return (ConditionalFormat[])this.conditionalFormats.toArray(arrobject);
    }

    public DataValidation getDataValidation() {
        return this.dataValidation;
    }

    @Override
    public Image getDrawing(int n) {
        if (this.images == null) {
            this.initializeImages();
        }
        return (Image)this.images.get(n);
    }

    public DrawingData getDrawingData() {
        SheetReader sheetReader = new SheetReader(this.excelFile, this.sharedStrings, this.formattingRecords, this.sheetBof, this.workbookBof, this.nineteenFour, this.workbook, this.startPosition, this);
        sheetReader.read();
        return sheetReader.getDrawingData();
    }

    public final DrawingGroupObject[] getDrawings() {
        Object[] arrobject = new DrawingGroupObject[this.drawings.size()];
        return (DrawingGroupObject[])this.drawings.toArray(arrobject);
    }

    @Override
    public Hyperlink[] getHyperlinks() {
        Hyperlink[] arrhyperlink = new Hyperlink[this.hyperlinks.size()];
        for (int i = 0; i < this.hyperlinks.size(); ++i) {
            arrhyperlink[i] = (Hyperlink)this.hyperlinks.get(i);
        }
        return arrhyperlink;
    }

    public int getMaxColumnOutlineLevel() {
        return this.maxColumnOutlineLevel;
    }

    public int getMaxRowOutlineLevel() {
        return this.maxRowOutlineLevel;
    }

    @Override
    public Range[] getMergedCells() {
        Range[] arrrange = this.mergedCells;
        if (arrrange == null) {
            arrrange = new Range[]{};
        }
        return arrrange;
    }

    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public int getNumberOfImages() {
        if (this.images == null) {
            this.initializeImages();
        }
        return this.images.size();
    }

    public PLSRecord getPLS() {
        return this.plsRecord;
    }

    @Override
    public Cell[] getRow(int n) {
        if (this.cells == null) {
            this.readSheet();
        }
        int n2 = this.numCols - 1;
        int n3 = 0;
        boolean bl = false;
        while (n2 >= 0 && !bl) {
            if (this.cells[n][n2] != null) {
                bl = true;
                continue;
            }
            --n2;
        }
        Cell[] arrcell = new Cell[n2 + 1];
        while (n3 <= n2) {
            arrcell[n3] = this.getCell(n3, n);
            ++n3;
        }
        return arrcell;
    }

    @Override
    public int getRowHeight(int n) {
        return this.getRowView(n).getDimension();
    }

    RowRecord getRowInfo(int n) {
        RowRecord[] arrrowRecord;
        if (!this.rowRecordsInitialized) {
            this.rowRecords = new RowRecord[this.getRows()];
            for (RowRecord rowRecord : this.rowProperties) {
                RowRecord[] arrrowRecord2;
                int n2 = rowRecord.getRowNumber();
                if (n2 >= (arrrowRecord2 = this.rowRecords).length) continue;
                arrrowRecord2[n2] = rowRecord;
            }
            this.rowRecordsInitialized = true;
        }
        if (n < (arrrowRecord = this.rowRecords).length) {
            return arrrowRecord[n];
        }
        return null;
    }

    @Override
    public final int[] getRowPageBreaks() {
        return this.rowBreaks;
    }

    public RowRecord[] getRowProperties() {
        RowRecord[] arrrowRecord = new RowRecord[this.rowProperties.size()];
        for (int i = 0; i < arrrowRecord.length; ++i) {
            arrrowRecord[i] = (RowRecord)this.rowProperties.get(i);
        }
        return arrrowRecord;
    }

    @Override
    public CellView getRowView(int n) {
        RowRecord rowRecord = this.getRowInfo(n);
        CellView cellView = new CellView();
        if (rowRecord != null) {
            cellView.setDimension(rowRecord.getRowHeight());
            cellView.setSize(rowRecord.getRowHeight());
            cellView.setHidden(rowRecord.isCollapsed());
            if (rowRecord.hasDefaultFormat()) {
                cellView.setFormat(this.formattingRecords.getXFRecord(rowRecord.getXFIndex()));
                return cellView;
            }
        } else {
            cellView.setDimension(this.settings.getDefaultRowHeight());
            cellView.setSize(this.settings.getDefaultRowHeight());
        }
        return cellView;
    }

    @Override
    public int getRows() {
        if (this.cells == null) {
            this.readSheet();
        }
        return this.numRows;
    }

    @Override
    public SheetSettings getSettings() {
        return this.settings;
    }

    public BOFRecord getSheetBof() {
        return this.sheetBof;
    }

    public WorkbookParser getWorkbook() {
        return this.workbook;
    }

    public BOFRecord getWorkbookBof() {
        return this.workbookBof;
    }

    public WorkspaceInformationRecord getWorkspaceOptions() {
        return this.workspaceOptions;
    }

    @Override
    public boolean isHidden() {
        return this.hidden;
    }

    @Override
    public boolean isProtected() {
        return this.settings.isProtected();
    }

    final void readSheet() {
        if (!this.sheetBof.isWorksheet()) {
            this.numRows = 0;
            this.numCols = 0;
            this.cells = (Cell[][])Array.newInstance(Cell.class, (int[])new int[]{0, 0});
        }
        SheetReader sheetReader = new SheetReader(this.excelFile, this.sharedStrings, this.formattingRecords, this.sheetBof, this.workbookBof, this.nineteenFour, this.workbook, this.startPosition, this);
        sheetReader.read();
        this.numRows = sheetReader.getNumRows();
        this.numCols = sheetReader.getNumCols();
        this.cells = sheetReader.getCells();
        this.rowProperties = sheetReader.getRowProperties();
        this.columnInfosArray = sheetReader.getColumnInfosArray();
        this.hyperlinks = sheetReader.getHyperlinks();
        this.conditionalFormats = sheetReader.getConditionalFormats();
        this.autoFilter = sheetReader.getAutoFilter();
        this.charts = sheetReader.getCharts();
        this.drawings = sheetReader.getDrawings();
        this.dataValidation = sheetReader.getDataValidation();
        this.mergedCells = sheetReader.getMergedCells();
        this.settings = sheetReader.getSettings();
        this.settings.setHidden(this.hidden);
        this.rowBreaks = sheetReader.getRowBreaks();
        this.columnBreaks = sheetReader.getColumnBreaks();
        this.workspaceOptions = sheetReader.getWorkspaceOptions();
        this.plsRecord = sheetReader.getPLS();
        this.buttonPropertySet = sheetReader.getButtonPropertySet();
        this.maxRowOutlineLevel = sheetReader.getMaxRowOutlineLevel();
        this.maxColumnOutlineLevel = sheetReader.getMaxColumnOutlineLevel();
        if (!this.workbookSettings.getGCDisabled()) {
            System.gc();
        }
        if (this.columnInfosArray.size() > 0) {
            ArrayList arrayList = this.columnInfosArray;
            this.columnInfos = new ColumnInfoRecord[1 + ((ColumnInfoRecord)arrayList.get(-1 + arrayList.size())).getEndColumn()];
        } else {
            this.columnInfos = new ColumnInfoRecord[0];
        }
        ArrayList arrayList = this.localNames;
        if (arrayList != null) {
            for (NameRecord nameRecord : arrayList) {
                if (nameRecord.getBuiltInName() == BuiltInName.PRINT_AREA) {
                    if (nameRecord.getRanges().length <= 0) continue;
                    NameRecord.NameRange nameRange = nameRecord.getRanges()[0];
                    this.settings.setPrintArea(nameRange.getFirstColumn(), nameRange.getFirstRow(), nameRange.getLastColumn(), nameRange.getLastRow());
                    continue;
                }
                if (nameRecord.getBuiltInName() != BuiltInName.PRINT_TITLES) continue;
                for (int i = 0; i < nameRecord.getRanges().length; ++i) {
                    NameRecord.NameRange nameRange = nameRecord.getRanges()[i];
                    if (nameRange.getFirstColumn() == 0 && nameRange.getLastColumn() == 255) {
                        this.settings.setPrintTitlesRow(nameRange.getFirstRow(), nameRange.getLastRow());
                        continue;
                    }
                    this.settings.setPrintTitlesCol(nameRange.getFirstColumn(), nameRange.getLastColumn());
                }
            }
        }
    }

    final void setHidden(boolean bl) {
        this.hidden = bl;
    }

    final void setName(String string) {
        this.name = string;
    }
}

