/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 */
package jxl.read.biff;

import jxl.Cell;
import jxl.CellType;
import jxl.LabelCell;
import jxl.StringFormulaCell;
import jxl.WorkbookSettings;
import jxl.biff.FormattingRecords;
import jxl.biff.FormulaData;
import jxl.biff.IntegerHelper;
import jxl.biff.StringHelper;
import jxl.biff.Type;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.FormulaParser;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.BOFRecord;
import jxl.read.biff.CellValue;
import jxl.read.biff.File;
import jxl.read.biff.Record;
import jxl.read.biff.SheetImpl;
import jxl.read.biff.WorkbookParser;

class StringFormulaRecord
extends CellValue
implements LabelCell,
FormulaData,
StringFormulaCell {
    private static Logger logger = Logger.getLogger(StringFormulaRecord.class);
    private byte[] data;
    private ExternalSheet externalSheet;
    private String formulaString;
    private WorkbookMethods nameTable;
    private String value;

    public StringFormulaRecord(Record record, FormattingRecords formattingRecords, ExternalSheet externalSheet, WorkbookMethods workbookMethods, SheetImpl sheetImpl) {
        super(record, formattingRecords, sheetImpl);
        this.externalSheet = externalSheet;
        this.nameTable = workbookMethods;
        this.data = this.getRecord().getData();
        this.value = "";
    }

    public StringFormulaRecord(Record record, File file, FormattingRecords formattingRecords, ExternalSheet externalSheet, WorkbookMethods workbookMethods, SheetImpl sheetImpl, WorkbookSettings workbookSettings) {
        int n;
        super(record, formattingRecords, sheetImpl);
        this.externalSheet = externalSheet;
        this.nameTable = workbookMethods;
        this.data = this.getRecord().getData();
        int n2 = file.getPos();
        Record record2 = file.next();
        for (n = 0; record2.getType() != Type.STRING && n < 4; ++n) {
            record2 = file.next();
        }
        boolean bl = n < 4;
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(" @ ");
        stringBuilder.append(n2);
        Assert.verify(bl, stringBuilder.toString());
        byte[] arrby = record2.getData();
        Record record3 = file.peek();
        while (record3.getType() == Type.CONTINUE) {
            Record record4 = file.next();
            byte[] arrby2 = new byte[arrby.length + record4.getLength() - 1];
            System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby.length);
            System.arraycopy((Object)record4.getData(), (int)1, (Object)arrby2, (int)arrby.length, (int)(record4.getLength() - 1));
            record3 = file.peek();
            arrby = arrby2;
        }
        this.readString(arrby, workbookSettings);
    }

    private void readString(byte[] arrby, WorkbookSettings workbookSettings) {
        int n = IntegerHelper.getInt(arrby[0], arrby[1]);
        if (n == 0) {
            this.value = "";
            return;
        }
        int n2 = 2;
        byte by = arrby[n2];
        if ((by & 15) != by) {
            n = IntegerHelper.getInt(arrby[0], (byte)0);
            by = arrby[1];
        } else {
            n2 = 3;
        }
        boolean bl = (by & 4) != 0;
        boolean bl2 = (by & 8) != 0;
        if (bl2) {
            n2 += 2;
        }
        if (bl) {
            n2 += 4;
        }
        int n3 = by & 1;
        boolean bl3 = false;
        if (n3 == 0) {
            bl3 = true;
        }
        if (bl3) {
            this.value = StringHelper.getString(arrby, n, n2, workbookSettings);
            return;
        }
        this.value = StringHelper.getUnicodeString(arrby, n, n2);
    }

    @Override
    public String getContents() {
        return this.value;
    }

    @Override
    public String getFormula() throws FormulaException {
        if (this.formulaString == null) {
            byte[] arrby = this.data;
            byte[] arrby2 = new byte[arrby.length - 22];
            System.arraycopy((Object)arrby, (int)22, (Object)arrby2, (int)0, (int)arrby2.length);
            FormulaParser formulaParser = new FormulaParser(arrby2, this, this.externalSheet, this.nameTable, this.getSheet().getWorkbook().getSettings());
            formulaParser.parse();
            this.formulaString = formulaParser.getFormula();
        }
        return this.formulaString;
    }

    @Override
    public byte[] getFormulaData() throws FormulaException {
        if (this.getSheet().getWorkbook().getWorkbookBof().isBiff8()) {
            byte[] arrby = this.data;
            byte[] arrby2 = new byte[arrby.length - 6];
            System.arraycopy((Object)arrby, (int)6, (Object)arrby2, (int)0, (int)(arrby.length - 6));
            return arrby2;
        }
        throw new FormulaException(FormulaException.BIFF8_SUPPORTED);
    }

    @Override
    public String getString() {
        return this.value;
    }

    @Override
    public CellType getType() {
        return CellType.STRING_FORMULA;
    }
}

