/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.File
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuffer
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.util.ArrayList
 *  java.util.HashMap
 *  java.util.Iterator
 *  java.util.Set
 */
package jxl.read.biff;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import jxl.Cell;
import jxl.Range;
import jxl.Sheet;
import jxl.Workbook;
import jxl.WorkbookSettings;
import jxl.biff.BuiltInName;
import jxl.biff.CellReferenceHelper;
import jxl.biff.DisplayFormat;
import jxl.biff.EmptyCell;
import jxl.biff.FontRecord;
import jxl.biff.Fonts;
import jxl.biff.FormatRecord;
import jxl.biff.FormattingRecords;
import jxl.biff.NameRangeException;
import jxl.biff.NumFormatRecordsException;
import jxl.biff.PaletteRecord;
import jxl.biff.RangeImpl;
import jxl.biff.StringHelper;
import jxl.biff.Type;
import jxl.biff.WorkbookMethods;
import jxl.biff.XCTRecord;
import jxl.biff.XFRecord;
import jxl.biff.drawing.DrawingGroup;
import jxl.biff.drawing.MsoDrawingGroupRecord;
import jxl.biff.drawing.Origin;
import jxl.biff.formula.ExternalSheet;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.BOFRecord;
import jxl.read.biff.BiffException;
import jxl.read.biff.BoundsheetRecord;
import jxl.read.biff.ButtonPropertySetRecord;
import jxl.read.biff.CodepageRecord;
import jxl.read.biff.CompoundFile;
import jxl.read.biff.CountryRecord;
import jxl.read.biff.Excel9FileRecord;
import jxl.read.biff.ExternalNameRecord;
import jxl.read.biff.ExternalSheetRecord;
import jxl.read.biff.File;
import jxl.read.biff.HideobjRecord;
import jxl.read.biff.NameRecord;
import jxl.read.biff.NineteenFourRecord;
import jxl.read.biff.PasswordException;
import jxl.read.biff.ProtectRecord;
import jxl.read.biff.Record;
import jxl.read.biff.RefreshAllRecord;
import jxl.read.biff.SSTRecord;
import jxl.read.biff.SheetImpl;
import jxl.read.biff.SupbookRecord;
import jxl.read.biff.TemplateRecord;
import jxl.read.biff.WindowProtectedRecord;
import jxl.read.biff.WriteAccessRecord;

public class WorkbookParser
extends Workbook
implements ExternalSheet,
WorkbookMethods {
    private static Logger logger = Logger.getLogger(WorkbookParser.class);
    private ArrayList addInFunctions;
    private int bofs;
    private ArrayList boundsheets;
    private ButtonPropertySetRecord buttonPropertySet;
    private boolean containsMacros;
    private CountryRecord countryRecord;
    private DrawingGroup drawingGroup;
    private File excelFile;
    private ExternalSheetRecord externSheet;
    private Fonts fonts;
    private FormattingRecords formattingRecords;
    private SheetImpl lastSheet;
    private int lastSheetIndex;
    private MsoDrawingGroupRecord msoDrawingGroup;
    private ArrayList nameTable;
    private HashMap namedRecords;
    private boolean nineteenFour;
    private WorkbookSettings settings;
    private SSTRecord sharedStrings;
    private ArrayList sheets;
    private ArrayList supbooks;
    private boolean wbProtected;
    private BOFRecord workbookBof;
    private ArrayList xctRecords;

    public WorkbookParser(File file, WorkbookSettings workbookSettings) {
        this.excelFile = file;
        this.boundsheets = new ArrayList(10);
        this.fonts = new Fonts();
        this.formattingRecords = new FormattingRecords(this.fonts);
        this.sheets = new ArrayList(10);
        this.supbooks = new ArrayList(10);
        this.namedRecords = new HashMap();
        this.lastSheetIndex = -1;
        this.wbProtected = false;
        this.containsMacros = false;
        this.settings = workbookSettings;
        this.xctRecords = new ArrayList(10);
    }

    final void addSheet(Sheet sheet) {
        this.sheets.add((Object)sheet);
    }

    @Override
    public void close() {
        SheetImpl sheetImpl = this.lastSheet;
        if (sheetImpl != null) {
            sheetImpl.clear();
        }
        this.excelFile.clear();
        if (!this.settings.getGCDisabled()) {
            System.gc();
        }
    }

    public boolean containsMacros() {
        return this.containsMacros;
    }

    @Override
    public Range[] findByName(String string) {
        NameRecord nameRecord = (NameRecord)this.namedRecords.get((Object)string);
        if (nameRecord == null) {
            return null;
        }
        NameRecord.NameRange[] arrnameRange = nameRecord.getRanges();
        Range[] arrrange = new Range[arrnameRange.length];
        for (int i = 0; i < arrnameRange.length; ++i) {
            RangeImpl rangeImpl = new RangeImpl(this, this.getExternalSheetIndex(arrnameRange[i].getExternalSheet()), arrnameRange[i].getFirstColumn(), arrnameRange[i].getFirstRow(), this.getLastExternalSheetIndex(arrnameRange[i].getExternalSheet()), arrnameRange[i].getLastColumn(), arrnameRange[i].getLastRow());
            arrrange[i] = rangeImpl;
        }
        return arrrange;
    }

    @Override
    public Cell findCellByName(String string) {
        NameRecord nameRecord = (NameRecord)this.namedRecords.get((Object)string);
        if (nameRecord == null) {
            return null;
        }
        NameRecord.NameRange[] arrnameRange = nameRecord.getRanges();
        Sheet sheet = this.getSheet(this.getExternalSheetIndex(arrnameRange[0].getExternalSheet()));
        int n = arrnameRange[0].getFirstColumn();
        int n2 = arrnameRange[0].getFirstRow();
        if (n <= sheet.getColumns() && n2 <= sheet.getRows()) {
            return sheet.getCell(n, n2);
        }
        return new EmptyCell(n, n2);
    }

    public String[] getAddInFunctionNames() {
        Object[] arrobject = new String[]{};
        return (String[])this.addInFunctions.toArray(arrobject);
    }

    public ButtonPropertySetRecord getButtonPropertySet() {
        return this.buttonPropertySet;
    }

    @Override
    public Cell getCell(String string) {
        return this.getSheet(CellReferenceHelper.getSheet(string)).getCell(string);
    }

    public CompoundFile getCompoundFile() {
        return this.excelFile.getCompoundFile();
    }

    public CountryRecord getCountryRecord() {
        return this.countryRecord;
    }

    public DrawingGroup getDrawingGroup() {
        return this.drawingGroup;
    }

    @Override
    public int getExternalSheetIndex(int n) {
        if (this.workbookBof.isBiff7()) {
            return n;
        }
        boolean bl = this.externSheet != null;
        Assert.verify(bl);
        return this.externSheet.getFirstTabIndex(n);
    }

    @Override
    public int getExternalSheetIndex(String string) {
        return 0;
    }

    @Override
    public String getExternalSheetName(int n) {
        if (this.workbookBof.isBiff7()) {
            return ((BoundsheetRecord)this.boundsheets.get(n)).getName();
        }
        int n2 = this.externSheet.getSupbookIndex(n);
        SupbookRecord supbookRecord = (SupbookRecord)this.supbooks.get(n2);
        int n3 = this.externSheet.getFirstTabIndex(n);
        int n4 = this.externSheet.getLastTabIndex(n);
        SupbookRecord.Type type = supbookRecord.getType();
        SupbookRecord.Type type2 = SupbookRecord.INTERNAL;
        String string = "#REF";
        if (type == type2) {
            String string2 = n3 == 65535 ? string : ((BoundsheetRecord)this.boundsheets.get(n3)).getName();
            if (n4 != 65535) {
                string = ((BoundsheetRecord)this.boundsheets.get(n4)).getName();
            }
            if (n3 != n4) {
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append(string2);
                stringBuilder.append(':');
                stringBuilder.append(string);
                string2 = stringBuilder.toString();
            }
            if (string2.indexOf(39) != -1) {
                string2 = StringHelper.replace(string2, "'", "''");
            }
            if (string2.indexOf(32) == -1) {
                return string2;
            }
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append('\'');
            stringBuilder.append(string2);
            stringBuilder.append('\'');
            return stringBuilder.toString();
        }
        if (supbookRecord.getType() == SupbookRecord.EXTERNAL) {
            StringBuffer stringBuffer = new StringBuffer();
            java.io.File file = new java.io.File(supbookRecord.getFileName());
            stringBuffer.append("'");
            stringBuffer.append(file.getAbsolutePath());
            stringBuffer.append("[");
            stringBuffer.append(file.getName());
            stringBuffer.append("]");
            if (n3 != 65535) {
                string = supbookRecord.getSheetName(n3);
            }
            stringBuffer.append(string);
            if (n4 != n3) {
                stringBuffer.append(supbookRecord.getSheetName(n4));
            }
            stringBuffer.append("'");
            return stringBuffer.toString();
        }
        logger.warn("Unknown Supbook 3");
        return "[UNKNOWN]";
    }

    public ExternalSheetRecord getExternalSheetRecord() {
        return this.externSheet;
    }

    public Fonts getFonts() {
        return this.fonts;
    }

    public FormattingRecords getFormattingRecords() {
        return this.formattingRecords;
    }

    public int getIndex(Sheet sheet) {
        String string = sheet.getName();
        Iterator iterator = this.boundsheets.iterator();
        int n = -1;
        int n2 = 0;
        while (iterator.hasNext() && n == -1) {
            if (((BoundsheetRecord)iterator.next()).getName().equals((Object)string)) {
                n = n2;
                continue;
            }
            ++n2;
        }
        return n;
    }

    @Override
    public int getLastExternalSheetIndex(int n) {
        if (this.workbookBof.isBiff7()) {
            return n;
        }
        boolean bl = this.externSheet != null;
        Assert.verify(bl);
        return this.externSheet.getLastTabIndex(n);
    }

    @Override
    public int getLastExternalSheetIndex(String string) {
        return 0;
    }

    public String getLastExternalSheetName(int n) {
        if (this.workbookBof.isBiff7()) {
            return ((BoundsheetRecord)this.boundsheets.get(n)).getName();
        }
        int n2 = this.externSheet.getSupbookIndex(n);
        SupbookRecord supbookRecord = (SupbookRecord)this.supbooks.get(n2);
        int n3 = this.externSheet.getLastTabIndex(n);
        SupbookRecord.Type type = supbookRecord.getType();
        SupbookRecord.Type type2 = SupbookRecord.INTERNAL;
        String string = "#REF";
        if (type == type2) {
            if (n3 == 65535) {
                return string;
            }
            return ((BoundsheetRecord)this.boundsheets.get(n3)).getName();
        }
        if (supbookRecord.getType() == SupbookRecord.EXTERNAL) {
            StringBuffer stringBuffer = new StringBuffer();
            java.io.File file = new java.io.File(supbookRecord.getFileName());
            stringBuffer.append("'");
            stringBuffer.append(file.getAbsolutePath());
            stringBuffer.append("[");
            stringBuffer.append(file.getName());
            stringBuffer.append("]");
            if (n3 != 65535) {
                string = supbookRecord.getSheetName(n3);
            }
            stringBuffer.append(string);
            stringBuffer.append("'");
            return stringBuffer.toString();
        }
        logger.warn("Unknown Supbook 4");
        return "[UNKNOWN]";
    }

    public MsoDrawingGroupRecord getMsoDrawingGroupRecord() {
        return this.msoDrawingGroup;
    }

    @Override
    public String getName(int n) throws NameRangeException {
        if (n >= 0 && n < this.nameTable.size()) {
            return ((NameRecord)this.nameTable.get(n)).getName();
        }
        throw new NameRangeException();
    }

    @Override
    public int getNameIndex(String string) {
        NameRecord nameRecord = (NameRecord)this.namedRecords.get((Object)string);
        if (nameRecord != null) {
            return nameRecord.getIndex();
        }
        return 0;
    }

    public NameRecord[] getNameRecords() {
        Object[] arrobject = new NameRecord[this.nameTable.size()];
        return (NameRecord[])this.nameTable.toArray(arrobject);
    }

    @Override
    public int getNumberOfSheets() {
        return this.sheets.size();
    }

    @Override
    public String[] getRangeNames() {
        Object[] arrobject = this.namedRecords.keySet().toArray();
        String[] arrstring = new String[arrobject.length];
        System.arraycopy((Object)arrobject, (int)0, (Object)arrstring, (int)0, (int)arrobject.length);
        return arrstring;
    }

    @Override
    public Sheet getReadSheet(int n) {
        return this.getSheet(n);
    }

    public WorkbookSettings getSettings() {
        return this.settings;
    }

    @Override
    public Sheet getSheet(int n) {
        SheetImpl sheetImpl = this.lastSheet;
        if (sheetImpl != null && this.lastSheetIndex == n) {
            return sheetImpl;
        }
        SheetImpl sheetImpl2 = this.lastSheet;
        if (sheetImpl2 != null) {
            sheetImpl2.clear();
            if (!this.settings.getGCDisabled()) {
                System.gc();
            }
        }
        this.lastSheet = (SheetImpl)this.sheets.get(n);
        this.lastSheetIndex = n;
        this.lastSheet.readSheet();
        return this.lastSheet;
    }

    @Override
    public Sheet getSheet(String string) {
        Iterator iterator = this.boundsheets.iterator();
        boolean bl = false;
        int n = 0;
        while (iterator.hasNext() && !bl) {
            if (((BoundsheetRecord)iterator.next()).getName().equals((Object)string)) {
                bl = true;
                continue;
            }
            ++n;
        }
        if (bl) {
            return this.getSheet(n);
        }
        return null;
    }

    @Override
    public String[] getSheetNames() {
        String[] arrstring = new String[this.boundsheets.size()];
        for (int i = 0; i < arrstring.length; ++i) {
            arrstring[i] = ((BoundsheetRecord)this.boundsheets.get(i)).getName();
        }
        return arrstring;
    }

    @Override
    public Sheet[] getSheets() {
        Object[] arrobject = new Sheet[this.getNumberOfSheets()];
        return (Sheet[])this.sheets.toArray(arrobject);
    }

    public SupbookRecord[] getSupbookRecords() {
        Object[] arrobject = new SupbookRecord[this.supbooks.size()];
        return (SupbookRecord[])this.supbooks.toArray(arrobject);
    }

    @Override
    public BOFRecord getWorkbookBof() {
        return this.workbookBof;
    }

    public XCTRecord[] getXCTRecords() {
        Object[] arrobject = new XCTRecord[]{};
        return (XCTRecord[])this.xctRecords.toArray(arrobject);
    }

    @Override
    public boolean isProtected() {
        return this.wbProtected;
    }

    /*
     * Unable to fully structure code
     * Enabled aggressive block sorting
     * Enabled unnecessary exception pruning
     * Enabled aggressive exception aggregation
     * Lifted jumps to return sites
     */
    @Override
    protected void parse() throws BiffException, PasswordException {
        block48 : {
            this.workbookBof = var1_1 = new BOFRecord(this.excelFile.next());
            this.bofs = 1 + this.bofs;
            if (!var1_1.isBiff8()) {
                if (var1_1.isBiff7() == false) throw new BiffException(BiffException.unrecognizedBiffVersion);
            }
            if (!var1_1.isWorkbookGlobals()) {
                var42_33 = new BiffException(BiffException.expectedGlobals);
                throw var42_33;
            }
            var2_2 = new ArrayList();
            var3_3 = new ArrayList();
            this.nameTable = new ArrayList();
            this.addInFunctions = new ArrayList();
            var4_4 = null;
            while (this.bofs == 1) {
                var4_4 = this.excelFile.next();
                if (var4_4.getType() == Type.SST) {
                    var2_2.clear();
                    var40_25 = this.excelFile.peek();
                    while (var40_25.getType() == Type.CONTINUE) {
                        var2_2.add((Object)this.excelFile.next());
                        var40_25 = this.excelFile.peek();
                    }
                    this.sharedStrings = new SSTRecord(var4_4, (Record[])var2_2.toArray((Object[])new Record[var2_2.size()]), this.settings);
                    continue;
                }
                if (var4_4.getType() == Type.FILEPASS) throw new PasswordException();
                if (var4_4.getType() == Type.NAME) {
                    var36_24 = var1_1.isBiff8() != false ? new NameRecord(var4_4, this.settings, this.nameTable.size()) : new NameRecord(var4_4, this.settings, this.nameTable.size(), NameRecord.biff7);
                    this.nameTable.add((Object)var36_24);
                    if (var36_24.isGlobal()) {
                        this.namedRecords.put((Object)var36_24.getName(), (Object)var36_24);
                        continue;
                    }
                    var3_3.add((Object)var36_24);
                    continue;
                }
                if (var4_4.getType() == Type.FONT) {
                    var35_23 = var1_1.isBiff8() != false ? new FontRecord(var4_4, this.settings) : new FontRecord(var4_4, this.settings, FontRecord.biff7);
                    this.fonts.addFont(var35_23);
                    continue;
                }
                if (var4_4.getType() == Type.PALETTE) {
                    var12_5 = new PaletteRecord(var4_4);
                    this.formattingRecords.setPalette(var12_5);
                    continue;
                }
                if (var4_4.getType() == Type.NINETEENFOUR) {
                    this.nineteenFour = new NineteenFourRecord(var4_4).is1904();
                    continue;
                }
                if (var4_4.getType() == Type.FORMAT) {
                    var33_21 = var1_1.isBiff8() != false ? new FormatRecord(var4_4, this.settings, FormatRecord.biff8) : new FormatRecord(var4_4, this.settings, FormatRecord.biff7);
                    try {
                        this.formattingRecords.addFormat(var33_21);
                    }
                    catch (NumFormatRecordsException var34_22) {
                        Assert.verify(false, var34_22.getMessage());
                    }
                    continue;
                }
                if (var4_4.getType() == Type.XF) {
                    var31_19 = var1_1.isBiff8() != false ? new XFRecord(var4_4, this.settings, XFRecord.biff8) : new XFRecord(var4_4, this.settings, XFRecord.biff7);
                    try {
                        this.formattingRecords.addStyle(var31_19);
                    }
                    catch (NumFormatRecordsException var32_20) {
                        Assert.verify(false, var32_20.getMessage());
                    }
                    continue;
                }
                if (var4_4.getType() == Type.BOUNDSHEET) {
                    var28_18 = var1_1.isBiff8() != false ? new BoundsheetRecord(var4_4, this.settings) : new BoundsheetRecord(var4_4, BoundsheetRecord.biff7);
                    if (var28_18.isSheet()) {
                        this.boundsheets.add((Object)var28_18);
                        continue;
                    }
                    if (!var28_18.isChart() || this.settings.getDrawingsDisabled()) continue;
                    this.boundsheets.add((Object)var28_18);
                    continue;
                }
                if (var4_4.getType() == Type.EXTERNSHEET) {
                    if (var1_1.isBiff8()) {
                        this.externSheet = new ExternalSheetRecord(var4_4, this.settings);
                        continue;
                    }
                    this.externSheet = new ExternalSheetRecord(var4_4, this.settings, ExternalSheetRecord.biff7);
                    continue;
                }
                if (var4_4.getType() == Type.XCT) {
                    var13_6 = new XCTRecord(var4_4);
                    this.xctRecords.add((Object)var13_6);
                    continue;
                }
                if (var4_4.getType() == Type.CODEPAGE) {
                    var15_7 = new CodepageRecord(var4_4);
                    this.settings.setCharacterSet(var15_7.getCharacterSet());
                    continue;
                }
                if (var4_4.getType() == Type.SUPBOOK) {
                    var25_16 = this.excelFile.peek();
                    while (var25_16.getType() == Type.CONTINUE) {
                        var4_4.addContinueRecord(this.excelFile.next());
                        var25_16 = this.excelFile.peek();
                    }
                    var26_17 = new SupbookRecord(var4_4, this.settings);
                    this.supbooks.add((Object)var26_17);
                    continue;
                }
                if (var4_4.getType() == Type.EXTERNNAME) {
                    var16_8 = new ExternalNameRecord(var4_4, this.settings);
                    if (!var16_8.isAddInFunction()) continue;
                    this.addInFunctions.add((Object)var16_8.getName());
                    continue;
                }
                if (var4_4.getType() == Type.PROTECT) {
                    this.wbProtected = new ProtectRecord(var4_4).isProtected();
                    continue;
                }
                if (var4_4.getType() == Type.OBJPROJ) {
                    this.containsMacros = true;
                    continue;
                }
                if (var4_4.getType() == Type.COUNTRY) {
                    this.countryRecord = new CountryRecord(var4_4);
                    continue;
                }
                if (var4_4.getType() == Type.MSODRAWINGGROUP) {
                    if (this.settings.getDrawingsDisabled()) continue;
                    this.msoDrawingGroup = new MsoDrawingGroupRecord(var4_4);
                    if (this.drawingGroup == null) {
                        this.drawingGroup = new DrawingGroup(Origin.READ);
                    }
                    this.drawingGroup.add(this.msoDrawingGroup);
                    var24_15 = this.excelFile.peek();
                    while (var24_15.getType() == Type.CONTINUE) {
                        this.drawingGroup.add(this.excelFile.next());
                        var24_15 = this.excelFile.peek();
                    }
                    continue;
                }
                if (var4_4.getType() == Type.BUTTONPROPERTYSET) {
                    this.buttonPropertySet = new ButtonPropertySetRecord(var4_4);
                    continue;
                }
                if (var4_4.getType() == Type.EOF) {
                    --this.bofs;
                    continue;
                }
                if (var4_4.getType() == Type.REFRESHALL) {
                    var18_9 = new RefreshAllRecord(var4_4);
                    this.settings.setRefreshAll(var18_9.getRefreshAll());
                    continue;
                }
                if (var4_4.getType() == Type.TEMPLATE) {
                    var19_10 = new TemplateRecord(var4_4);
                    this.settings.setTemplate(var19_10.getTemplate());
                    continue;
                }
                if (var4_4.getType() == Type.EXCEL9FILE) {
                    var20_11 = new Excel9FileRecord(var4_4);
                    this.settings.setExcel9File(var20_11.getExcel9File());
                    continue;
                }
                if (var4_4.getType() == Type.WINDOWPROTECT) {
                    var21_12 = new WindowProtectedRecord(var4_4);
                    this.settings.setWindowProtected(var21_12.getWindowProtected());
                    continue;
                }
                if (var4_4.getType() == Type.HIDEOBJ) {
                    var22_13 = new HideobjRecord(var4_4);
                    this.settings.setHideobj(var22_13.getHideMode());
                    continue;
                }
                if (var4_4.getType() != Type.WRITEACCESS) continue;
                var23_14 = new WriteAccessRecord(var4_4, var1_1.isBiff8(), this.settings);
                this.settings.setWriteAccess(var23_14.getWriteAccess());
            }
            if (!this.excelFile.hasNext() || (var4_4 = this.excelFile.next()).getType() != Type.BOF) break block48;
            var5_26 = new BOFRecord(var4_4);
            ** GOTO lbl153
        }
        block8 : do {
            var5_26 = null;
lbl153: // 3 sources:
            while (var5_26 != null && this.getNumberOfSheets() < this.boundsheets.size()) {
                if (!var5_26.isBiff8()) {
                    if (var5_26.isBiff7() == false) throw new BiffException(BiffException.unrecognizedBiffVersion);
                }
                if (var5_26.isWorksheet()) {
                    var8_27 = new SheetImpl(this.excelFile, this.sharedStrings, this.formattingRecords, var5_26, this.workbookBof, this.nineteenFour, this);
                    var9_28 = (BoundsheetRecord)this.boundsheets.get(this.getNumberOfSheets());
                    var8_27.setName(var9_28.getName());
                    var8_27.setHidden(var9_28.isHidden());
                    this.addSheet(var8_27);
                } else if (var5_26.isChart()) {
                    var10_29 = new SheetImpl(this.excelFile, this.sharedStrings, this.formattingRecords, var5_26, this.workbookBof, this.nineteenFour, this);
                    var11_30 = (BoundsheetRecord)this.boundsheets.get(this.getNumberOfSheets());
                    var10_29.setName(var11_30.getName());
                    var10_29.setHidden(var11_30.isHidden());
                    this.addSheet(var10_29);
                } else {
                    WorkbookParser.logger.warn("BOF is unrecognized");
                    while (this.excelFile.hasNext() && var4_4.getType() != Type.EOF) {
                        var4_4 = this.excelFile.next();
                    }
                }
                if (!this.excelFile.hasNext() || (var4_4 = this.excelFile.next()).getType() != Type.BOF) continue block8;
                var5_26 = new BOFRecord(var4_4);
            }
            break;
        } while (true);
        var6_31 = var3_3.iterator();
        while (var6_31.hasNext() != false) {
            var7_32 = (NameRecord)var6_31.next();
            if (var7_32.getBuiltInName() == null) {
                WorkbookParser.logger.warn("Usage of a local non-builtin name");
                continue;
            }
            if (var7_32.getBuiltInName() != BuiltInName.PRINT_AREA && var7_32.getBuiltInName() != BuiltInName.PRINT_TITLES) continue;
            ((SheetImpl)this.sheets.get(var7_32.getSheetRef() - 1)).addLocalName(var7_32);
        }
    }
}

