/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.IOException
 *  java.io.OutputStream
 *  java.lang.Double
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.util.ArrayList
 *  java.util.HashMap
 *  java.util.Iterator
 */
package jxl.write.biff;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import jxl.biff.BaseCompoundFile;
import jxl.biff.IntegerHelper;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.BiffException;
import jxl.write.biff.CopyAdditionalPropertySetsException;
import jxl.write.biff.ExcelDataOutput;

final class CompoundFile
extends BaseCompoundFile {
    private static Logger logger = Logger.getLogger(CompoundFile.class);
    private int additionalPropertyBlocks;
    private ArrayList additionalPropertySets;
    private int bbdPos;
    private int bbdStartBlock;
    private byte[] bigBlockDepot;
    private ExcelDataOutput excelData;
    private int excelDataBlocks;
    private int excelDataStartBlock;
    private int extensionBlock;
    private int numBigBlockDepotBlocks;
    private int numExtensionBlocks;
    private int numPropertySets;
    private int numRootEntryBlocks;
    private int numSmallBlockDepotBlocks;
    private int numSmallBlockDepotChainBlocks;
    private int numSmallBlocks;
    private OutputStream out;
    private int requiredSize;
    private int rootStartBlock;
    private int sbdStartBlock;
    private int sbdStartBlockChain;
    private int size;
    private HashMap standardPropertySets;

    public CompoundFile(ExcelDataOutput excelDataOutput, int n, OutputStream outputStream, jxl.read.biff.CompoundFile compoundFile) throws CopyAdditionalPropertySetsException, IOException {
        int n2;
        this.size = n;
        this.excelData = excelDataOutput;
        this.readAdditionalPropertySets(compoundFile);
        this.numRootEntryBlocks = 1;
        ArrayList arrayList = this.additionalPropertySets;
        int n3 = arrayList != null ? arrayList.size() : 0;
        this.numPropertySets = n3 + 4;
        if (this.additionalPropertySets != null) {
            this.numSmallBlockDepotChainBlocks = this.getBigBlocksRequired(4 * this.numSmallBlocks);
            this.numSmallBlockDepotBlocks = this.getBigBlocksRequired(64 * this.numSmallBlocks);
            this.numRootEntryBlocks += this.getBigBlocksRequired(128 * this.additionalPropertySets.size());
        }
        int n4 = this.getBigBlocksRequired(n);
        this.requiredSize = n < 4096 ? 4096 : n4 * 512;
        this.out = outputStream;
        this.excelDataBlocks = this.requiredSize / 512;
        this.numBigBlockDepotBlocks = 1;
        int n5 = 8 + (8 + this.excelDataBlocks) + this.additionalPropertyBlocks + this.numSmallBlockDepotBlocks + this.numSmallBlockDepotChainBlocks + this.numRootEntryBlocks;
        double d = n5 + this.numBigBlockDepotBlocks;
        Double.isNaN((double)d);
        this.numBigBlockDepotBlocks = (int)Math.ceil((double)(d / 128.0));
        double d2 = n5 + this.numBigBlockDepotBlocks;
        Double.isNaN((double)d2);
        int n6 = this.numBigBlockDepotBlocks = (int)Math.ceil((double)(d2 / 128.0));
        int n7 = n5 + n6;
        if (n6 > 108) {
            this.extensionBlock = 0;
            double d3 = 1 + (n6 - 109);
            Double.isNaN((double)d3);
            this.numExtensionBlocks = (int)Math.ceil((double)(d3 / 127.0));
            double d4 = n5 + this.numExtensionBlocks + this.numBigBlockDepotBlocks;
            Double.isNaN((double)d4);
            this.numBigBlockDepotBlocks = (int)Math.ceil((double)(d4 / 128.0));
            n7 = n5 + this.numExtensionBlocks + this.numBigBlockDepotBlocks;
        } else {
            this.extensionBlock = -2;
            this.numExtensionBlocks = 0;
        }
        this.excelDataStartBlock = this.numExtensionBlocks;
        this.sbdStartBlock = -2;
        if (this.additionalPropertySets != null && this.numSmallBlockDepotBlocks != 0) {
            this.sbdStartBlock = 16 + (this.excelDataStartBlock + this.excelDataBlocks + this.additionalPropertyBlocks);
        }
        this.sbdStartBlockChain = -2;
        int n8 = this.sbdStartBlock;
        if (n8 != -2) {
            this.sbdStartBlockChain = n8 + this.numSmallBlockDepotBlocks;
        }
        this.bbdStartBlock = (n2 = this.sbdStartBlockChain) != -2 ? n2 + this.numSmallBlockDepotChainBlocks : 16 + (this.excelDataStartBlock + this.excelDataBlocks + this.additionalPropertyBlocks);
        this.rootStartBlock = this.bbdStartBlock + this.numBigBlockDepotBlocks;
        if (n7 != this.rootStartBlock + this.numRootEntryBlocks) {
            logger.warn("Root start block and total blocks are inconsistent  generated file may be corrupt");
            Logger logger = CompoundFile.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("RootStartBlock ");
            stringBuilder.append(this.rootStartBlock);
            stringBuilder.append(" totalBlocks ");
            stringBuilder.append(n7);
            logger.warn(stringBuilder.toString());
        }
    }

    private void checkBbdPos() throws IOException {
        if (this.bbdPos >= 512) {
            this.out.write(this.bigBlockDepot);
            this.bigBlockDepot = new byte[512];
            this.bbdPos = 0;
        }
    }

    private int getBigBlocksRequired(int n) {
        int n2 = n / 512;
        if (n % 512 > 0) {
            ++n2;
        }
        return n2;
    }

    private int getSmallBlocksRequired(int n) {
        int n2 = n / 64;
        if (n % 64 > 0) {
            ++n2;
        }
        return n2;
    }

    private void readAdditionalPropertySets(jxl.read.biff.CompoundFile compoundFile) throws CopyAdditionalPropertySetsException, IOException {
        if (compoundFile == null) {
            return;
        }
        this.additionalPropertySets = new ArrayList();
        this.standardPropertySets = new HashMap();
        int n = compoundFile.getNumberOfPropertySets();
        int n2 = 0;
        for (int i = 0; i < n; ++i) {
            boolean bl;
            BaseCompoundFile.PropertyStorage propertyStorage = compoundFile.getPropertySet(i);
            if (propertyStorage.name.equalsIgnoreCase("Root Entry")) {
                Object object = new Object(propertyStorage, null, i){
                    byte[] data;
                    int number;
                    BaseCompoundFile.PropertyStorage propertyStorage;
                    {
                        this.propertyStorage = propertyStorage;
                        this.data = arrby;
                        this.number = n;
                    }
                };
                this.standardPropertySets.put((Object)"Root Entry", object);
                bl = true;
            } else {
                bl = false;
            }
            boolean bl2 = bl;
            for (int j = 0; j < STANDARD_PROPERTY_SETS.length && !bl2; ++j) {
                if (!propertyStorage.name.equalsIgnoreCase(STANDARD_PROPERTY_SETS[j])) continue;
                BaseCompoundFile.PropertyStorage propertyStorage2 = compoundFile.findPropertyStorage(propertyStorage.name);
                boolean bl3 = propertyStorage2 != null;
                Assert.verify(bl3);
                if (propertyStorage2 != propertyStorage) continue;
                Object object = new /* invalid duplicate definition of identical inner class */;
                this.standardPropertySets.put((Object)STANDARD_PROPERTY_SETS[j], object);
                bl2 = true;
            }
            if (bl2) continue;
            try {
                byte[] arrby = propertyStorage.size > 0 ? compoundFile.getStream(i) : new byte[0];
                Object object = new /* invalid duplicate definition of identical inner class */;
                this.additionalPropertySets.add(object);
                if (arrby.length > 4096) {
                    n2 += this.getBigBlocksRequired(arrby.length);
                    continue;
                }
                this.numSmallBlocks = this.getSmallBlocksRequired(arrby.length) + this.numSmallBlocks;
                continue;
            }
            catch (BiffException biffException) {
                logger.error((Object)biffException);
                throw new CopyAdditionalPropertySetsException();
            }
        }
        this.additionalPropertyBlocks = n2;
    }

    private void writeAdditionalPropertySetBlockChains() throws IOException {
        ArrayList arrayList = this.additionalPropertySets;
        if (arrayList == null) {
            return;
        }
        int n = 16 + (this.excelDataStartBlock + this.excelDataBlocks);
        for (ReadPropertyStorage readPropertyStorage : arrayList) {
            if (readPropertyStorage.data.length <= 4096) continue;
            int n2 = this.getBigBlocksRequired(readPropertyStorage.data.length);
            this.writeBlockChain(n, n2);
            n += n2;
        }
    }

    private void writeAdditionalPropertySets() throws IOException {
        ArrayList arrayList = this.additionalPropertySets;
        if (arrayList == null) {
            return;
        }
        Iterator iterator = arrayList.iterator();
        while (iterator.hasNext()) {
            byte[] arrby = (iterator.next()).data;
            if (arrby.length <= 4096) continue;
            int n = 512 * this.getBigBlocksRequired(arrby.length);
            this.out.write(arrby, 0, arrby.length);
            byte[] arrby2 = new byte[n - arrby.length];
            this.out.write(arrby2, 0, arrby2.length);
        }
    }

    private void writeBigBlockDepot() throws IOException {
        int n;
        int n2;
        this.bigBlockDepot = new byte[512];
        this.bbdPos = 0;
        for (int i = 0; i < this.numExtensionBlocks; ++i) {
            IntegerHelper.getFourBytes(-3, this.bigBlockDepot, this.bbdPos);
            this.bbdPos = 4 + this.bbdPos;
            this.checkBbdPos();
        }
        this.writeBlockChain(this.excelDataStartBlock, this.excelDataBlocks);
        int n3 = n = this.excelDataStartBlock + this.excelDataBlocks + this.additionalPropertyBlocks;
        while (n3 < n + 7) {
            IntegerHelper.getFourBytes(++n3, this.bigBlockDepot, this.bbdPos);
            this.bbdPos = 4 + this.bbdPos;
            this.checkBbdPos();
        }
        IntegerHelper.getFourBytes(-2, this.bigBlockDepot, this.bbdPos);
        this.bbdPos = 4 + this.bbdPos;
        this.checkBbdPos();
        int n4 = n + 8;
        while (n4 < n + 15) {
            IntegerHelper.getFourBytes(++n4, this.bigBlockDepot, this.bbdPos);
            this.bbdPos = 4 + this.bbdPos;
            this.checkBbdPos();
        }
        IntegerHelper.getFourBytes(-2, this.bigBlockDepot, this.bbdPos);
        this.bbdPos = 4 + this.bbdPos;
        this.checkBbdPos();
        this.writeAdditionalPropertySetBlockChains();
        int n5 = this.sbdStartBlock;
        int n6 = 0;
        if (n5 != -2) {
            this.writeBlockChain(n5, this.numSmallBlockDepotBlocks);
            this.writeBlockChain(this.sbdStartBlockChain, this.numSmallBlockDepotChainBlocks);
        }
        while (n6 < this.numBigBlockDepotBlocks) {
            IntegerHelper.getFourBytes(-3, this.bigBlockDepot, this.bbdPos);
            this.bbdPos = 4 + this.bbdPos;
            this.checkBbdPos();
            ++n6;
        }
        this.writeBlockChain(this.rootStartBlock, this.numRootEntryBlocks);
        if (n2 != 0) {
            for (n2 = this.bbdPos; n2 < 512; ++n2) {
                this.bigBlockDepot[n2] = -1;
            }
            this.out.write(this.bigBlockDepot);
        }
    }

    private void writeBlockChain(int n, int n2) throws IOException {
        int n3;
        int n4 = n + 1;
        for (int i = n2 - 1; i > 0; i -= n3) {
            n3 = Math.min((int)i, (int)((512 - this.bbdPos) / 4));
            for (int j = 0; j < n3; ++j) {
                IntegerHelper.getFourBytes(n4, this.bigBlockDepot, this.bbdPos);
                this.bbdPos = 4 + this.bbdPos;
                ++n4;
            }
            this.checkBbdPos();
        }
        IntegerHelper.getFourBytes(-2, this.bigBlockDepot, this.bbdPos);
        this.bbdPos = 4 + this.bbdPos;
        this.checkBbdPos();
    }

    private void writeDocumentSummaryData() throws IOException {
        byte[] arrby = new byte[4096];
        this.out.write(arrby);
    }

    private void writeExcelData() throws IOException {
        this.excelData.writeData(this.out);
        byte[] arrby = new byte[this.requiredSize - this.size];
        this.out.write(arrby);
    }

    private void writeHeader() throws IOException {
        int n;
        byte[] arrby = new byte[512];
        byte[] arrby2 = new byte[512 * this.numExtensionBlocks];
        System.arraycopy((Object)IDENTIFIER, (int)0, (Object)arrby, (int)0, (int)IDENTIFIER.length);
        arrby[24] = 62;
        arrby[26] = 3;
        arrby[28] = -2;
        arrby[29] = -1;
        arrby[30] = 9;
        arrby[32] = 6;
        arrby[57] = 16;
        IntegerHelper.getFourBytes(this.numBigBlockDepotBlocks, arrby, 44);
        IntegerHelper.getFourBytes(this.sbdStartBlockChain, arrby, 60);
        IntegerHelper.getFourBytes(this.numSmallBlockDepotChainBlocks, arrby, 64);
        IntegerHelper.getFourBytes(this.extensionBlock, arrby, 68);
        IntegerHelper.getFourBytes(this.numExtensionBlocks, arrby, 72);
        IntegerHelper.getFourBytes(this.rootStartBlock, arrby, 48);
        int n2 = Math.min((int)this.numBigBlockDepotBlocks, (int)109);
        int n3 = 76;
        int n4 = 0;
        for (int i = 0; i < n2; ++i) {
            IntegerHelper.getFourBytes(i + this.bbdStartBlock, arrby, n3);
            n3 += 4;
            ++n4;
        }
        while (n3 < 512) {
            arrby[n3] = -1;
            ++n3;
        }
        this.out.write(arrby);
        int n5 = 0;
        for (int i = 0; i < (n = this.numExtensionBlocks); ++i) {
            int n6 = Math.min((int)(this.numBigBlockDepotBlocks - n4), (int)127);
            int n7 = n5;
            for (int j = 0; j < n6; ++j) {
                IntegerHelper.getFourBytes(j + (n4 + this.bbdStartBlock), arrby2, n7);
                n7 += 4;
            }
            int n8 = (n4 += n6) == this.numBigBlockDepotBlocks ? -2 : i + 1;
            IntegerHelper.getFourBytes(n8, arrby2, n7);
            n5 = n7 + 4;
        }
        if (n > 0) {
            while (n5 < arrby2.length) {
                arrby2[n5] = -1;
                ++n5;
            }
            this.out.write(arrby2);
        }
    }

    private void writePropertySets() throws IOException {
        int n;
        int n2;
        int[] arrn;
        ReadPropertyStorage readPropertyStorage;
        int n3;
        byte[] arrby = new byte[512 * this.numRootEntryBlocks];
        ArrayList arrayList = this.additionalPropertySets;
        int n4 = 1;
        if (arrayList != null) {
            arrn = new int[this.numPropertySets];
            for (int i = 0; i < STANDARD_PROPERTY_SETS.length; ++i) {
                ReadPropertyStorage readPropertyStorage2 = this.standardPropertySets.get((Object)STANDARD_PROPERTY_SETS[i]);
                if (readPropertyStorage2 != null) {
                    arrn[readPropertyStorage2.number] = i;
                    continue;
                }
                Logger logger = CompoundFile.logger;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("Standard property set ");
                stringBuilder.append(STANDARD_PROPERTY_SETS[i]);
                stringBuilder.append(" not present in source file");
                logger.warn(stringBuilder.toString());
            }
            int n5 = STANDARD_PROPERTY_SETS.length;
            Iterator iterator = this.additionalPropertySets.iterator();
            while (iterator.hasNext()) {
                arrn[(iterator.next()).number] = n5;
                n5 += n4;
            }
        } else {
            arrn = null;
        }
        if (this.additionalPropertySets != null) {
            n2 = 0 + 512 * this.getBigBlocksRequired(this.requiredSize) + 512 * this.getBigBlocksRequired(4096) + 512 * this.getBigBlocksRequired(4096);
            for (ReadPropertyStorage readPropertyStorage3 : this.additionalPropertySets) {
                if (readPropertyStorage3.propertyStorage.type == n4) continue;
                int n6 = readPropertyStorage3.propertyStorage.size >= 4096 ? 512 * this.getBigBlocksRequired(readPropertyStorage3.propertyStorage.size) : 64 * this.getSmallBlocksRequired(readPropertyStorage3.propertyStorage.size);
                n2 += n6;
            }
        } else {
            n2 = 0;
        }
        BaseCompoundFile.PropertyStorage propertyStorage = new BaseCompoundFile.PropertyStorage((BaseCompoundFile)this, "Root Entry");
        propertyStorage.setType(5);
        propertyStorage.setStartBlock(this.sbdStartBlock);
        propertyStorage.setSize(n2);
        propertyStorage.setPrevious(-1);
        propertyStorage.setNext(-1);
        propertyStorage.setColour(0);
        int n7 = this.additionalPropertySets != null ? arrn[(this.standardPropertySets.get((Object)"Root Entry")).propertyStorage.child] : 1;
        propertyStorage.setChild(n7);
        System.arraycopy((Object)propertyStorage.data, (int)0, (Object)arrby, (int)0, (int)128);
        BaseCompoundFile.PropertyStorage propertyStorage2 = new BaseCompoundFile.PropertyStorage((BaseCompoundFile)this, "Workbook");
        propertyStorage2.setType(2);
        propertyStorage2.setStartBlock(this.excelDataStartBlock);
        propertyStorage2.setSize(this.requiredSize);
        ArrayList arrayList2 = this.additionalPropertySets;
        int n8 = 3;
        if (arrayList2 != null) {
            ReadPropertyStorage readPropertyStorage4 = this.standardPropertySets.get((Object)"Workbook");
            n3 = readPropertyStorage4.propertyStorage.previous != -1 ? arrn[readPropertyStorage4.propertyStorage.previous] : -1;
            n = readPropertyStorage4.propertyStorage.next != -1 ? arrn[readPropertyStorage4.propertyStorage.next] : -1;
        } else {
            n = -1;
            n3 = 3;
        }
        propertyStorage2.setPrevious(n3);
        propertyStorage2.setNext(n);
        propertyStorage2.setChild(-1);
        System.arraycopy((Object)propertyStorage2.data, (int)0, (Object)arrby, (int)128, (int)128);
        BaseCompoundFile.PropertyStorage propertyStorage3 = new BaseCompoundFile.PropertyStorage((BaseCompoundFile)this, "\u0005SummaryInformation");
        propertyStorage3.setType(2);
        propertyStorage3.setStartBlock(this.excelDataStartBlock + this.excelDataBlocks);
        propertyStorage3.setSize(4096);
        if (this.additionalPropertySets != null && (readPropertyStorage = this.standardPropertySets.get((Object)"\u0005SummaryInformation")) != null) {
            n4 = readPropertyStorage.propertyStorage.previous != -1 ? arrn[readPropertyStorage.propertyStorage.previous] : -1;
            n8 = readPropertyStorage.propertyStorage.next != -1 ? arrn[readPropertyStorage.propertyStorage.next] : -1;
        }
        propertyStorage3.setPrevious(n4);
        propertyStorage3.setNext(n8);
        propertyStorage3.setChild(-1);
        System.arraycopy((Object)propertyStorage3.data, (int)0, (Object)arrby, (int)256, (int)128);
        BaseCompoundFile.PropertyStorage propertyStorage4 = new BaseCompoundFile.PropertyStorage((BaseCompoundFile)this, "\u0005DocumentSummaryInformation");
        propertyStorage4.setType(2);
        propertyStorage4.setStartBlock(8 + (this.excelDataStartBlock + this.excelDataBlocks));
        propertyStorage4.setSize(4096);
        propertyStorage4.setPrevious(-1);
        propertyStorage4.setNext(-1);
        propertyStorage4.setChild(-1);
        System.arraycopy((Object)propertyStorage4.data, (int)0, (Object)arrby, (int)384, (int)128);
        ArrayList arrayList3 = this.additionalPropertySets;
        if (arrayList3 == null) {
            this.out.write(arrby);
            return;
        }
        int n9 = 16 + (this.excelDataStartBlock + this.excelDataBlocks);
        Iterator iterator = arrayList3.iterator();
        int n10 = 0;
        int n11 = 512;
        while (iterator.hasNext()) {
            ReadPropertyStorage readPropertyStorage5 = iterator.next();
            int n12 = readPropertyStorage5.data.length > 4096 ? n9 : n10;
            BaseCompoundFile.PropertyStorage propertyStorage5 = new BaseCompoundFile.PropertyStorage((BaseCompoundFile)this, readPropertyStorage5.propertyStorage.name);
            propertyStorage5.setType(readPropertyStorage5.propertyStorage.type);
            propertyStorage5.setStartBlock(n12);
            propertyStorage5.setSize(readPropertyStorage5.propertyStorage.size);
            int n13 = readPropertyStorage5.propertyStorage.previous != -1 ? arrn[readPropertyStorage5.propertyStorage.previous] : -1;
            int n14 = readPropertyStorage5.propertyStorage.next != -1 ? arrn[readPropertyStorage5.propertyStorage.next] : -1;
            int n15 = readPropertyStorage5.propertyStorage.child != -1 ? arrn[readPropertyStorage5.propertyStorage.child] : -1;
            propertyStorage5.setPrevious(n13);
            propertyStorage5.setNext(n14);
            propertyStorage5.setChild(n15);
            System.arraycopy((Object)propertyStorage5.data, (int)0, (Object)arrby, (int)n11, (int)128);
            n11 += 128;
            if (readPropertyStorage5.data.length > 4096) {
                n9 += this.getBigBlocksRequired(readPropertyStorage5.data.length);
                continue;
            }
            n10 += this.getSmallBlocksRequired(readPropertyStorage5.data.length);
        }
        this.out.write(arrby);
    }

    private void writeSmallBlockDepot() throws IOException {
        ArrayList arrayList = this.additionalPropertySets;
        if (arrayList == null) {
            return;
        }
        byte[] arrby = new byte[512 * this.numSmallBlockDepotBlocks];
        Iterator iterator = arrayList.iterator();
        int n = 0;
        while (iterator.hasNext()) {
            ReadPropertyStorage readPropertyStorage = iterator.next();
            if (readPropertyStorage.data.length > 4096) continue;
            int n2 = 64 * this.getSmallBlocksRequired(readPropertyStorage.data.length);
            System.arraycopy((Object)readPropertyStorage.data, (int)0, (Object)arrby, (int)n, (int)readPropertyStorage.data.length);
            n += n2;
        }
        this.out.write(arrby);
    }

    private void writeSmallBlockDepotChain() throws IOException {
        if (this.sbdStartBlockChain == -2) {
            return;
        }
        byte[] arrby = new byte[512 * this.numSmallBlockDepotChainBlocks];
        Iterator iterator = this.additionalPropertySets.iterator();
        int n = 0;
        int n2 = 1;
        while (iterator.hasNext()) {
            ReadPropertyStorage readPropertyStorage = iterator.next();
            if (readPropertyStorage.data.length > 4096 || readPropertyStorage.data.length == 0) continue;
            int n3 = this.getSmallBlocksRequired(readPropertyStorage.data.length);
            int n4 = n2;
            int n5 = n;
            for (int i = 0; i < n3 - 1; ++i) {
                IntegerHelper.getFourBytes(n4, arrby, n5);
                n5 += 4;
                ++n4;
            }
            IntegerHelper.getFourBytes(-2, arrby, n5);
            int n6 = n5 + 4;
            int n7 = n4 + 1;
            n = n6;
            n2 = n7;
        }
        this.out.write(arrby);
    }

    private void writeSummaryData() throws IOException {
        byte[] arrby = new byte[4096];
        this.out.write(arrby);
    }

    public void write() throws IOException {
        this.writeHeader();
        this.writeExcelData();
        this.writeDocumentSummaryData();
        this.writeSummaryData();
        this.writeAdditionalPropertySets();
        this.writeSmallBlockDepot();
        this.writeSmallBlockDepotChain();
        this.writeBigBlockDepot();
        this.writePropertySets();
    }

}

