/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Double
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.System
 *  java.text.DateFormat
 *  java.util.Calendar
 *  java.util.Date
 */
package jxl.write.biff;

import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;
import jxl.Cell;
import jxl.CellType;
import jxl.DateCell;
import jxl.biff.DisplayFormat;
import jxl.biff.DoubleHelper;
import jxl.biff.Type;
import jxl.common.Logger;
import jxl.format.CellFormat;
import jxl.write.DateFormats;
import jxl.write.WritableCellFormat;
import jxl.write.biff.CellValue;

public abstract class DateRecord
extends CellValue {
    static final WritableCellFormat defaultDateFormat;
    private static Logger logger;
    private static final long msInADay = 86400000L;
    private static final int nonLeapDay = 61;
    private static final int utcOffsetDays = 25569;
    private Date date;
    private boolean time;
    private double value;

    static {
        logger = Logger.getLogger(DateRecord.class);
        defaultDateFormat = new WritableCellFormat(DateFormats.DEFAULT);
    }

    protected DateRecord(int n, int n2, Date date) {
        this(n, n2, date, (CellFormat)defaultDateFormat, false);
    }

    protected DateRecord(int n, int n2, Date date, CellFormat cellFormat) {
        super(Type.NUMBER, n, n2, cellFormat);
        this.date = date;
        this.calculateValue(true);
    }

    protected DateRecord(int n, int n2, Date date, CellFormat cellFormat, GMTDate gMTDate) {
        super(Type.NUMBER, n, n2, cellFormat);
        this.date = date;
        this.calculateValue(false);
    }

    protected DateRecord(int n, int n2, Date date, CellFormat cellFormat, boolean bl) {
        super(Type.NUMBER, n, n2, cellFormat);
        this.date = date;
        this.time = bl;
        this.calculateValue(false);
    }

    protected DateRecord(int n, int n2, Date date, GMTDate gMTDate) {
        this(n, n2, date, (CellFormat)defaultDateFormat, false);
    }

    protected DateRecord(int n, int n2, DateRecord dateRecord) {
        super(Type.NUMBER, n, n2, dateRecord);
        this.value = dateRecord.value;
        this.time = dateRecord.time;
        this.date = dateRecord.date;
    }

    protected DateRecord(DateCell dateCell) {
        super(Type.NUMBER, dateCell);
        this.date = dateCell.getDate();
        this.time = dateCell.isTime();
        this.calculateValue(false);
    }

    private void calculateValue(boolean bl) {
        double d;
        long l;
        long l2 = 0L;
        if (bl) {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(this.date);
            l2 = calendar.get(15);
            l = calendar.get(16);
        } else {
            l = l2;
        }
        double d2 = l + (l2 + this.date.getTime());
        Double.isNaN((double)d2);
        this.value = 25569.0 + d2 / 8.64E7;
        if (!this.time && (d = this.value) < 61.0) {
            this.value = d - 1.0;
        }
        if (this.time) {
            double d3 = this.value;
            double d4 = (int)d3;
            Double.isNaN((double)d4);
            this.value = d3 - d4;
        }
    }

    @Override
    public String getContents() {
        return this.date.toString();
    }

    @Override
    public byte[] getData() {
        byte[] arrby = super.getData();
        byte[] arrby2 = new byte[8 + arrby.length];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby.length);
        DoubleHelper.getIEEEBytes(this.value, arrby2, arrby.length);
        return arrby2;
    }

    public Date getDate() {
        return this.date;
    }

    public DateFormat getDateFormat() {
        return null;
    }

    @Override
    public CellType getType() {
        return CellType.DATE;
    }

    public boolean isTime() {
        return this.time;
    }

    protected void setDate(Date date) {
        this.date = date;
        this.calculateValue(true);
    }

    protected void setDate(Date date, GMTDate gMTDate) {
        this.date = date;
        this.calculateValue(false);
    }

}

