/*
 * Decompiled with CFR 0.0.
 */
package jxl.write.biff;

import jxl.biff.IntegerHelper;
import jxl.biff.Type;
import jxl.biff.WritableRecordData;

class ExtendedSSTRecord
extends WritableRecordData {
    private static final int infoRecordSize = 8;
    private int[] absoluteStreamPositions;
    private int currentStringIndex = 0;
    private int numberOfStrings;
    private int[] relativeStreamPositions;

    public ExtendedSSTRecord(int n) {
        super(Type.EXTSST);
        this.numberOfStrings = n;
        int n2 = this.getNumberOfBuckets();
        this.absoluteStreamPositions = new int[n2];
        this.relativeStreamPositions = new int[n2];
        this.currentStringIndex = 0;
    }

    public void addString(int n, int n2) {
        int[] arrn = this.absoluteStreamPositions;
        int n3 = this.currentStringIndex;
        arrn[n3] = n + n2;
        this.relativeStreamPositions[n3] = n2;
        this.currentStringIndex = n3 + 1;
    }

    @Override
    public byte[] getData() {
        int n = this.getNumberOfBuckets();
        byte[] arrby = new byte[2 + n * 8];
        int n2 = this.getNumberOfStringsPerBucket();
        IntegerHelper.getTwoBytes(n2, arrby, 0);
        for (int i = 0; i < n; ++i) {
            int n3 = this.absoluteStreamPositions[i];
            int n4 = i * 8;
            IntegerHelper.getFourBytes(n3, arrby, n4 + 2);
            IntegerHelper.getTwoBytes(this.relativeStreamPositions[i], arrby, n4 + 6);
        }
        return arrby;
    }

    public int getNumberOfBuckets() {
        int n = this.getNumberOfStringsPerBucket();
        if (n != 0) {
            return (-1 + (n + this.numberOfStrings)) / n;
        }
        return 0;
    }

    public int getNumberOfStringsPerBucket() {
        return (-1 + (128 + this.numberOfStrings)) / 128;
    }
}

