/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.File
 *  java.io.IOException
 *  java.io.OutputStream
 *  java.lang.Object
 *  java.lang.System
 *  jxl.read.biff.CompoundFile
 *  jxl.write.biff.CompoundFile
 *  jxl.write.biff.FileDataOutput
 *  jxl.write.biff.JxlWriteException
 *  jxl.write.biff.MemoryDataOutput
 */
package jxl.write.biff;

import java.io.IOException;
import java.io.OutputStream;
import jxl.WorkbookSettings;
import jxl.biff.ByteData;
import jxl.common.Logger;
import jxl.write.biff.CompoundFile;
import jxl.write.biff.ExcelDataOutput;
import jxl.write.biff.FileDataOutput;
import jxl.write.biff.JxlWriteException;
import jxl.write.biff.MemoryDataOutput;

public final class File {
    private static Logger logger = Logger.getLogger(File.class);
    private int arrayGrowSize;
    private ExcelDataOutput data;
    private int initialFileSize;
    private OutputStream outputStream;
    private int pos;
    jxl.read.biff.CompoundFile readCompoundFile;
    private WorkbookSettings workbookSettings;

    File(OutputStream outputStream, WorkbookSettings workbookSettings, jxl.read.biff.CompoundFile compoundFile) throws IOException {
        this.outputStream = outputStream;
        this.workbookSettings = workbookSettings;
        this.readCompoundFile = compoundFile;
        this.createDataOutput();
    }

    private void createDataOutput() throws IOException {
        if (this.workbookSettings.getUseTemporaryFileDuringWrite()) {
            this.data = new FileDataOutput(this.workbookSettings.getTemporaryFileDuringWriteDirectory());
            return;
        }
        this.initialFileSize = this.workbookSettings.getInitialFileSize();
        this.arrayGrowSize = this.workbookSettings.getArrayGrowSize();
        this.data = new MemoryDataOutput(this.initialFileSize, this.arrayGrowSize);
    }

    void close(boolean bl) throws IOException, JxlWriteException {
        ExcelDataOutput excelDataOutput = this.data;
        new CompoundFile(excelDataOutput, excelDataOutput.getPosition(), this.outputStream, this.readCompoundFile).write();
        this.outputStream.flush();
        this.data.close();
        if (bl) {
            this.outputStream.close();
        }
        this.data = null;
        if (!this.workbookSettings.getGCDisabled()) {
            System.gc();
        }
    }

    int getPos() throws IOException {
        return this.data.getPosition();
    }

    void setData(byte[] arrby, int n) throws IOException {
        this.data.setData(arrby, n);
    }

    public void setOutputFile(OutputStream outputStream) throws IOException {
        if (this.data != null) {
            logger.warn("Rewriting a workbook with non-empty data");
        }
        this.outputStream = outputStream;
        this.createDataOutput();
    }

    public void write(ByteData byteData) throws IOException {
        byte[] arrby = byteData.getBytes();
        this.data.write(arrby);
    }
}

