/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.lang.Throwable
 */
package jxl.write.biff;

import jxl.Cell;
import jxl.CellReferenceHelper;
import jxl.CellType;
import jxl.Sheet;
import jxl.WorkbookSettings;
import jxl.biff.FormattingRecords;
import jxl.biff.FormulaData;
import jxl.biff.IntegerHelper;
import jxl.biff.Type;
import jxl.biff.WorkbookMethods;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.biff.formula.FormulaParser;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.format.CellFormat;
import jxl.write.WritableCell;
import jxl.write.biff.CellValue;
import jxl.write.biff.ReadFormulaRecord;
import jxl.write.biff.SharedStrings;
import jxl.write.biff.WritableSheetImpl;
import jxl.write.biff.WritableWorkbookImpl;

public class FormulaRecord
extends CellValue
implements FormulaData {
    private static Logger logger = Logger.getLogger(FormulaRecord.class);
    private CellValue copiedFrom;
    private byte[] formulaBytes;
    private String formulaString;
    private String formulaToParse;
    private FormulaParser parser;

    public FormulaRecord(int n, int n2, String string) {
        super(Type.FORMULA2, n, n2);
        this.formulaToParse = string;
        this.copiedFrom = null;
    }

    public FormulaRecord(int n, int n2, String string, CellFormat cellFormat) {
        super(Type.FORMULA, n, n2, cellFormat);
        this.formulaToParse = string;
        this.copiedFrom = null;
    }

    protected FormulaRecord(int n, int n2, FormulaRecord formulaRecord) {
        super(Type.FORMULA, n, n2, formulaRecord);
        this.copiedFrom = formulaRecord;
        this.formulaBytes = new byte[formulaRecord.formulaBytes.length];
        byte[] arrby = formulaRecord.formulaBytes;
        byte[] arrby2 = this.formulaBytes;
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby2.length);
    }

    protected FormulaRecord(int n, int n2, ReadFormulaRecord readFormulaRecord) {
        super(Type.FORMULA, n, n2, readFormulaRecord);
        try {
            this.copiedFrom = readFormulaRecord;
            this.formulaBytes = readFormulaRecord.getFormulaBytes();
            return;
        }
        catch (FormulaException formulaException) {
            logger.error("", (Throwable)formulaException);
            return;
        }
    }

    private void initialize(WorkbookSettings workbookSettings, ExternalSheet externalSheet, WorkbookMethods workbookMethods) {
        if (this.copiedFrom != null) {
            this.initializeCopiedFormula(workbookSettings, externalSheet, workbookMethods);
            return;
        }
        this.parser = new FormulaParser(this.formulaToParse, externalSheet, workbookMethods, workbookSettings);
        try {
            this.parser.parse();
            this.formulaString = this.parser.getFormula();
            this.formulaBytes = this.parser.getBytes();
            return;
        }
        catch (FormulaException formulaException) {
            Logger logger = FormulaRecord.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append(formulaException.getMessage());
            stringBuilder.append(" when parsing formula ");
            stringBuilder.append(this.formulaToParse);
            stringBuilder.append(" in cell ");
            stringBuilder.append(this.getSheet().getName());
            stringBuilder.append("!");
            stringBuilder.append(CellReferenceHelper.getCellReference(this.getColumn(), this.getRow()));
            logger.warn(stringBuilder.toString());
            try {
                this.formulaToParse = "ERROR(1)";
                this.parser = new FormulaParser(this.formulaToParse, externalSheet, workbookMethods, workbookSettings);
                this.parser.parse();
                this.formulaString = this.parser.getFormula();
                this.formulaBytes = this.parser.getBytes();
                return;
            }
            catch (FormulaException formulaException2) {
                FormulaRecord.logger.error("", (Throwable)formulaException2);
                return;
            }
        }
    }

    private void initializeCopiedFormula(WorkbookSettings workbookSettings, ExternalSheet externalSheet, WorkbookMethods workbookMethods) {
        try {
            FormulaParser formulaParser;
            this.parser = formulaParser = new FormulaParser(this.formulaBytes, this, externalSheet, workbookMethods, workbookSettings);
            this.parser.parse();
            this.parser.adjustRelativeCellReferences(this.getColumn() - this.copiedFrom.getColumn(), this.getRow() - this.copiedFrom.getRow());
            this.formulaString = this.parser.getFormula();
            this.formulaBytes = this.parser.getBytes();
            return;
        }
        catch (FormulaException formulaException) {
            try {
                this.formulaToParse = "ERROR(1)";
                this.parser = new FormulaParser(this.formulaToParse, externalSheet, workbookMethods, workbookSettings);
                this.parser.parse();
                this.formulaString = this.parser.getFormula();
                this.formulaBytes = this.parser.getBytes();
                return;
            }
            catch (FormulaException formulaException2) {
                logger.error("", (Throwable)formulaException2);
                return;
            }
        }
    }

    @Override
    void columnInserted(Sheet sheet, int n, int n2) {
        FormulaParser formulaParser = this.parser;
        boolean bl = sheet == this.getSheet();
        formulaParser.columnInserted(n, n2, bl);
        this.formulaBytes = this.parser.getBytes();
    }

    @Override
    void columnRemoved(Sheet sheet, int n, int n2) {
        FormulaParser formulaParser = this.parser;
        boolean bl = sheet == this.getSheet();
        formulaParser.columnRemoved(n, n2, bl);
        this.formulaBytes = this.parser.getBytes();
    }

    @Override
    public WritableCell copyTo(int n, int n2) {
        Assert.verify(false);
        return null;
    }

    @Override
    public String getContents() {
        return this.formulaString;
    }

    @Override
    public byte[] getData() {
        byte[] arrby = super.getData();
        byte[] arrby2 = this.getFormulaData();
        byte[] arrby3 = new byte[arrby2.length + arrby.length];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby3, (int)0, (int)arrby.length);
        System.arraycopy((Object)arrby2, (int)0, (Object)arrby3, (int)arrby.length, (int)arrby2.length);
        return arrby3;
    }

    @Override
    public byte[] getFormulaData() {
        byte[] arrby = this.formulaBytes;
        byte[] arrby2 = new byte[16 + arrby.length];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)16, (int)arrby.length);
        arrby2[6] = 16;
        arrby2[7] = 64;
        arrby2[12] = -32;
        arrby2[13] = -4;
        arrby2[8] = (byte)(2 | arrby2[8]);
        IntegerHelper.getTwoBytes(this.formulaBytes.length, arrby2, 14);
        return arrby2;
    }

    @Override
    public CellType getType() {
        return CellType.ERROR;
    }

    @Override
    void rowInserted(Sheet sheet, int n, int n2) {
        FormulaParser formulaParser = this.parser;
        boolean bl = sheet == this.getSheet();
        formulaParser.rowInserted(n, n2, bl);
        this.formulaBytes = this.parser.getBytes();
    }

    @Override
    void rowRemoved(Sheet sheet, int n, int n2) {
        FormulaParser formulaParser = this.parser;
        boolean bl = sheet == this.getSheet();
        formulaParser.rowRemoved(n, n2, bl);
        this.formulaBytes = this.parser.getBytes();
    }

    @Override
    void setCellDetails(FormattingRecords formattingRecords, SharedStrings sharedStrings, WritableSheetImpl writableSheetImpl) {
        super.setCellDetails(formattingRecords, sharedStrings, writableSheetImpl);
        this.initialize(writableSheetImpl.getWorkbookSettings(), writableSheetImpl.getWorkbook(), writableSheetImpl.getWorkbook());
        writableSheetImpl.getWorkbook().addRCIRCell(this);
    }
}

