/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.File
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuffer
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.net.URL
 *  java.util.ArrayList
 */
package jxl.write.biff;

import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import jxl.CellType;
import jxl.Hyperlink;
import jxl.Range;
import jxl.Sheet;
import jxl.biff.CellReferenceHelper;
import jxl.biff.IntegerHelper;
import jxl.biff.SheetRangeImpl;
import jxl.biff.StringHelper;
import jxl.biff.Type;
import jxl.biff.WritableRecordData;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.Record;
import jxl.write.Label;
import jxl.write.WritableCell;
import jxl.write.WritableSheet;
import jxl.write.biff.HyperlinkRecord;

public class HyperlinkRecord
extends WritableRecordData {
    private static final LinkType fileLink;
    private static Logger logger;
    private static final LinkType uncLink;
    private static final LinkType unknown;
    private static final LinkType urlLink;
    private static final LinkType workbookLink;
    private String contents;
    private byte[] data;
    private File file;
    private int firstColumn;
    private int firstRow;
    private int lastColumn;
    private int lastRow;
    private LinkType linkType;
    private String location;
    private boolean modified;
    private Range range;
    private WritableSheet sheet;
    private URL url;

    static {
        logger = Logger.getLogger(HyperlinkRecord.class);
        urlLink = new Object(){};
        fileLink = new /* invalid duplicate definition of identical inner class */;
        uncLink = new /* invalid duplicate definition of identical inner class */;
        workbookLink = new /* invalid duplicate definition of identical inner class */;
        unknown = new /* invalid duplicate definition of identical inner class */;
    }

    protected HyperlinkRecord(int n, int n2, int n3, int n4, File file, String string) {
        super(Type.HLINK);
        this.firstColumn = n;
        this.firstRow = n2;
        this.lastColumn = Math.max((int)this.firstColumn, (int)n3);
        this.lastRow = Math.max((int)this.firstRow, (int)n4);
        this.contents = string;
        this.file = file;
        this.linkType = file.getPath().startsWith("\\\\") ? uncLink : fileLink;
        this.modified = true;
    }

    protected HyperlinkRecord(int n, int n2, int n3, int n4, String string, WritableSheet writableSheet, int n5, int n6, int n7, int n8) {
        super(Type.HLINK);
        this.firstColumn = n;
        this.firstRow = n2;
        this.lastColumn = Math.max((int)this.firstColumn, (int)n3);
        this.lastRow = Math.max((int)this.firstRow, (int)n4);
        this.setLocation(writableSheet, n5, n6, n7, n8);
        this.contents = string;
        this.linkType = workbookLink;
        this.modified = true;
    }

    protected HyperlinkRecord(int n, int n2, int n3, int n4, URL uRL, String string) {
        super(Type.HLINK);
        this.firstColumn = n;
        this.firstRow = n2;
        this.lastColumn = Math.max((int)this.firstColumn, (int)n3);
        this.lastRow = Math.max((int)this.firstRow, (int)n4);
        this.url = uRL;
        this.contents = string;
        this.linkType = urlLink;
        this.modified = true;
    }

    protected HyperlinkRecord(Hyperlink hyperlink, WritableSheet writableSheet) {
        super(Type.HLINK);
        if (hyperlink instanceof jxl.read.biff.HyperlinkRecord) {
            this.copyReadHyperlink(hyperlink, writableSheet);
            return;
        }
        this.copyWritableHyperlink(hyperlink, writableSheet);
    }

    private void copyReadHyperlink(Hyperlink hyperlink, WritableSheet writableSheet) {
        jxl.read.biff.HyperlinkRecord hyperlinkRecord = (jxl.read.biff.HyperlinkRecord)hyperlink;
        this.data = hyperlinkRecord.getRecord().getData();
        this.sheet = writableSheet;
        this.firstRow = hyperlinkRecord.getRow();
        this.firstColumn = hyperlinkRecord.getColumn();
        this.lastRow = hyperlinkRecord.getLastRow();
        this.lastColumn = hyperlinkRecord.getLastColumn();
        SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(writableSheet, this.firstColumn, this.firstRow, this.lastColumn, this.lastRow);
        this.range = sheetRangeImpl;
        this.linkType = unknown;
        if (hyperlinkRecord.isFile()) {
            this.linkType = fileLink;
            this.file = hyperlinkRecord.getFile();
        } else if (hyperlinkRecord.isURL()) {
            this.linkType = urlLink;
            this.url = hyperlinkRecord.getURL();
        } else if (hyperlinkRecord.isLocation()) {
            this.linkType = workbookLink;
            this.location = hyperlinkRecord.getLocation();
        }
        this.modified = false;
    }

    /*
     * Exception decompiling
     */
    private void copyWritableHyperlink(Hyperlink var1, WritableSheet var2) {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl35 : ALOAD_3 : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }

    private byte[] getFileData(byte[] arrby) {
        char c;
        ArrayList arrayList = new ArrayList();
        ArrayList arrayList2 = new ArrayList();
        arrayList.add((Object)this.file.getName());
        arrayList2.add((Object)this.getShortName(this.file.getName()));
        for (File file = this.file.getParentFile(); file != null; file = file.getParentFile()) {
            arrayList.add((Object)file.getName());
            arrayList2.add((Object)this.getShortName(file.getName()));
        }
        int n = arrayList.size() - 1;
        boolean bl = true;
        int n2 = 0;
        while (bl) {
            if (((String)arrayList.get(n)).equals((Object)"..")) {
                ++n2;
                arrayList.remove(n);
                arrayList2.remove(n);
            } else {
                bl = false;
            }
            --n;
        }
        StringBuffer stringBuffer = new StringBuffer();
        StringBuffer stringBuffer2 = new StringBuffer();
        if (this.file.getPath().charAt(1) == ':' && (c = this.file.getPath().charAt(0)) != 'C' && c != 'c') {
            stringBuffer.append(c);
            stringBuffer.append(':');
            stringBuffer2.append(c);
            stringBuffer2.append(':');
        }
        for (int i = arrayList.size() - 1; i >= 0; --i) {
            stringBuffer.append((String)arrayList.get(i));
            stringBuffer2.append((String)arrayList2.get(i));
            if (i == 0) continue;
            stringBuffer.append("\\");
            stringBuffer2.append("\\");
        }
        String string = stringBuffer.toString();
        String string2 = stringBuffer2.toString();
        int n3 = 24 + (8 + (2 + (16 + (4 + arrby.length + (1 + string2.length())))) + 2 * (1 + string.length()));
        String string3 = this.contents;
        if (string3 != null) {
            n3 += 4 + 2 * (1 + string3.length());
        }
        byte[] arrby2 = new byte[n3];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby.length);
        int n4 = arrby.length;
        String string4 = this.contents;
        if (string4 != null) {
            IntegerHelper.getFourBytes(1 + string4.length(), arrby2, n4);
            StringHelper.getUnicodeBytes(this.contents, arrby2, n4 + 4);
            n4 += 4 + 2 * (1 + this.contents.length());
        }
        arrby2[n4] = 3;
        arrby2[n4 + 1] = 3;
        arrby2[n4 + 2] = 0;
        arrby2[n4 + 3] = 0;
        arrby2[n4 + 4] = 0;
        arrby2[n4 + 5] = 0;
        arrby2[n4 + 6] = 0;
        arrby2[n4 + 7] = 0;
        arrby2[n4 + 8] = -64;
        arrby2[n4 + 9] = 0;
        arrby2[n4 + 10] = 0;
        arrby2[n4 + 11] = 0;
        arrby2[n4 + 12] = 0;
        arrby2[n4 + 13] = 0;
        arrby2[n4 + 14] = 0;
        arrby2[n4 + 15] = 70;
        int n5 = n4 + 16;
        IntegerHelper.getTwoBytes(n2, arrby2, n5);
        int n6 = n5 + 2;
        IntegerHelper.getFourBytes(1 + string2.length(), arrby2, n6);
        StringHelper.getBytes(string2, arrby2, n6 + 4);
        int n7 = n6 + (4 + (1 + string2.length()));
        arrby2[n7] = -1;
        arrby2[n7 + 1] = -1;
        arrby2[n7 + 2] = -83;
        arrby2[n7 + 3] = -34;
        arrby2[n7 + 4] = 0;
        arrby2[n7 + 5] = 0;
        arrby2[n7 + 6] = 0;
        arrby2[n7 + 7] = 0;
        arrby2[n7 + 8] = 0;
        arrby2[n7 + 9] = 0;
        arrby2[n7 + 10] = 0;
        arrby2[n7 + 11] = 0;
        arrby2[n7 + 12] = 0;
        arrby2[n7 + 13] = 0;
        arrby2[n7 + 14] = 0;
        arrby2[n7 + 15] = 0;
        arrby2[n7 + 16] = 0;
        arrby2[n7 + 17] = 0;
        arrby2[n7 + 18] = 0;
        arrby2[n7 + 19] = 0;
        arrby2[n7 + 20] = 0;
        arrby2[n7 + 21] = 0;
        arrby2[n7 + 22] = 0;
        arrby2[n7 + 23] = 0;
        int n8 = n7 + 24;
        IntegerHelper.getFourBytes(6 + 2 * string.length(), arrby2, n8);
        int n9 = n8 + 4;
        IntegerHelper.getFourBytes(2 * string.length(), arrby2, n9);
        int n10 = n9 + 4;
        arrby2[n10] = 3;
        arrby2[n10 + 1] = 0;
        StringHelper.getUnicodeBytes(string, arrby2, n10 + 2);
        string.length();
        return arrby2;
    }

    private byte[] getLocationData(byte[] arrby) {
        byte[] arrby2 = new byte[4 + arrby.length + 2 * (1 + this.location.length())];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby.length);
        int n = arrby.length;
        IntegerHelper.getFourBytes(1 + this.location.length(), arrby2, n);
        StringHelper.getUnicodeBytes(this.location, arrby2, n + 4);
        return arrby2;
    }

    private String getShortName(String string) {
        String string2;
        String string3;
        int n = string.indexOf(46);
        if (n == -1) {
            string3 = "";
        } else {
            String string4 = string.substring(0, n);
            string3 = string.substring(n + 1);
            string = string4;
        }
        if (string.length() > 8) {
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append(string.substring(0, 6));
            stringBuilder.append("~");
            stringBuilder.append(string.length() - 8);
            string = stringBuilder.toString().substring(0, 8);
        }
        if ((string2 = string3.substring(0, Math.min((int)3, (int)string3.length()))).length() > 0) {
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append(string);
            stringBuilder.append('.');
            stringBuilder.append(string2);
            string = stringBuilder.toString();
        }
        return string;
    }

    private byte[] getUNCData(byte[] arrby) {
        String string = this.file.getPath();
        byte[] arrby2 = new byte[4 + (2 + (arrby.length + 2 * string.length()))];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby.length);
        int n = arrby.length;
        IntegerHelper.getFourBytes(1 + string.length(), arrby2, n);
        StringHelper.getUnicodeBytes(string, arrby2, n + 4);
        return arrby2;
    }

    private byte[] getURLData(byte[] arrby) {
        String string = this.url.toString();
        int n = 20 + arrby.length + 2 * (1 + string.length());
        String string2 = this.contents;
        if (string2 != null) {
            n += 4 + 2 * (1 + string2.length());
        }
        byte[] arrby2 = new byte[n];
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)0, (int)arrby.length);
        int n2 = arrby.length;
        String string3 = this.contents;
        if (string3 != null) {
            IntegerHelper.getFourBytes(1 + string3.length(), arrby2, n2);
            StringHelper.getUnicodeBytes(this.contents, arrby2, n2 + 4);
            n2 += 4 + 2 * (1 + this.contents.length());
        }
        arrby2[n2] = -32;
        arrby2[n2 + 1] = -55;
        arrby2[n2 + 2] = -22;
        arrby2[n2 + 3] = 121;
        arrby2[n2 + 4] = -7;
        arrby2[n2 + 5] = -70;
        arrby2[n2 + 6] = -50;
        arrby2[n2 + 7] = 17;
        arrby2[n2 + 8] = -116;
        arrby2[n2 + 9] = -126;
        arrby2[n2 + 10] = 0;
        arrby2[n2 + 11] = -86;
        arrby2[n2 + 12] = 0;
        arrby2[n2 + 13] = 75;
        arrby2[n2 + 14] = -87;
        arrby2[n2 + 15] = 11;
        IntegerHelper.getFourBytes(2 * (1 + string.length()), arrby2, n2 + 16);
        StringHelper.getUnicodeBytes(string, arrby2, n2 + 20);
        return arrby2;
    }

    private void setLocation(WritableSheet writableSheet, int n, int n2, int n3, int n4) {
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append('\'');
        if (writableSheet.getName().indexOf(39) == -1) {
            stringBuffer.append(writableSheet.getName());
        } else {
            String string = writableSheet.getName();
            int n5 = 0;
            int n6 = string.indexOf(39, 0);
            while (n6 != -1 && n5 < string.length()) {
                stringBuffer.append(string.substring(n5, n6));
                stringBuffer.append("''");
                n5 = n6 + 1;
                n6 = string.indexOf(39, n5);
            }
            stringBuffer.append(string.substring(n5));
        }
        stringBuffer.append('\'');
        stringBuffer.append('!');
        int n7 = Math.max((int)n, (int)n3);
        int n8 = Math.max((int)n2, (int)n4);
        CellReferenceHelper.getCellReference(n, n2, stringBuffer);
        stringBuffer.append(':');
        CellReferenceHelper.getCellReference(n7, n8, stringBuffer);
        this.location = stringBuffer.toString();
    }

    public int getColumn() {
        return this.firstColumn;
    }

    String getContents() {
        return this.contents;
    }

    @Override
    public byte[] getData() {
        int n;
        if (!this.modified) {
            return this.data;
        }
        byte[] arrby = new byte[32];
        IntegerHelper.getTwoBytes(this.firstRow, arrby, 0);
        IntegerHelper.getTwoBytes(this.lastRow, arrby, 2);
        IntegerHelper.getTwoBytes(this.firstColumn, arrby, 4);
        IntegerHelper.getTwoBytes(this.lastColumn, arrby, 6);
        arrby[8] = -48;
        arrby[9] = -55;
        arrby[10] = -22;
        arrby[11] = 121;
        arrby[12] = -7;
        arrby[13] = -70;
        arrby[14] = -50;
        arrby[15] = 17;
        arrby[16] = -116;
        arrby[17] = -126;
        arrby[18] = 0;
        arrby[19] = -86;
        arrby[20] = 0;
        arrby[21] = 75;
        arrby[22] = -87;
        arrby[23] = 11;
        arrby[24] = 2;
        arrby[25] = 0;
        arrby[26] = 0;
        arrby[27] = 0;
        if (this.isURL()) {
            n = 3;
            if (this.contents != null) {
                n = 23;
            }
        } else if (this.isFile()) {
            n = 1;
            if (this.contents != null) {
                n = 21;
            }
        } else if (this.isLocation()) {
            n = 8;
        } else {
            boolean bl = this.isUNC();
            n = 0;
            if (bl) {
                n = 259;
            }
        }
        IntegerHelper.getFourBytes(n, arrby, 28);
        if (this.isURL()) {
            this.data = this.getURLData(arrby);
        } else if (this.isFile()) {
            this.data = this.getFileData(arrby);
        } else if (this.isLocation()) {
            this.data = this.getLocationData(arrby);
        } else if (this.isUNC()) {
            this.data = this.getUNCData(arrby);
        }
        return this.data;
    }

    public File getFile() {
        return this.file;
    }

    public int getLastColumn() {
        return this.lastColumn;
    }

    public int getLastRow() {
        return this.lastRow;
    }

    public Range getRange() {
        return this.range;
    }

    public int getRow() {
        return this.firstRow;
    }

    public URL getURL() {
        return this.url;
    }

    void initialize(WritableSheet writableSheet) {
        this.sheet = writableSheet;
        SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(writableSheet, this.firstColumn, this.firstRow, this.lastColumn, this.lastRow);
        this.range = sheetRangeImpl;
    }

    void insertColumn(int n) {
        int n2;
        boolean bl = this.sheet != null && this.range != null;
        Assert.verify(bl);
        if (n > this.lastColumn) {
            return;
        }
        int n3 = this.firstColumn;
        if (n <= n3) {
            this.firstColumn = n3 + 1;
            this.modified = true;
        }
        if (n <= (n2 = this.lastColumn)) {
            this.lastColumn = n2 + 1;
            this.modified = true;
        }
        if (this.modified) {
            SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, this.firstColumn, this.firstRow, this.lastColumn, this.lastRow);
            this.range = sheetRangeImpl;
        }
    }

    void insertRow(int n) {
        int n2;
        boolean bl = this.sheet != null && this.range != null;
        Assert.verify(bl);
        if (n > this.lastRow) {
            return;
        }
        int n3 = this.firstRow;
        if (n <= n3) {
            this.firstRow = n3 + 1;
            this.modified = true;
        }
        if (n <= (n2 = this.lastRow)) {
            this.lastRow = n2 + 1;
            this.modified = true;
        }
        if (this.modified) {
            SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, this.firstColumn, this.firstRow, this.lastColumn, this.lastRow);
            this.range = sheetRangeImpl;
        }
    }

    public boolean isFile() {
        return this.linkType == fileLink;
    }

    public boolean isLocation() {
        return this.linkType == workbookLink;
    }

    public boolean isUNC() {
        return this.linkType == uncLink;
    }

    public boolean isURL() {
        return this.linkType == urlLink;
    }

    void removeColumn(int n) {
        int n2;
        boolean bl = this.sheet != null && this.range != null;
        Assert.verify(bl);
        if (n > this.lastColumn) {
            return;
        }
        int n3 = this.firstColumn;
        if (n < n3) {
            this.firstColumn = n3 - 1;
            this.modified = true;
        }
        if (n < (n2 = this.lastColumn)) {
            this.lastColumn = n2 - 1;
            this.modified = true;
        }
        if (this.modified) {
            Range range = this.range;
            boolean bl2 = false;
            if (range != null) {
                bl2 = true;
            }
            Assert.verify(bl2);
            SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, this.firstColumn, this.firstRow, this.lastColumn, this.lastRow);
            this.range = sheetRangeImpl;
        }
    }

    void removeRow(int n) {
        int n2;
        boolean bl = this.sheet != null && this.range != null;
        Assert.verify(bl);
        if (n > this.lastRow) {
            return;
        }
        int n3 = this.firstRow;
        if (n < n3) {
            this.firstRow = n3 - 1;
            this.modified = true;
        }
        if (n < (n2 = this.lastRow)) {
            this.lastRow = n2 - 1;
            this.modified = true;
        }
        if (this.modified) {
            Range range = this.range;
            boolean bl2 = false;
            if (range != null) {
                bl2 = true;
            }
            Assert.verify(bl2);
            SheetRangeImpl sheetRangeImpl = new SheetRangeImpl(this.sheet, this.firstColumn, this.firstRow, this.lastColumn, this.lastRow);
            this.range = sheetRangeImpl;
        }
    }

    protected void setContents(String string) {
        this.contents = string;
        this.modified = true;
    }

    public void setFile(File file) {
        boolean bl;
        this.linkType = fileLink;
        this.url = null;
        this.location = null;
        this.contents = null;
        this.file = file;
        this.modified = bl = true;
        WritableSheet writableSheet = this.sheet;
        if (writableSheet == null) {
            return;
        }
        WritableCell writableCell = writableSheet.getWritableCell(this.firstColumn, this.firstRow);
        if (writableCell.getType() != CellType.LABEL) {
            bl = false;
        }
        Assert.verify(bl);
        ((Label)writableCell).setString(file.toString());
    }

    protected void setLocation(String string, WritableSheet writableSheet, int n, int n2, int n3, int n4) {
        boolean bl;
        this.linkType = workbookLink;
        this.url = null;
        this.file = null;
        this.modified = bl = true;
        this.contents = string;
        this.setLocation(writableSheet, n, n2, n3, n4);
        if (writableSheet == null) {
            return;
        }
        WritableCell writableCell = writableSheet.getWritableCell(this.firstColumn, this.firstRow);
        if (writableCell.getType() != CellType.LABEL) {
            bl = false;
        }
        Assert.verify(bl);
        ((Label)writableCell).setString(string);
    }

    public void setURL(URL uRL) {
        URL uRL2 = this.url;
        this.linkType = urlLink;
        this.file = null;
        this.location = null;
        this.contents = null;
        this.url = uRL;
        this.modified = true;
        WritableSheet writableSheet = this.sheet;
        if (writableSheet == null) {
            return;
        }
        WritableCell writableCell = writableSheet.getWritableCell(this.firstColumn, this.firstRow);
        if (writableCell.getType() == CellType.LABEL) {
            Label label = (Label)writableCell;
            String string = uRL2.toString();
            String string2 = string.charAt(string.length() - 1) != '/' && string.charAt(string.length() - 1) != '\\' ? "" : string.substring(0, string.length() - 1);
            if (label.getString().equals((Object)string) || label.getString().equals((Object)string2)) {
                label.setString(uRL.toString());
            }
        }
    }

    public String toString() {
        if (this.isFile()) {
            return this.file.toString();
        }
        if (this.isURL()) {
            return this.url.toString();
        }
        if (this.isUNC()) {
            return this.file.toString();
        }
        return "";
    }

}

