/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.io.IOException
 *  java.lang.Math
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.lang.System
 *  java.util.ArrayList
 *  java.util.Iterator
 *  java.util.List
 */
package jxl.write.biff;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import jxl.CellFeatures;
import jxl.CellType;
import jxl.SheetSettings;
import jxl.biff.ByteData;
import jxl.biff.CellReferenceHelper;
import jxl.biff.DVParser;
import jxl.biff.IndexMapping;
import jxl.biff.IntegerHelper;
import jxl.biff.Type;
import jxl.biff.WritableRecordData;
import jxl.biff.XFRecord;
import jxl.common.Logger;
import jxl.write.Number;
import jxl.write.WritableCellFeatures;
import jxl.write.WritableSheet;
import jxl.write.biff.CellValue;
import jxl.write.biff.File;
import jxl.write.biff.MulRKRecord;
import jxl.write.biff.StringRecord;

class RowRecord
extends WritableRecordData {
    private static int defaultHeightIndicator = 0;
    private static final int growSize = 10;
    private static final Logger logger = Logger.getLogger(RowRecord.class);
    private static int maxColumns = 0;
    private static final int maxRKValue = 536870911;
    private static final int minRKValue = -536870912;
    private CellValue[] cells;
    private boolean collapsed;
    private byte[] data;
    private boolean defaultFormat;
    private boolean groupStart;
    private boolean matchesDefFontHeight;
    private int numColumns;
    private int outlineLevel;
    private int rowHeight;
    private int rowNumber;
    private WritableSheet sheet;
    private XFRecord style;
    private int xfIndex;

    static {
        defaultHeightIndicator = 255;
        maxColumns = 256;
    }

    public RowRecord(int n, WritableSheet writableSheet) {
        super(Type.ROW);
        this.rowNumber = n;
        this.cells = new CellValue[0];
        this.numColumns = 0;
        this.rowHeight = defaultHeightIndicator;
        this.collapsed = false;
        this.matchesDefFontHeight = true;
        this.sheet = writableSheet;
    }

    private void writeIntegerValues(ArrayList arrayList, File file) throws IOException {
        if (arrayList.size() == 0) {
            return;
        }
        if (arrayList.size() >= 3) {
            file.write(new MulRKRecord((List)arrayList));
        } else {
            Iterator iterator = arrayList.iterator();
            while (iterator.hasNext()) {
                file.write((CellValue)iterator.next());
            }
        }
        arrayList.clear();
    }

    public void addCell(CellValue cellValue) {
        WritableCellFeatures writableCellFeatures;
        CellValue[] arrcellValue;
        int n = cellValue.getColumn();
        if (n >= maxColumns) {
            Logger logger = RowRecord.logger;
            StringBuilder stringBuilder = new StringBuilder();
            stringBuilder.append("Could not add cell at ");
            stringBuilder.append(CellReferenceHelper.getCellReference(cellValue.getRow(), cellValue.getColumn()));
            stringBuilder.append(" because it exceeds the maximum column limit");
            logger.warn(stringBuilder.toString());
            return;
        }
        CellValue[] arrcellValue2 = this.cells;
        if (n >= arrcellValue2.length) {
            this.cells = new CellValue[Math.max((int)(10 + arrcellValue2.length), (int)(n + 1))];
            System.arraycopy((Object)arrcellValue2, (int)0, (Object)this.cells, (int)0, (int)arrcellValue2.length);
        }
        if ((arrcellValue = this.cells)[n] != null && (writableCellFeatures = arrcellValue[n].getWritableCellFeatures()) != null) {
            writableCellFeatures.removeComment();
            if (writableCellFeatures.getDVParser() != null && !writableCellFeatures.getDVParser().extendedCellsValidation()) {
                writableCellFeatures.removeDataValidation();
            }
        }
        this.cells[n] = cellValue;
        this.numColumns = Math.max((int)(n + 1), (int)this.numColumns);
    }

    public void decrementOutlineLevel() {
        int n = this.outlineLevel;
        if (n > 0) {
            this.outlineLevel = n - 1;
        }
        if (this.outlineLevel == 0) {
            this.collapsed = false;
        }
    }

    void decrementRow() {
        CellValue[] arrcellValue;
        this.rowNumber = -1 + this.rowNumber;
        for (int i = 0; i < (arrcellValue = this.cells).length; ++i) {
            if (arrcellValue[i] == null) continue;
            arrcellValue[i].decrementRow();
        }
    }

    public CellValue getCell(int n) {
        if (n >= 0 && n < this.numColumns) {
            return this.cells[n];
        }
        return null;
    }

    @Override
    public byte[] getData() {
        byte[] arrby = new byte[16];
        int n = this.rowHeight;
        if (this.sheet.getSettings().getDefaultRowHeight() != 255 && n == defaultHeightIndicator) {
            n = this.sheet.getSettings().getDefaultRowHeight();
        }
        IntegerHelper.getTwoBytes(this.rowNumber, arrby, 0);
        IntegerHelper.getTwoBytes(this.numColumns, arrby, 4);
        IntegerHelper.getTwoBytes(n, arrby, 6);
        int n2 = 256 + this.outlineLevel;
        if (this.groupStart) {
            n2 |= 16;
        }
        if (this.collapsed) {
            n2 |= 32;
        }
        if (!this.matchesDefFontHeight) {
            n2 |= 64;
        }
        if (this.defaultFormat) {
            n2 = n2 | 128 | this.xfIndex << 16;
        }
        IntegerHelper.getFourBytes(n2, arrby, 12);
        return arrby;
    }

    public boolean getGroupStart() {
        return this.groupStart;
    }

    public int getMaxColumn() {
        return this.numColumns;
    }

    public int getOutlineLevel() {
        return this.outlineLevel;
    }

    public int getRowHeight() {
        return this.rowHeight;
    }

    public int getRowNumber() {
        return this.rowNumber;
    }

    XFRecord getStyle() {
        return this.style;
    }

    boolean hasDefaultFormat() {
        return this.defaultFormat;
    }

    public void incrementOutlineLevel() {
        this.outlineLevel = 1 + this.outlineLevel;
    }

    void incrementRow() {
        CellValue[] arrcellValue;
        this.rowNumber = 1 + this.rowNumber;
        for (int i = 0; i < (arrcellValue = this.cells).length; ++i) {
            if (arrcellValue[i] == null) continue;
            arrcellValue[i].incrementRow();
        }
    }

    void insertColumn(int n) {
        int n2;
        int n3;
        int n4 = this.numColumns;
        if (n >= n4) {
            return;
        }
        CellValue[] arrcellValue = this.cells;
        this.cells = n4 >= -1 + arrcellValue.length ? new CellValue[10 + arrcellValue.length] : new CellValue[arrcellValue.length];
        System.arraycopy((Object)arrcellValue, (int)0, (Object)this.cells, (int)0, (int)n);
        CellValue[] arrcellValue2 = this.cells;
        System.arraycopy((Object)arrcellValue, (int)n, (Object)arrcellValue2, (int)n2, (int)(this.numColumns - n));
        for (n2 = n + 1; n2 <= (n3 = this.numColumns); ++n2) {
            CellValue[] arrcellValue3 = this.cells;
            if (arrcellValue3[n2] == null) continue;
            arrcellValue3[n2].incrementColumn();
        }
        this.numColumns = Math.min((int)(n3 + 1), (int)maxColumns);
    }

    public boolean isCollapsed() {
        return this.collapsed;
    }

    public boolean isDefaultHeight() {
        return this.rowHeight == defaultHeightIndicator;
    }

    boolean matchesDefaultFontHeight() {
        return this.matchesDefFontHeight;
    }

    void rationalize(IndexMapping indexMapping) {
        if (this.defaultFormat) {
            this.xfIndex = indexMapping.getNewIndex(this.xfIndex);
        }
    }

    public void removeCell(int n) {
        if (n >= this.numColumns) {
            return;
        }
        this.cells[n] = null;
    }

    void removeColumn(int n) {
        int n2;
        if (n >= this.numColumns) {
            return;
        }
        CellValue[] arrcellValue = this.cells;
        this.cells = new CellValue[arrcellValue.length];
        System.arraycopy((Object)arrcellValue, (int)0, (Object)this.cells, (int)0, (int)n);
        int n3 = n + 1;
        System.arraycopy((Object)arrcellValue, (int)n3, (Object)this.cells, (int)n, (int)(this.numColumns - n3));
        while (n < (n2 = this.numColumns)) {
            CellValue[] arrcellValue2 = this.cells;
            if (arrcellValue2[n] != null) {
                arrcellValue2[n].decrementColumn();
            }
            ++n;
        }
        this.numColumns = n2 - 1;
    }

    public void setCollapsed(boolean bl) {
        this.collapsed = bl;
    }

    public void setGroupStart(boolean bl) {
        this.groupStart = bl;
    }

    public void setOutlineLevel(int n) {
        this.outlineLevel = n;
    }

    void setRowDetails(int n, boolean bl, boolean bl2, int n2, boolean bl3, XFRecord xFRecord) {
        this.rowHeight = n;
        this.collapsed = bl2;
        this.matchesDefFontHeight = bl;
        this.outlineLevel = n2;
        this.groupStart = bl3;
        if (xFRecord != null) {
            this.defaultFormat = true;
            this.style = xFRecord;
            this.xfIndex = this.style.getXFIndex();
        }
    }

    public void setRowHeight(int n) {
        if (n == 0) {
            this.setCollapsed(true);
            this.matchesDefFontHeight = false;
            return;
        }
        this.rowHeight = n;
        this.matchesDefFontHeight = false;
    }

    public void write(File file) throws IOException {
        file.write(this);
    }

    public void writeCells(File file) throws IOException {
        ArrayList arrayList = new ArrayList();
        for (int i = 0; i < this.numColumns; ++i) {
            CellValue[] arrcellValue = this.cells;
            if (arrcellValue[i] != null) {
                Number number;
                boolean bl = arrcellValue[i].getType() == CellType.NUMBER && (number = (Number)this.cells[i]).getValue() == (double)((int)number.getValue()) && number.getValue() < 5.36870911E8 && number.getValue() > -5.36870912E8 && number.getCellFeatures() == null;
                if (bl) {
                    arrayList.add((Object)this.cells[i]);
                    continue;
                }
                this.writeIntegerValues(arrayList, file);
                file.write(this.cells[i]);
                if (this.cells[i].getType() != CellType.STRING_FORMULA) continue;
                file.write(new StringRecord(this.cells[i].getContents()));
                continue;
            }
            this.writeIntegerValues(arrayList, file);
        }
        this.writeIntegerValues(arrayList, file);
    }
}

