/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Integer
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.util.ArrayList
 *  java.util.Arrays
 *  java.util.HashMap
 *  java.util.TreeSet
 *  jxl.BooleanCell
 *  jxl.DateCell
 *  jxl.LabelCell
 *  jxl.NumberCell
 *  jxl.biff.FormulaData
 *  jxl.biff.XFRecord
 *  jxl.biff.drawing.ComboBox
 *  jxl.biff.formula.FormulaException
 *  jxl.read.biff.NameRecord
 *  jxl.read.biff.SheetImpl
 *  jxl.read.biff.WorkbookParser
 *  jxl.write.Blank
 *  jxl.write.Boolean
 *  jxl.write.DateTime
 *  jxl.write.Formula
 *  jxl.write.Label
 *  jxl.write.Number
 *  jxl.write.WritableCell
 *  jxl.write.WritableCellFormat
 *  jxl.write.WritableSheet
 *  jxl.write.biff.ButtonPropertySetRecord
 *  jxl.write.biff.PLSRecord
 *  jxl.write.biff.ReadBooleanFormulaRecord
 *  jxl.write.biff.ReadDateFormulaRecord
 *  jxl.write.biff.ReadErrorFormulaRecord
 *  jxl.write.biff.ReadFormulaRecord
 *  jxl.write.biff.ReadNumberFormulaRecord
 *  jxl.write.biff.ReadStringFormulaRecord
 *  jxl.write.biff.WritableSheetImpl
 *  jxl.write.biff.WritableWorkbookImpl
 */
package jxl.write.biff;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.TreeSet;
import jxl.BooleanCell;
import jxl.Cell;
import jxl.CellType;
import jxl.DateCell;
import jxl.LabelCell;
import jxl.NumberCell;
import jxl.Sheet;
import jxl.WorkbookSettings;
import jxl.biff.AutoFilter;
import jxl.biff.CellReferenceHelper;
import jxl.biff.DataValidation;
import jxl.biff.FormattingRecords;
import jxl.biff.FormulaData;
import jxl.biff.NumFormatRecordsException;
import jxl.biff.WorkbookMethods;
import jxl.biff.XFRecord;
import jxl.biff.drawing.ComboBox;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.common.Logger;
import jxl.format.CellFormat;
import jxl.read.biff.NameRecord;
import jxl.read.biff.SheetImpl;
import jxl.read.biff.WorkbookParser;
import jxl.write.Blank;
import jxl.write.Boolean;
import jxl.write.DateTime;
import jxl.write.Formula;
import jxl.write.Label;
import jxl.write.Number;
import jxl.write.WritableCell;
import jxl.write.WritableCellFormat;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.biff.ButtonPropertySetRecord;
import jxl.write.biff.MergedCells;
import jxl.write.biff.PLSRecord;
import jxl.write.biff.ReadBooleanFormulaRecord;
import jxl.write.biff.ReadDateFormulaRecord;
import jxl.write.biff.ReadErrorFormulaRecord;
import jxl.write.biff.ReadFormulaRecord;
import jxl.write.biff.ReadNumberFormulaRecord;
import jxl.write.biff.ReadStringFormulaRecord;
import jxl.write.biff.SheetWriter;
import jxl.write.biff.WritableSheetImpl;
import jxl.write.biff.WritableWorkbookImpl;

class SheetCopier {
    private static Logger logger = Logger.getLogger(SheetCopier.class);
    private AutoFilter autoFilter;
    private ButtonPropertySetRecord buttonPropertySet;
    private boolean chartOnly;
    private ArrayList columnBreaks;
    private TreeSet columnFormats;
    private ComboBox comboBox;
    private ArrayList conditionalFormats;
    private DataValidation dataValidation;
    private ArrayList drawings;
    private HashMap fonts;
    private FormattingRecords formatRecords;
    private HashMap formats;
    private SheetImpl fromSheet;
    private ArrayList hyperlinks;
    private ArrayList images;
    private int maxColumnOutlineLevel;
    private int maxRowOutlineLevel;
    private MergedCells mergedCells;
    private int numRows;
    private PLSRecord plsRecord;
    private ArrayList rowBreaks;
    private SheetWriter sheetWriter;
    private WritableSheetImpl toSheet;
    private ArrayList validatedCells;
    private WorkbookSettings workbookSettings;
    private HashMap xfRecords;

    public SheetCopier(Sheet sheet, WritableSheet writableSheet) {
        this.fromSheet = (SheetImpl)sheet;
        this.toSheet = (WritableSheetImpl)writableSheet;
        this.workbookSettings = this.toSheet.getWorkbook().getSettings();
        this.chartOnly = false;
    }

    private WritableCellFormat copyCellFormat(CellFormat cellFormat) {
        try {
            XFRecord xFRecord = (XFRecord)cellFormat;
            WritableCellFormat writableCellFormat = new WritableCellFormat((CellFormat)xFRecord);
            this.formatRecords.addStyle((XFRecord)writableCellFormat);
            int n = xFRecord.getXFIndex();
            this.xfRecords.put((Object)new Integer(n), (Object)writableCellFormat);
            int n2 = xFRecord.getFontIndex();
            this.fonts.put((Object)new Integer(n2), (Object)new Integer(writableCellFormat.getFontIndex()));
            int n3 = xFRecord.getFormatRecord();
            this.formats.put((Object)new Integer(n3), (Object)new Integer(writableCellFormat.getFormatRecord()));
            return writableCellFormat;
        }
        catch (NumFormatRecordsException numFormatRecordsException) {
            logger.warn("Maximum number of format records exceeded.  Using default format.");
            return WritableWorkbook.NORMAL_STYLE;
        }
    }

    private WritableCell deepCopyCell(Cell cell) {
        WritableCellFormat writableCellFormat;
        ReadFormulaRecord readFormulaRecord;
        CellFormat cellFormat;
        int n;
        WritableCell writableCell = this.shallowCopyCell(cell);
        if (writableCell == null) {
            return writableCell;
        }
        if (writableCell instanceof ReadFormulaRecord && true ^ (readFormulaRecord = (ReadFormulaRecord)writableCell).handleImportedCellReferences((ExternalSheet)this.fromSheet.getWorkbook(), (WorkbookMethods)this.fromSheet.getWorkbook(), this.workbookSettings)) {
            try {
                Logger logger = SheetCopier.logger;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("Formula ");
                stringBuilder.append(readFormulaRecord.getFormula());
                stringBuilder.append(" in cell ");
                stringBuilder.append(CellReferenceHelper.getCellReference(cell.getColumn(), cell.getRow()));
                stringBuilder.append(" cannot be imported because it references another ");
                stringBuilder.append(" sheet from the source workbook");
                logger.warn(stringBuilder.toString());
            }
            catch (FormulaException formulaException) {
                Logger logger = SheetCopier.logger;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("Formula  in cell ");
                stringBuilder.append(CellReferenceHelper.getCellReference(cell.getColumn(), cell.getRow()));
                stringBuilder.append(" cannot be imported:  ");
                stringBuilder.append(formulaException.getMessage());
                logger.warn(stringBuilder.toString());
            }
            writableCell = new Formula(cell.getColumn(), cell.getRow(), "\"ERROR\"");
        }
        if ((writableCellFormat = (WritableCellFormat)this.xfRecords.get((Object)new Integer(n = ((XFRecord)(cellFormat = writableCell.getCellFormat())).getXFIndex()))) == null) {
            writableCellFormat = this.copyCellFormat(cellFormat);
        }
        writableCell.setCellFormat((CellFormat)writableCellFormat);
        return writableCell;
    }

    private void importNames() {
        WorkbookParser workbookParser = this.fromSheet.getWorkbook();
        WritableWorkbookImpl writableWorkbookImpl = this.toSheet.getWorkbook();
        int n = workbookParser.getIndex((Sheet)this.fromSheet);
        NameRecord[] arrnameRecord = workbookParser.getNameRecords();
        Object[] arrobject = writableWorkbookImpl.getRangeNames();
        for (int i = 0; i < arrnameRecord.length; ++i) {
            NameRecord.NameRange[] arrnameRange = arrnameRecord[i].getRanges();
            int n2 = 0;
            while (n2 < arrnameRange.length) {
                int n3;
                if (n == workbookParser.getExternalSheetIndex(arrnameRange[n2].getExternalSheet())) {
                    String string2 = arrnameRecord[i].getName();
                    if (Arrays.binarySearch((Object[])arrobject, (Object)string2) < 0) {
                        WritableSheetImpl writableSheetImpl = this.toSheet;
                        int n4 = arrnameRange[n2].getFirstColumn();
                        int n5 = arrnameRange[n2].getFirstRow();
                        int n6 = arrnameRange[n2].getLastColumn();
                        int n7 = arrnameRange[n2].getLastRow();
                        n3 = n2;
                        writableWorkbookImpl.addNameArea(string2, (WritableSheet)writableSheetImpl, n4, n5, n6, n7);
                    } else {
                        n3 = n2;
                        Logger logger = SheetCopier.logger;
                        StringBuilder stringBuilder = new StringBuilder();
                        stringBuilder.append("Named range ");
                        stringBuilder.append(string2);
                        stringBuilder.append(" is already present in the destination workbook");
                        logger.warn(stringBuilder.toString());
                    }
                } else {
                    n3 = n2;
                }
                n2 = n3 + 1;
            }
        }
    }

    private WritableCell shallowCopyCell(Cell cell) {
        CellType cellType = cell.getType();
        if (cellType == CellType.LABEL) {
            return new Label((LabelCell)cell);
        }
        if (cellType == CellType.NUMBER) {
            return new Number((NumberCell)cell);
        }
        if (cellType == CellType.DATE) {
            return new DateTime((DateCell)cell);
        }
        if (cellType == CellType.BOOLEAN) {
            return new Boolean((BooleanCell)cell);
        }
        if (cellType == CellType.NUMBER_FORMULA) {
            return new ReadNumberFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.STRING_FORMULA) {
            return new ReadStringFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.BOOLEAN_FORMULA) {
            return new ReadBooleanFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.DATE_FORMULA) {
            return new ReadDateFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.FORMULA_ERROR) {
            return new ReadErrorFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.EMPTY && cell.getCellFormat() != null) {
            return new Blank(cell);
        }
        return null;
    }

    /*
     * Exception decompiling
     */
    public void copySheet() {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl167 : ALOAD_0 : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }

    public void copyWritableSheet() {
        this.shallowCopyCells();
    }

    /*
     * Exception decompiling
     */
    void deepCopyCells() {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl53 : IINC : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }

    AutoFilter getAutoFilter() {
        return this.autoFilter;
    }

    ButtonPropertySetRecord getButtonPropertySet() {
        return this.buttonPropertySet;
    }

    ComboBox getComboBox() {
        return this.comboBox;
    }

    DataValidation getDataValidation() {
        return this.dataValidation;
    }

    public int getMaxColumnOutlineLevel() {
        return this.maxColumnOutlineLevel;
    }

    public int getMaxRowOutlineLevel() {
        return this.maxRowOutlineLevel;
    }

    PLSRecord getPLSRecord() {
        return this.plsRecord;
    }

    int getRows() {
        return this.numRows;
    }

    /*
     * Exception decompiling
     */
    public void importSheet() {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl215 : ALOAD_0 : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }

    boolean isChartOnly() {
        return this.chartOnly;
    }

    void setColumnBreaks(ArrayList arrayList) {
        this.columnBreaks = arrayList;
    }

    void setColumnFormats(TreeSet treeSet) {
        this.columnFormats = treeSet;
    }

    void setConditionalFormats(ArrayList arrayList) {
        this.conditionalFormats = arrayList;
    }

    void setDrawings(ArrayList arrayList) {
        this.drawings = arrayList;
    }

    void setFormatRecords(FormattingRecords formattingRecords) {
        this.formatRecords = formattingRecords;
    }

    void setHyperlinks(ArrayList arrayList) {
        this.hyperlinks = arrayList;
    }

    void setImages(ArrayList arrayList) {
        this.images = arrayList;
    }

    void setMergedCells(MergedCells mergedCells) {
        this.mergedCells = mergedCells;
    }

    void setRowBreaks(ArrayList arrayList) {
        this.rowBreaks = arrayList;
    }

    void setSheetWriter(SheetWriter sheetWriter) {
        this.sheetWriter = sheetWriter;
    }

    void setValidatedCells(ArrayList arrayList) {
        this.validatedCells = arrayList;
    }

    /*
     * Exception decompiling
     */
    void shallowCopyCells() {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl48 : IINC : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }
}

