/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  jxl.biff.FontRecord
 *  jxl.biff.XFRecord
 *  jxl.write.DateFormat
 *  jxl.write.WritableCellFormat
 *  jxl.write.WritableFont
 *  jxl.write.biff.DateRecord
 */
package jxl.write.biff;

import jxl.biff.DisplayFormat;
import jxl.biff.FontRecord;
import jxl.biff.XFRecord;
import jxl.common.Logger;
import jxl.format.Font;
import jxl.write.DateFormat;
import jxl.write.DateFormats;
import jxl.write.NumberFormats;
import jxl.write.WritableCellFormat;
import jxl.write.WritableFont;
import jxl.write.WritableWorkbook;
import jxl.write.biff.DateRecord;

class Styles {
    private static Logger logger = Logger.getLogger(Styles.class);
    private WritableFont arial10pt = null;
    private WritableCellFormat defaultDateFormat;
    private WritableCellFormat hiddenStyle = null;
    private WritableFont hyperlinkFont = null;
    private WritableCellFormat hyperlinkStyle = null;
    private WritableCellFormat normalStyle = null;

    private void initArial10Pt() {
        Styles styles = this;
        synchronized (styles) {
            this.arial10pt = new WritableFont((Font)WritableWorkbook.ARIAL_10_PT);
            return;
        }
    }

    private void initDefaultDateFormat() {
        Styles styles = this;
        synchronized (styles) {
            this.defaultDateFormat = new WritableCellFormat(DateFormats.DEFAULT);
            return;
        }
    }

    private void initHiddenStyle() {
        Styles styles = this;
        synchronized (styles) {
            this.hiddenStyle = new WritableCellFormat(this.getArial10Pt(), (DisplayFormat)new DateFormat(";;;"));
            return;
        }
    }

    private void initHyperlinkFont() {
        Styles styles = this;
        synchronized (styles) {
            this.hyperlinkFont = new WritableFont((Font)WritableWorkbook.HYPERLINK_FONT);
            return;
        }
    }

    private void initHyperlinkStyle() {
        Styles styles = this;
        synchronized (styles) {
            this.hyperlinkStyle = new WritableCellFormat(this.getHyperlinkFont(), NumberFormats.DEFAULT);
            return;
        }
    }

    private void initNormalStyle() {
        Styles styles = this;
        synchronized (styles) {
            this.normalStyle = new WritableCellFormat(this.getArial10Pt(), NumberFormats.DEFAULT);
            this.normalStyle.setFont((FontRecord)this.getArial10Pt());
            return;
        }
    }

    public WritableFont getArial10Pt() {
        if (this.arial10pt == null) {
            this.initArial10Pt();
        }
        return this.arial10pt;
    }

    public WritableCellFormat getDefaultDateFormat() {
        if (this.defaultDateFormat == null) {
            this.initDefaultDateFormat();
        }
        return this.defaultDateFormat;
    }

    public XFRecord getFormat(XFRecord xFRecord) {
        if (xFRecord == WritableWorkbook.NORMAL_STYLE) {
            xFRecord = this.getNormalStyle();
        } else if (xFRecord == WritableWorkbook.HYPERLINK_STYLE) {
            xFRecord = this.getHyperlinkStyle();
        } else if (xFRecord == WritableWorkbook.HIDDEN_STYLE) {
            xFRecord = this.getHiddenStyle();
        } else if (xFRecord == DateRecord.defaultDateFormat) {
            xFRecord = this.getDefaultDateFormat();
        }
        if (xFRecord.getFont() == WritableWorkbook.ARIAL_10_PT) {
            xFRecord.setFont((FontRecord)this.getArial10Pt());
            return xFRecord;
        }
        if (xFRecord.getFont() == WritableWorkbook.HYPERLINK_FONT) {
            xFRecord.setFont((FontRecord)this.getHyperlinkFont());
        }
        return xFRecord;
    }

    public WritableCellFormat getHiddenStyle() {
        if (this.hiddenStyle == null) {
            this.initHiddenStyle();
        }
        return this.hiddenStyle;
    }

    public WritableFont getHyperlinkFont() {
        if (this.hyperlinkFont == null) {
            this.initHyperlinkFont();
        }
        return this.hyperlinkFont;
    }

    public WritableCellFormat getHyperlinkStyle() {
        if (this.hyperlinkStyle == null) {
            this.initHyperlinkStyle();
        }
        return this.hyperlinkStyle;
    }

    public WritableCellFormat getNormalStyle() {
        if (this.normalStyle == null) {
            this.initNormalStyle();
        }
        return this.normalStyle;
    }
}

