/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.System
 */
package jxl.write.biff;

import jxl.WorkbookSettings;
import jxl.biff.EncodedURLHelper;
import jxl.biff.IntegerHelper;
import jxl.biff.StringHelper;
import jxl.biff.Type;
import jxl.biff.WritableRecordData;
import jxl.common.Assert;
import jxl.common.Logger;
import jxl.read.biff.SupbookRecord;
import jxl.write.biff.SupbookRecord;

class SupbookRecord
extends WritableRecordData {
    public static final SupbookType ADDIN;
    public static final SupbookType EXTERNAL;
    public static final SupbookType INTERNAL;
    public static final SupbookType LINK;
    public static final SupbookType UNKNOWN;
    private static Logger logger;
    private byte[] data;
    private String fileName;
    private int numSheets;
    private String[] sheetNames;
    private SupbookType type;
    private WorkbookSettings workbookSettings;

    static {
        logger = Logger.getLogger(SupbookRecord.class);
        INTERNAL = new Object(){};
        EXTERNAL = new /* invalid duplicate definition of identical inner class */;
        ADDIN = new /* invalid duplicate definition of identical inner class */;
        LINK = new /* invalid duplicate definition of identical inner class */;
        UNKNOWN = new /* invalid duplicate definition of identical inner class */;
    }

    public SupbookRecord() {
        super(Type.SUPBOOK);
        this.type = ADDIN;
    }

    public SupbookRecord(int n, WorkbookSettings workbookSettings) {
        super(Type.SUPBOOK);
        this.numSheets = n;
        this.type = INTERNAL;
        this.workbookSettings = workbookSettings;
    }

    public SupbookRecord(String string, WorkbookSettings workbookSettings) {
        super(Type.SUPBOOK);
        this.fileName = string;
        this.numSheets = 1;
        this.sheetNames = new String[0];
        this.workbookSettings = workbookSettings;
        this.type = EXTERNAL;
    }

    public SupbookRecord(jxl.read.biff.SupbookRecord supbookRecord, WorkbookSettings workbookSettings) {
        super(Type.SUPBOOK);
        this.workbookSettings = workbookSettings;
        if (supbookRecord.getType() == jxl.read.biff.SupbookRecord.INTERNAL) {
            this.type = INTERNAL;
            this.numSheets = supbookRecord.getNumberOfSheets();
        } else if (supbookRecord.getType() == jxl.read.biff.SupbookRecord.EXTERNAL) {
            this.type = EXTERNAL;
            this.numSheets = supbookRecord.getNumberOfSheets();
            this.fileName = supbookRecord.getFileName();
            this.sheetNames = new String[this.numSheets];
            for (int i = 0; i < this.numSheets; ++i) {
                this.sheetNames[i] = supbookRecord.getSheetName(i);
            }
        }
        if (supbookRecord.getType() == jxl.read.biff.SupbookRecord.ADDIN) {
            logger.warn("Supbook type is addin");
        }
    }

    private void initAddin() {
        this.data = new byte[]{1, 0, 1, 58};
    }

    private void initExternal() {
        String[] arrstring;
        int n = 0;
        int n2 = 0;
        for (int i = 0; i < this.numSheets; ++i) {
            n2 += this.sheetNames[i].length();
        }
        byte[] arrby = EncodedURLHelper.getEncodedURL(this.fileName, this.workbookSettings);
        int n3 = 6 + arrby.length;
        int n4 = this.numSheets;
        this.data = new byte[n3 + n4 * 3 + n2 * 2];
        IntegerHelper.getTwoBytes(n4, this.data, 0);
        IntegerHelper.getTwoBytes(1 + arrby.length, this.data, 2);
        byte[] arrby2 = this.data;
        arrby2[4] = 0;
        arrby2[5] = 1;
        System.arraycopy((Object)arrby, (int)0, (Object)arrby2, (int)6, (int)arrby.length);
        int n5 = 2 + (4 + arrby.length);
        while (n < (arrstring = this.sheetNames).length) {
            IntegerHelper.getTwoBytes(arrstring[n].length(), this.data, n5);
            byte[] arrby3 = this.data;
            arrby3[n5 + 2] = 1;
            StringHelper.getUnicodeBytes(this.sheetNames[n], arrby3, n5 + 3);
            n5 += 3 + 2 * this.sheetNames[n].length();
            ++n;
        }
    }

    private void initInternal() {
        this.data = new byte[4];
        IntegerHelper.getTwoBytes(this.numSheets, this.data, 0);
        byte[] arrby = this.data;
        arrby[2] = 1;
        arrby[3] = 4;
        this.type = INTERNAL;
    }

    private void initInternal(jxl.read.biff.SupbookRecord supbookRecord) {
        this.numSheets = supbookRecord.getNumberOfSheets();
        this.initInternal();
    }

    void adjustInternal(int n) {
        boolean bl = this.type == INTERNAL;
        Assert.verify(bl);
        this.numSheets = n;
        this.initInternal();
    }

    @Override
    public byte[] getData() {
        SupbookType supbookType = this.type;
        if (supbookType == INTERNAL) {
            this.initInternal();
        } else if (supbookType == EXTERNAL) {
            this.initExternal();
        } else if (supbookType == ADDIN) {
            this.initAddin();
        } else {
            logger.warn("unsupported supbook type - defaulting to internal");
            this.initInternal();
        }
        return this.data;
    }

    public String getFileName() {
        return this.fileName;
    }

    public int getNumberOfSheets() {
        return this.numSheets;
    }

    public int getSheetIndex(String string) {
        String[] arrstring;
        boolean bl = false;
        for (int i = 0; i < (arrstring = this.sheetNames).length && !bl; ++i) {
            if (!arrstring[i].equals((Object)string)) continue;
            bl = true;
        }
        if (bl) {
            return 0;
        }
        String[] arrstring2 = this.sheetNames;
        String[] arrstring3 = new String[1 + arrstring2.length];
        System.arraycopy((Object)arrstring2, (int)0, (Object)arrstring3, (int)0, (int)arrstring2.length);
        arrstring3[this.sheetNames.length] = string;
        this.sheetNames = arrstring3;
        return this.sheetNames.length - 1;
    }

    public String getSheetName(int n) {
        return this.sheetNames[n];
    }

    public SupbookType getType() {
        return this.type;
    }

}

