/*
 * Decompiled with CFR 0.0.
 * 
 * Could not load the following classes:
 *  java.lang.Integer
 *  java.lang.Object
 *  java.lang.String
 *  java.lang.StringBuilder
 *  java.util.ArrayList
 *  java.util.HashMap
 *  java.util.TreeSet
 *  jxl.BooleanCell
 *  jxl.DateCell
 *  jxl.LabelCell
 *  jxl.NumberCell
 *  jxl.biff.FormulaData
 *  jxl.biff.WorkspaceInformationRecord
 *  jxl.biff.XFRecord
 *  jxl.biff.formula.FormulaException
 *  jxl.write.Blank
 *  jxl.write.Boolean
 *  jxl.write.DateTime
 *  jxl.write.Formula
 *  jxl.write.Label
 *  jxl.write.Number
 *  jxl.write.WritableCell
 *  jxl.write.WritableCellFormat
 *  jxl.write.WritableSheet
 *  jxl.write.biff.ButtonPropertySetRecord
 *  jxl.write.biff.PLSRecord
 *  jxl.write.biff.ReadBooleanFormulaRecord
 *  jxl.write.biff.ReadDateFormulaRecord
 *  jxl.write.biff.ReadErrorFormulaRecord
 *  jxl.write.biff.ReadFormulaRecord
 *  jxl.write.biff.ReadNumberFormulaRecord
 *  jxl.write.biff.ReadStringFormulaRecord
 *  jxl.write.biff.RowRecord
 *  jxl.write.biff.WritableSheetImpl
 *  jxl.write.biff.WritableWorkbookImpl
 */
package jxl.write.biff;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.TreeSet;
import jxl.BooleanCell;
import jxl.Cell;
import jxl.CellType;
import jxl.DateCell;
import jxl.LabelCell;
import jxl.NumberCell;
import jxl.WorkbookSettings;
import jxl.biff.CellReferenceHelper;
import jxl.biff.DataValidation;
import jxl.biff.FormattingRecords;
import jxl.biff.FormulaData;
import jxl.biff.NumFormatRecordsException;
import jxl.biff.WorkbookMethods;
import jxl.biff.WorkspaceInformationRecord;
import jxl.biff.XFRecord;
import jxl.biff.formula.ExternalSheet;
import jxl.biff.formula.FormulaException;
import jxl.common.Logger;
import jxl.format.CellFormat;
import jxl.write.Blank;
import jxl.write.Boolean;
import jxl.write.DateTime;
import jxl.write.Formula;
import jxl.write.Label;
import jxl.write.Number;
import jxl.write.WritableCell;
import jxl.write.WritableCellFormat;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.biff.ButtonPropertySetRecord;
import jxl.write.biff.MergedCells;
import jxl.write.biff.PLSRecord;
import jxl.write.biff.ReadBooleanFormulaRecord;
import jxl.write.biff.ReadDateFormulaRecord;
import jxl.write.biff.ReadErrorFormulaRecord;
import jxl.write.biff.ReadFormulaRecord;
import jxl.write.biff.ReadNumberFormulaRecord;
import jxl.write.biff.ReadStringFormulaRecord;
import jxl.write.biff.RowRecord;
import jxl.write.biff.SheetCopier;
import jxl.write.biff.SheetWriter;
import jxl.write.biff.WritableSheetImpl;
import jxl.write.biff.WritableWorkbookImpl;

class WritableSheetCopier {
    private static Logger logger = Logger.getLogger(SheetCopier.class);
    private boolean chartOnly;
    private HashMap fonts;
    private FormattingRecords formatRecords;
    private HashMap formats;
    private ButtonPropertySetRecord fromButtonPropertySet;
    private ArrayList fromColumnBreaks;
    private TreeSet fromColumnFormats;
    private DataValidation fromDataValidation;
    private ArrayList fromDrawings;
    private ArrayList fromHyperlinks;
    private MergedCells fromMergedCells;
    private PLSRecord fromPLSRecord;
    private ArrayList fromRowBreaks;
    private RowRecord[] fromRows;
    private WritableSheetImpl fromSheet;
    private WorkspaceInformationRecord fromWorkspaceOptions;
    private int maxColumnOutlineLevel;
    private int maxRowOutlineLevel;
    private int numRows;
    private SheetWriter sheetWriter;
    private ButtonPropertySetRecord toButtonPropertySet;
    private ArrayList toColumnBreaks;
    private TreeSet toColumnFormats;
    private DataValidation toDataValidation;
    private ArrayList toDrawings;
    private ArrayList toHyperlinks;
    private ArrayList toImages;
    private MergedCells toMergedCells;
    private PLSRecord toPLSRecord;
    private ArrayList toRowBreaks;
    private WritableSheetImpl toSheet;
    private ArrayList validatedCells;
    private WorkbookSettings workbookSettings;
    private HashMap xfRecords;

    public WritableSheetCopier(WritableSheet writableSheet, WritableSheet writableSheet2) {
        this.fromSheet = (WritableSheetImpl)writableSheet;
        this.toSheet = (WritableSheetImpl)writableSheet2;
        this.workbookSettings = this.toSheet.getWorkbook().getSettings();
        this.chartOnly = false;
    }

    private WritableCellFormat copyCellFormat(CellFormat cellFormat) {
        try {
            XFRecord xFRecord = (XFRecord)cellFormat;
            WritableCellFormat writableCellFormat = new WritableCellFormat((CellFormat)xFRecord);
            this.formatRecords.addStyle((XFRecord)writableCellFormat);
            int n = xFRecord.getXFIndex();
            this.xfRecords.put((Object)new Integer(n), (Object)writableCellFormat);
            int n2 = xFRecord.getFontIndex();
            this.fonts.put((Object)new Integer(n2), (Object)new Integer(writableCellFormat.getFontIndex()));
            int n3 = xFRecord.getFormatRecord();
            this.formats.put((Object)new Integer(n3), (Object)new Integer(writableCellFormat.getFormatRecord()));
            return writableCellFormat;
        }
        catch (NumFormatRecordsException numFormatRecordsException) {
            logger.warn("Maximum number of format records exceeded.  Using default format.");
            return WritableWorkbook.NORMAL_STYLE;
        }
    }

    private WritableCell deepCopyCell(Cell cell) {
        WritableCellFormat writableCellFormat;
        ReadFormulaRecord readFormulaRecord;
        CellFormat cellFormat;
        int n;
        WritableCell writableCell = this.shallowCopyCell(cell);
        if (writableCell == null) {
            return writableCell;
        }
        if (writableCell instanceof ReadFormulaRecord && true ^ (readFormulaRecord = (ReadFormulaRecord)writableCell).handleImportedCellReferences((ExternalSheet)this.fromSheet.getWorkbook(), (WorkbookMethods)this.fromSheet.getWorkbook(), this.workbookSettings)) {
            try {
                Logger logger = WritableSheetCopier.logger;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("Formula ");
                stringBuilder.append(readFormulaRecord.getFormula());
                stringBuilder.append(" in cell ");
                stringBuilder.append(CellReferenceHelper.getCellReference(cell.getColumn(), cell.getRow()));
                stringBuilder.append(" cannot be imported because it references another ");
                stringBuilder.append(" sheet from the source workbook");
                logger.warn(stringBuilder.toString());
            }
            catch (FormulaException formulaException) {
                Logger logger = WritableSheetCopier.logger;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.append("Formula  in cell ");
                stringBuilder.append(CellReferenceHelper.getCellReference(cell.getColumn(), cell.getRow()));
                stringBuilder.append(" cannot be imported:  ");
                stringBuilder.append(formulaException.getMessage());
                logger.warn(stringBuilder.toString());
            }
            writableCell = new Formula(cell.getColumn(), cell.getRow(), "\"ERROR\"");
        }
        if ((writableCellFormat = (WritableCellFormat)this.xfRecords.get((Object)new Integer(n = ((XFRecord)(cellFormat = writableCell.getCellFormat())).getXFIndex()))) == null) {
            writableCellFormat = this.copyCellFormat(cellFormat);
        }
        writableCell.setCellFormat((CellFormat)writableCellFormat);
        return writableCell;
    }

    private WritableCell shallowCopyCell(Cell cell) {
        CellType cellType = cell.getType();
        if (cellType == CellType.LABEL) {
            return new Label((LabelCell)cell);
        }
        if (cellType == CellType.NUMBER) {
            return new Number((NumberCell)cell);
        }
        if (cellType == CellType.DATE) {
            return new DateTime((DateCell)cell);
        }
        if (cellType == CellType.BOOLEAN) {
            return new Boolean((BooleanCell)cell);
        }
        if (cellType == CellType.NUMBER_FORMULA) {
            return new ReadNumberFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.STRING_FORMULA) {
            return new ReadStringFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.BOOLEAN_FORMULA) {
            return new ReadBooleanFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.DATE_FORMULA) {
            return new ReadDateFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.FORMULA_ERROR) {
            return new ReadErrorFormulaRecord((FormulaData)cell);
        }
        if (cellType == CellType.EMPTY && cell.getCellFormat() != null) {
            return new Blank(cell);
        }
        return null;
    }

    /*
     * Exception decompiling
     */
    public void copySheet() {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl88 : ALOAD_0 : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }

    /*
     * Exception decompiling
     */
    void deepCopyCells() {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl53 : IINC : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }

    ButtonPropertySetRecord getButtonPropertySet() {
        return this.toButtonPropertySet;
    }

    DataValidation getDataValidation() {
        return this.toDataValidation;
    }

    public int getMaxColumnOutlineLevel() {
        return this.maxColumnOutlineLevel;
    }

    public int getMaxRowOutlineLevel() {
        return this.maxRowOutlineLevel;
    }

    PLSRecord getPLSRecord() {
        return this.toPLSRecord;
    }

    boolean isChartOnly() {
        return this.chartOnly;
    }

    void setButtonPropertySetRecord(ButtonPropertySetRecord buttonPropertySetRecord) {
        this.fromButtonPropertySet = buttonPropertySetRecord;
    }

    void setColumnBreaks(ArrayList arrayList, ArrayList arrayList2) {
        this.fromColumnBreaks = arrayList;
        this.toColumnBreaks = arrayList2;
    }

    void setColumnFormats(TreeSet treeSet, TreeSet treeSet2) {
        this.fromColumnFormats = treeSet;
        this.toColumnFormats = treeSet2;
    }

    void setDataValidation(DataValidation dataValidation) {
        this.fromDataValidation = dataValidation;
    }

    void setDrawings(ArrayList arrayList, ArrayList arrayList2, ArrayList arrayList3) {
        this.fromDrawings = arrayList;
        this.toDrawings = arrayList2;
        this.toImages = arrayList3;
    }

    void setHyperlinks(ArrayList arrayList, ArrayList arrayList2) {
        this.fromHyperlinks = arrayList;
        this.toHyperlinks = arrayList2;
    }

    void setMergedCells(MergedCells mergedCells, MergedCells mergedCells2) {
        this.fromMergedCells = mergedCells;
        this.toMergedCells = mergedCells2;
    }

    void setPLSRecord(PLSRecord pLSRecord) {
        this.fromPLSRecord = pLSRecord;
    }

    void setRowBreaks(ArrayList arrayList, ArrayList arrayList2) {
        this.fromRowBreaks = arrayList;
        this.toRowBreaks = arrayList2;
    }

    void setRows(RowRecord[] arrrowRecord) {
        this.fromRows = arrrowRecord;
    }

    void setSheetWriter(SheetWriter sheetWriter) {
        this.sheetWriter = sheetWriter;
    }

    void setValidatedCells(ArrayList arrayList) {
        this.validatedCells = arrayList;
    }

    void setWorkspaceOptions(WorkspaceInformationRecord workspaceInformationRecord) {
        this.fromWorkspaceOptions = workspaceInformationRecord;
    }

    /*
     * Exception decompiling
     */
    void shallowCopyCells() {
        // This method has failed to decompile.  When submitting a bug report, please provide this stack trace, and (if you hold appropriate legal rights) the relevant class file.
        // org.benf.cfr.reader.util.ConfusedCFRException: Invalid stack depths @ lbl53 : IINC : trying to set 1 previously set to 0
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:203)
        // org.benf.cfr.reader.b.a.a.g.a(Op02WithProcessedDataAndRefs.java:1489)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:308)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:182)
        // org.benf.cfr.reader.b.f.a(CodeAnalyser.java:127)
        // org.benf.cfr.reader.entities.attributes.f.c(AttributeCode.java:96)
        // org.benf.cfr.reader.entities.g.p(Method.java:396)
        // org.benf.cfr.reader.entities.d.e(ClassFile.java:890)
        // org.benf.cfr.reader.entities.d.b(ClassFile.java:792)
        // org.benf.cfr.reader.b.a(Driver.java:128)
        // org.benf.cfr.reader.a.a(CfrDriverImpl.java:63)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.decompileWithCFR(JavaExtractionWorker.kt:61)
        // com.njlabs.showjava.decompilers.JavaExtractionWorker.doWork(JavaExtractionWorker.kt:130)
        // com.njlabs.showjava.decompilers.BaseDecompiler.withAttempt(BaseDecompiler.kt:108)
        // com.njlabs.showjava.workers.DecompilerWorker$b.run(DecompilerWorker.kt:118)
        // java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1167)
        // java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:641)
        // java.lang.Thread.run(Thread.java:919)
        throw new IllegalStateException("Decompilation failed");
    }
}

